// Export JS functions


function startExport(export_level) {
	export_level = typeof export_level !== 'undefined' ? export_level : 1;

	Ext.get('log_output').dom.innerHTML = '';
	var URL = "/opmon/opcfg/ajax_export.php?action=start_export";
	Ext.Ajax.request({
		url: URL,
		method: 'post',
		params: { full: export_level },
		success:	function( result, request ) {
			var mb = Ext.MessageBox.show({
			    title: 'Configuration update',
			    msg: result.responseText,
			    icon: Ext.Msg.INFO,
			    closable: true,
			    fn:function(btn) { } // singleton
			});
			setTimeout(function(){
			    mb.close();
			}, 3500);
			Ext.get('export_button').dom.disabled = false;
			Ext.get('apply_button').dom.disabled = false;
			checkRunningExport();
		}
	});

}

function checkRunningExport(schedule) {
	schedule = schedule || false;
	var URL = "/opmon/opcfg/ajax_export.php?action=check_running_export";
	Ext.get('reading_log').dom.innerHTML = "<b>Reading export log</b>";
	Ext.get('loader2').dom.style.display = 'block';
	Ext.Ajax.request({
		url: URL,
		method: 'post',
		callback: function( request, success, result ) {
			var datetime  = new Date();
			if (schedule) {
				setTimeout('checkRunningExport(true)', 10000);
			}
			if (!success) {
				Ext.get('reading_log').dom.innerHTML = '<b>Last refresh '+datetime+' - Timeout reading export log</b>';
				Ext.get('loader2').dom.style.display = 'none';
				return;
			}

			var obj = Ext.decode(result.responseText);

			// Export running
			if (obj.running) {
				Ext.get('current_status').dom.innerHTML = 'Running...';
				Ext.get('loader').dom.style.display = 'block';
				parent.frames['sidenav'].document.getElementById('loaderapply').style.display = 'inline';
				Ext.get('export_button').dom.disabled = true;
				Ext.get('apply_button').dom.disabled = true;
			} else {
				Ext.get('current_status').dom.innerHTML = 'Not Running';
				Ext.get('loader').dom.style.display = 'none';
				parent.frames['sidenav'].document.getElementById('loaderapply').style.display = 'none';
				Ext.get('export_button').dom.disabled = false;
				Ext.get('apply_button').dom.disabled = false;
			}
			Ext.get('reading_log').dom.innerHTML = '<b>Last refresh '+datetime+'</b>';
			Ext.get('loader2').dom.style.display = 'none';
			Ext.get('log_output').dom.innerHTML = obj.log;
		}
	});
}
