/*
 * File: app/model/OtrsConnectionModel.js
 *
 * This file was generated by Sencha Architect version 3.1.0.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('otrs_integration.model.OtrsConnectionModel', {
    extend: 'Ext.data.Model',

    requires: [
        'Ext.data.Field'
    ],

    idProperty: 'contact_name',

    fields: [
        {
            name: 'contact_name'
        },
        {
            name: 'url'
        },
        {
            name: 'username'
        },
        {
            name: 'password'
        },
        {
            name: 'uri'
        },
        {
            name: 'ticket_queue'
        },
        {
            name: 'ticket_type'
        },
        {
            name: 'ticket_service'
        },
        {
            name: 'ticket_sla'
        },
        {
            name: 'ticket_priority'
        },
        {
            name: 'ticket_customer_user'
        },
        {
            name: 'article_type'
        },
        {
            name: 'close_on_recovery'
        },
        {
            name: 'feedback'
        },
        {
            name: 'open_states'
        }
    ],

    test: function(callback) {
        var me;

        Ext.getCmp("connectionsLogScreen").printLog("success", "Starting to test "+this.data.contact_name);

        me = this;

        var post_data = this.data;
        post_data.action = "test_connection";
        post_data.host_name = "ci-test";

        Ext.Ajax.request({

            url: "/opmon/opcfg/otrs/ws/",
            params: post_data,
            success: function(response) {

                var obj;
                var i;
                var msg;
                var msgtype;
                var success = true;

                try {
                    obj = JSON.parse(response.responseText);
                    if (obj.response_status.status != 1) {
                        Ext.getCmp("connectionsLogScreen").printLog("critical", obj.response_status.msg);
                        Ext.getCmp("connectionsLogScreen").loadingLog(false);
                        return;
                    }

                    for(i=0; i<obj.response_data.length; i++) {

                        msg = obj.response_data[i];

                        switch(msg.status) {

                            case 0:
                                msgtype = "success";
                                break;

                            case 1:
                                msgtype = "warning";
                                break;

                            case 2:
                                success = false;
                                msgtype = "critical";
                                break;

                            default:
                                msgtype = "unknown";

                        }

                        Ext.getCmp("connectionsLogScreen").printLog(msgtype, msg.msg);
                        Ext.getCmp("connectionsLogScreen").loadingLog(false);

                    }


                    if (callback)
                        callback(success);

                } catch(err) {
                        Ext.getCmp("connectionsLogScreen").printLog("critical", err.message);
                }



            },
            failure: function(response, options) {
                Ext.getCmp("connectionsLogScreen").printLog("critical", "Server response:");
                Ext.getCmp("connectionsLogScreen").printLog("critical", response.statusText);
                Ext.getCmp("connectionsLogScreen").loadingLog(false);
            }

        });
    },

    validate_url: function(callback) {
        Ext.Ajax.request({

            url: "/opmon/opcfg/otrs/ws/",
            params: {
                action: "try_connect",
                url: this.get("url"),
                uri: this.get("uri"),
                username: this.get("username"),
                password: this.get("password")
            },
            success: function(response) {

                var obj;

                try {

                    obj = JSON.parse(response.responseText);
                } catch(err) {
                    Ext.getCmp("connectionsLogScreen").printLog("critical", err.message);
                    return;
                }

                callback(obj);

            },
            failure: function(response) {
                Ext.getCmp("connectionsLogScreen").printLog("critical", "Server response:");
                Ext.getCmp("connectionsLogScreen").printLog("critical", response.statusText);
            }

        });


    },

    save: function(n, callback) {
        var params = this.data;
        params.action = "crud";

        params.operation = "update";
        if (n) {
            params.operation = "new";
        }

        Ext.Ajax.request({
            url: "/opmon/opcfg/otrs/ws/",
            params: params,
            success: function(response) {

                try {
                    obj = JSON.parse(response.responseText);
                } catch(err) {
                    Ext.getCmp("connectionsLogScreen").printLog("critical", err.message);
                    return;
                }

                callback(obj);

            },
            failure: function(response) {
                Ext.getCmp("connectionsLogScreen").printLog("critical", "Server response:");
                Ext.getCmp("connectionsLogScreen").printLog("critical", response.statusText);
            }

        });
    }

});