/*
 * File: app/store/OtrsConnection.js
 *
 * This file was generated by Sencha Architect version 3.1.0.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('otrs_integration.store.OtrsConnection', {
    extend: 'Ext.data.Store',

    requires: [
        'otrs_integration.model.OtrsConnectionModel',
        'Ext.data.proxy.Ajax',
        'Ext.data.reader.Json'
    ],

    constructor: function(cfg) {
        var me = this;
        cfg = cfg || {};
        me.callParent([Ext.apply({
            autoLoad: true,
            model: 'otrs_integration.model.OtrsConnectionModel',
            storeId: 'OtrsConnection',
            proxy: {
                type: 'ajax',
                api: {
                    read: '/opmon/opcfg/otrs/ws/?action=crud&operation=list'
                },
                reader: {
                    type: 'json',
                    idProperty: 'contact_name',
                    root: 'response_data'
                }
            },
            listeners: {
                load: {
                    fn: me.onJsonstoreLoad,
                    scope: me
                }
            }
        }, cfg)]);
    },

    onJsonstoreLoad: function(store, records, successful, eOpts) {
        store.validate_ws_return();
    },

    validate_ws_return: function() {
        var obj;

        try {

            obj = this.proxy.reader.jsonData;
            if (obj.response_status.status != 1) {
                Ext.getCmp("connectionsLogScreen").printLog("critical", obj.response_status.msg);
            }

        } catch(err) {
            Ext.getCmp("connectionsLogScreen").printLog("critical", err.message);
        }


    }

});