/*
 * File: app/view/ConnectionsContainer.js
 *
 * This file was generated by Sencha Architect version 3.1.0.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('otrs_integration.view.ConnectionsContainer', {
    extend: 'Ext.container.Viewport',

    requires: [
        'Ext.view.View',
        'Ext.XTemplate',
        'Ext.button.Button',
        'Ext.form.Panel',
        'Ext.toolbar.Toolbar',
        'Ext.form.FieldSet',
        'Ext.form.field.ComboBox',
        'Ext.form.field.Checkbox'
    ],

    id: 'ConnectionsContainer',

    layout: {
        type: 'vbox',
        align: 'stretch'
    },

    initComponent: function() {
        var me = this;

        Ext.applyIf(me, {
            items: [
                {
                    xtype: 'container',
                    flex: 1,
                    id: 'connectionsContent',
                    layout: {
                        type: 'hbox',
                        align: 'stretch'
                    },
                    items: [
                        {
                            xtype: 'container',
                            flex: 1,
                            id: 'connectionsCards',
                            layout: 'card',
                            items: [
                                {
                                    xtype: 'container',
                                    id: 'connectionsActiveList',
                                    layout: {
                                        type: 'hbox',
                                        align: 'stretch',
                                        padding: '0 20 0 0'
                                    },
                                    items: [
                                        {
                                            xtype: 'container',
                                            flex: 1
                                        },
                                        {
                                            xtype: 'container',
                                            flex: 1,
                                            id: 'connectionsActiveAddnew',
                                            maxWidth: 400,
                                            minWidth: 400,
                                            width: 400,
                                            layout: {
                                                type: 'vbox',
                                                align: 'stretch'
                                            },
                                            items: [
                                                {
                                                    xtype: 'panel',
                                                    height: 400,
                                                    margin: '40 0 0',
                                                    maxHeight: 400,
                                                    minHeight: 400,
                                                    width: 300,
                                                    overflowY: 'auto',
                                                    layout: 'anchor',
                                                    title: 'Active Connections',
                                                    items: [
                                                        {
                                                            xtype: 'dataview',
                                                            callTip: function(el, msg) {
                                                                Ext.create('Ext.tip.ToolTip', {
                                                                    target: el,
                                                                    html: msg,
                                                                    showDelay: 0
                                                                });
                                                            },
                                                            removeMsg: function(item, name, logText) {
                                                                Ext.Msg.show({
                                                                    title: 'Remove ' + name,
                                                                    msg: 'Do you really want to remove this connection?',
                                                                    buttons: Ext.Msg.YESNO,
                                                                    buttonText: {
                                                                        yes: 'Yes',
                                                                        no: 'Cancel'
                                                                    },
                                                                    fn: function(btn) {

                                                                        if (btn !== "yes") {
                                                                            return;
                                                                        }

                                                                        Ext.getCmp("connectionsLogScreen").loadingLog(true);
                                                                        Ext.getCmp("connectionsLogScreen").printLog("success", "Removing "+name);

                                                                        Ext.Ajax.request({

                                                                            url: "/opmon/opcfg/otrs/ws/",
                                                                            params: {
                                                                                action: "crud",
                                                                                operation: "delete",
                                                                                contact_name: name
                                                                            },

                                                                            success: function(response) {

                                                                                var obj;
                                                                                var i;
                                                                                var msg;
                                                                                var msgtype;

                                                                                try {
                                                                                    obj = JSON.parse(response.responseText);
                                                                                    if (obj.response_status.status != 1) {
                                                                                        Ext.getCmp("connectionsLogScreen").printLog("critical", obj.response_status.msg);
                                                                                        Ext.getCmp("connectionsLogScreen").loadingLog(false);
                                                                                        return;
                                                                                    }

                                                                                    var myapp = otrs_integration.getApplication();
                                                                                    var connStore = myapp.getOtrsConnectionStore();
                                                                                    connStore.load();

                                                                                    Ext.getCmp("connectionsLogScreen").printLog("success", "Done");

                                                                                } catch(err) {
                                                                                    Ext.getCmp("connectionsLogScreen").printLog("critical", err.message);
                                                                                }

                                                                                Ext.getCmp("connectionsLogScreen").loadingLog(false);

                                                                            },
                                                                            failure: function(response) {
                                                                                Ext.getCmp("connectionsLogScreen").printLog("critical", response);
                                                                                Ext.getCmp("connectionsLogScreen").loadingLog(false);
                                                                            }

                                                                        });
                                                                    },
                                                                    icon: Ext.Msg.QUESTION
                                                                });
                                                            },
                                                            id: 'connectionsActiveListItems',
                                                            itemCls: 'x-dataview-item connection-item',
                                                            itemSelector: 'div',
                                                            itemTpl: [
                                                                '<span class="connection-name">{contact_name}</span>',
                                                                '<a class="connection-tool connection-edit" onmouseover="javascript:Ext.getCmp(\'connectionsActiveListItems\').callTip(this,\'Edit\');" href="#"></a>',
                                                                '<a class="connection-tool connection-test" onmouseover="javascript:Ext.getCmp(\'connectionsActiveListItems\').callTip(this,\'Test\');" href="#"></a>',
                                                                '<a class="connection-tool connection-remove" onmouseover="javascript:Ext.getCmp(\'connectionsActiveListItems\').callTip(this,\'Remove\');" href="#"></a>'
                                                            ],
                                                            store: 'OtrsConnection',
                                                            listeners: {
                                                                itemclick: {
                                                                    fn: me.onDataviewItemClick,
                                                                    scope: me
                                                                }
                                                            }
                                                        }
                                                    ]
                                                },
                                                {
                                                    xtype: 'container',
                                                    flex: 1,
                                                    height: 40,
                                                    id: 'connectionsActiveAddnewWrapper',
                                                    margin: '10 0 0',
                                                    maxHeight: 40,
                                                    layout: {
                                                        type: 'hbox',
                                                        align: 'stretch'
                                                    },
                                                    items: [
                                                        {
                                                            xtype: 'button',
                                                            exampleFunctionreturn: function(test_param) {
                                                                if (test_param === true) {
                                                                    console.log(1);
                                                                    return "adding new connection";
                                                                } else {
                                                                    console.log(0);
                                                                    return "nothing new";
                                                                }
                                                            },
                                                            flex: 1,
                                                            height: 25,
                                                            maxHeight: 27,
                                                            glyph: 43,
                                                            text: 'Add new connection',
                                                            listeners: {
                                                                click: {
                                                                    fn: me.onButtonClick,
                                                                    scope: me
                                                                }
                                                            }
                                                        },
                                                        {
                                                            xtype: 'container',
                                                            flex: 1
                                                        }
                                                    ]
                                                }
                                            ]
                                        }
                                    ]
                                },
                                {
                                    xtype: 'container',
                                    id: 'connectionsNewStep01',
                                    layout: {
                                        type: 'hbox',
                                        align: 'stretch',
                                        padding: '0 20 0 0'
                                    },
                                    items: [
                                        {
                                            xtype: 'container',
                                            flex: 1
                                        },
                                        {
                                            xtype: 'container',
                                            flex: 1,
                                            margin: '40 0 0',
                                            maxWidth: 400,
                                            minWidth: 400,
                                            width: 400,
                                            layout: {
                                                type: 'vbox',
                                                align: 'stretch'
                                            },
                                            items: [
                                                {
                                                    xtype: 'form',
                                                    flex: 1,
                                                    maxHeight: 400,
                                                    bodyPadding: 20,
                                                    title: 'New connection',
                                                    items: [
                                                        {
                                                            xtype: 'textfield',
                                                            anchor: '100%',
                                                            id: 'connectionsNewName',
                                                            fieldLabel: 'Connection name',
                                                            labelAlign: 'top',
                                                            labelSeparator: ' ',
                                                            listeners: {
                                                                blur: {
                                                                    fn: me.onConnectionsNewNameBlur,
                                                                    scope: me
                                                                }
                                                            }
                                                        },
                                                        {
                                                            xtype: 'textfield',
                                                            anchor: '100%',
                                                            id: 'connectionsNewUsername',
                                                            fieldLabel: 'User name',
                                                            labelAlign: 'top',
                                                            labelSeparator: ' '
                                                        },
                                                        {
                                                            xtype: 'textfield',
                                                            anchor: '100%',
                                                            id: 'connectionsNewPassword',
                                                            fieldLabel: 'Password',
                                                            labelAlign: 'top',
                                                            labelSeparator: ' ',
                                                            inputType: 'password'
                                                        },
                                                        {
                                                            xtype: 'textfield',
                                                            anchor: '100%',
                                                            id: 'connectionsNewUrl',
                                                            fieldLabel: 'Connection URL',
                                                            labelAlign: 'top',
                                                            labelSeparator: ' '
                                                        },
                                                        {
                                                            xtype: 'textfield',
                                                            anchor: '100%',
                                                            id: 'connectionsNewUri',
                                                            fieldLabel: 'Connection Namespace',
                                                            labelAlign: 'top',
                                                            labelSeparator: ' '
                                                        }
                                                    ],
                                                    dockedItems: [
                                                        {
                                                            xtype: 'toolbar',
                                                            dock: 'bottom',
                                                            items: [
                                                                {
                                                                    xtype: 'button',
                                                                    text: 'Cancel',
                                                                    listeners: {
                                                                        click: {
                                                                            fn: me.onButtonClick2,
                                                                            scope: me
                                                                        }
                                                                    }
                                                                },
                                                                {
                                                                    xtype: 'container',
                                                                    flex: 1
                                                                },
                                                                {
                                                                    xtype: 'container',
                                                                    items: [
                                                                        {
                                                                            xtype: 'button',
                                                                            id: 'connectionsNewStep01Advance',
                                                                            text: 'Continue',
                                                                            listeners: {
                                                                                click: {
                                                                                    fn: me.onButtonClick1,
                                                                                    scope: me
                                                                                }
                                                                            }
                                                                        }
                                                                    ]
                                                                }
                                                            ]
                                                        }
                                                    ]
                                                }
                                            ]
                                        }
                                    ],
                                    listeners: {
                                        activate: {
                                            fn: me.onConnectionsNewStep01Activate,
                                            scope: me
                                        }
                                    }
                                },
                                {
                                    xtype: 'container',
                                    disableSaveButton: function() {
                                        Ext.getCmp("saveButton").disable();
                                    },
                                    id: 'connectionsNewStep02',
                                    layout: {
                                        type: 'hbox',
                                        align: 'stretch',
                                        padding: '0 20 0 0'
                                    },
                                    items: [
                                        {
                                            xtype: 'container',
                                            flex: 1
                                        },
                                        {
                                            xtype: 'container',
                                            flex: 1,
                                            margin: '40 0 0',
                                            maxWidth: 400,
                                            minWidth: 400,
                                            width: 400,
                                            layout: {
                                                type: 'vbox',
                                                align: 'stretch'
                                            },
                                            items: [
                                                {
                                                    xtype: 'form',
                                                    flex: 1,
                                                    maxHeight: 400,
                                                    autoScroll: true,
                                                    bodyPadding: 20,
                                                    title: 'New connection',
                                                    dockedItems: [
                                                        {
                                                            xtype: 'toolbar',
                                                            dock: 'bottom',
                                                            items: [
                                                                {
                                                                    xtype: 'button',
                                                                    text: 'Back',
                                                                    listeners: {
                                                                        click: {
                                                                            fn: me.onButtonClick3,
                                                                            scope: me
                                                                        }
                                                                    }
                                                                },
                                                                {
                                                                    xtype: 'container',
                                                                    width: 15
                                                                },
                                                                {
                                                                    xtype: 'button',
                                                                    text: 'Cancel',
                                                                    listeners: {
                                                                        click: {
                                                                            fn: me.onButtonClick4,
                                                                            scope: me
                                                                        }
                                                                    }
                                                                },
                                                                {
                                                                    xtype: 'container',
                                                                    flex: 1
                                                                },
                                                                {
                                                                    xtype: 'container',
                                                                    items: [
                                                                        {
                                                                            xtype: 'button',
                                                                            text: 'Test',
                                                                            listeners: {
                                                                                click: {
                                                                                    fn: me.onButtonClick5,
                                                                                    scope: me
                                                                                }
                                                                            }
                                                                        },
                                                                        {
                                                                            xtype: 'button',
                                                                            id: 'saveButton',
                                                                            text: 'Save',
                                                                            listeners: {
                                                                                click: {
                                                                                    fn: me.onButtonClick51,
                                                                                    scope: me
                                                                                }
                                                                            }
                                                                        }
                                                                    ]
                                                                }
                                                            ]
                                                        }
                                                    ],
                                                    items: [
                                                        {
                                                            xtype: 'fieldset',
                                                            title: 'Open ticket configuration',
                                                            items: [
                                                                {
                                                                    xtype: 'textfield',
                                                                    anchor: '100%',
                                                                    id: 'connectionsNewTicketQueue',
                                                                    fieldLabel: 'Queue',
                                                                    labelAlign: 'top',
                                                                    labelSeparator: ' ',
                                                                    emptyText: 'Postmaster',
                                                                    listeners: {
                                                                        change: {
                                                                            fn: me.onConnectionsNewTicketQueueChange,
                                                                            scope: me
                                                                        }
                                                                    }
                                                                },
                                                                {
                                                                    xtype: 'textfield',
                                                                    anchor: '100%',
                                                                    id: 'connectionsNewTicketType',
                                                                    fieldLabel: 'Type',
                                                                    labelAlign: 'top',
                                                                    labelSeparator: ' ',
                                                                    emptyText: 'Problem',
                                                                    listeners: {
                                                                        change: {
                                                                            fn: me.onConnectionsNewTicketTypeChange,
                                                                            scope: me
                                                                        }
                                                                    }
                                                                },
                                                                {
                                                                    xtype: 'textfield',
                                                                    anchor: '100%',
                                                                    id: 'connectionsNewTicketService',
                                                                    fieldLabel: 'Service',
                                                                    labelAlign: 'top',
                                                                    labelSeparator: ' ',
                                                                    emptyText: 'Service::My Sub-service X',
                                                                    listeners: {
                                                                        change: {
                                                                            fn: me.onConnectionsNewTicketServiceChange,
                                                                            scope: me
                                                                        }
                                                                    }
                                                                },
                                                                {
                                                                    xtype: 'textfield',
                                                                    anchor: '100%',
                                                                    id: 'connectionsNewTicketSla',
                                                                    fieldLabel: 'SLA',
                                                                    labelAlign: 'top',
                                                                    labelSeparator: ' ',
                                                                    emptyText: 'My SLA Y',
                                                                    listeners: {
                                                                        change: {
                                                                            fn: me.onConnectionsNewTicketSlaChange,
                                                                            scope: me
                                                                        }
                                                                    }
                                                                },
                                                                {
                                                                    xtype: 'textfield',
                                                                    anchor: '100%',
                                                                    id: 'connectionsNewTicketPriority',
                                                                    fieldLabel: 'Priority',
                                                                    labelAlign: 'top',
                                                                    labelSeparator: ' ',
                                                                    emptyText: '4 high',
                                                                    listeners: {
                                                                        change: {
                                                                            fn: me.onConnectionsNewTicketPriorityChange,
                                                                            scope: me
                                                                        }
                                                                    }
                                                                },
                                                                {
                                                                    xtype: 'textfield',
                                                                    anchor: '100%',
                                                                    id: 'connectionsNewTicketCustomerUser',
                                                                    fieldLabel: 'Customer Username',
                                                                    labelAlign: 'top',
                                                                    labelSeparator: ' ',
                                                                    emptyText: 'customer@enterprise.com',
                                                                    listeners: {
                                                                        change: {
                                                                            fn: me.onConnectionsNewTicketCustomerUserChange,
                                                                            scope: me
                                                                        }
                                                                    }
                                                                }
                                                            ]
                                                        },
                                                        {
                                                            xtype: 'fieldset',
                                                            title: 'Search for open tickets parameters',
                                                            items: [
                                                                {
                                                                    xtype: 'textfield',
                                                                    anchor: '100%',
                                                                    id: 'connectionsNewTicketOpenStates',
                                                                    fieldLabel: 'Open ticket states(comma separated values)',
                                                                    labelAlign: 'top',
                                                                    labelSeparator: ' ',
                                                                    emptyText: 'new,open'
                                                                }
                                                            ]
                                                        },
                                                        {
                                                            xtype: 'fieldset',
                                                            title: 'New article creation',
                                                            items: [
                                                                {
                                                                    xtype: 'textfield',
                                                                    anchor: '100%',
                                                                    id: 'connectionsNewArticleType',
                                                                    fieldLabel: 'Type',
                                                                    labelAlign: 'top',
                                                                    labelSeparator: ' ',
                                                                    emptyText: 'email-external',
                                                                    listeners: {
                                                                        change: {
                                                                            fn: me.onConnectionsNewArticleTypeChange,
                                                                            scope: me
                                                                        }
                                                                    }
                                                                }
                                                            ]
                                                        },
                                                        {
                                                            xtype: 'fieldset',
                                                            title: 'Close ticket configuration',
                                                            items: [
                                                                {
                                                                    xtype: 'combobox',
                                                                    anchor: '100%',
                                                                    id: 'connectionsNewFeedback',
                                                                    fieldLabel: 'IC Receive',
                                                                    labelAlign: 'top',
                                                                    labelSeparator: ' ',
                                                                    queryMode: 'local',
                                                                    store: [
                                                                        [
                                                                            '0',
                                                                            'Acknowledge'
                                                                        ],
                                                                        [
                                                                            '1',
                                                                            'Comment'
                                                                        ]
                                                                    ],
                                                                    listeners: {
                                                                        change: {
                                                                            fn: me.onConnectionsNewFeedbackChange,
                                                                            scope: me
                                                                        }
                                                                    }
                                                                },
                                                                {
                                                                    xtype: 'checkboxfield',
                                                                    anchor: '100%',
                                                                    id: 'connectionsNewCloseOnRecovery',
                                                                    fieldLabel: 'Label',
                                                                    hideLabel: true,
                                                                    boxLabel: 'Close on recovery',
                                                                    listeners: {
                                                                        change: {
                                                                            fn: me.onConnectionsNewCloseOnRecoveryChange,
                                                                            scope: me
                                                                        }
                                                                    }
                                                                }
                                                            ]
                                                        }
                                                    ]
                                                }
                                            ]
                                        }
                                    ],
                                    listeners: {
                                        activate: {
                                            fn: me.onConnectionsNewStep02Activate,
                                            scope: me
                                        }
                                    }
                                }
                            ]
                        },
                        {
                            xtype: 'container',
                            flex: 1,
                            width: 300,
                            layout: {
                                type: 'vbox',
                                padding: '0 0 0 20'
                            },
                            items: [
                                {
                                    xtype: 'panel',
                                    printLog: function(state, msg) {
                                        var logScreen, logScroll;

                                        logScreen = this;
                                        logScreen.add( {xtype: "container", cls: state+"-text black-bg", html: msg} );
                                        logScroll = logScreen.body;
                                        logScroll.dom.scrollTop = logScroll.dom.scrollHeight - window.parseInt(logScroll.dom.style.height);

                                        //console.log(el.xtype);
                                    },
                                    loadingLog: function(areLoading) {
                                        if (areLoading) {
                                            Ext.getCmp("connectionsLogScreen").setIcon("/opmon/opcfg/images/load.gif");
                                        } else {
                                            Ext.getCmp("connectionsLogScreen").setIcon(Ext.BLANK_IMAGE_URL);
                                        }

                                        return;


                                        var logScreen, logScroll, counter, text, loadInterval;

                                        logScreen = this;
                                        counter = 0;
                                        text = "loading";
                                        loadInterval = 0;


                                        if (areLoading === true) {
                                            logScreen.add({xtype: "container", id: "loading_container", cls:"white-text black-bg", html: "<div id='loading_box'></div>"} );
                                            loadInterval = setInterval(function() {
                                                document.getElementById("loading_box").innerHTML = text+Array((++counter % 4)+1).join(".");
                                            }, 200);
                                        } else {
                                            logScreen.remove(Ext.getCmp("loading_container"));
                                            clearInterval(loadInterval);
                                        }

                                        logScroll = logScreen.body;
                                        logScroll.dom.scrollTop = logScroll.dom.scrollHeight - window.parseInt(logScroll.dom.style.height);
                                    },
                                    cls: 'black-bg',
                                    height: 400,
                                    id: 'connectionsLogScreen',
                                    margin: '40 0 0',
                                    maxHeight: 400,
                                    minHeight: 400,
                                    width: 300,
                                    autoScroll: true,
                                    bodyCls: [
                                        'black-bg',
                                        'console-log'
                                    ],
                                    bodyPadding: 15,
                                    icon: '',
                                    title: 'Logs',
                                    items: [
                                        {
                                            xtype: 'container',
                                            cls: 'white-text black-bg',
                                            html: 'OpMon + OTRS Integration',
                                            id: 'startLog'
                                        }
                                    ]
                                }
                            ]
                        }
                    ]
                }
            ]
        });

        me.callParent(arguments);
    },

    onDataviewItemClick: function(dataview, record, item, index, e, eOpts) {
        var clickedTool;
        var clickedItem;
        var clickedAuth;
        var clickedAction;
        var myapp;
        var connStore;
        var conn;


        myapp = otrs_integration.getApplication();
        connStore = myapp.getOtrsConnectionStore();

        clickedTool = e.target.className;
        clickedTool = clickedTool.split(' ');
        clickedAuth = clickedTool[0];
        clickedAction = clickedTool[1];

        clickedItem = item.childNodes.item('span').innerHTML;

        if (clickedAuth != 'connection-tool') {
            return false;
        }

        switch (clickedAction) {

            case 'connection-remove':
                clickedAction = 'Removing';
                Ext.getCmp('connectionsActiveListItems').removeMsg(item, clickedItem, clickedAction + ' ' + clickedItem);
                return;

            case 'connection-test':
                conn = connStore.find("contact_name",clickedItem);
                if (conn < 0) {
                    Ext.getCmp("connectionsLogScreen").printLog("critical", "Invalid connection");
                    return;
                }

                conn = connStore.getAt(conn);
                Ext.getCmp("connectionsLogScreen").loadingLog(true);
                conn.test();
                return;

            case 'connection-edit':

                conn = connStore.find("contact_name",clickedItem);
                if (conn < 0) {
                    Ext.getCmp("connectionsLogScreen").printLog("critical", "Invalid connection");
                    return;
                }

                var cardsContainer;
                otrs_integration.conn =  connStore.getAt(conn);
                otrs_integration.editing_new = false;

                cardsContainer = Ext.getCmp("connectionsCards");
                cardsContainer.getLayout().setActiveItem(1);
                return;

        }

    },

    onButtonClick: function(button, e, eOpts) {
        var cardsContainer;

        cardsContainer = button.up("#connectionsCards");
        cardsContainer.getLayout().setActiveItem(1);
    },

    onConnectionsNewNameBlur: function(component, e, eOpts) {
        component.setValue(changeCharCode(component.getValue()));
    },

    onButtonClick2: function(button, e, eOpts) {
        var cardsContainer;

        delete otrs_integration.conn;
        cardsContainer = button.up("#connectionsCards");
        cardsContainer.getLayout().setActiveItem(0);
    },

    onButtonClick1: function(button, e, eOpts) {
        var cardsContainer;
        var fieldName;
        var fieldUrl;

        var myapp = otrs_integration.getApplication();
        var connStore = myapp.getOtrsConnectionStore();
        var cname_regex = new RegExp('^' + Ext.getCmp("connectionsNewName").value + '$');

        var idx = connStore.find("contact_name",cname_regex);
        if (otrs_integration.editing_new === true && idx >= 0) {
            Ext.Msg.show({
                title: 'Invalid connection name',
                msg: 'A connection with this name already exists',
                buttons: Ext.Msg.YES,
                buttonText: {
                    yes: 'OK'
                }
            });
            return;
        }

        cardsContainer = button.up("#connectionsCards");

        otrs_integration.conn.set("contact_name",Ext.getCmp("connectionsNewName").value);
        otrs_integration.conn.set("username",Ext.getCmp("connectionsNewUsername").value);
        otrs_integration.conn.set("password",Ext.getCmp("connectionsNewPassword").value);
        otrs_integration.conn.set("url",Ext.getCmp("connectionsNewUrl").value);
        otrs_integration.conn.set("uri",Ext.getCmp("connectionsNewUri").value);


        Ext.getCmp("connectionsLogScreen").loadingLog(true);
        Ext.getCmp("connectionsLogScreen").printLog("success", "Validating url");
        otrs_integration.conn.validate_url(function(obj) {


            /* validating callback */
            if (obj.response_status.status != 1) {
                Ext.getCmp("connectionsLogScreen").printLog("critical", obj.response_status.msg);
                Ext.getCmp("connectionsLogScreen").loadingLog(false);
                return;
            }
            Ext.getCmp("connectionsLogScreen").printLog("success", "Done.");


            cardsContainer.getLayout().setActiveItem(2);
            Ext.getCmp("connectionsLogScreen").loadingLog(false);

        });
    },

    onConnectionsNewStep01Activate: function(component, eOpts) {
        /* new connection */
        if (otrs_integration.conn === undefined) {
            otrs_integration.conn = Ext.create('otrs_integration.model.OtrsConnectionModel',{});
            otrs_integration.editing_new = true;
        }

        Ext.getCmp("connectionsNewName").setValue(
            otrs_integration.conn.get("contact_name")
        );

        Ext.getCmp("connectionsNewUsername").setValue(
            otrs_integration.conn.get("username")
        );

        Ext.getCmp("connectionsNewPassword").setValue(
            otrs_integration.conn.get("password")
        );


        Ext.getCmp("connectionsNewUrl").setValue(
            otrs_integration.conn.get("url")
        );

        Ext.getCmp("connectionsNewUri").setValue(
            otrs_integration.conn.get("uri")
        );

        if (otrs_integration.editing_new === true) {
            Ext.getCmp("connectionsNewName").enable();
        } else {
            Ext.getCmp("connectionsNewName").disable();
        }
    },

    onButtonClick3: function(button, e, eOpts) {
        var cardsContainer;

        cardsContainer = button.up("#connectionsCards");
        cardsContainer.getLayout().setActiveItem(1);
    },

    onButtonClick4: function(button, e, eOpts) {
        var cardsContainer;

        delete otrs_integration.conn;
        cardsContainer = button.up("#connectionsCards");
        cardsContainer.getLayout().setActiveItem(0);
    },

    onButtonClick5: function(button, e, eOpts) {
        var cardsContainer, fieldUsername, fieldPassword, fieldCompany;

        otrs_integration.conn.set("ticket_queue",Ext.getCmp("connectionsNewTicketQueue").value);
        otrs_integration.conn.set("ticket_type",Ext.getCmp("connectionsNewTicketType").value);
        otrs_integration.conn.set("ticket_service",Ext.getCmp("connectionsNewTicketService").value);
        otrs_integration.conn.set("ticket_sla",Ext.getCmp("connectionsNewTicketSla").value);
        otrs_integration.conn.set("ticket_priority",Ext.getCmp("connectionsNewTicketPriority").value);
        otrs_integration.conn.set("ticket_customer_user",Ext.getCmp("connectionsNewTicketCustomerUser").value);
        otrs_integration.conn.set("article_type",Ext.getCmp("connectionsNewArticleType").value);
        otrs_integration.conn.set("feedback",Ext.getCmp("connectionsNewFeedback").value);
        otrs_integration.conn.set("open_states",Ext.getCmp("connectionsNewTicketOpenStates").value);

        if (Ext.getCmp("connectionsNewCloseOnRecovery").value) {
            otrs_integration.conn.set("close_on_recovery",1);
        } else {
            otrs_integration.conn.set("close_on_recovery",0);
        }


        Ext.getCmp("saveButton").disable();
        Ext.getCmp("connectionsLogScreen").loadingLog(true);
        otrs_integration.conn.test(function(success) {

            Ext.getCmp("connectionsLogScreen").loadingLog(false);
            if (success === false) {
                return;
            }

            Ext.getCmp("saveButton").enable();
        });

    },

    onButtonClick51: function(button, e, eOpts) {
        otrs_integration.conn.save(
            otrs_integration.editing_new,
            function() {


                /* reload store */
                otrs_integration.getApplication().getOtrsConnectionStore().load();

                cardsContainer = Ext.getCmp("connectionsCards");
                cardsContainer.getLayout().setActiveItem(0);
            }
        );
    },

    onConnectionsNewTicketQueueChange: function(field, newValue, oldValue, eOpts) {
        Ext.getCmp("connectionsNewStep02").disableSaveButton();
    },

    onConnectionsNewTicketTypeChange: function(field, newValue, oldValue, eOpts) {
        Ext.getCmp("connectionsNewStep02").disableSaveButton();
    },

    onConnectionsNewTicketServiceChange: function(field, newValue, oldValue, eOpts) {
        Ext.getCmp("connectionsNewStep02").disableSaveButton();
    },

    onConnectionsNewTicketSlaChange: function(field, newValue, oldValue, eOpts) {
        Ext.getCmp("connectionsNewStep02").disableSaveButton();
    },

    onConnectionsNewTicketPriorityChange: function(field, newValue, oldValue, eOpts) {
        Ext.getCmp("connectionsNewStep02").disableSaveButton();
    },

    onConnectionsNewTicketCustomerUserChange: function(field, newValue, oldValue, eOpts) {
        Ext.getCmp("connectionsNewStep02").disableSaveButton();
    },

    onConnectionsNewArticleTypeChange: function(field, newValue, oldValue, eOpts) {
        Ext.getCmp("connectionsNewStep02").disableSaveButton();
    },

    onConnectionsNewFeedbackChange: function(field, newValue, oldValue, eOpts) {
        Ext.getCmp("connectionsNewStep02").disableSaveButton();
    },

    onConnectionsNewCloseOnRecoveryChange: function(field, newValue, oldValue, eOpts) {
        Ext.getCmp("connectionsNewStep02").disableSaveButton();
    },

    onConnectionsNewStep02Activate: function(component, eOpts) {
        Ext.getCmp("connectionsNewTicketQueue").setValue(
            otrs_integration.conn.get("ticket_queue")
        );

        Ext.getCmp("connectionsNewTicketType").setValue(
            otrs_integration.conn.get("ticket_type")
        );

        Ext.getCmp("connectionsNewTicketService").setValue(
            otrs_integration.conn.get("ticket_service")
        );

        Ext.getCmp("connectionsNewTicketSla").setValue(
            otrs_integration.conn.get("ticket_sla")
        );

        Ext.getCmp("connectionsNewTicketPriority").setValue(
            otrs_integration.conn.get("ticket_priority")
        );

        Ext.getCmp("connectionsNewTicketCustomerUser").setValue(
            otrs_integration.conn.get("ticket_customer_user")
        );

        Ext.getCmp("connectionsNewArticleType").setValue(
            otrs_integration.conn.get("article_type")
        );

        Ext.getCmp("connectionsNewCloseOnRecovery").setValue(
            otrs_integration.conn.get("close_on_recovery")
        );

        Ext.getCmp("connectionsNewFeedback").setValue(
            otrs_integration.conn.get("feedback")
        );

        Ext.getCmp("connectionsNewTicketOpenStates").setValue(
            otrs_integration.conn.get("open_states")
        );


        Ext.getCmp("saveButton").disable();
    }

});