/*
 * File: app/model/QualitorConnectionModel.js
 *
 * This file was generated by Sencha Architect version 3.5.1.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('qualitor_integration.model.QualitorConnectionModel', {
    extend: 'Ext.data.Model',

    requires: [
        'Ext.data.Field'
    ],

    idProperty: 'contact_name',

    fields: [
        {
            name: 'contact_name'
        },
        {
            name: 'url'
        },
        {
            name: 'user'
        },
        {
            name: 'password'
        },
        {
            name: 'company_id'
        },
        {
            name: 'severity_ok'
        },
        {
            name: 'severity_warning'
        },
        {
            name: 'severity_critical'
        },
        {
            name: 'severity_unknown'
        },
        {
            name: 'ic_location'
        },
        {
            name: 'ic_type'
        },
        {
            name: 'ticket_template'
        },
        {
            name: 'customer'
        },
        {
            name: 'customer_contact'
        },
        {
            name: 'customer_contact_id'
        },
        {
            name: 'close_on_recovery'
        },
        {
            name: 'team'
        },
        {
            name: 'feedback'
        },
        {
            name: 'version'
        },
        {
            name: 'followup_id'
        }
    ],

    test: function() {
        var me;

        Ext.getCmp("connectionsLogScreen").printLog("success", "Starting to test "+this.data.contact_name);

        me = this;

        Ext.Ajax.request({

            url: "/opmon/opcfg/qualitor/ws/",
            params: {
                action: "test_connection",
                contact_name: this.data.contact_name,
                host_name: "ci-test"
            },
            success: function(response) {

                var obj;
                var i;
                var msg;
                var msgtype;

                try {
                    obj = JSON.parse(response.responseText);
                    if (obj.response_status.status != 1) {
                        Ext.getCmp("connectionsLogScreen").printLog("critical", obj.response_status.msg);
                        Ext.getCmp("connectionsLogScreen").loadingLog(false);
                        return;
                    }

                    for(i=0; i<obj.response_data.length; i++) {

                        msg = obj.response_data[i];

                        switch(msg.status) {

                            case 0:
                                msgtype = "success";
                                break;

                            case 1:
                                msgtype = "warning";
                                break;

                            case 2:
                                msgtype = "critical";
                                break;

                            default:
                                msgtype = "unknown";

                        }

                        Ext.getCmp("connectionsLogScreen").printLog(msgtype, msg.msg);
                        Ext.getCmp("connectionsLogScreen").loadingLog(false);

                    }

                } catch(err) {
                        Ext.getCmp("connectionsLogScreen").printLog("critical", err.message);
                }



            },
            failure: function(response, options) {
                Ext.getCmp("connectionsLogScreen").printLog("critical", "Server response:");
                Ext.getCmp("connectionsLogScreen").printLog("critical", response.statusText);
                Ext.getCmp("connectionsLogScreen").loadingLog(false);
            }

        });
    },

    validate_url: function(callback) {
        Ext.Ajax.request({

            url: "/opmon/opcfg/qualitor/ws/",
            params: {
                action: "try_connect",
                url: this.get("url")
            },
            success: function(response) {

                var obj;

                try {

                    obj = JSON.parse(response.responseText);
                } catch(err) {
                    Ext.getCmp("connectionsLogScreen").printLog("critical", err.message);
                    return;
                }

                callback(obj);

            },
            failure: function(response) {
                Ext.getCmp("connectionsLogScreen").printLog("critical", "Server response:");
                Ext.getCmp("connectionsLogScreen").printLog("critical", response.statusText);
            }

        });


    },

    get_version: function(callback) {
        Ext.Ajax.request({
            url: "/opmon/opcfg/qualitor/ws/",
            params: {
                action: "get_version",
                url: this.get("url")
            },
            success: function(response) {

                try {
                    obj = JSON.parse(response.responseText);
                } catch(err) {
                    Ext.getCmp("connectionsLogScreen").printLog("critical", err.message);
                    return;
                }

                callback(obj);

            },
            failure: function(response) {
                Ext.getCmp("connectionsLogScreen").printLog("critical", "Server response:");
                Ext.getCmp("connectionsLogScreen").printLog("critical", response.statusText);
            }

        });
    },

    get_company: function(callback) {
        Ext.Ajax.request({
            url: "/opmon/opcfg/qualitor/ws/",
            params: {
                action: "get_company",
                url: this.get("url"),
                version: this.data.version
            },
            success: function(response) {

                try {
                    obj = JSON.parse(response.responseText);
                } catch(err) {
                    Ext.getCmp("connectionsLogScreen").printLog("critical", err.message);
                    return;
                }

                callback(obj);

            },
            failure: function(response) {
                Ext.getCmp("connectionsLogScreen").printLog("critical", "Server response:");
                Ext.getCmp("connectionsLogScreen").printLog("critical", response.statusText);
            }

        });
    },

    get_ticket_template: function(callback) {
        var params = this.data;
        params.action = "get_ticket_template";

        Ext.Ajax.request({
            url: "/opmon/opcfg/qualitor/ws/",
            params: params,
            success: function(response) {

                try {
                    obj = JSON.parse(response.responseText);
                } catch(err) {
                    Ext.getCmp("connectionsLogScreen").printLog("critical", err.message);
                    return;
                }

                callback(obj);

            },
            failure: function(response) {
                Ext.getCmp("connectionsLogScreen").printLog("critical", "Server response:");
                Ext.getCmp("connectionsLogScreen").printLog("critical", response.statusText);
            }

        });
    },

    get_customer: function(callback) {
        var params = this.data;
        params.action = "get_customer";

        Ext.Ajax.request({
            url: "/opmon/opcfg/qualitor/ws/",
            params: params,
            success: function(response) {

                try {
                    obj = JSON.parse(response.responseText);
                } catch(err) {
                    Ext.getCmp("connectionsLogScreen").printLog("critical", err.message);
                    return;
                }

                callback(obj);

            },
            failure: function(response) {
                Ext.getCmp("connectionsLogScreen").printLog("critical", "Server response:");
                Ext.getCmp("connectionsLogScreen").printLog("critical", response.statusText);
            }

        });
    },

    get_customer_contact: function(callback) {
        var params = this.data;
        params.action = "get_customer_contact";
        params.customer_contact = Ext.getCmp("connectionsNewContact").getValue();

        Ext.Ajax.timeout = 120000;
        Ext.Ajax.request({
            url: "/opmon/opcfg/qualitor/ws/",
            params: params,
            success: function(response) {

                try {
                    obj = JSON.parse(response.responseText);
                } catch(err) {
                    Ext.getCmp("connectionsLogScreen").printLog("critical", err.message);
                    return;
                }

                callback(obj);

            },
            failure: function(response) {
                Ext.getCmp("connectionsLogScreen").printLog("critical", "Server response:");
                Ext.getCmp("connectionsLogScreen").printLog("critical", response.statusText);
            }

        });
    },

    get_teams: function(callback) {
        var params = this.data;
        params.action = "get_teams";

        Ext.Ajax.request({
            url: "/opmon/opcfg/qualitor/ws/",
            params: params,
            success: function(response) {

                try {
                    obj = JSON.parse(response.responseText);
                } catch(err) {
                    Ext.getCmp("connectionsLogScreen").printLog("critical", err.message);
                    return;
                }

                callback(obj);

            },
            failure: function(response) {
                Ext.getCmp("connectionsLogScreen").printLog("critical", "Server response:");
                Ext.getCmp("connectionsLogScreen").printLog("critical", response.statusText);
            }

        });
    },

    get_severities: function(callback) {
        var params = this.data;
        params.action = "get_severities";

        Ext.Ajax.request({
            url: "/opmon/opcfg/qualitor/ws/",
            params: params,
            success: function(response) {

                try {
                    obj = JSON.parse(response.responseText);
                } catch(err) {
                    Ext.getCmp("connectionsLogScreen").printLog("critical", err.message);
                    return;
                }

                callback(obj);

            },
            failure: function(response) {
                Ext.getCmp("connectionsLogScreen").printLog("critical", "Server response:");
                Ext.getCmp("connectionsLogScreen").printLog("critical", response.statusText);
            }

        });
    },

    get_ic_locations: function(callback) {
        var params = this.data;
        params.action = "get_ic_locations";

        Ext.Ajax.request({
            url: "/opmon/opcfg/qualitor/ws/",
            params: params,
            success: function(response) {

                try {
                    obj = JSON.parse(response.responseText);
                } catch(err) {
                    Ext.getCmp("connectionsLogScreen").printLog("critical", err.message);
                    return;
                }

                callback(obj);

            },
            failure: function(response) {
                Ext.getCmp("connectionsLogScreen").printLog("critical", "Server response:");
                Ext.getCmp("connectionsLogScreen").printLog("critical", response.statusText);
            }

        });
    },

    get_ic_types: function(callback) {
        var params = this.data;
        params.action = "get_ic_types";

        Ext.Ajax.request({
            url: "/opmon/opcfg/qualitor/ws/",
            params: params,
            success: function(response) {

                try {
                    obj = JSON.parse(response.responseText);
                } catch(err) {
                    Ext.getCmp("connectionsLogScreen").printLog("critical", err.message);
                    return;
                }

                callback(obj);

            },
            failure: function(response) {
                Ext.getCmp("connectionsLogScreen").printLog("critical", "Server response:");
                Ext.getCmp("connectionsLogScreen").printLog("critical", response.statusText);
            }

        });
    },

    get_type_of_register: function(callback) {

        var params = this.data;
        params.action = "get_type_of_register";

        Ext.Ajax.request({
            url: "/opmon/opcfg/qualitor/ws/",
            params: params,
            success: function(response) {

                try {
                    obj = JSON.parse(response.responseText);
                } catch(err) {
                    Ext.getCmp("connectionsLogScreen").printLog("critical", err.message);
                    return;
                }

                callback(obj);

            },
            failure: function(response) {
                Ext.getCmp("connectionsLogScreen").printLog("critical", "Server response:");
                Ext.getCmp("connectionsLogScreen").printLog("critical", response.statusText);
            }

        });
    },

    save: function(n, callback) {
        var params = this.data;
        params.action = "crud";

        params.operation = "update";
        if (n) {
            params.operation = "new";
        }

        Ext.Ajax.request({
            url: "/opmon/opcfg/qualitor/ws/",
            params: params,
            success: function(response) {

                try {
                    obj = JSON.parse(response.responseText);
                } catch(err) {
                    Ext.getCmp("connectionsLogScreen").printLog("critical", err.message);
                    return;
                }

                callback(obj);

            },
            failure: function(response) {
                Ext.getCmp("connectionsLogScreen").printLog("critical", "Server response:");
                Ext.getCmp("connectionsLogScreen").printLog("critical", response.statusText);
            }

        });
    }

});