// SNMP JS functions

function startSnmpQuery(btn) {
	btn.disabled = true;
	var loading_msg = jQuery('#snmp_query_loading_msg');
	var box = jQuery('#snmp_query_result');

	box.show();
	box.html(loading_msg.html());

	var opt = new Object();
	opt.host = jQuery.parseJSON(jQuery('#host_obj').html());
	opt.method = jQuery('#snmp_method option:selected').val();
	
	var request = jQuery.ajax({
		url: "/opmon/opcfg/snmp.php?action=start_snmp_query",
		type: "POST",
		data: "opt=" + escape(JSON.stringify(opt)),
		timeout: 120000
	});
	request.done(function(msg) {
		jQuery('#snmp_query_result').html(msg);
		btn.disabled = false;
	});
	request.fail(function(jqXHR, textStatus) {
		alert("Connection timeout!");
		btn.disabled = false;
		box.hide();
	});
}

function addInputText(el,name) {
	
	var str = '';
	if (el.childNodes.length>1) {
		var text = el.childNodes[0].data;
		var img = el.childNodes[1];
		str = '<input type="text" name="interfaces[\'' + name + '\'][custom_ifDescr]" value="' + text + '">';
		el.innerHTML = str;
		el.appendChild(img);
	} else {
		str = '<input type="text" name="interfaces[\'' + name + '\'][custom_ifDescr]" value="' + el.innerHTML + '">';
		el.innerHTML = str;
	}
	
	// Remove event
	el.onclick = null;
}

function fixIfNames() {

	jQuery('.op-ifname').each(function(index, value) {
		this.value = changeCharCode(this.value);
	});

	return true;
}

function updateDescription(img,ifname,value,event) {
	
	var root = img.parentNode;
	root.innerHTML = value;
	
	var el = document.getElementsByName("interfaces['" + ifname + "'][ifDescr]")[0];
	el.value = value;
	
	// Stop event propagation
	if (!event)
		event = window.event;
	if (event.cancelBubble)
		event.cancelBubble = true;
	else
		event.stopPropagation();

	
}

function checkUncheckAll(btn) {
	
	var flag = false;
	if (btn.value == 'Check All') {
		flag = true;
		btn.value = 'Uncheck All';
	} else {
		btn.value = 'Check All';
	}
	jQuery('.op-check').each(function(index, value) {
		this.checked = flag;
	});

	return true;
}
