CREATE DATABASE IF NOT EXISTS `opcfg`;
USE `opcfg`;

--
-- Create language table
--
drop table languages;
CREATE TABLE `languages` (
  `lang` varchar(50),
  `idx` text,
  `value` text,
  KEY `lang_id` (`lang`)
) DEFAULT CHARSET=utf8;


INSERT INTO languages VALUES ("en_US", "Neoson informs", "Neoson informs");
INSERT INTO languages VALUES ("en_US", "Neoson has come back from the future to anticipate %s possible predictive alerts for the coming days. Click here to see more.", "Neoson has come back from the future to anticipate %s possible predictive alerts for the coming days. Click here to see more.");
INSERT INTO languages VALUES ("en_US", "Estimated value", "Estimated value");
INSERT INTO languages VALUES ("en_US", "Estimated date", "Estimated date");
INSERT INTO languages VALUES ("en_US", "Collection date", "Collection date");
INSERT INTO languages VALUES ("en_US", "Trend", "Trend");
INSERT INTO languages VALUES ("en_US", "Prediction", "Prediction");
INSERT INTO languages VALUES ("en_US", "Predictive analysis description", "This widget shows object that are about to break stablished thresholds in the next 30 days.<br><br>When represented by red it means that there are less than 7 days left to break the thresholds. Yellow means the alert is within the next 30 days.<br><br>Clicking on the object you’ll be taken to the capacity planning graphic with a predictive analysis based in the collected data of the host/service in the 4 months. In the capacity chart you can try different collected periods and future projections.<br><br>The goal of this functionality is to provide you with relevant informations to predict future problems, before they occur.");
INSERT INTO languages VALUES ("en_US", "Predictive analysis of future incidents", "Predictive analysis of future incidents");
INSERT INTO languages VALUES ("en_US", "Predictive Analysis", "Predictive Analysis");
INSERT INTO languages VALUES ("en_US", "Invalid Expiration Date/Time", "Invalid Expiration Date/Time");
INSERT INTO languages VALUES ("en_US", "Network outages", "Network outages");
INSERT INTO languages VALUES ("en_US", "Outages", "Outages");
INSERT INTO languages VALUES ("en_US", "Affected", "Affected");
INSERT INTO languages VALUES ("en_US", "Event log timeline", "Event log timeline");
INSERT INTO languages VALUES ("en_US", "Incidents last 24 hours", "Incidents last 24 hours");
INSERT INTO languages VALUES ("en_US", "System health", "System health");
INSERT INTO languages VALUES ("en_US", "Incidents per groups", "Incidents per groups");
INSERT INTO languages VALUES ("en_US", "Top 10 incidents", "Top 10 incidents");

INSERT INTO languages VALUES ("en_US", "ServiceRemoved", "Service has already been removed");
INSERT INTO languages VALUES ("en_US", "HostRemoved", "Host has already been removed");
INSERT INTO languages VALUES ("en_US", "Filter activated", "Filter enabled");
INSERT INTO languages VALUES ("en_US", "AdvancedFilterApplied", "Advanced filter applied");
INSERT INTO languages VALUES ("en_US", "Detailed view", "Detailed view");
INSERT INTO languages VALUES ("en_US", "Grouped by tag", "Grouped by tag");
INSERT INTO languages VALUES ("en_US", "devices and applications discovered", "devices and applications discovered");
INSERT INTO languages VALUES ("en_US", "Downtimes", "Downtime");
INSERT INTO languages VALUES ("en_US", "Select All ", "Select All");
INSERT INTO languages VALUES ("en_US", " If you need help click ", " For help click ");
INSERT INTO languages VALUES ("en_US", "%COUNT% probes found. Mark which you want to monitor with the OpMon Traffic Analyzer.", "%COUNT% probes found. Mark which you want to monitor with the OpMon Traffic Analyzer.");
INSERT INTO languages VALUES ("en_US", "%link%Click here%endlink% if you need help", "%link%Click here%endlink% if you need help");
INSERT INTO languages VALUES ("en_US", "%n% host(s) of %m% available", "%n% host(s) of %m% available");
INSERT INTO languages VALUES ("en_US", "%n% service(s) of %m% available", "%n% service(s) of %m% available");
INSERT INTO languages VALUES ("en_US", "%qtd%/%of% services have been retrieved successfully", "%qtd%/%of% services have been retrieved successfully");
INSERT INTO languages VALUES ("en_US", "(All)", "(All)");
INSERT INTO languages VALUES ("en_US", "(No shortcuts found)", "(No shortcuts)");
INSERT INTO languages VALUES ("en_US", "0", "Disabled");
INSERT INTO languages VALUES ("en_US", "1", "Enabled");
INSERT INTO languages VALUES ("en_US", "<h2 class=\'popup-title\' style=\'margin:0;\'>Some settings could not be applied.<br>Check below.</h2>", "<h2 class=\'popup-title\' style=\'margin:0;\'>Some settings could not be applied.<br>Check below.</h2>");
INSERT INTO languages VALUES ("en_US", "<strong> Algorithm </ strong> analysis", "<strong> Algorithm </ strong> analysis");
INSERT INTO languages VALUES ("en_US", "<strong>Lower</strong> limit of the confidence interval", "<strong>Lower</strong> limit of the confidence interval");
INSERT INTO languages VALUES ("en_US", "<strong>Upper</strong> limit of the confidence interval", "<strong>Upper</strong> limit of the confidence interval");
INSERT INTO languages VALUES ("en_US", "A new version of this package is available", "A new version of this package is available");
INSERT INTO languages VALUES ("en_US", "API returned the following error on service %servicename% of host %hostname%", "API returned the following error on service %servicename% of host %hostname%");
INSERT INTO languages VALUES ("en_US", "AVAIL", "Availability");
INSERT INTO languages VALUES ("en_US", "Absolute min/max", "Absolute min/max");
INSERT INTO languages VALUES ("en_US", "Access Denied", "Access Denied");
INSERT INTO languages VALUES ("en_US", "Access expired", "Your access has expired. Contact your administrator.");
INSERT INTO languages VALUES ("en_US", "Ack", "Ack");
INSERT INTO languages VALUES ("en_US", "Acknowledge this incident", "Acknowledge this incident");
INSERT INTO languages VALUES ("en_US", "Acknowledge", "Acknowledgement");
INSERT INTO languages VALUES ("en_US", "Acknowledged incidents", "Acknowledged incidents");
INSERT INTO languages VALUES ("en_US", "Acknowledged", "Acknowledged");
INSERT INTO languages VALUES ("en_US", "Acks AND downtimes", "Acks AND downtimes");
INSERT INTO languages VALUES ("en_US", "Acks OR downtimes", "Acks OR downtimes");
INSERT INTO languages VALUES ("en_US", "Acks", "Acks");
INSERT INTO languages VALUES ("en_US", "Action URL", "Action URL");
INSERT INTO languages VALUES ("en_US", "Actions", "Actions");
INSERT INTO languages VALUES ("en_US", "Active Downtimes", "Active Downtimes");
INSERT INTO languages VALUES ("en_US", "Active check", "Active check");
INSERT INTO languages VALUES ("en_US", "Active checks disabled", "Active checks disabled");
INSERT INTO languages VALUES ("en_US", "Active checks enabled", "Active checks enabled");
INSERT INTO languages VALUES ("en_US", "Active probes can not be removed", "Active probes can not be removed");
INSERT INTO languages VALUES ("en_US", "Active", "Active");
INSERT INTO languages VALUES ("en_US", "Add Command to Service", "Add Command to Service");
INSERT INTO languages VALUES ("en_US", "Add Command", "Add Command");
INSERT INTO languages VALUES ("en_US", "Add Host", "Add Host");
INSERT INTO languages VALUES ("en_US", "Add IP / Range to discovery", "Add IP / Range to discovery");
INSERT INTO languages VALUES ("en_US", "Add IP Range or the discovery", "Add IP Range or the discovery");
INSERT INTO languages VALUES ("en_US", "Add IP or network range that you want to discover", "Add IP or network range that you want to discover");
INSERT INTO languages VALUES ("en_US", "Add SNMP Community", "Add SNMP Community");
INSERT INTO languages VALUES ("en_US", "Add Teams to user", "Add contactgroups to contact");
INSERT INTO languages VALUES ("en_US", "Add a SLA breach reason", "Add a SLA breach reason");
INSERT INTO languages VALUES ("en_US", "Add a comment", "Add comment");
INSERT INTO languages VALUES ("en_US", "Add a new command to the list", "Add a new command to the list");
INSERT INTO languages VALUES ("en_US", "Add action to all Hosts", "Add action to all Hosts");
INSERT INTO languages VALUES ("en_US", "Add action to all Services", "Add action to all Services");
INSERT INTO languages VALUES ("en_US", "Add and configure network elements", "Add and configure network elements");
INSERT INTO languages VALUES ("en_US", "Add directory", "Add directory");
INSERT INTO languages VALUES ("en_US", "Add host manually", "Add host manually");
INSERT INTO languages VALUES ("en_US", "Add host", "Add host");
INSERT INTO languages VALUES ("en_US", "Add hots to a group", "Add hots to a group");
INSERT INTO languages VALUES ("en_US", "Add just one", "Add just one");
INSERT INTO languages VALUES ("en_US", "Add more communities", "Add more communities");
INSERT INTO languages VALUES ("en_US", "Add more than one", "Add more than one");
INSERT INTO languages VALUES ("en_US", "Add multiple hosts. Write as follow: ip,hostname,description. Write one host per line.", "Add multiple hosts. Write as follow: IP,hostname,description. Write one host per line.");
INSERT INTO languages VALUES ("en_US", "Add new Application Protocol", "Add new Application Protocol");
INSERT INTO languages VALUES ("en_US", "Add new host manually", "Add new host manually");
INSERT INTO languages VALUES ("en_US", "Add new metrics", "Add new metrics");
INSERT INTO languages VALUES ("en_US", "Add new package", "Add new package");
INSERT INTO languages VALUES ("en_US", "Add new template", "Add new template");
INSERT INTO languages VALUES ("en_US", "Add selected elements", "Add selected elements");
INSERT INTO languages VALUES ("en_US", "Add service", "Add service");
INSERT INTO languages VALUES ("en_US", "Add services to groups", "Add services to groups");
INSERT INTO languages VALUES ("en_US", "Add the current page to bookmark links", "Add the current page to bookmark links");
INSERT INTO languages VALUES ("en_US", "Add the current page to shortcut links", "Add the current page to shortcut links");
INSERT INTO languages VALUES ("en_US", "Add users to team", "Add contacts to contactgroup");
INSERT INTO languages VALUES ("en_US", "Add your first metric", "Add your first metric");
INSERT INTO languages VALUES ("en_US", "Add", "Add");
INSERT INTO languages VALUES ("en_US", "Adding Traffic Sources", "Adding Traffic Sources");
INSERT INTO languages VALUES ("en_US", "Additional Actions", "Additional Actions");
INSERT INTO languages VALUES ("en_US", "Additional Modules", "Additional&nbsp;Modules");
INSERT INTO languages VALUES ("en_US", "Additional Notes", "Additional Notes");
INSERT INTO languages VALUES ("en_US", "Address", "Address");
INSERT INTO languages VALUES ("en_US", "Administrator", "Administrator");
INSERT INTO languages VALUES ("en_US", "Advanced Options", "Advanced Options");
INSERT INTO languages VALUES ("en_US", "Advanced Search", "Advanced search");
INSERT INTO languages VALUES ("en_US", "Advanced Service Level Agreement Report", "Advanced Service Level Agreement Report");
INSERT INTO languages VALUES ("en_US", "Advanced commands", "Advanced commands");
INSERT INTO languages VALUES ("en_US", "Advanced options", "Advanced options");
INSERT INTO languages VALUES ("en_US", "Advanced", "Avanced");
INSERT INTO languages VALUES ("en_US", "Affected services", "Affected service catalogs");
INSERT INTO languages VALUES ("en_US", "Alarm operation", "Alarm operation");
INSERT INTO languages VALUES ("en_US", "Alarm when", "Alarm when");
INSERT INTO languages VALUES ("en_US", "Alert history", "Alert history");
INSERT INTO languages VALUES ("en_US", "Alert", "Alert");
INSERT INTO languages VALUES ("en_US", "Alerts Summary", "Alerts Summary");
INSERT INTO languages VALUES ("en_US", "Alerts", "Alerts");
INSERT INTO languages VALUES ("en_US", "Alias", "Alias");
INSERT INTO languages VALUES ("en_US", "All May View", "Any user can view the report");
INSERT INTO languages VALUES ("en_US", "All categories", "All categories");
INSERT INTO languages VALUES ("en_US", "All hosts must contain at least one user or team responsible", "All hosts must contain at least one contact or contactgroup responsible");
INSERT INTO languages VALUES ("en_US", "All may view", "All may view");
INSERT INTO languages VALUES ("en_US", "All models", "All models");
INSERT INTO languages VALUES ("en_US", "All ready", "All ready");
INSERT INTO languages VALUES ("en_US", "All rights reserved", "All rights reserved");
INSERT INTO languages VALUES ("en_US", "All services must contain at least one user or team responsible", "All services must contain at least contact or contactgroup responsible");
INSERT INTO languages VALUES ("en_US", "All", "All");
INSERT INTO languages VALUES ("en_US", "Already created", "Already created");
INSERT INTO languages VALUES ("en_US", "Already exists", "Already exists");
INSERT INTO languages VALUES ("en_US", "Already monitored items will not appear as discovered elements", "Already monitored items will not appear as discovered elements");
INSERT INTO languages VALUES ("en_US", "Already selected", "Already selected");
INSERT INTO languages VALUES ("en_US", "An unexpected error occured during Timecut save process", "An unexpected error occured during Timecut save process");
INSERT INTO languages VALUES ("en_US", "An unexpected error occured retrieving Timecut", "An unexpected error occured retrieving Timecut");
INSERT INTO languages VALUES ("en_US", "AndRelatedAcknowledgements", "This action will remove the acknowledgment");
INSERT INTO languages VALUES ("en_US", "Any probes weren't found. Try again.", "Any probes weren't found. Try again.");
INSERT INTO languages VALUES ("en_US", "Application protocols registry", "Application protocols registry");
INSERT INTO languages VALUES ("en_US", "Application protocols", "Application protocols");
INSERT INTO languages VALUES ("en_US", "Application", "Application");
INSERT INTO languages VALUES ("en_US", "Apply Model", "Apply Model");
INSERT INTO languages VALUES ("en_US", "Apply Settings", "Apply Settings");
INSERT INTO languages VALUES ("en_US", "Apply command to the service", "Apply command to the service");
INSERT INTO languages VALUES ("en_US", "Apply command", "Apply command");
INSERT INTO languages VALUES ("en_US", "Apply selected model", "Apply selected model");
INSERT INTO languages VALUES ("en_US", "Apply service to hosts", "Apply service to hosts");
INSERT INTO languages VALUES ("en_US", "Apply templates to selected hosts", "Apply templates to selected hosts");
INSERT INTO languages VALUES ("en_US", "Apply the topology to OpMon", "Apply the topology to OpMon");
INSERT INTO languages VALUES ("en_US", "Apply to all hosts", "Apply to all hosts");
INSERT INTO languages VALUES ("en_US", "Apply to all services", "Apply to all services");
INSERT INTO languages VALUES ("en_US", "Apply to all", "Apply to all");
INSERT INTO languages VALUES ("en_US", "Apply to child hosts", "Apply to child Hosts");
INSERT INTO languages VALUES ("en_US", "Apply to host", "Apply to Host");
INSERT INTO languages VALUES ("en_US", "Apply topology", "Apply topology");
INSERT INTO languages VALUES ("en_US", "Apply", "Apply");
INSERT INTO languages VALUES ("en_US", "Applying new configuration", "Applying new configuration");
INSERT INTO languages VALUES ("en_US", "Applying topology to OpMon and Complete", "Applying topology to OpMon and Complete");
INSERT INTO languages VALUES ("en_US", "Apr", "Apr");
INSERT INTO languages VALUES ("en_US", "April", "April");
INSERT INTO languages VALUES ("en_US", "Are you ready to visualize all your network flow?", "Are you ready to visualize all your network flow?");
INSERT INTO languages VALUES ("en_US", "Are you sure do you want to uninstall this package? All services using it are going to be removed.", "Are you sure do you want to uninstall this package? All services using it are going to be removed.");
INSERT INTO languages VALUES ("en_US", "Are you sure you want to remove this comment?", "Are you sure you want to remove this comment?");
INSERT INTO languages VALUES ("en_US", "Are you sure you want to run the selected command?", "Are you sure you want to run the selected command?");
INSERT INTO languages VALUES ("en_US", "Assignment", "Assignment");
INSERT INTO languages VALUES ("en_US", "Associated Baseline", "Associated Baseline");
INSERT INTO languages VALUES ("en_US", "Attempts", "Attempts");
INSERT INTO languages VALUES ("en_US", "Aug", "Aug");
INSERT INTO languages VALUES ("en_US", "August", "August");
INSERT INTO languages VALUES ("en_US", "Authentication Mode", "Authentication Mode");
INSERT INTO languages VALUES ("en_US", "Authentication name", "Authentication name");
INSERT INTO languages VALUES ("en_US", "Authentication", "Authentication");
INSERT INTO languages VALUES ("en_US", "Author", "Author");
INSERT INTO languages VALUES ("en_US", "Auto discovery disabled", "Auto discovery disabled");
INSERT INTO languages VALUES ("en_US", "Auto discovery enabled", "Auto discovery enabled");
INSERT INTO languages VALUES ("en_US", "Auto scale", "Auto scale");
INSERT INTO languages VALUES ("en_US", "Auto-Discovery finished! (see log below)", "Auto-Discovery finished! (see log below)");
INSERT INTO languages VALUES ("en_US", "Auto-Discovery finished!", "Auto-Discovery finished!");
INSERT INTO languages VALUES ("en_US", "Auto-Discovery started!", "Auto-Discovery started!");
INSERT INTO languages VALUES ("en_US", "Auto-Discovery", "Auto-Discovery");
INSERT INTO languages VALUES ("en_US", "AutoDiscoveryDescription", "If you have just installed OpMon, you can use this tool to easily discover devices in your network. It's the easiest way to get started.");
INSERT INTO languages VALUES ("en_US", "AutoDiscoveryMsg", "Put your network information below to perform an automatic scan. All discovered devices will be imported. This process can take some time.");
INSERT INTO languages VALUES ("en_US", "Autodiscovery enabled", "Autodiscovery enabled");
INSERT INTO languages VALUES ("en_US", "Autoscale", "Autoscale");
INSERT INTO languages VALUES ("en_US", "Availability Report", "Availability Report");
INSERT INTO languages VALUES ("en_US", "Availability for CI", "Availability for Host");
INSERT INTO languages VALUES ("en_US", "Availability for service", "Availability for service");
INSERT INTO languages VALUES ("en_US", "Availability", "Availability");
INSERT INTO languages VALUES ("en_US", "Available Dashboards", "Available Dashboards");
INSERT INTO languages VALUES ("en_US", "Available Hosts", "Available Hosts");
INSERT INTO languages VALUES ("en_US", "Available Services", "Available Services");
INSERT INTO languages VALUES ("en_US", "Available objects", "Available objects");
INSERT INTO languages VALUES ("en_US", "Available", "Available");
INSERT INTO languages VALUES ("en_US", "Average", "Average");
INSERT INTO languages VALUES ("en_US", "Avg", "Avg");
INSERT INTO languages VALUES ("en_US", "Back to Settings", "Back to Settings");
INSERT INTO languages VALUES ("en_US", "Back to the default", "Back to the default");
INSERT INTO languages VALUES ("en_US", "Back to the discovered elements", "Back to the discovered elements");
INSERT INTO languages VALUES ("en_US", "Back to the list", "Back to the list");
INSERT INTO languages VALUES ("en_US", "Back", "Back");
INSERT INTO languages VALUES ("en_US", "Backup settings", "Backup settings");
INSERT INTO languages VALUES ("en_US", "Baseline Name", "Baseline Name");
INSERT INTO languages VALUES ("en_US", "Baseline can not be deleted", "Baseline can not be deleted");
INSERT INTO languages VALUES ("en_US", "Baseline down", "Baseline down");
INSERT INTO languages VALUES ("en_US", "Baseline up", "Baseline up");
INSERT INTO languages VALUES ("en_US", "Baselines registered", "Baselines List");
INSERT INTO languages VALUES ("en_US", "Before you start", "Before you start");
INSERT INTO languages VALUES ("en_US", "Behavior of the baseline", "Behavior of the baseline");
INSERT INTO languages VALUES ("en_US", "Behavioral simulation", "Behavioral simulation");
INSERT INTO languages VALUES ("en_US", "Bookmark already exists", "Bookmark already exists!");
INSERT INTO languages VALUES ("en_US", "Bookmarks", "Bookmarks");
INSERT INTO languages VALUES ("en_US", "Broadcast", "Broadcast");
INSERT INTO languages VALUES ("en_US", "Business Accountable", "Business Accountable");
INSERT INTO languages VALUES ("en_US", "Business Impact Analysis (BIA)", "Business&nbsp;Impact&nbsp;Analysis&nbsp;(BIA)");
INSERT INTO languages VALUES ("en_US", "Business", "Business");
INSERT INTO languages VALUES ("en_US", "Buy Traffic Analyzer Link", "http://www.opservices.com/comercializacao-opmon-traffic-analyzer");
INSERT INTO languages VALUES ("en_US", "By group", "By group");
INSERT INTO languages VALUES ("en_US", "CI Metrics Group", "Host Metrics Group");
INSERT INTO languages VALUES ("en_US", "CI's Attributes Groups", "Service Groups");
INSERT INTO languages VALUES ("en_US", "CI's Attributes", "Services");
INSERT INTO languages VALUES ("en_US", "CIs Groups", "Host Groups");
INSERT INTO languages VALUES ("en_US", "CIs Metrics", "Hosts Metrics");
INSERT INTO languages VALUES ("en_US", "CIs", "Hosts");
INSERT INTO languages VALUES ("en_US", "CMDB", "CMDB");
INSERT INTO languages VALUES ("en_US", "CP", "Capacity Planning");
INSERT INTO languages VALUES ("en_US", "CRITICAL", "CRITICAL");
INSERT INTO languages VALUES ("en_US", "Calculed", "Calculated");
INSERT INTO languages VALUES ("en_US", "Calendar Overview", "Calendar Overview");
INSERT INTO languages VALUES ("en_US", "Calendar settings", "Calendar settings");
INSERT INTO languages VALUES ("en_US", "Cancel and go to management", "Cancel and go to management");
INSERT INTO languages VALUES ("en_US", "Cancel process", "Cancel process");
INSERT INTO languages VALUES ("en_US", "Cancel setup", "Cancel setup");
INSERT INTO languages VALUES ("en_US", "Cancel the process and go to management", "Cancel the process and go to management");
INSERT INTO languages VALUES ("en_US", "Cancel", "Cancel");
INSERT INTO languages VALUES ("en_US", "Cant write license file", "Can't write license file.");
INSERT INTO languages VALUES ("en_US", "Capacity", "Capacity");
INSERT INTO languages VALUES ("en_US", "Capacity/Performance", "Capacity/Performance");
INSERT INTO languages VALUES ("en_US", "Catalogs", "Catalogs");
INSERT INTO languages VALUES ("en_US", "Category", "Category");
INSERT INTO languages VALUES ("en_US", "Caution", "Caution");
INSERT INTO languages VALUES ("en_US", "Change Teams and Team members", "Change contacts and contactgroups");
INSERT INTO languages VALUES ("en_US", "Change password", "Change password");
INSERT INTO languages VALUES ("en_US", "Change ports", "Change ports");
INSERT INTO languages VALUES ("en_US", "Change theme", "Change theme");
INSERT INTO languages VALUES ("en_US", "Change to default and continue", "Change to default and continue");
INSERT INTO languages VALUES ("en_US", "Change", "Change");
INSERT INTO languages VALUES ("en_US", "ChangePasswordText", "To change your password,<br> enter in contact with your Administrator.");
INSERT INTO languages VALUES ("en_US", "Changes in baseline [name of baseline] were not saved.", "Changes in baseline [name of baseline] were not saved.");
INSERT INTO languages VALUES ("en_US", "Changes saved successfully", "Changes saved successfully");
INSERT INTO languages VALUES ("en_US", "Check Interval", "Check Interval");
INSERT INTO languages VALUES ("en_US", "Check Period", "Check Period");
INSERT INTO languages VALUES ("en_US", "Check command", "Check command");
INSERT INTO languages VALUES ("en_US", "Check duration", "Check duration");
INSERT INTO languages VALUES ("en_US", "Check output", "Check output");
INSERT INTO languages VALUES ("en_US", "Check result", "Check result");
INSERT INTO languages VALUES ("en_US", "Check the environment settings", "Check the environment settings");
INSERT INTO languages VALUES ("en_US", "Check time", "Check time");
INSERT INTO languages VALUES ("en_US", "Check type", "Check type");
INSERT INTO languages VALUES ("en_US", "Check your license.", "Check your license.");
INSERT INTO languages VALUES ("en_US", "Check", "Check");
INSERT INTO languages VALUES ("en_US", "Checking Period", "Checking Period");
INSERT INTO languages VALUES ("en_US", "Checking if the port is available...", "Checking if the port is available...");
INSERT INTO languages VALUES ("en_US", "Checks", "Checks");
INSERT INTO languages VALUES ("en_US", "Child hosts", "Child Hosts");
INSERT INTO languages VALUES ("en_US", "Choose OpMon color theme", "Choose OpMon color theme");
INSERT INTO languages VALUES ("en_US", "Choose a metric", "Choose a metric");
INSERT INTO languages VALUES ("en_US", "Choose a monitoring model", "Choose a monitoring model");
INSERT INTO languages VALUES ("en_US", "Clean Filter", "Clean Filter");
INSERT INTO languages VALUES ("en_US", "Clear Field", "Clear Field");
INSERT INTO languages VALUES ("en_US", "Click here to purchase a license now", "Click here to purchase a license now");
INSERT INTO languages VALUES ("en_US", "Click in the cel you want to edit", "Click in the cel you want to edit");
INSERT INTO languages VALUES ("en_US", "Click to see the element details", "Click to see the element details");
INSERT INTO languages VALUES ("en_US", "Clone", "Clone");
INSERT INTO languages VALUES ("en_US", "Close advanced search", "Close advanced search");
INSERT INTO languages VALUES ("en_US", "Close details", "Close details");
INSERT INTO languages VALUES ("en_US", "Close", "Close");
INSERT INTO languages VALUES ("en_US", "Color", "Color");
INSERT INTO languages VALUES ("en_US", "Colors - State configuration", "Colors - State configuration");
INSERT INTO languages VALUES ("en_US", "Command Line", "Command Line");
INSERT INTO languages VALUES ("en_US", "Command executed", "Command executed");
INSERT INTO languages VALUES ("en_US", "Command list", "Command list");
INSERT INTO languages VALUES ("en_US", "Command name must have at last 2 caracters.", "Command name must have at last 2 caracters.");
INSERT INTO languages VALUES ("en_US", "Command submitted successfully", "Command submitted successfully!");
INSERT INTO languages VALUES ("en_US", "Command", "Command");
INSERT INTO languages VALUES ("en_US", "Commands", "Commands");
INSERT INTO languages VALUES ("en_US", "Comment", "Comment");
INSERT INTO languages VALUES ("en_US", "Comments Totals", "Comments Totals");
INSERT INTO languages VALUES ("en_US", "Comments", "Comments");
INSERT INTO languages VALUES ("en_US", "Common Users", "Common Users");
INSERT INTO languages VALUES ("en_US", "Communities added", "Communities added");
INSERT INTO languages VALUES ("en_US", "Community Awareness Message", "Set up here SNMP communities that you use in your network, it will allow Discovery to monitor more data on the servers.");
INSERT INTO languages VALUES ("en_US", "Community", "Community");
INSERT INTO languages VALUES ("en_US", "Compared with the days", "Compared with the days");
INSERT INTO languages VALUES ("en_US", "Comparison period", "Comparison period");
INSERT INTO languages VALUES ("en_US", "Complete the setup for me", "Complete the setup for me");
INSERT INTO languages VALUES ("en_US", "Complete", "Complete");
INSERT INTO languages VALUES ("en_US", "Completed", "Completed");
INSERT INTO languages VALUES ("en_US", "Components", "Components");
INSERT INTO languages VALUES ("en_US", "Configuration Items", "Configuration Items");
INSERT INTO languages VALUES ("en_US", "Configuration exported!", "Configuration exported!");
INSERT INTO languages VALUES ("en_US", "Configuration of application protocols performed successfully", "Configuration of application protocols performed successfully");
INSERT INTO languages VALUES ("en_US", "Configuration", "Configuration");
INSERT INTO languages VALUES ("en_US", "ConfigurationDescription", "This option will allow you to manually configure new devices.");
INSERT INTO languages VALUES ("en_US", "Configurations", "Configurations");
INSERT INTO languages VALUES ("en_US", "Configure E-mail Server", "Configure E-mail Server");
INSERT INTO languages VALUES ("en_US", "Configure OpMon", "Configure OpMon");
INSERT INTO languages VALUES ("en_US", "Configure Traffic Analyzer", "Configure Traffic Analyzer");
INSERT INTO languages VALUES ("en_US", "Configure model settings", "Configure model settings");
INSERT INTO languages VALUES ("en_US", "Configure selected elements", "Configure selected elements");
INSERT INTO languages VALUES ("en_US", "Configure selected items", "Configure selected items");
INSERT INTO languages VALUES ("en_US", "Configure the IP and port of the OpMon Traffic Analyzer", "Configure the IP and port of the OpMon Traffic Analyzer");
INSERT INTO languages VALUES ("en_US", "Configure the Report", "Configure the report");
INSERT INTO languages VALUES ("en_US", "Configure the data below to finish installation or %link%click here%endlink% if you need help", "Configure the data below to finish installation or %link%click here%endlink% if you need help");
INSERT INTO languages VALUES ("en_US", "Configuring Network", "Configuring Network");
INSERT INTO languages VALUES ("en_US", "Configuring application", "Configuring application");
INSERT INTO languages VALUES ("en_US", "Configuring hosts", "Configuring hosts");
INSERT INTO languages VALUES ("en_US", "Configuring user", "Configuring user");
INSERT INTO languages VALUES ("en_US", "Configuring", "Configuring");
INSERT INTO languages VALUES ("en_US", "Confirm change", "Confirm change");
INSERT INTO languages VALUES ("en_US", "Confirm command execution", "Confirm command execution");
INSERT INTO languages VALUES ("en_US", "Confirm command execution?", "Confirm command execution?");
INSERT INTO languages VALUES ("en_US", "Confirm delete?", "Confirm delete?");
INSERT INTO languages VALUES ("en_US", "Confirm password", "Confirm password");
INSERT INTO languages VALUES ("en_US", "Confirm", "Confirm");
INSERT INTO languages VALUES ("en_US", "Confirmation", "Confirmation");
INSERT INTO languages VALUES ("en_US", "Conflict resolved", "Conflict resolved");
INSERT INTO languages VALUES ("en_US", "Connection Error", "Connection Error");
INSERT INTO languages VALUES ("en_US", "Contact name", "Contact name");
INSERT INTO languages VALUES ("en_US", "Contact", "Contact");
INSERT INTO languages VALUES ("en_US", "Contactgroup", "Contactgroup");
INSERT INTO languages VALUES ("en_US", "Contactgroups and Contacts", "Contactgroups and Contacts");
INSERT INTO languages VALUES ("en_US", "Contactgroups", "Contactgroups");
INSERT INTO languages VALUES ("en_US", "Contacts", "Contacts");
INSERT INTO languages VALUES ("en_US", "Contacts/Users", "Contacts/Users");
INSERT INTO languages VALUES ("en_US", "Containers", "Containers");
INSERT INTO languages VALUES ("en_US", "Context", "Context");
INSERT INTO languages VALUES ("en_US", "Continent / Country", "Continent/Country");
INSERT INTO languages VALUES ("en_US", "Copyright", "Copyright");
INSERT INTO languages VALUES ("en_US", "Correct Syntax: hostname,adddress,description", "Correct Syntax: hostname,adddress,description");
INSERT INTO languages VALUES ("en_US", "Corrupted license", "Corrupted license");
INSERT INTO languages VALUES ("en_US", "Could not create shortcut because it exists already", "Could not create shortcut because it exists already");
INSERT INTO languages VALUES ("en_US", "Could not get any data from the host. Make sure your global settings are correct.", "Could not get any data from the host. Make sure your global settings are correct.");
INSERT INTO languages VALUES ("en_US", "Could not get any data from the selected hosts. Make sure your global settings are correct.", "Could not get any data from the selected hosts. Make sure your global settings are correct.");
INSERT INTO languages VALUES ("en_US", "Create Host Groups", "Create Host Groups");
INSERT INTO languages VALUES ("en_US", "Create Service Groups", "Create Service Groups");
INSERT INTO languages VALUES ("en_US", "Create a service manually", "Create a service manually");
INSERT INTO languages VALUES ("en_US", "Create new Authentication", "Create new Authentication");
INSERT INTO languages VALUES ("en_US", "Create new SNMP Community", "Create new SNMP Community");
INSERT INTO languages VALUES ("en_US", "Create new baseline", "Create new baseline");
INSERT INTO languages VALUES ("en_US", "Create new host", "Create new host");
INSERT INTO languages VALUES ("en_US", "Create new hosts", "Create new hosts");
INSERT INTO languages VALUES ("en_US", "Create new report", "Create new report");
INSERT INTO languages VALUES ("en_US", "Create new", "Create new");
INSERT INTO languages VALUES ("en_US", "Create service", "Create service");
INSERT INTO languages VALUES ("en_US", "Created in", "Created in");
INSERT INTO languages VALUES ("en_US", "Creation date", "Creation date");
INSERT INTO languages VALUES ("en_US", "Critical", "Critical");
INSERT INTO languages VALUES ("en_US", "Current attempt", "Current attempt");
INSERT INTO languages VALUES ("en_US", "Current logo", "Current logo");
INSERT INTO languages VALUES ("en_US", "Custom map", "Custom map");
INSERT INTO languages VALUES ("en_US", "Custom period", "Custom period");
INSERT INTO languages VALUES ("en_US", "Custom", "Custom");
INSERT INTO languages VALUES ("en_US", "Customize alarm for this day", "Customize alarm for this day");
INSERT INTO languages VALUES ("en_US", "DATABASECONNECTION", "Database Connection");
INSERT INTO languages VALUES ("en_US", "DNS", "DNS");
INSERT INTO languages VALUES ("en_US", "DOWN", "DOWN");
INSERT INTO languages VALUES ("en_US", "Daily", "Daily");
INSERT INTO languages VALUES ("en_US", "Dashboards", "Dashboards");
INSERT INTO languages VALUES ("en_US", "Database connection problem", "Database connection problem!");
INSERT INTO languages VALUES ("en_US", "Date and Time Settings", "Date and Time Settings");
INSERT INTO languages VALUES ("en_US", "Date and time", "Date and time");
INSERT INTO languages VALUES ("en_US", "Date", "Date");
INSERT INTO languages VALUES ("en_US", "Date/Time", "Date/Time");
INSERT INTO languages VALUES ("en_US", "Day", "Day");
INSERT INTO languages VALUES ("en_US", "Days", "Days");
INSERT INTO languages VALUES ("en_US", "Dear", "Dear");
INSERT INTO languages VALUES ("en_US", "Dec", "Dec");
INSERT INTO languages VALUES ("en_US", "December", "December");
INSERT INTO languages VALUES ("en_US", "Default", "Default");
INSERT INTO languages VALUES ("en_US", "Define Output", "Define output");
INSERT INTO languages VALUES ("en_US", "Define basic parameters of selected hosts", "Define basic parameters of selected hosts");
INSERT INTO languages VALUES ("en_US", "Define host check commmand and values", "Define host check commmand and values");
INSERT INTO languages VALUES ("en_US", "Define the authentication mode", "Define the authentication mode");
INSERT INTO languages VALUES ("en_US", "Define the report format", "Define the report format");
INSERT INTO languages VALUES ("en_US", "Defined", "Defined");
INSERT INTO languages VALUES ("en_US", "Delete baseline", "Delete baseline");
INSERT INTO languages VALUES ("en_US", "Delete selected", "Delete selected");
INSERT INTO languages VALUES ("en_US", "Delete the custom report", "Delete the custom report");
INSERT INTO languages VALUES ("en_US", "Delete this report", "Delete this report");
INSERT INTO languages VALUES ("en_US", "Description of baseline", "Description of baseline");
INSERT INTO languages VALUES ("en_US", "Description", "Description");
INSERT INTO languages VALUES ("en_US", "Destination", "Destination");
INSERT INTO languages VALUES ("en_US", "Detailed", "Detailed");
INSERT INTO languages VALUES ("en_US", "Details of", "Details of");
INSERT INTO languages VALUES ("en_US", "Details", "Details");
INSERT INTO languages VALUES ("en_US", "Different passwords", "Different passwords");
INSERT INTO languages VALUES ("en_US", "Disable active checks for all services", "Disable active checks for all Services");
INSERT INTO languages VALUES ("en_US", "Disable checks for all services", "Disable checks for all Services");
INSERT INTO languages VALUES ("en_US", "Disable checks", "Disable checks");
INSERT INTO languages VALUES ("en_US", "Disable notifications for all hosts", "Disable notifications for all Hosts");
INSERT INTO languages VALUES ("en_US", "Disable notifications for all services", "Disable notifications for all Services");
INSERT INTO languages VALUES ("en_US", "Disable notifications", "Disable notifications");
INSERT INTO languages VALUES ("en_US", "Disabled", "Disabled");
INSERT INTO languages VALUES ("en_US", "Disableda", "Disabled");
INSERT INTO languages VALUES ("en_US", "Disassociate the metrics to be able to delete the baseline.", "Disassociate the metrics to be able to delete the baseline.");
INSERT INTO languages VALUES ("en_US", "Disassociate this metric", "Disassociate this metric");
INSERT INTO languages VALUES ("en_US", "Discard", "Discard");
INSERT INTO languages VALUES ("en_US", "Discarded packets", "Discarded packets");
INSERT INTO languages VALUES ("en_US", "Discover and IP Ranges", "Discover and IP Ranges");
INSERT INTO languages VALUES ("en_US", "Discover elements", "Discover elements");
INSERT INTO languages VALUES ("en_US", "Discovered Device", "Discovered Device");
INSERT INTO languages VALUES ("en_US", "devices discovered", "devices discovered");
INSERT INTO languages VALUES ("en_US", "Discovering network elements", "Discovering network elements");
INSERT INTO languages VALUES ("en_US", "Discovery Awareness Message", "Network discovery of elements try to locate hosts through open ports and by responses to the SNMP protocol on target servers. Often this kind of scan (search for open ports) may be detected by an IDS as an intrusion attempt, therefore, we reccomend to always talk with your network administrator before run the discovery.");
INSERT INTO languages VALUES ("en_US", "Discovery Configuration", "Discovery Configuration");
INSERT INTO languages VALUES ("en_US", "Discovery Status", "Discovery Status");
INSERT INTO languages VALUES ("en_US", "Discovery result", "Discovery result");
INSERT INTO languages VALUES ("en_US", "Discovery running", "Discovery running");
INSERT INTO languages VALUES ("en_US", "Discovery", "Discovery");
INSERT INTO languages VALUES ("en_US", "Display the discovered elements by OpMon", "Display the discovered elements by OpMon");
INSERT INTO languages VALUES ("en_US", "Display the topology of the monitored elements", "Display the topology of the monitored elements");
INSERT INTO languages VALUES ("en_US", "Displaying", "Displaying");
INSERT INTO languages VALUES ("en_US", "Do not monitor", "Do not monitor");
INSERT INTO languages VALUES ("en_US", "Do not select service", "Do not select service");
INSERT INTO languages VALUES ("en_US", "Do nothing", "Do nothing");
INSERT INTO languages VALUES ("en_US", "Do you really want to apply all the changes ?", "Do you really want to apply all the changes ?");
INSERT INTO languages VALUES ("en_US", "Do you really want to cancel it?", "Do you really want to cancel it?");
INSERT INTO languages VALUES ("en_US", "Do you really want to cancel the setup process", "Do you really want to cancel the setup process");
INSERT INTO languages VALUES ("en_US", "Do you really want to not monitor this service?", "Do you really want to not monitor this service?");
INSERT INTO languages VALUES ("en_US", "Do you really want to remove it?", "Do you really want to remove it?");
INSERT INTO languages VALUES ("en_US", "Do you want to cancel the process of adding / editing ?", "Do you want to cancel the process of adding / editing ?");
INSERT INTO languages VALUES ("en_US", "Do you want to remove the port", "Do you want to remove the port");
INSERT INTO languages VALUES ("en_US", "Do you want to remove the probe", "Do you want to remove the probe");
INSERT INTO languages VALUES ("en_US", "Do you want to select this service?", "Do you want to select this service?");
INSERT INTO languages VALUES ("en_US", "Documentation", "Documentation");
INSERT INTO languages VALUES ("en_US", "DocumentationDescription", "You can access our Wiki where many resources are available to help you including a knowledge base, service plugins, videos and tutorials.");
INSERT INTO languages VALUES ("en_US", "Documentations", "Documentations");
INSERT INTO languages VALUES ("en_US", "Don't show again", "Don't show again");
INSERT INTO languages VALUES ("en_US", "Don't show this window again", "Don't show this window again");
INSERT INTO languages VALUES ("en_US", "Double-click to add to selection", "Double-click to add to selection");
INSERT INTO languages VALUES ("en_US", "Double-click to edit", "Double-click to edit");
INSERT INTO languages VALUES ("en_US", "Double-click to remove the item of selection", "Double-click to remove the item of selection");
INSERT INTO languages VALUES ("en_US", "Down time", "Down time");
INSERT INTO languages VALUES ("en_US", "Down", "Down");
INSERT INTO languages VALUES ("en_US", "Download the custom report", "Download the custom report");
INSERT INTO languages VALUES ("en_US", "Downtime Totals", "Downtime Totals");
INSERT INTO languages VALUES ("en_US", "Downtimes", "Downtime");
INSERT INTO languages VALUES ("en_US", "Downtimes between dates", "Downtimes between dates");
INSERT INTO languages VALUES ("en_US", "Duplicate host", "Duplicate host");
INSERT INTO languages VALUES ("en_US", "Duplicate service", "Duplicate service");
INSERT INTO languages VALUES ("en_US", "Duration", "Duration");
INSERT INTO languages VALUES ("en_US", "E-mail could not be sent", "E-mail could not be sent");
INSERT INTO languages VALUES ("en_US", "E-mail notifications from to", "E-mail notifications from to");
INSERT INTO languages VALUES ("en_US", "E-mail server settings", "E-mail server settings");
INSERT INTO languages VALUES ("en_US", "E-mail settings", "E-mail settings");
INSERT INTO languages VALUES ("en_US", "E-mail", "E-mail");
INSERT INTO languages VALUES ("en_US", "E-mails dont match", "E-mails dont match");
INSERT INTO languages VALUES ("en_US", "EVENTGUARD", "EventGuard");
INSERT INTO languages VALUES ("en_US", "EXTERNALAUTH", "External Authentication");
INSERT INTO languages VALUES ("en_US", "EXTERNALCOMMANDS", "External Commands");
INSERT INTO languages VALUES ("en_US", "Edit Host Groups", "Edit Host Groups");
INSERT INTO languages VALUES ("en_US", "Edit Service Groups", "Edit Service Groups");
INSERT INTO languages VALUES ("en_US", "Edit Teams and Team Members", "Edit contactgroups and contacts");
INSERT INTO languages VALUES ("en_US", "Edit Templates", "Edit Templates");
INSERT INTO languages VALUES ("en_US", "Edit associated metrics", "Edit associated metrics");
INSERT INTO languages VALUES ("en_US", "Edit baseline", "Edit baseline");
INSERT INTO languages VALUES ("en_US", "Edit before duplicating", "Edit before duplicating");
INSERT INTO languages VALUES ("en_US", "Edit bookmark links", "Edit bookmark links");
INSERT INTO languages VALUES ("en_US", "Edit check command", "Edit check command");
INSERT INTO languages VALUES ("en_US", "Edit checks", "Edit checks");
INSERT INTO languages VALUES ("en_US", "Edit description", "Edit description");
INSERT INTO languages VALUES ("en_US", "Edit extended information", "Edit extended information");
INSERT INTO languages VALUES ("en_US", "Edit host groups", "Edit host groups");
INSERT INTO languages VALUES ("en_US", "Edit host", "Edit host");
INSERT INTO languages VALUES ("en_US", "Edit name", "Edit name");
INSERT INTO languages VALUES ("en_US", "Edit notifications", "Edit notifications");
INSERT INTO languages VALUES ("en_US", "Edit service", "Edit service");
INSERT INTO languages VALUES ("en_US", "Edit settings", "Edit settings");
INSERT INTO languages VALUES ("en_US", "Edit teams", "Edit contactgroups");
INSERT INTO languages VALUES ("en_US", "Edit", "Edit");
INSERT INTO languages VALUES ("en_US", "Element (s) selected (s)", "Element (s) selected (s)");
INSERT INTO languages VALUES ("en_US", "Element description", "Element description");
INSERT INTO languages VALUES ("en_US", "Element name", "Element name");
INSERT INTO languages VALUES ("en_US", "Element origin of new metrics", "Element origin of new metrics");
INSERT INTO languages VALUES ("en_US", "Element's history is going to be permanently removed", "Element's history is going to be permanently removed");
INSERT INTO languages VALUES ("en_US", "Elements Selected for the Report", "element(s) selected for the report");
INSERT INTO languages VALUES ("en_US", "Email sent", "Email sent.");
INSERT INTO languages VALUES ("en_US", "Email", "Email");
INSERT INTO languages VALUES ("en_US", "Empty host list", "Empty host list");
INSERT INTO languages VALUES ("en_US", "Enable active checks for all services", "Enable active checks for all Services");
INSERT INTO languages VALUES ("en_US", "Enable checks for all services", "Enable checks for all Services");
INSERT INTO languages VALUES ("en_US", "Enable checks", "Enable checks");
INSERT INTO languages VALUES ("en_US", "Enable discovery", "Enable discovery");
INSERT INTO languages VALUES ("en_US", "Enable notifications for all hosts", "Enable notifications for all Hosts");
INSERT INTO languages VALUES ("en_US", "Enable notifications for all services", "Enable notifications for all Services");
INSERT INTO languages VALUES ("en_US", "Enable notifications", "Enable notifications");
INSERT INTO languages VALUES ("en_US", "Enable zoom", "Enable zoom");
INSERT INTO languages VALUES ("en_US", "Enabled", "Enabled");
INSERT INTO languages VALUES ("en_US", "Enableda", "Enabled");
INSERT INTO languages VALUES ("en_US", "End Discovery", "End Discovery");
INSERT INTO languages VALUES ("en_US", "End date", "End date");
INSERT INTO languages VALUES ("en_US", "End time", "End time");
INSERT INTO languages VALUES ("en_US", "End", "End");
INSERT INTO languages VALUES ("en_US", "Enter the Default Gateway", "Enter the Default Gateway");
INSERT INTO languages VALUES ("en_US", "Enter the IP or the Range to be discovered", "Enter the IP or the Range to be discovered");
INSERT INTO languages VALUES ("en_US", "Enter the Netmask", "Enter the Netmask");
INSERT INTO languages VALUES ("en_US", "Enter the Primary DNS", "Enter the Primary DNS");
INSERT INTO languages VALUES ("en_US", "Enter the Secondary DNS", "Enter the Secondary DNS");
INSERT INTO languages VALUES ("en_US", "Enter the fixed IP", "Enter the fixed IP");
INSERT INTO languages VALUES ("en_US", "Enter the server address", "Enter the server address");
INSERT INTO languages VALUES ("en_US", "Entry time", "Entry time");
INSERT INTO languages VALUES ("en_US", "Error to locate group of hosts", "Error to locate group of hosts");
INSERT INTO languages VALUES ("en_US", "Error to locate team", "Error to locate contactgroup");
INSERT INTO languages VALUES ("en_US", "Error", "Error");
INSERT INTO languages VALUES ("en_US", "Event handler disabled", "Event handler disabled");
INSERT INTO languages VALUES ("en_US", "Event handler enabled", "Event handler enabled");
INSERT INTO languages VALUES ("en_US", "Event handler", "Event handler");
INSERT INTO languages VALUES ("en_US", "Event handlers disabled in monitoring, but enabled in the Configuration", "Event handlers disabled in monitoring, but enabled in the Configuration");
INSERT INTO languages VALUES ("en_US", "Event handlers enabled in monitoring, but disabled in the Configuration", "Event handlers enabled in monitoring, but disabled in the Configuration");
INSERT INTO languages VALUES ("en_US", "Event log", "Event log");
INSERT INTO languages VALUES ("en_US", "Events Totals", "Event Totals");
INSERT INTO languages VALUES ("en_US", "Events", "Events");
INSERT INTO languages VALUES ("en_US", "Every Sunday, 00:00", "Every Sunday, 00:00");
INSERT INTO languages VALUES ("en_US", "Every day, 00:00", "Every day, 00:00");
INSERT INTO languages VALUES ("en_US", "Every first Sunday of the month, 00:00", "Every first Sunday of the month, 00:00");
INSERT INTO languages VALUES ("en_US", "Example: 192.168.10.1,linux server 07,intranet and website server.", "Example: 192.168.10.1,linux server 07,intranet and website server.");
INSERT INTO languages VALUES ("en_US", "Exceeded the Lower limit", "Exceeded the Lower limit");
INSERT INTO languages VALUES ("en_US", "Exceeded the Upper limit", "Exceeded the Upper limit");
INSERT INTO languages VALUES ("en_US", "Execute a command on selected items", "Execute a command on selected items");
INSERT INTO languages VALUES ("en_US", "Execute an external command", "Execute an external command");
INSERT INTO languages VALUES ("en_US", "Expiration (Date/Time)", "Expiration (Date/Time)");
INSERT INTO languages VALUES ("en_US", "Expiration Date", "Expiration Date");
INSERT INTO languages VALUES ("en_US", "Expire time", "Expire time");
INSERT INTO languages VALUES ("en_US", "Expire", "Expire");
INSERT INTO languages VALUES ("en_US", "Export as PDF", "Export as PDF");
INSERT INTO languages VALUES ("en_US", "Export to", "Export to");
INSERT INTO languages VALUES ("en_US", "Exporting new config", "Exporting new config");
INSERT INTO languages VALUES ("en_US", "Extended Output", "Extended Output");
INSERT INTO languages VALUES ("en_US", "Extended information", "Extended information");
INSERT INTO languages VALUES ("en_US", "External command cannot be executed", "External command cannot be executed");
INSERT INTO languages VALUES ("en_US", "External command was executed", "External command was executed");
INSERT INTO languages VALUES ("en_US", "External commands", "External commands");
INSERT INTO languages VALUES ("en_US", "External links", "External Links");
INSERT INTO languages VALUES ("en_US", "Extra parameter", "Extra parameter");
INSERT INTO languages VALUES ("en_US", "Extras", "Extras");
INSERT INTO languages VALUES ("en_US", "Fail log", "Fail log");
INSERT INTO languages VALUES ("en_US", "Fail", "Fail");
INSERT INTO languages VALUES ("en_US", "Failed to connect to the server. Try again.", "Failed to connect to the server. Try again.");
INSERT INTO languages VALUES ("en_US", "Failed to restart OpMon Traffic Analyzer process.", "Failed to restart OpMon Traffic Analyzer process.");
INSERT INTO languages VALUES ("en_US", "Failed to save an activation key", "Failed to save an activation key");
INSERT INTO languages VALUES ("en_US", "Failed to update OpMon Traffic Analyzer port.", "Failed to update OpMon Traffic Analyzer port.");
INSERT INTO languages VALUES ("en_US", "Failed to update the configuration file.", "Failed to update the configuration file.");
INSERT INTO languages VALUES ("en_US", "Failed to update the database.", "Failed to update the database.");
INSERT INTO languages VALUES ("en_US", "Fas addition of elements", "Fas addition of elements");
INSERT INTO languages VALUES ("en_US", "Fast addition of elements", "Fast addition of elements");
INSERT INTO languages VALUES ("en_US", "Favorite this", "Favorite this");
INSERT INTO languages VALUES ("en_US", "Favorites", "Favorites");
INSERT INTO languages VALUES ("en_US", "Feb", "Feb");
INSERT INTO languages VALUES ("en_US", "February", "February");
INSERT INTO languages VALUES ("en_US", "File uploaded successfuly", "File uploaded successfuly");
INSERT INTO languages VALUES ("en_US", "Filter Report", "Filter Report");
INSERT INTO languages VALUES ("en_US", "Filter enabled", "%nameOfFilter% Filter applied");
INSERT INTO languages VALUES ("en_US", "Filter by Application", "Filter by Application");
INSERT INTO languages VALUES ("en_US", "Filter by host", "Filter by host");
INSERT INTO languages VALUES ("en_US", "Filter by metric", "Filter by metric");
INSERT INTO languages VALUES ("en_US", "Filter by port", "Filter by port");
INSERT INTO languages VALUES ("en_US", "Filter by probe", "Filter by probe");
INSERT INTO languages VALUES ("en_US", "Filter by service", "Filter by service");
INSERT INTO languages VALUES ("en_US", "Filter by date", "Filter by date");
INSERT INTO languages VALUES ("en_US", "Filter by", "Filter by");
INSERT INTO languages VALUES ("en_US", "Filter discovered elements", "Filter discovered elements");
INSERT INTO languages VALUES ("en_US", "Filter", "Filter");
INSERT INTO languages VALUES ("en_US", "Filtering services", "Filtering services");
INSERT INTO languages VALUES ("en_US", "Filters", "Filters");
INSERT INTO languages VALUES ("en_US", "Financial Losses", "Financial Losses");
INSERT INTO languages VALUES ("en_US", "Finish Wizard and go to OpMon", "Finish Wizard and go to OpMon");
INSERT INTO languages VALUES ("en_US", "Finish", "Finish");
INSERT INTO languages VALUES ("en_US", "Finished", "Finished");
INSERT INTO languages VALUES ("en_US", "First Page", "First Page");
INSERT INTO languages VALUES ("en_US", "First page", "First page");
INSERT INTO languages VALUES ("en_US", "Fixed IP", "Fixed IP");
INSERT INTO languages VALUES ("en_US", "Fixed", "Fixed");
INSERT INTO languages VALUES ("en_US", "Flap detection disabled", "Flap detection disabled");
INSERT INTO languages VALUES ("en_US", "Flap detection enabled", "Flap detection enabled");
INSERT INTO languages VALUES ("en_US", "Flap detection", "Flap detection");
INSERT INTO languages VALUES ("en_US", "Flapping", "Flapping");
INSERT INTO languages VALUES ("en_US", "Flexible", "Flexible");
INSERT INTO languages VALUES ("en_US", "Flow collector", "Flow collector");
INSERT INTO languages VALUES ("en_US", "Force check", "Force check");
INSERT INTO languages VALUES ("en_US", "Forced", "Forced");
INSERT INTO languages VALUES ("en_US", "Frequency of backup", "Frequency of backup");
INSERT INTO languages VALUES ("en_US", "Frequency", "Frequency");
INSERT INTO languages VALUES ("en_US", "Friday", "Friday");
INSERT INTO languages VALUES ("en_US", "From", "From");
INSERT INTO languages VALUES ("en_US", "FullscreenText", "You are entering in fullscreen mode. To return to normal mode, click the buttons to expand the panels located on the side of the page.");
INSERT INTO languages VALUES ("en_US", "Future trend", "Future trend");
INSERT INTO languages VALUES ("en_US", "Generate a Capacity Planning Report from the selected items", "Generate a Capacity Planning Report from the selected items");
INSERT INTO languages VALUES ("en_US", "Generate a Network Utilization Report from the selected items", "Generate a Network Utilization Report from the selected items");
INSERT INTO languages VALUES ("en_US", "Generate an Availability Report from the selected items", "Generate an Availability Report from the selected items");
INSERT INTO languages VALUES ("en_US", "Generate network topology", "Generate network topology");
INSERT INTO languages VALUES ("en_US", "Generate report and send by e-mail", "Generate report and send by e-mail");
INSERT INTO languages VALUES ("en_US", "Generate report", "Generate report");
INSERT INTO languages VALUES ("en_US", "Generating network topology", "Generating network topology");
INSERT INTO languages VALUES ("en_US", "Get a new key", "Get a new key");
INSERT INTO languages VALUES ("en_US", "Get me out of here", "Get me out of here");
INSERT INTO languages VALUES ("en_US", "Global Settings", "Global Settings");
INSERT INTO languages VALUES ("en_US", "Graphics in %", "Graphics in %");
INSERT INTO languages VALUES ("en_US", "Green bullet means that the device is already being monitored. Gray bullet means that device has been discovered however it's not being monitored", "Green bullet means that the device is already being monitored. Gray bullet means that device has been discovered however it's not being monitored");
INSERT INTO languages VALUES ("en_US", "GridNoElements", "No matches");
INSERT INTO languages VALUES ("en_US", "Group By", "Group By");
INSERT INTO languages VALUES ("en_US", "Group by metric", "Group by metric");
INSERT INTO languages VALUES ("en_US", "Group by", "Group by");
INSERT INTO languages VALUES ("en_US", "Groups of Hosts", "Groups of Hosts");
INSERT INTO languages VALUES ("en_US", "HARD", "HARD");
INSERT INTO languages VALUES ("en_US", "HDs", "HDs");
INSERT INTO languages VALUES ("en_US", "Hard State", "Hard State");
INSERT INTO languages VALUES ("en_US", "Have documentation?", "Have documentation?");
INSERT INTO languages VALUES ("en_US", "Help", "Help");
INSERT INTO languages VALUES ("en_US", "Helpful", "Helpful");
INSERT INTO languages VALUES ("en_US", "Hide options", "Hide options");
INSERT INTO languages VALUES ("en_US", "Highlight on the calendar", "Highlight on the calendar");
INSERT INTO languages VALUES ("en_US", "Hint IP/Range", "Follow the examples:<br>192.168.10.130 or;<br>192.168.10. * or;<br>192.168.10.x - 192.168.10.y or;<br>www.google.com or;<br>for more information, click the icon.");
INSERT INTO languages VALUES ("en_US", "Hint", "Hint");
INSERT INTO languages VALUES ("en_US", "History", "History");
INSERT INTO languages VALUES ("en_US", "Holtz-Winters", "Holtz-Winters");
INSERT INTO languages VALUES ("en_US", "Host Grid", "Host Grid");
INSERT INTO languages VALUES ("en_US", "Host Group already contains target host", "Host Group already contains target host");
INSERT INTO languages VALUES ("en_US", "Host Group", "Host Group");
INSERT INTO languages VALUES ("en_US", "Host Groups", "Host Groups");
INSERT INTO languages VALUES ("en_US", "Host Name", "Host Name");
INSERT INTO languages VALUES ("en_US", "Host existing", "Host existing");
INSERT INTO languages VALUES ("en_US", "Host icon", "Host icon");
INSERT INTO languages VALUES ("en_US", "Host information", "Host information");
INSERT INTO languages VALUES ("en_US", "Host origin of new metrics", "Host origin of new metrics");
INSERT INTO languages VALUES ("en_US", "Host service is not selected", "Host service is not selected");
INSERT INTO languages VALUES ("en_US", "Host status", "Host status");
INSERT INTO languages VALUES ("en_US", "Host", "Host");
INSERT INTO languages VALUES ("en_US", "Host(s) modified", "Host(s) modified");
INSERT INTO languages VALUES ("en_US", "Hostgroup Grid", "Host Groups Grid");
INSERT INTO languages VALUES ("en_US", "Hostgroup origin of new metrics", "Hostgroup origin of new metrics");
INSERT INTO languages VALUES ("en_US", "Hostgroup", "Host Group");
INSERT INTO languages VALUES ("en_US", "Hostname", "Hostname");
INSERT INTO languages VALUES ("en_US", "Hosts and Contacts", "Hosts and Contacts");
INSERT INTO languages VALUES ("en_US", "Hosts with ack", "Hosts with ack");
INSERT INTO languages VALUES ("en_US", "Hosts", "Hosts");
INSERT INTO languages VALUES ("en_US", "Hour", "Hour");
INSERT INTO languages VALUES ("en_US", "Hours", "Hours");
INSERT INTO languages VALUES ("en_US", "How do I add a probe?", "How do I add a probe?");
INSERT INTO languages VALUES ("en_US", "I accept the %link%EULA terms described here%endlink%", "I accept the %link%EULA terms described here%endlink%");
INSERT INTO languages VALUES ("en_US", "I accept the EULA described above", "I accept the EULA described above");
INSERT INTO languages VALUES ("en_US", "I accept the eula described above", "I accept the eula described above");
INSERT INTO languages VALUES ("en_US", "I agree", "I agree");
INSERT INTO languages VALUES ("en_US", "I am ready! Begin to monitor my traffic.", "I am ready! Begin to monitor my traffic.");
INSERT INTO languages VALUES ("en_US", "I did not understand. I need more information.", "I did not understand. I need more information.");
INSERT INTO languages VALUES ("en_US", "I disagree", "I disagree");
INSERT INTO languages VALUES ("en_US", "I do not agree", "I do not agree");
INSERT INTO languages VALUES ("en_US", "I know what I'm doing.", "I know what I'm doing.");
INSERT INTO languages VALUES ("en_US", "I prefer to manually configure (Advanced Configuration)", "I prefer to manually configure (Advanced Configuration)");
INSERT INTO languages VALUES ("en_US", "I want to add more probes", "I want to add more probes");
INSERT INTO languages VALUES ("en_US", "I want to configure ports and protocol applications", "I want to configure ports and protocol applications");
INSERT INTO languages VALUES ("en_US", "I want to go to the traffic dashboard!", "I want to go to the traffic dashboard!");
INSERT INTO languages VALUES ("en_US", "I want to know more about OpMon Traffic Analyzer", "I want to know more about OpMon Traffic Analyzer");
INSERT INTO languages VALUES ("en_US", "I want to monitoring OpMon Traffic Analyzer's internal traffic", "I want to monitoring OpMon Traffic Analyzer's internal traffic");
INSERT INTO languages VALUES ("en_US", "ID", "ID");
INSERT INTO languages VALUES ("en_US", "IP Address", "IP Address");
INSERT INTO languages VALUES ("en_US", "IP address", "IP address");
INSERT INTO languages VALUES ("en_US", "IP", "IP");
INSERT INTO languages VALUES ("en_US", "Icon", "Icon");
INSERT INTO languages VALUES ("en_US", "Identify, register and change ports and application protocols. This information will be used to storage and data presentation.", "Identify, create and change ports and application protocols. This information will be used to storage and data presentation.");
INSERT INTO languages VALUES ("en_US", "If flexible, duration", "If flexible, duration");
INSERT INTO languages VALUES ("en_US", "If you remove this element, all child nodes will be removed. Continue?", "If you remove this element, all child nodes will be removed. Continue?");
INSERT INTO languages VALUES ("en_US", "Impact", "Impact");
INSERT INTO languages VALUES ("en_US", "Importing discovered objects", "Importing discovered objects");
INSERT INTO languages VALUES ("en_US", "In Flapping State", "In Flapping State");
INSERT INTO languages VALUES ("en_US", "In Progress", "In Progress");
INSERT INTO languages VALUES ("en_US", "In Scheduled Downtime", "In Scheduled Downtime");
INSERT INTO languages VALUES ("en_US", "In maintenance since", "In maintenance since ");
INSERT INTO languages VALUES ("en_US", "In scheduled downtime", "In scheduled downtime");
INSERT INTO languages VALUES ("en_US", "Incidents", "Incidents");
INSERT INTO languages VALUES ("en_US", "Include soft states", "Include soft states");
INSERT INTO languages VALUES ("en_US", "Information", "Information");
INSERT INTO languages VALUES ("en_US", "Informations", "Information");
INSERT INTO languages VALUES ("en_US", "Initializing", "Initializing");
INSERT INTO languages VALUES ("en_US", "Install custom package", "Install custom package");
INSERT INTO languages VALUES ("en_US", "Install default packages", "Install default packages");
INSERT INTO languages VALUES ("en_US", "Install selected packages", "Install selected packages");
INSERT INTO languages VALUES ("en_US", "Installing packages, do not close this window...", "Installing packages, do not close this window...");
INSERT INTO languages VALUES ("en_US", "Interface", "Interface");
INSERT INTO languages VALUES ("en_US", "Interval", "Interval");
INSERT INTO languages VALUES ("en_US", "Invalid Configuration", "Invalid Configuration");
INSERT INTO languages VALUES ("en_US", "Invalid IP", "Invalid IP");
INSERT INTO languages VALUES ("en_US", "Invalid Range", "Invalid IP/Range syntax. Follow the examples: 192.10.168.100, as model for IPs; 192.168.10.*, as model for ranges.");
INSERT INTO languages VALUES ("en_US", "Invalid Request", "Invalid Request");
INSERT INTO languages VALUES ("en_US", "Invalid command description.", "Invalid command description.");
INSERT INTO languages VALUES ("en_US", "Invalid command line.", "Invalid command line.");
INSERT INTO languages VALUES ("en_US", "Invalid command", "Invalid command");
INSERT INTO languages VALUES ("en_US", "Invalid e-mail", "Invalid e-mail");
INSERT INTO languages VALUES ("en_US", "Invalid group name", "Invalid group name");
INSERT INTO languages VALUES ("en_US", "Invalid host", "Invalid host");
INSERT INTO languages VALUES ("en_US", "Invalid hostname", "Invalid hostname");
INSERT INTO languages VALUES ("en_US", "Invalid language selected", "Invalid language selected");
INSERT INTO languages VALUES ("en_US", "Invalid license expire time", "Invalid license expire time");
INSERT INTO languages VALUES ("en_US", "Invalid license file extension", "Invalid license file extension. Requires .txt");
INSERT INTO languages VALUES ("en_US", "Invalid name", "Invalid name");
INSERT INTO languages VALUES ("en_US", "Invalid parameters received. We need fields from, to and relay for send mail test.", "Invalid parameters received. We need fields from, to and relay for send mail test.");
INSERT INTO languages VALUES ("en_US", "Invalid password", "Invalid password");
INSERT INTO languages VALUES ("en_US", "Invalid team name", "Invalid contactgroup name");
INSERT INTO languages VALUES ("en_US", "Invalid user type", "Invalid contact type");
INSERT INTO languages VALUES ("en_US", "Invalid user", "Invalid contact!");
INSERT INTO languages VALUES ("en_US", "Invalid username", "Invalid username");
INSERT INTO languages VALUES ("en_US", "Ips and Ranges to be processed", "IPs and Ranges to be processed");
INSERT INTO languages VALUES ("en_US", "Ips to be processed", "IPs to be processed");
INSERT INTO languages VALUES ("en_US", "JSON not found", "JSON not found");
INSERT INTO languages VALUES ("en_US", "Jan", "Jan");
INSERT INTO languages VALUES ("en_US", "January", "January");
INSERT INTO languages VALUES ("en_US", "Jelp", "Jelp");
INSERT INTO languages VALUES ("en_US", "Jul", "Jul");
INSERT INTO languages VALUES ("en_US", "July", "July");
INSERT INTO languages VALUES ("en_US", "Jun", "Jun");
INSERT INTO languages VALUES ("en_US", "June", "June");
INSERT INTO languages VALUES ("en_US", "Key Availability Indicators", "Key Availability Indicators");
INSERT INTO languages VALUES ("en_US", "Key Performance Indicators", "Key Performance Indicators");
INSERT INTO languages VALUES ("en_US", "Key Users", "Key Users");
INSERT INTO languages VALUES ("en_US", "Kind of source of metrics", "Kind of source of metrics");
INSERT INTO languages VALUES ("en_US", "Knowledge Base Link", "http://kb.opservices.com");
INSERT INTO languages VALUES ("en_US", "Label", "Label");
INSERT INTO languages VALUES ("en_US", "Language", "English International");
INSERT INTO languages VALUES ("en_US", "Last 24 hours", "Last 24 hours");
INSERT INTO languages VALUES ("en_US", "Last 31 days", "Last 31 days");
INSERT INTO languages VALUES ("en_US", "Last 7 days", "Last 7 days");
INSERT INTO languages VALUES ("en_US", "Last Check Header", "Last Check");
INSERT INTO languages VALUES ("en_US", "Last Check", "Last Check");
INSERT INTO languages VALUES ("en_US", "Last Page", "Last Page");
INSERT INTO languages VALUES ("en_US", "Last Update", "Last Update");
INSERT INTO languages VALUES ("en_US", "Last Value", "Last Value");
INSERT INTO languages VALUES ("en_US", "Last collect", "Last collect");
INSERT INTO languages VALUES ("en_US", "Last hour", "Last hour");
INSERT INTO languages VALUES ("en_US", "Last month", "Last month");
INSERT INTO languages VALUES ("en_US", "Last notification", "Last notification");
INSERT INTO languages VALUES ("en_US", "Last page", "Last page");
INSERT INTO languages VALUES ("en_US", "Last review", "Last review");
INSERT INTO languages VALUES ("en_US", "Last state change", "Last state change");
INSERT INTO languages VALUES ("en_US", "Last update", "Last update");
INSERT INTO languages VALUES ("en_US", "Last week", "Last week");
INSERT INTO languages VALUES ("en_US", "Last year", "Last year");
INSERT INTO languages VALUES ("en_US", "Last", "Last");
INSERT INTO languages VALUES ("en_US", "Last...", "Last...");
INSERT INTO languages VALUES ("en_US", "Latency", "Latency");
INSERT INTO languages VALUES ("en_US", "Layout", "Layout");
INSERT INTO languages VALUES ("en_US", "Learn more about OpMon", "Learn more about OpMon");
INSERT INTO languages VALUES ("en_US", "Legend", "Legend");
INSERT INTO languages VALUES ("en_US", "Level", "Level");
INSERT INTO languages VALUES ("en_US", "License Type", "License Type");
INSERT INTO languages VALUES ("en_US", "License details", "License details");
INSERT INTO languages VALUES ("en_US", "License file updated successfully", "License file updated successfully.");
INSERT INTO languages VALUES ("en_US", "License is expired", "License is expired");
INSERT INTO languages VALUES ("en_US", "License limit reached", "License limit reached");
INSERT INTO languages VALUES ("en_US", "License limit reached.", "License limit reached.");
INSERT INTO languages VALUES ("en_US", "License", "License");
INSERT INTO languages VALUES ("en_US", "Licensed Dashboards", "Licensed Dashboards");
INSERT INTO languages VALUES ("en_US", "Licensed Hosts", "Licensed Hosts");
INSERT INTO languages VALUES ("en_US", "Licensed Services", "Licensed Services");
INSERT INTO languages VALUES ("en_US", "Licensed", "Licensed");
INSERT INTO languages VALUES ("en_US", "List SLA Description", "A contract between a service provider and a customer that specifies, usually in measurable terms, what services the service provider will furnish.");
INSERT INTO languages VALUES ("en_US", "List SLA(Service Level Agreement)", "List SLA(Service Level Agreement)");
INSERT INTO languages VALUES ("en_US", "List of Communities", "List of Communities");
INSERT INTO languages VALUES ("en_US", "List", "List");
INSERT INTO languages VALUES ("en_US", "Loading Models...", "Loading Models...");
INSERT INTO languages VALUES ("en_US", "Loading interface", "Loading interface...");
INSERT INTO languages VALUES ("en_US", "Loading items...", "Loading items");
INSERT INTO languages VALUES ("en_US", "Loading language array", "Loading language...");
INSERT INTO languages VALUES ("en_US", "Loading objects", "Loading objects...");
INSERT INTO languages VALUES ("en_US", "Loading user's profile", "Loading user's profile...");
INSERT INTO languages VALUES ("en_US", "Loading", "Loading");
INSERT INTO languages VALUES ("en_US", "Location", "Location");
INSERT INTO languages VALUES ("en_US", "Log", "Log");
INSERT INTO languages VALUES ("en_US", "Login", "Login");
INSERT INTO languages VALUES ("en_US", "Logo upload", "Logo upload");
INSERT INTO languages VALUES ("en_US", "Logout", "Logout");
INSERT INTO languages VALUES ("en_US", "Lower limit", "Lower limit");
INSERT INTO languages VALUES ("en_US", "MTBF", "MTBF");
INSERT INTO languages VALUES ("en_US", "MTTF", "MTTF");
INSERT INTO languages VALUES ("en_US", "MTTR", "MTTR");
INSERT INTO languages VALUES ("en_US", "Make sure you have enabled your probe's netflow correctly.", "Make sure you have enabled your probe's netflow correctly.");
INSERT INTO languages VALUES ("en_US", "Manage in real time the selected items", "Manage in real time the selected items");
INSERT INTO languages VALUES ("en_US", "Management commands", "Management commands");
INSERT INTO languages VALUES ("en_US", "Management", "Management");
INSERT INTO languages VALUES ("en_US", "Manages the network topology with the elements", "Manages the network topology with the elements");
INSERT INTO languages VALUES ("en_US", "Maps", "Maps");
INSERT INTO languages VALUES ("en_US", "Mar", "Mar");
INSERT INTO languages VALUES ("en_US", "March", "March");
INSERT INTO languages VALUES ("en_US", "Max", "Max");
INSERT INTO languages VALUES ("en_US", "Maximize view", "Maximize view");
INSERT INTO languages VALUES ("en_US", "Maximum Attempts", "Maximum Attempts");
INSERT INTO languages VALUES ("en_US", "Maximum Check Attempts", "Maximum Check Attempts");
INSERT INTO languages VALUES ("en_US", "Maximum", "Maximum");
INSERT INTO languages VALUES ("en_US", "May", "May");
INSERT INTO languages VALUES ("en_US", "Menu_Custom", "Custom");
INSERT INTO languages VALUES ("en_US", "Method", "Method");
INSERT INTO languages VALUES ("en_US", "Metric Aggregated", "Metric aggregated");
INSERT INTO languages VALUES ("en_US", "Metric", "Metric");
INSERT INTO languages VALUES ("en_US", "Metrics Available", "Metrics available");
INSERT INTO languages VALUES ("en_US", "Metrics associated with baseline", "Metrics associated with baseline");
INSERT INTO languages VALUES ("en_US", "Metrics available", "Metrics available");
INSERT INTO languages VALUES ("en_US", "Metrics", "Metrics");
INSERT INTO languages VALUES ("en_US", "Min", "Min");
INSERT INTO languages VALUES ("en_US", "Minimum", "Minimum");
INSERT INTO languages VALUES ("en_US", "Mobile", "Mobile");
INSERT INTO languages VALUES ("en_US", "Model Groups", "Model Groups");
INSERT INTO languages VALUES ("en_US", "Model name", "Model name");
INSERT INTO languages VALUES ("en_US", "Model", "Model");
INSERT INTO languages VALUES ("en_US", "Module not installed. Contact your system administrator.", "Module not installed. Contact your system administrator.");
INSERT INTO languages VALUES ("en_US", "Module", "Module");
INSERT INTO languages VALUES ("en_US", "Monday", "Monday");
INSERT INTO languages VALUES ("en_US", "Monitor selected", "Monitor selected");
INSERT INTO languages VALUES ("en_US", "Monitored with new services", "Monitored with new services");
INSERT INTO languages VALUES ("en_US", "Monitored", "Monitored");
INSERT INTO languages VALUES ("en_US", "Monitoring problems", "Monitoring features");
INSERT INTO languages VALUES ("en_US", "Monitoring state", "Monitoring state");
INSERT INTO languages VALUES ("en_US", "Monitoring without a model", "Monitoring without a model");
INSERT INTO languages VALUES ("en_US", "Monitoring without model", "Monitoring without model");
INSERT INTO languages VALUES ("en_US", "Monitoring", "Monitoring");
INSERT INTO languages VALUES ("en_US", "Month day", "Month day");
INSERT INTO languages VALUES ("en_US", "Month", "Month");
INSERT INTO languages VALUES ("en_US", "Monthly", "Monthly");
INSERT INTO languages VALUES ("en_US", "Months", "Months");
INSERT INTO languages VALUES ("en_US", "Move down", "Move down");
INSERT INTO languages VALUES ("en_US", "Move up", "Move up");
INSERT INTO languages VALUES ("en_US", "MsgNoUserDefined", "(No user defined)");
INSERT INTO languages VALUES ("en_US", "My Dashboards", "My Dashboards");
INSERT INTO languages VALUES ("en_US", "N/D", "N/D");
INSERT INTO languages VALUES ("en_US", "NTP server", "NTP server");
INSERT INTO languages VALUES ("en_US", "Name", "Name");
INSERT INTO languages VALUES ("en_US", "Network Range", "Network Range");
INSERT INTO languages VALUES ("en_US", "Network Utilization", "Network&nbsp;Utilization");
INSERT INTO languages VALUES ("en_US", "Network configuration", "Network configuration");
INSERT INTO languages VALUES ("en_US", "Network mask", "Network mask");
INSERT INTO languages VALUES ("en_US", "Network settings", "Network settings");
INSERT INTO languages VALUES ("en_US", "Network", "Network");
INSERT INTO languages VALUES ("en_US", "New IP / Range not added", "New IP / Range not added");
INSERT INTO languages VALUES ("en_US", "New IP or Range", "New IP or Range");
INSERT INTO languages VALUES ("en_US", "New IP or added range", "New IP or added range");
INSERT INTO languages VALUES ("en_US", "New Password", "New Password");
INSERT INTO languages VALUES ("en_US", "New baseline", "New baseline");
INSERT INTO languages VALUES ("en_US", "New entries", "New entries");
INSERT INTO languages VALUES ("en_US", "New entry", "New entry");
INSERT INTO languages VALUES ("en_US", "New host group", "New host group");
INSERT INTO languages VALUES ("en_US", "New host", "New host");
INSERT INTO languages VALUES ("en_US", "New host(s) created", "New host(s) created");
INSERT INTO languages VALUES ("en_US", "New package", "New package");
INSERT INTO languages VALUES ("en_US", "New passowrd doesn't match", "New passowrd doesn't match!");
INSERT INTO languages VALUES ("en_US", "New report", "New report");
INSERT INTO languages VALUES ("en_US", "New service group", "New service group");
INSERT INTO languages VALUES ("en_US", "New service(s) configured", "New service(s) configured");
INSERT INTO languages VALUES ("en_US", "New shortcut", "New shortcut");
INSERT INTO languages VALUES ("en_US", "New team", "New contactgroup");
INSERT INTO languages VALUES ("en_US", "New user", "New contact");
INSERT INTO languages VALUES ("en_US", "New version available", "New version available");
INSERT INTO languages VALUES ("en_US", "New", "New");
INSERT INTO languages VALUES ("en_US", "Next Page", "Next Page");
INSERT INTO languages VALUES ("en_US", "Next check Header", "Next check");
INSERT INTO languages VALUES ("en_US", "Next check", "Next check");
INSERT INTO languages VALUES ("en_US", "Next page", "Next page");
INSERT INTO languages VALUES ("en_US", "Next", "Next");
INSERT INTO languages VALUES ("en_US", "No Data", "No Data");
INSERT INTO languages VALUES ("en_US", "No IPs or ranges to be processed", "No IPs or ranges to be processed");
INSERT INTO languages VALUES ("en_US", "No SNMP community added", "No SNMP community added");
INSERT INTO languages VALUES ("en_US", "No bookmark found", "No bookmark found");
INSERT INTO languages VALUES ("en_US", "No data available", "No data available");
INSERT INTO languages VALUES ("en_US", "No data found, please, check SNMP authentications", "No data found, please, check SNMP authentications.");
INSERT INTO languages VALUES ("en_US", "No data", "No data");
INSERT INTO languages VALUES ("en_US", "No has any service", "No has any service");
INSERT INTO languages VALUES ("en_US", "No incidents at this moment", "No incidents at this moment");
INSERT INTO languages VALUES ("en_US", "No model found", "No model found");
INSERT INTO languages VALUES ("en_US", "No notifications available", "No notifications are available");
INSERT INTO languages VALUES ("en_US", "No selected template", "No selected template");
INSERT INTO languages VALUES ("en_US", "No template template", "No template template");
INSERT INTO languages VALUES ("en_US", "No window", "No window");
INSERT INTO languages VALUES ("en_US", "No", "No");
INSERT INTO languages VALUES ("en_US", "No. I want to continue the process", "No. I want to continue the process");
INSERT INTO languages VALUES ("en_US", "No. metrics", "No. metrics");
INSERT INTO languages VALUES ("en_US", "NoElementsSelectedMsg", "You must select at least one object to perform this action!");
INSERT INTO languages VALUES ("en_US", "Non work", "Non work");
INSERT INTO languages VALUES ("en_US", "Not defined", "Not defined");
INSERT INTO languages VALUES ("en_US", "Not helpful", "Not helpful");
INSERT INTO languages VALUES ("en_US", "Not monitored", "Not monitored");
INSERT INTO languages VALUES ("en_US", "Not saved report", "Not saved report");
INSERT INTO languages VALUES ("en_US", "Note URL", "Note URL");
INSERT INTO languages VALUES ("en_US", "Nothing to do.", "Nothing to do.");
INSERT INTO languages VALUES ("en_US", "Notification enabled", "Notification enabled");
INSERT INTO languages VALUES ("en_US", "Notification interval", "Notification interval");
INSERT INTO languages VALUES ("en_US", "Notification period", "Notification period");
INSERT INTO languages VALUES ("en_US", "Notification", "Notification");
INSERT INTO languages VALUES ("en_US", "Notifications Totals", "Notifications Totals");
INSERT INTO languages VALUES ("en_US", "Notifications disabled", "Notifications disabled");
INSERT INTO languages VALUES ("en_US", "Notifications enabled", "Notifications enabled");
INSERT INTO languages VALUES ("en_US", "Notifications", "Notifications");
INSERT INTO languages VALUES ("en_US", "Nov", "Nov");
INSERT INTO languages VALUES ("en_US", "November", "November");
INSERT INTO languages VALUES ("en_US", "Number of users", "Number of users");
INSERT INTO languages VALUES ("en_US", "OEM", "OEM");
INSERT INTO languages VALUES ("en_US", "OK", "OK");
INSERT INTO languages VALUES ("en_US", "OK, I got it", "OK, I got it");
INSERT INTO languages VALUES ("en_US", "OK, I understood.", "OK, I understood.");
INSERT INTO languages VALUES ("en_US", "OK, I'm ready.", "OK, I'm ready.");
INSERT INTO languages VALUES ("en_US", "ONC", "ONC");
INSERT INTO languages VALUES ("en_US", "OPCFG_Advanced", "Advanced");
INSERT INTO languages VALUES ("en_US", "OPCFG_Alerting", "Alerting");
INSERT INTO languages VALUES ("en_US", "OPCFG_CGIConfig", "CGI Config");
INSERT INTO languages VALUES ("en_US", "OPCFG_Commands", "Commands");
INSERT INTO languages VALUES ("en_US", "OPCFG_ContactGroups", "Contact Groups");
INSERT INTO languages VALUES ("en_US", "OPCFG_Contacts", "Contacts");
INSERT INTO languages VALUES ("en_US", "OPCFG_Discovery", "Discovery");
INSERT INTO languages VALUES ("en_US", "OPCFG_DiscoveryCommunities", "SNMP Communities");
INSERT INTO languages VALUES ("en_US", "OPCFG_DiscoveryImport", "Import Objects");
INSERT INTO languages VALUES ("en_US", "OPCFG_DiscoveryImportedElements", "Imported objects");
INSERT INTO languages VALUES ("en_US", "OPCFG_Export", "Export");
INSERT INTO languages VALUES ("en_US", "OPCFG_Extras", "Extras");
INSERT INTO languages VALUES ("en_US", "OPCFG_HostGroups", "Host Groups");
INSERT INTO languages VALUES ("en_US", "OPCFG_Hosts", "Hosts");
INSERT INTO languages VALUES ("en_US", "OPCFG_MainConfig", "Main Config");
INSERT INTO languages VALUES ("en_US", "OPCFG_Monitoring", "Monitoring");
INSERT INTO languages VALUES ("en_US", "OPCFG_PortScan", "Object Import");
INSERT INTO languages VALUES ("en_US", "OPCFG_Resources", "Resources");
INSERT INTO languages VALUES ("en_US", "OPCFG_SNMPDiscovery", "SNMP Discovery");
INSERT INTO languages VALUES ("en_US", "OPCFG_ServiceGroups", "Service Groups");
INSERT INTO languages VALUES ("en_US", "OPCFG_TITLE", "Configuration Utility");
INSERT INTO languages VALUES ("en_US", "OPCFG_Templates", "Templates");
INSERT INTO languages VALUES ("en_US", "OPCFG_TimePeriods", "Time Periods");
INSERT INTO languages VALUES ("en_US", "OPCFG_Tools", "Tools");
INSERT INTO languages VALUES ("en_US", "OPCFG_Topology", "Topology");
INSERT INTO languages VALUES ("en_US", "OPDOCS", "Documentation");
INSERT INTO languages VALUES ("en_US", "OPTRAFFIC", "Traffic Analyzer");
INSERT INTO languages VALUES ("en_US", "OPVIEW", "Dashboards");
INSERT INTO languages VALUES ("en_US", "OPVIEWREMOTE", "Dashboard Customs Handlers");
INSERT INTO languages VALUES ("en_US", "OS", "OS");
INSERT INTO languages VALUES ("en_US", "OTRS", "OTRS Integration");
INSERT INTO languages VALUES ("en_US", "Object not found", "Object not found");
INSERT INTO languages VALUES ("en_US", "Object", "Object");
INSERT INTO languages VALUES ("en_US", "Objects Available", "Objects available");
INSERT INTO languages VALUES ("en_US", "Objects Selected", "Objects selected");
INSERT INTO languages VALUES ("en_US", "Objects Spreadsheet", "Objects Spreadsheet");
INSERT INTO languages VALUES ("en_US", "ObjectsLoadingMsg", "Loading objects. Please wait...");
INSERT INTO languages VALUES ("en_US", "Obsess check", "Obsess check");
INSERT INTO languages VALUES ("en_US", "Obsess checks disabled", "Obsess checks disabled");
INSERT INTO languages VALUES ("en_US", "Obsess checks enabled", "Obsess checks enabled");
INSERT INTO languages VALUES ("en_US", "Oct", "Oct");
INSERT INTO languages VALUES ("en_US", "October", "October");
INSERT INTO languages VALUES ("en_US", "Offset", "Offset");
INSERT INTO languages VALUES ("en_US", "Old Password", "Old Password");
INSERT INTO languages VALUES ("en_US", "Once", "Once");
INSERT INTO languages VALUES ("en_US", "Only Lines", "Only Lines");
INSERT INTO languages VALUES ("en_US", "Only acks", "Only acks");
INSERT INTO languages VALUES ("en_US", "Only disabled", "Only disabled");
INSERT INTO languages VALUES ("en_US", "Only downtimes", "Only downtimes");
INSERT INTO languages VALUES ("en_US", "Only enabled", "Only enabled");
INSERT INTO languages VALUES ("en_US", "Only hard state", "Only hard state");
INSERT INTO languages VALUES ("en_US", "Only hosts", "Only hosts");
INSERT INTO languages VALUES ("en_US", "Only one time", "Only one time");
INSERT INTO languages VALUES ("en_US", "Only services", "Only services");
INSERT INTO languages VALUES ("en_US", "Only soft state", "Only soft state");
INSERT INTO languages VALUES ("en_US", "Only unmonitored hosts discovered by OpMon are listed", "Only unmonitored hosts discovered by OpMon are listed");
INSERT INTO languages VALUES ("en_US", "Only view report", "Only view report");
INSERT INTO languages VALUES ("en_US", "Only with", "Only with");
INSERT INTO languages VALUES ("en_US", "Only without", "Only without");
INSERT INTO languages VALUES ("en_US", "OpDiscovery", "OpDiscovery");
INSERT INTO languages VALUES ("en_US", "OpLogs", "OpLogs");
INSERT INTO languages VALUES ("en_US", "OpMon Deamon is stopped", "OpMon Daemon is stopped!");
INSERT INTO languages VALUES ("en_US", "OpMon Traffic Analizer can be configured later", "OpMon Traffic Analizer can be configured later");
INSERT INTO languages VALUES ("en_US", "OpMon Traffic Analyzer Light", "OpMon Traffic Analyzer Light");
INSERT INTO languages VALUES ("en_US", "OpMon can be configured later", "OpMon can be configured later");
INSERT INTO languages VALUES ("en_US", "OpMon in maintenance", "OpMon in maintenance!");
INSERT INTO languages VALUES ("en_US", "OpMon initial setup", "OpMon initial setup");
INSERT INTO languages VALUES ("en_US", "OpMon", "OpMon");
INSERT INTO languages VALUES ("en_US", "OpMonExceededMsg", "OpMon database monitoring delayed.");
INSERT INTO languages VALUES ("en_US", "OpServices License and Services Agreement", "OpServices License and Services Agreement");
INSERT INTO languages VALUES ("en_US", "OpTraps", "OpTraps");
INSERT INTO languages VALUES ("en_US", "Open a saved baseline ...", "Open a saved baseline ...");
INSERT INTO languages VALUES ("en_US", "Open a saved report", "Open a saved report");
INSERT INTO languages VALUES ("en_US", "Operation succeeded", "Operation succeeded");
INSERT INTO languages VALUES ("en_US", "Operational commands", "Operational commands");
INSERT INTO languages VALUES ("en_US", "Operational system", "Operational system");
INSERT INTO languages VALUES ("en_US", "Operator", "Operator");
INSERT INTO languages VALUES ("en_US", "Opmonadmin", "Opmonadmin");
INSERT INTO languages VALUES ("en_US", "Origin of metrics", "Origin of metrics");
INSERT INTO languages VALUES ("en_US", "Other", "Other");
INSERT INTO languages VALUES ("en_US", "Others", "Others");
INSERT INTO languages VALUES ("en_US", "Output", "Output");
INSERT INTO languages VALUES ("en_US", "Overview", "Overview");
INSERT INTO languages VALUES ("en_US", "Overwrite all", "Overwrite all");
INSERT INTO languages VALUES ("en_US", "Overwrite current hosts settings", "Overwrite current hosts settings");
INSERT INTO languages VALUES ("en_US", "Overwrite default", "Overwrite default");
INSERT INTO languages VALUES ("en_US", "Package manager", "Package manager");
INSERT INTO languages VALUES ("en_US", "Package uninstalled successfuly", "Package uninstalled successfuly");
INSERT INTO languages VALUES ("en_US", "Package uploaded successfuly", "Package uploaded successfuly");
INSERT INTO languages VALUES ("en_US", "Packages installed successfuly", "Packages installed successfuly");
INSERT INTO languages VALUES ("en_US", "Packet", "Packet");
INSERT INTO languages VALUES ("en_US", "Page", "Page");
INSERT INTO languages VALUES ("en_US", "Parameters", "Parameters");
INSERT INTO languages VALUES ("en_US", "Passive check", "Passive check");
INSERT INTO languages VALUES ("en_US", "Passive checks disabled", "Passive checks disabled");
INSERT INTO languages VALUES ("en_US", "Passive checks enabled", "Passive checks enabled");
INSERT INTO languages VALUES ("en_US", "Passive", "Passive");
INSERT INTO languages VALUES ("en_US", "Password change", "Password change");
INSERT INTO languages VALUES ("en_US", "Password updated successfully", "Password updated successfully!");
INSERT INTO languages VALUES ("en_US", "Password", "Password");
INSERT INTO languages VALUES ("en_US", "Passwords does not match", "Passwords does not match");
INSERT INTO languages VALUES ("en_US", "Pendings", "Pendings");
INSERT INTO languages VALUES ("en_US", "Perc95", "Perc95");
INSERT INTO languages VALUES ("en_US", "Percent change", "Percent change");
INSERT INTO languages VALUES ("en_US", "Performance data", "Performance data");
INSERT INTO languages VALUES ("en_US", "Performance", "Performance");
INSERT INTO languages VALUES ("en_US", "Period check invalid", "Period check invalid");
INSERT INTO languages VALUES ("en_US", "Period check", "Period check");
INSERT INTO languages VALUES ("en_US", "Period variation", "Period variation");
INSERT INTO languages VALUES ("en_US", "Period", "Period");
INSERT INTO languages VALUES ("en_US", "Periodicity", "Periodicity");
INSERT INTO languages VALUES ("en_US", "Permission Denied Description", "You are <strong>not</strong> allowed to access this page");
INSERT INTO languages VALUES ("en_US", "Permission Denied", "Permission denied");
INSERT INTO languages VALUES ("en_US", "Permission denied", "Permission denied");
INSERT INTO languages VALUES ("en_US", "Persistent comment", "Persistent comment");
INSERT INTO languages VALUES ("en_US", "Persistent", "Persistent");
INSERT INTO languages VALUES ("en_US", "Ping", "Ping");
INSERT INTO languages VALUES ("en_US", "Planned Downtimes", "Planned Downtimes");
INSERT INTO languages VALUES ("en_US", "Planned", "Planned");
INSERT INTO languages VALUES ("en_US", "Please contact your administrator", "Please contact your administrator");
INSERT INTO languages VALUES ("en_US", "Please enter a new report name", "Please enter a new report name");
INSERT INTO languages VALUES ("en_US", "Please select a command", "Please select a command");
INSERT INTO languages VALUES ("en_US", "Please select a host already discovered", "Please select a host already discovered");
INSERT INTO languages VALUES ("en_US", "Please select a host to be tested", "Please select a host to be tested");
INSERT INTO languages VALUES ("en_US", "Please wait", "Please wait");
INSERT INTO languages VALUES ("en_US", "Please wait. Uploading your file...", "Please wait. Uploading your file...");
INSERT INTO languages VALUES ("en_US", "Port", "Port");
INSERT INTO languages VALUES ("en_US", "Ports", "Ports");
INSERT INTO languages VALUES ("en_US", "Portscan", "Portscan");
INSERT INTO languages VALUES ("en_US", "Previous Page", "Previous Page");
INSERT INTO languages VALUES ("en_US", "Previous page", "Previous page");
INSERT INTO languages VALUES ("en_US", "Primary DNS", "Primary DNS");
INSERT INTO languages VALUES ("en_US", "Privacy", "Privacy");
INSERT INTO languages VALUES ("en_US", "Problem uploading your report", "Problem uploading your report");
INSERT INTO languages VALUES ("en_US", "Problems", "Problems");
INSERT INTO languages VALUES ("en_US", "Proceed with this element removal?", "Proceed with this element removal?");
INSERT INTO languages VALUES ("en_US", "Process canceled successfully", "Process canceled successfully");
INSERT INTO languages VALUES ("en_US", "Process", "Process");
INSERT INTO languages VALUES ("en_US", "Processes", "Processes");
INSERT INTO languages VALUES ("en_US", "Product", "Product");
INSERT INTO languages VALUES ("en_US", "Property", "Property");
INSERT INTO languages VALUES ("en_US", "Protocol", "Protocol");
INSERT INTO languages VALUES ("en_US", "Put the license below", "Put the license below");
INSERT INTO languages VALUES ("en_US", "QUALITOR", "Qualitor Integration");
INSERT INTO languages VALUES ("en_US", "RSCHED", "Report Scheduler");
INSERT INTO languages VALUES ("en_US", "Range check", "Range check");
INSERT INTO languages VALUES ("en_US", "Reached", "Reached");
INSERT INTO languages VALUES ("en_US", "Realtime graph", "Realtime graph");
INSERT INTO languages VALUES ("en_US", "Receive host's notification?", "Receive host's notification?");
INSERT INTO languages VALUES ("en_US", "Receive service's notification?", "Receive service's notification?");
INSERT INTO languages VALUES ("en_US", "Received bytes", "Received bytes");
INSERT INTO languages VALUES ("en_US", "Received kbps", "Received(kbps)");
INSERT INTO languages VALUES ("en_US", "Receiving network traffic on ports", "Receiving network traffic on ports");
INSERT INTO languages VALUES ("en_US", "Recheck", "Recheck");
INSERT INTO languages VALUES ("en_US", "Recommended hosts for the model", "Recommended hosts for the model");
INSERT INTO languages VALUES ("en_US", "Recovery", "Recovery");
INSERT INTO languages VALUES ("en_US", "Redirecting to discovery", "Redirecting to discovery");
INSERT INTO languages VALUES ("en_US", "Refresh list", "Refresh list");
INSERT INTO languages VALUES ("en_US", "Refresh", "Refresh");
INSERT INTO languages VALUES ("en_US", "Register a new authentication", "Add a new authentication");
INSERT INTO languages VALUES ("en_US", "Register and associate ports, applications and protocols", "Create and associate ports, applications and protocols");
INSERT INTO languages VALUES ("en_US", "Register new authentication", "Add new authentication");
INSERT INTO languages VALUES ("en_US", "Registered Authentications", "Authentications");
INSERT INTO languages VALUES ("en_US", "Registering changes", "Setting up changes");
INSERT INTO languages VALUES ("en_US", "Relay server email", "Relay server email");
INSERT INTO languages VALUES ("en_US", "Remember me", "Remember me");
INSERT INTO languages VALUES ("en_US", "Remove Host (s) ?", "Remove Host (s) ?");
INSERT INTO languages VALUES ("en_US", "Remove Item", "Remove Item");
INSERT INTO languages VALUES ("en_US", "Remove Timecut", "Remove Timecut");
INSERT INTO languages VALUES ("en_US", "Remove a downtime", "Remove downtime");
INSERT INTO languages VALUES ("en_US", "Remove acknowledgement for this incident", "Remove acknowledgement for this incident");
INSERT INTO languages VALUES ("en_US", "Remove acknowledgement", "Remove acknowledgement");
INSERT INTO languages VALUES ("en_US", "Remove all actions of Hosts", "Remove all actions of Hosts");
INSERT INTO languages VALUES ("en_US", "Remove all actions of Services", "Remove all actions of Services");
INSERT INTO languages VALUES ("en_US", "Remove all comments", "Remove all comments");
INSERT INTO languages VALUES ("en_US", "Remove all host comments", "Remove all Host comments");
INSERT INTO languages VALUES ("en_US", "Remove all scheduled downtimes of the Hosts", "Remove all scheduled downtimes of the Hosts");
INSERT INTO languages VALUES ("en_US", "Remove all scheduled downtimes of the Services", "Remove all scheduled downtimes of the Services");
INSERT INTO languages VALUES ("en_US", "Remove bookmark", "Remove bookmark");
INSERT INTO languages VALUES ("en_US", "Remove current report", "Remove current report");
INSERT INTO languages VALUES ("en_US", "Remove host", "Remove host");
INSERT INTO languages VALUES ("en_US", "Remove report", "Remove report");
INSERT INTO languages VALUES ("en_US", "Remove selected elements", "Remove selected elements");
INSERT INTO languages VALUES ("en_US", "Remove service (s) ?", "Remove service (s) ?");
INSERT INTO languages VALUES ("en_US", "Remove service", "Remove service");
INSERT INTO languages VALUES ("en_US", "Remove this comment", "Remove this comment");
INSERT INTO languages VALUES ("en_US", "Remove this scheduled downtime", "Remove this scheduled downtime");
INSERT INTO languages VALUES ("en_US", "Remove", "Remove");
INSERT INTO languages VALUES ("en_US", "Removed successfully", "Removed successfully");
INSERT INTO languages VALUES ("en_US", "Rename service", "Rename service");
INSERT INTO languages VALUES ("en_US", "Rename", "Rename");
INSERT INTO languages VALUES ("en_US", "Repeat New Password", "Repeat New Password");
INSERT INTO languages VALUES ("en_US", "Repeat email", "Repeat email");
INSERT INTO languages VALUES ("en_US", "Repeat selected hours", "Repeat selected hours");
INSERT INTO languages VALUES ("en_US", "Repeat the e-mail", "Repeat the e-mail");
INSERT INTO languages VALUES ("en_US", "Repeat the password", "Repeat the password");
INSERT INTO languages VALUES ("en_US", "Report Name", "Report Name");
INSERT INTO languages VALUES ("en_US", "Report Scheduler", "Report scheduler");
INSERT INTO languages VALUES ("en_US", "Report Type", "Report Type");
INSERT INTO languages VALUES ("en_US", "Report by e-mail", "Report by e-mail");
INSERT INTO languages VALUES ("en_US", "Report configuration", "Report configuration");
INSERT INTO languages VALUES ("en_US", "Report objects", "Report objects");
INSERT INTO languages VALUES ("en_US", "Report removed successfully", "Report removed successfully");
INSERT INTO languages VALUES ("en_US", "Report scheduled", "Report scheduled");
INSERT INTO languages VALUES ("en_US", "Reports", "Reports");
INSERT INTO languages VALUES ("en_US", "Requeriments", "Requeriments");
INSERT INTO languages VALUES ("en_US", "Request Error", "Request Error");
INSERT INTO languages VALUES ("en_US", "Request Status", "Request Status");
INSERT INTO languages VALUES ("en_US", "RequestErrorMsg", "An error occurred while trying to process this request. Please refresh the page.<br>If the problem persists, contact your system administrator.");
INSERT INTO languages VALUES ("en_US", "Requesting information for %COUNT%.", "Requesting information for %COUNT%.");
INSERT INTO languages VALUES ("en_US", "Reschedule next check", "Reschedule next check");
INSERT INTO languages VALUES ("en_US", "Reschedule next host check", "Reschedule next Host check");
INSERT INTO languages VALUES ("en_US", "Reset Done", "Reset Done");
INSERT INTO languages VALUES ("en_US", "Reset fields", "Reset fields");
INSERT INTO languages VALUES ("en_US", "Resolve conflict", "Resolve conflict");
INSERT INTO languages VALUES ("en_US", "Responsible users", "Responsible users");
INSERT INTO languages VALUES ("en_US", "Responsible", "Responsible");
INSERT INTO languages VALUES ("en_US", "Restarting OpMon Traffic Analyzer process...", "Restarting OpMon Traffic Analyzer process...");
INSERT INTO languages VALUES ("en_US", "Restore default OpMon logo", "Restore default OpMon logo");
INSERT INTO languages VALUES ("en_US", "Restore default", "Restore default");
INSERT INTO languages VALUES ("en_US", "Restore values", "Restore values");
INSERT INTO languages VALUES ("en_US", "Retrieving discovered objects", "Retrieving discovered objects");
INSERT INTO languages VALUES ("en_US", "Retry Interval", "Retry Interval");
INSERT INTO languages VALUES ("en_US", "Retry check interval", "Retry check interval");
INSERT INTO languages VALUES ("en_US", "Retry interval", "Retry interval");
INSERT INTO languages VALUES ("en_US", "Retry", "Retry");
INSERT INTO languages VALUES ("en_US", "Return", "Return");
INSERT INTO languages VALUES ("en_US", "Review your configuration", "Review your configuration");
INSERT INTO languages VALUES ("en_US", "Run Command?", "Run Command?");
INSERT INTO languages VALUES ("en_US", "SCAT Description", "Here you can define the components of service catalog");
INSERT INTO languages VALUES ("en_US", "SCAT", "Service Catalogs");
INSERT INTO languages VALUES ("en_US", "SCM", "Switchs' Backup");
INSERT INTO languages VALUES ("en_US", "SLA Breach Reason Start", "SLA BREACH REASON START");
INSERT INTO languages VALUES ("en_US", "SLA Breach Reason Stop", "SLA BREACH REASON STOP");
INSERT INTO languages VALUES ("en_US", "SLA Breach Reason", "SLA Breach Reason");
INSERT INTO languages VALUES ("en_US", "SLA Breach Reasons as OK", "SLA Breach Reasons as OK");
INSERT INTO languages VALUES ("en_US", "SLA Breach Reasons", "SLA Breach Reasons");
INSERT INTO languages VALUES ("en_US", "SLA Breach", "SLA Breach");
INSERT INTO languages VALUES ("en_US", "SLA Description", "A contract between a service provider and a customer that specifies, usually in measurable terms, what services the service provider will furnish.");
INSERT INTO languages VALUES ("en_US", "SLA For Catalog", "SLA for Service Catalog service");
INSERT INTO languages VALUES ("en_US", "SLA", "SLA");
INSERT INTO languages VALUES ("en_US", "SLA(Service Level Agreement)", "SLA(Service Level Agreement)");
INSERT INTO languages VALUES ("en_US", "SLM", "SLM");
INSERT INTO languages VALUES ("en_US", "SLM_License", "Service Level Management");
INSERT INTO languages VALUES ("en_US", "SNMP Communities", "SNMP Communities");
INSERT INTO languages VALUES ("en_US", "SNMP Version", "SNMP Version");
INSERT INTO languages VALUES ("en_US", "SOAP", "Soap API");
INSERT INTO languages VALUES ("en_US", "SOFT", "SOFT");
INSERT INTO languages VALUES ("en_US", "SUMALERT", "Alerts Summary");
INSERT INTO languages VALUES ("en_US", "Sample collected", "Sample collected");
INSERT INTO languages VALUES ("en_US", "Saturday", "Saturday");
INSERT INTO languages VALUES ("en_US", "Savar baseline", "Savar baseline");
INSERT INTO languages VALUES ("en_US", "Save Changes", "Save Changes");
INSERT INTO languages VALUES ("en_US", "Save Settings", "Save Settings");
INSERT INTO languages VALUES ("en_US", "Save Timecut", "Save Timecut");
INSERT INTO languages VALUES ("en_US", "Save as ...", "Save as ...");
INSERT INTO languages VALUES ("en_US", "Save as", "Save as");
INSERT INTO languages VALUES ("en_US", "Save changes", "Save changes");
INSERT INTO languages VALUES ("en_US", "Save created command", "Save created command");
INSERT INTO languages VALUES ("en_US", "Save report", "Save report");
INSERT INTO languages VALUES ("en_US", "Save the Report", "Save the report");
INSERT INTO languages VALUES ("en_US", "Save this report", "Save this report");
INSERT INTO languages VALUES ("en_US", "Save", "Save");
INSERT INTO languages VALUES ("en_US", "Saving Changes", "Saving Changes");
INSERT INTO languages VALUES ("en_US", "Scan finished!", "Scan finished!");
INSERT INTO languages VALUES ("en_US", "Scanning network", "Scanning network");
INSERT INTO languages VALUES ("en_US", "Scanning", "Scanning");
INSERT INTO languages VALUES ("en_US", "Sched. Downtime", "Sched. Downtime");
INSERT INTO languages VALUES ("en_US", "Schedule a downtime for all hosts", "Schedule downtime for all Hosts");
INSERT INTO languages VALUES ("en_US", "Schedule a downtime for all services", "Schedule downtime for all Services");
INSERT INTO languages VALUES ("en_US", "Schedule a downtime", "Schedule downtime");
INSERT INTO languages VALUES ("en_US", "Schedule a non programmed downtime", "Schedule a non programmed downtime");
INSERT INTO languages VALUES ("en_US", "Schedule a programmed downtime", "Schedule a programmed downtime");
INSERT INTO languages VALUES ("en_US", "Schedule check for all services", "Schedule check for all Services");
INSERT INTO languages VALUES ("en_US", "Schedule report", "Schedule report");
INSERT INTO languages VALUES ("en_US", "Scheduled Downtime Begin", "Schedule Downtime Start");
INSERT INTO languages VALUES ("en_US", "Scheduled Downtime End", "Schedule Downtime Stop");
INSERT INTO languages VALUES ("en_US", "Scheduled as OK", "Scheduled as OK");
INSERT INTO languages VALUES ("en_US", "Scheduled checks queue", "Scheduled checks queue");
INSERT INTO languages VALUES ("en_US", "Scheduled downtime", "Scheduled&nbsp;downtime");
INSERT INTO languages VALUES ("en_US", "Scheduled downtimes", "Scheduled&nbsp;downtimes");
INSERT INTO languages VALUES ("en_US", "Scheduled queue", "Scheduled queue");
INSERT INTO languages VALUES ("en_US", "Scheduled", "Scheduled");
INSERT INTO languages VALUES ("en_US", "Scheduler", "Scheduler");
INSERT INTO languages VALUES ("en_US", "Search for specific elements", "Search for specific elements");
INSERT INTO languages VALUES ("en_US", "Search", "Search");
INSERT INTO languages VALUES ("en_US", "Searching for sources of network traffic", "Searching for sources of network traffic");
INSERT INTO languages VALUES ("en_US", "Secondary DNS", "Secondary DNS");
INSERT INTO languages VALUES ("en_US", "Secundary DNS", "Secundary DNS");
INSERT INTO languages VALUES ("en_US", "Security", "Security");
INSERT INTO languages VALUES ("en_US", "See Ips and Ranges to be processed", "See IPs and Ranges to be processed");
INSERT INTO languages VALUES ("en_US", "See metrics", "See metrics");
INSERT INTO languages VALUES ("en_US", "Select Template", "Select Template");
INSERT INTO languages VALUES ("en_US", "Select a CI", "Select a Host");
INSERT INTO languages VALUES ("en_US", "Select a command", "Select a command");
INSERT INTO languages VALUES ("en_US", "Select a contactgroup", "Select a contactgroup");
INSERT INTO languages VALUES ("en_US", "Select a contacts", "Select a contacts");
INSERT INTO languages VALUES ("en_US", "Select a custom report", "Select a custom report");
INSERT INTO languages VALUES ("en_US", "Select a host already discovered", "Select a host already discovered");
INSERT INTO languages VALUES ("en_US", "Select a host", "Select a host");
INSERT INTO languages VALUES ("en_US", "Select a method for group by", "Select a method for group by");
INSERT INTO languages VALUES ("en_US", "Select a report first", "Select a report first");
INSERT INTO languages VALUES ("en_US", "Select a servicegroup", "Select a servicegroup");
INSERT INTO languages VALUES ("en_US", "Select a timecut", "Select a timecut");
INSERT INTO languages VALUES ("en_US", "Select all elements", "Select all elements");
INSERT INTO languages VALUES ("en_US", "Select an available command", "Select an available command");
INSERT INTO languages VALUES ("en_US", "Select an object type", "Select an object type");
INSERT INTO languages VALUES ("en_US", "Select an output type", "Select an output type");
INSERT INTO languages VALUES ("en_US", "Select and configure the elements you want to monitor", "Select and configure the elements you want to monitor");
INSERT INTO languages VALUES ("en_US", "Select column", "Select column");
INSERT INTO languages VALUES ("en_US", "Select desired objects", "Select desired objects");
INSERT INTO languages VALUES ("en_US", "Select models", "Select models");
INSERT INTO languages VALUES ("en_US", "Select objects", "Select objects");
INSERT INTO languages VALUES ("en_US", "Select one or more exist metrics on your system to apply the baseline.", "Select one or more exist metrics on your system to apply the baseline.");
INSERT INTO languages VALUES ("en_US", "Select one or more hosts to apply the model", "Select one or more hosts to apply the model");
INSERT INTO languages VALUES ("en_US", "Select or search an external command", "Select or search an external command");
INSERT INTO languages VALUES ("en_US", "Select package for upload", "Select package for upload");
INSERT INTO languages VALUES ("en_US", "Select packages for installation", "Select packages for installation");
INSERT INTO languages VALUES ("en_US", "Select period", "Select period");
INSERT INTO languages VALUES ("en_US", "Select saved report", "Select saved report");
INSERT INTO languages VALUES ("en_US", "Select service", "Select service");
INSERT INTO languages VALUES ("en_US", "Select services", "Select services");
INSERT INTO languages VALUES ("en_US", "Select the Report Objects", "Select the report objects");
INSERT INTO languages VALUES ("en_US", "Select the contact", "Select the contact");
INSERT INTO languages VALUES ("en_US", "Select the element", "Select the element");
INSERT INTO languages VALUES ("en_US", "Select the group", "Select the group");
INSERT INTO languages VALUES ("en_US", "Select the host", "Select the host");
INSERT INTO languages VALUES ("en_US", "Select the hosts that receive the service", "Select the hosts that receive the service");
INSERT INTO languages VALUES ("en_US", "Select the hosts", "Select the hosts");
INSERT INTO languages VALUES ("en_US", "Select the probes you want to monitor", "Select the probes you want to monitor");
INSERT INTO languages VALUES ("en_US", "Select the service and its parameters", "Select the service and its parameters");
INSERT INTO languages VALUES ("en_US", "Select the services to monitor and set its parameters", "Select the services and set its parameters");
INSERT INTO languages VALUES ("en_US", "Select the source host", "Select the source host");
INSERT INTO languages VALUES ("en_US", "Select the templates you want to apply to hosts in the editing", "Select the templates you want to apply to hosts in the editing");
INSERT INTO languages VALUES ("en_US", "Select the type of the element", "Select the type of the element");
INSERT INTO languages VALUES ("en_US", "Select timecut", "Select timecut");
INSERT INTO languages VALUES ("en_US", "Selected objects", "Selected objects");
INSERT INTO languages VALUES ("en_US", "Selected", "Selected");
INSERT INTO languages VALUES ("en_US", "Send Test", "Send Test");
INSERT INTO languages VALUES ("en_US", "Send by e-mail for {0} contact(s)", "Send by e-mail for {0} contact(s)");
INSERT INTO languages VALUES ("en_US", "Send by e-mail for", "Send by e-mail for");
INSERT INTO languages VALUES ("en_US", "Send custom notification", "Send custom notification");
INSERT INTO languages VALUES ("en_US", "Send notification", "Send notification");
INSERT INTO languages VALUES ("en_US", "Send passive check result", "Send passive check result");
INSERT INTO languages VALUES ("en_US", "Send report by e-mail", "Send report by e-mail");
INSERT INTO languages VALUES ("en_US", "Send result", "Send result");
INSERT INTO languages VALUES ("en_US", "Send", "Send");
INSERT INTO languages VALUES ("en_US", "Sent bytes", "Sent bytes");
INSERT INTO languages VALUES ("en_US", "Sent kbps", "Sent(kbps)");
INSERT INTO languages VALUES ("en_US", "Sep", "Sep");
INSERT INTO languages VALUES ("en_US", "September", "September");
INSERT INTO languages VALUES ("en_US", "Service Grid", "Service Grid");
INSERT INTO languages VALUES ("en_US", "Service Group", "Service Group");
INSERT INTO languages VALUES ("en_US", "Service Groups", "Service Groups");
INSERT INTO languages VALUES ("en_US", "Service Name", "Service Name");
INSERT INTO languages VALUES ("en_US", "Service Structure", "Service Structure");
INSERT INTO languages VALUES ("en_US", "Service description invalid", "Service description invalid");
INSERT INTO languages VALUES ("en_US", "Service description", "Service description");
INSERT INTO languages VALUES ("en_US", "Service groups", "Service groups");
INSERT INTO languages VALUES ("en_US", "Service is not selected", "Service is not selected");
INSERT INTO languages VALUES ("en_US", "Service origin of new metrics", "Service origin of new metrics");
INSERT INTO languages VALUES ("en_US", "Service status", "Service status");
INSERT INTO languages VALUES ("en_US", "Service successfully updated", "Service successfully updated");
INSERT INTO languages VALUES ("en_US", "Service", "Service");
INSERT INTO languages VALUES ("en_US", "Service(s) with conflict", "Service(s) with conflict");
INSERT INTO languages VALUES ("en_US", "Servicegroup Grid", "Service Groups Grid");
INSERT INTO languages VALUES ("en_US", "Servicegroup origin of new metrics", "Servicegroup origin of new metrics");
INSERT INTO languages VALUES ("en_US", "Servicegroup", "Service Group");
INSERT INTO languages VALUES ("en_US", "Services Catalog", "Catalogs");
INSERT INTO languages VALUES ("en_US", "Services and Contacts", "Services and Contacts");
INSERT INTO languages VALUES ("en_US", "Services of ", "Services of ");
INSERT INTO languages VALUES ("en_US", "Services template", "Services template");
INSERT INTO languages VALUES ("en_US", "Services with ack", "Services with ack");
INSERT INTO languages VALUES ("en_US", "Services", "Services");
INSERT INTO languages VALUES ("en_US", "Set Date and Time", "Set Date and Time");
INSERT INTO languages VALUES ("en_US", "Set Teams and Responsibles for hosts", "Set contacts and contactgroups for hosts");
INSERT INTO languages VALUES ("en_US", "Set Up Backup", "Set Up Backup");
INSERT INTO languages VALUES ("en_US", "Set contacts and contactgroups for services", "Set contacts and contactgroups for services");
INSERT INTO languages VALUES ("en_US", "Set email and password to start or %link%click here%endlink% for help", "Set email and password to start or %link%click here%endlink% for help");
INSERT INTO languages VALUES ("en_US", "Set password and email", "Set password and email");
INSERT INTO languages VALUES ("en_US", "Set the Community parameters", "Set the Community parameters");
INSERT INTO languages VALUES ("en_US", "Set the administrator password", "Set the administrator password");
INSERT INTO languages VALUES ("en_US", "Set the arguments of the selected command", "Set the arguments of the selected command");
INSERT INTO languages VALUES ("en_US", "Set the data of the system administrator user.", "Set the data of the system administrator user.");
INSERT INTO languages VALUES ("en_US", "Set the description", "Set the description");
INSERT INTO languages VALUES ("en_US", "Set the e- mail", "Set the e- mail");
INSERT INTO languages VALUES ("en_US", "Set the e-mail", "Set the e-mail");
INSERT INTO languages VALUES ("en_US", "Set the group parameters", "Set the group parameters");
INSERT INTO languages VALUES ("en_US", "Set the host IP", "Set the host IP");
INSERT INTO languages VALUES ("en_US", "Set the hostname", "Set the hostname");
INSERT INTO languages VALUES ("en_US", "Set the parameters of group", "Set the parameters of group");
INSERT INTO languages VALUES ("en_US", "Set the parameters of the command", "Set the parameters of the command");
INSERT INTO languages VALUES ("en_US", "Set the parameters of the host", "Set the parameters of the host");
INSERT INTO languages VALUES ("en_US", "Set the parameters of the service", "Set the parameters of the service");
INSERT INTO languages VALUES ("en_US", "Set the parameters of the team", "Set the parameters of the contactgroup");
INSERT INTO languages VALUES ("en_US", "Set the password and the e-mail", "Set the password and the e-mail");
INSERT INTO languages VALUES ("en_US", "Set the password of the administrator user and email", "Set the password of the administrator user and email");
INSERT INTO languages VALUES ("en_US", "Set the password", "Set the password");
INSERT INTO languages VALUES ("en_US", "Set the services parameters", "Set the services parameters");
INSERT INTO languages VALUES ("en_US", "Set the source host to be added", "Set the source host to be added");
INSERT INTO languages VALUES ("en_US", "Set up the environment for me <br> <span class=\'btn_subtext fa-green\'> Recommended </ span>", "Set up the environment for me <br> <span class=\'btn_subtext fa-green\'> Recommended </ span>");
INSERT INTO languages VALUES ("en_US", "Set via DHCP", "Set via DHCP");
INSERT INTO languages VALUES ("en_US", "Setting behavior", "Setting behavior");
INSERT INTO languages VALUES ("en_US", "Settings saved successfully", "Settings saved successfully");
INSERT INTO languages VALUES ("en_US", "Settings", "Settings");
INSERT INTO languages VALUES ("en_US", "Setup finished!", "Setup finished!");
INSERT INTO languages VALUES ("en_US", "Share", "Share");
INSERT INTO languages VALUES ("en_US", "Shortcuts", "Shortcuts");
INSERT INTO languages VALUES ("en_US", "Show alarms", "Show alarms");
INSERT INTO languages VALUES ("en_US", "Show details", "Show details");
INSERT INTO languages VALUES ("en_US", "Show errors", "Show errors");
INSERT INTO languages VALUES ("en_US", "Show only", "Show only");
INSERT INTO languages VALUES ("en_US", "Show thresholds", "Show thresholds");
INSERT INTO languages VALUES ("en_US", "Simple Service Level Agreement Report", "Simple Service Level Agreement Report");
INSERT INTO languages VALUES ("en_US", "Simple", "Simple");
INSERT INTO languages VALUES ("en_US", "Size of the collected sample", "Size of the collected sample");
INSERT INTO languages VALUES ("en_US", "Skip", "Skip");
INSERT INTO languages VALUES ("en_US", "Soft State", "Soft State");
INSERT INTO languages VALUES ("en_US", "Some changes on OpMon configuration are being applied, this can time some time.", "Some changes on OpMon configuration are being applied, this can time some time.");
INSERT INTO languages VALUES ("en_US", "Some network settings are invalid", "Some network settings are invalid");
INSERT INTO languages VALUES ("en_US", "Some of your services belong to a template, unable to remove them", "Some of your services belong to a template, unable to remove them");
INSERT INTO languages VALUES ("en_US", "Special calendar", "Calendar");
INSERT INTO languages VALUES ("en_US", "SplashScreenMsg", "Thank you for using OpMon, a complete platform for IT Governance, Business Process Monitoring and Systems &amp Network Management.");
INSERT INTO languages VALUES ("en_US", "Stage 1 of 4", "Stage 1 of 4");
INSERT INTO languages VALUES ("en_US", "Stage 2 of 4", "Stage 2 of 4");
INSERT INTO languages VALUES ("en_US", "Stage 3 of 4", "Stage 3 of 4");
INSERT INTO languages VALUES ("en_US", "Stage 4 of 4", "Stage 4 of 4");
INSERT INTO languages VALUES ("en_US", "Start Scan", "Start Scan");
INSERT INTO languages VALUES ("en_US", "Start date", "Start date");
INSERT INTO languages VALUES ("en_US", "Start discovery", "Start discovery");
INSERT INTO languages VALUES ("en_US", "Start new Discovery", "Start new Discovery");
INSERT INTO languages VALUES ("en_US", "Start selection", "Start selection");
INSERT INTO languages VALUES ("en_US", "Start setting your report here", "Start setting your report here");
INSERT INTO languages VALUES ("en_US", "Start setup", "Start setup");
INSERT INTO languages VALUES ("en_US", "Start the configuration!", "Start the configuration!");
INSERT INTO languages VALUES ("en_US", "Start time", "Start time");
INSERT INTO languages VALUES ("en_US", "Start", "Start");
INSERT INTO languages VALUES ("en_US", "State Type", "State type");
INSERT INTO languages VALUES ("en_US", "State", "State");
INSERT INTO languages VALUES ("en_US", "Status Overview", "Status Overview");
INSERT INTO languages VALUES ("en_US", "Status Totals", "Status Totals");
INSERT INTO languages VALUES ("en_US", "Status", "Status");
INSERT INTO languages VALUES ("en_US", "Step 1 of 3", "Step 1 of 3");
INSERT INTO languages VALUES ("en_US", "Step 1 of 4", "Step 1 of 4");
INSERT INTO languages VALUES ("en_US", "Step 1", "Step 1");
INSERT INTO languages VALUES ("en_US", "Step 1: Set the Administrator user", "Step 1: Set the Administrator user");
INSERT INTO languages VALUES ("en_US", "Step 2 of 3", "Step 2 of 3");
INSERT INTO languages VALUES ("en_US", "Step 2 of 4", "Step 2 of 4");
INSERT INTO languages VALUES ("en_US", "Step 2", "Step 2");
INSERT INTO languages VALUES ("en_US", "Step 2: Set up the environment", "Step 2: Set up the environment");
INSERT INTO languages VALUES ("en_US", "Step 3 of 4", "Step 3 of 4");
INSERT INTO languages VALUES ("en_US", "Step 3", "Step 3");
INSERT INTO languages VALUES ("en_US", "Step 3: Configure the application", "Step 3: Configure the application");
INSERT INTO languages VALUES ("en_US", "Step 4 of 4", "Step 4 of 4");
INSERT INTO languages VALUES ("en_US", "Stop setting. I want to leave it for later.", "Stop setting. I want to leave it for later.");
INSERT INTO languages VALUES ("en_US", "Stop", "Stop");
INSERT INTO languages VALUES ("en_US", "Stopped since", "Stopped since ");
INSERT INTO languages VALUES ("en_US", "Storage error", "Storage error");
INSERT INTO languages VALUES ("en_US", "Storage path", "Storage path");
INSERT INTO languages VALUES ("en_US", "Submit", "Submit");
INSERT INTO languages VALUES ("en_US", "Submiting command, please wait", "Submiting command, please wait");
INSERT INTO languages VALUES ("en_US", "Subscribe", "Subscribe");
INSERT INTO languages VALUES ("en_US", "Success log", "Success log");
INSERT INTO languages VALUES ("en_US", "Success", "Success");
INSERT INTO languages VALUES ("en_US", "Suggested categories", "Suggested categories");
INSERT INTO languages VALUES ("en_US", "Suggested models", "Suggested models");
INSERT INTO languages VALUES ("en_US", "Sum", "Sum");
INSERT INTO languages VALUES ("en_US", "Summary view", "Summary View");
INSERT INTO languages VALUES ("en_US", "Sunday", "Sunday");
INSERT INTO languages VALUES ("en_US", "Support", "Support");
INSERT INTO languages VALUES ("en_US", "Syntax error on line:", "Syntax error on line:");
INSERT INTO languages VALUES ("en_US", "System", "System");
INSERT INTO languages VALUES ("en_US", "THEMES", "Themes");
INSERT INTO languages VALUES ("en_US", "TOPOLOGY", "Monitoring Topology");
INSERT INTO languages VALUES ("en_US", "Tabular", "Grid");
INSERT INTO languages VALUES ("en_US", "Tabular", "Tabular");
INSERT INTO languages VALUES ("en_US", "Tactical View", "Tactical View");
INSERT INTO languages VALUES ("en_US", "Target hosts", "Target hosts");
INSERT INTO languages VALUES ("en_US", "Team already contains this user", "Team already contains this user");
INSERT INTO languages VALUES ("en_US", "Teams Responsible", "Teams Responsible");
INSERT INTO languages VALUES ("en_US", "Teams", "Teams");
INSERT INTO languages VALUES ("en_US", "Technical Accountable", "Technical Accountable");
INSERT INTO languages VALUES ("en_US", "Template name", "Template name");
INSERT INTO languages VALUES ("en_US", "Test Command", "Test Command");
INSERT INTO languages VALUES ("en_US", "Test command", "Test command");
INSERT INTO languages VALUES ("en_US", "Test result", "Test result");
INSERT INTO languages VALUES ("en_US", "Test sending", "Test sending");
INSERT INTO languages VALUES ("en_US", "Test", "Test");
INSERT INTO languages VALUES ("en_US", "Thank you for installing OpMon . Now you can anticipate problems and manage your IT environment and Telecom proactively , before it impact your organization . With only 3 steps you can set the administrator , perform the discovery operation , identify and monitor hosts and services automatically and generate the topology of your network .", "Thank you for installing OpMon . Now you can anticipate problems and manage your IT environment and Telecom proactively , before it impact your organization . With only 3 steps you can set the administrator , perform the discovery operation , identify and monitor hosts and services automatically and generate the topology of your network .");
INSERT INTO languages VALUES ("en_US", "The %COUNT% address does not respond...", "The %COUNT% address does not respond...");
INSERT INTO languages VALUES ("en_US", "The %XYZ% module is available only from the PRO version", "The %XYZ% module is available only from the PRO version");
INSERT INTO languages VALUES ("en_US", "The OpMon Traffic Analyzer already has settings for ports, protocols and applications. Changes to these settings will impact the way data is stored and presented.", "The OpMon Traffic Analyzer already has settings for ports, protocols and applications. Changes to these settings will impact the way data is stored and presented.");
INSERT INTO languages VALUES ("en_US", "The OpMon Traffic Analyzer found no source of traffic", "The OpMon Traffic Analyzer found no source of traffic");
INSERT INTO languages VALUES ("en_US", "The OpMon Traffic Analyzer is waiting while you set up your sources of network traffic.", "The OpMon Traffic Analyzer is waiting while you set up your sources of network traffic.");
INSERT INTO languages VALUES ("en_US", "The OpMon Traffic Analyzer is waiting", "The OpMon Traffic Analyzer is waiting");
INSERT INTO languages VALUES ("en_US", "The emails you entered do not match", "The emails you entered do not match");
INSERT INTO languages VALUES ("en_US", "The end date and end time must be less than now", "The end date and end time must be less than now");
INSERT INTO languages VALUES ("en_US", "The following services belong to a template and can't be edited", "The following services belong to a template and can't be edited");
INSERT INTO languages VALUES ("en_US", "The greatest number allowed for ports is", "The greatest number allowed for ports is");
INSERT INTO languages VALUES ("en_US", "The lowest number allowed for ports is", "The lowest number allowed for ports is");
INSERT INTO languages VALUES ("en_US", "The passwords entered do not match", "The passwords entered do not match");
INSERT INTO languages VALUES ("en_US", "The ports must be different.", "The ports must be different.");
INSERT INTO languages VALUES ("en_US", "The selected port is already in use by OpMon Traffic Analyzer.", "The selected port is already in use by OpMon Traffic Analyzer.");
INSERT INTO languages VALUES ("en_US", "The selected port is already in use.", "The selected port is already in use.");
INSERT INTO languages VALUES ("en_US", "The settings could not be applied, please try again later", "The settings could not be applied, please try again later");
INSERT INTO languages VALUES ("en_US", "The start date must be less than the end date.", "The start date must be less than the end date.");
INSERT INTO languages VALUES ("en_US", "The traffic analysis environment is ready for you.", "The traffic analysis environment is ready for you.");
INSERT INTO languages VALUES ("en_US", "The version %s are available in our repositories. Click here to see more.", "The version %s are available in our repositories. Click here to see more.");
INSERT INTO languages VALUES ("en_US", "Theme Changed", "Theme Changed");
INSERT INTO languages VALUES ("en_US", "Theme color", "Theme color");
INSERT INTO languages VALUES ("en_US", "Themes", "Themes");
INSERT INTO languages VALUES ("en_US", "There are any metrics on this service.", "There are any metrics on this service.");
INSERT INTO languages VALUES ("en_US", "There are no metric available", "There are no metric available");
INSERT INTO languages VALUES ("en_US", "There are no metrics selected yet", "There are no metrics selected yet");
INSERT INTO languages VALUES ("en_US", "There has not been any elements discovered yet. %link% in order to start the discovery process.", "There has not been any elements discovered yet. %link% in order to start the discovery process.");
INSERT INTO languages VALUES ("en_US", "There is no model related to hosts", "There is no model related to hosts");
INSERT INTO languages VALUES ("en_US", "There is no object available", "There is no object available");
INSERT INTO languages VALUES ("en_US", "There is no object selected", "There is no object selected");
INSERT INTO languages VALUES ("en_US", "These are the chosen environment settings. Make sure they are correct.", "These are the chosen environment settings. Make sure they are correct.");
INSERT INTO languages VALUES ("en_US", "This authentication cannot be removed because is used by the following hosts", "This authentication cannot be removed because is used by the following hosts");
INSERT INTO languages VALUES ("en_US", "This baseline can not be deleted because it is associated with [number of metrics available] metrics.", "This baseline can not be deleted because it is associated with [number of metrics available] metrics.");
INSERT INTO languages VALUES ("en_US", "This baseline serves to test the interface", "This baseline serves to test the interface");
INSERT INTO languages VALUES ("en_US", "This field is mandatory", "This field is mandatory");
INSERT INTO languages VALUES ("en_US", "This hour", "This hour");
INSERT INTO languages VALUES ("en_US", "This is a system element and can't be removed!", "This is a system element and can't be removed!");
INSERT INTO languages VALUES ("en_US", "This item dont have performance data", "This item don't have performance data");
INSERT INTO languages VALUES ("en_US", "This month", "This month");
INSERT INTO languages VALUES ("en_US", "This port is already used by Netflow", "his port is already used by Netflow");
INSERT INTO languages VALUES ("en_US", "This port is already used by SFlow", "This port is already used by SFlow");
INSERT INTO languages VALUES ("en_US", "This service is not available for the selected host(s)", "This service is not available for the selected host(s)");
INSERT INTO languages VALUES ("en_US", "This week", "This week");
INSERT INTO languages VALUES ("en_US", "This year", "This year");
INSERT INTO languages VALUES ("en_US", "Thresholds", "Thresholds");
INSERT INTO languages VALUES ("en_US", "Thursday", "Thursday");
INSERT INTO languages VALUES ("en_US", "Time", "Time");
INSERT INTO languages VALUES ("en_US", "Timecut Description", "Here you can define your enterprise workhours, these pre-defined 'timecuts' can be used on Capacity and Availability Reports.");
INSERT INTO languages VALUES ("en_US", "Timecut removed sucessfully", "Timecut removed sucessfully");
INSERT INTO languages VALUES ("en_US", "Timecut saved sucessfully", "Timecut saved sucessfully");
INSERT INTO languages VALUES ("en_US", "Timecut", "Timecut");
INSERT INTO languages VALUES ("en_US", "To", "To");
INSERT INTO languages VALUES ("en_US", "Today", "Today");
INSERT INTO languages VALUES ("en_US", "Toggle autoscale", "Toggle autoscale");
INSERT INTO languages VALUES ("en_US", "Toggle metric", "Toggle metric");
INSERT INTO languages VALUES ("en_US", "Toggle metrics", "Toggle metrics");
INSERT INTO languages VALUES ("en_US", "Toggle thresholds", "Toggle thresholds");
INSERT INTO languages VALUES ("en_US", "Tools", "Tools");
INSERT INTO languages VALUES ("en_US", "Top 5 - Alerts", "Top 5 - Alerts");
INSERT INTO languages VALUES ("en_US", "Topology Awareness Message", "Here you can generate and view before applying the topology of your monitored servers.");
INSERT INTO languages VALUES ("en_US", "Topology", "Topology");
INSERT INTO languages VALUES ("en_US", "Traceroute", "Traceroute");
INSERT INTO languages VALUES ("en_US", "Transfer errors", "Transfer errors");
INSERT INTO languages VALUES ("en_US", "Trend lines", "Trend lines");
INSERT INTO languages VALUES ("en_US", "Trigger ID", "Trigger ID");
INSERT INTO languages VALUES ("en_US", "Triggered by", "Triggered by");
INSERT INTO languages VALUES ("en_US", "Try again", "Try again");
INSERT INTO languages VALUES ("en_US", "Try exporting configuration", "Try exporting configuration");
INSERT INTO languages VALUES ("en_US", "Tuesday", "Tuesday");
INSERT INTO languages VALUES ("en_US", "Type an user", "Type an user");
INSERT INTO languages VALUES ("en_US", "Type of day", "Type of day");
INSERT INTO languages VALUES ("en_US", "Type the directory name", "Type the directory name");
INSERT INTO languages VALUES ("en_US", "Type the new bookmark name", "Type the new bookmark name");
INSERT INTO languages VALUES ("en_US", "Type the new shortcut name", "Type the new shortcut name");
INSERT INTO languages VALUES ("en_US", "Type the word <strong> DELETE </ strong> to confirm", "Type the word <strong> DELETE </ strong> to confirm");
INSERT INTO languages VALUES ("en_US", "Type", "Type");
INSERT INTO languages VALUES ("en_US", "UNKNOWN", "UNKNOWN");
INSERT INTO languages VALUES ("en_US", "UNREACHABLE", "UNREACHABLE");
INSERT INTO languages VALUES ("en_US", "UP", "UP");
INSERT INTO languages VALUES ("en_US", "Unable to access the server", "Unable to access the server");
INSERT INTO languages VALUES ("en_US", "Unable to add a field without `name' defined", "Unable to add a field without `name' defined");
INSERT INTO languages VALUES ("en_US", "Unable to connect to server", "Unable to connect to server");
INSERT INTO languages VALUES ("en_US", "Unable to locate host group", "Unable to locate host group");
INSERT INTO languages VALUES ("en_US", "Unable to locate host", "Unable to locate host");
INSERT INTO languages VALUES ("en_US", "Unable to locate service", "Unable to locate service");
INSERT INTO languages VALUES ("en_US", "Unable to locate services group", "Unable to locate services group");
INSERT INTO languages VALUES ("en_US", "Unable to locate staff", "Unable to locate staff");
INSERT INTO languages VALUES ("en_US", "Unable to locate team", "Unable to locate contactgroup");
INSERT INTO languages VALUES ("en_US", "Unable to synchronize group of hosts", "Unable to synchronize group of hosts");
INSERT INTO languages VALUES ("en_US", "Unable to synchronize services group", "Unable to synchronize services group");
INSERT INTO languages VALUES ("en_US", "Unable to synchronize teams", "Unable to synchronize contactgroups");
INSERT INTO languages VALUES ("en_US", "Unable to write content into backup", "Unable to write content into backup");
INSERT INTO languages VALUES ("en_US", "Unable to write content into ifcfg-eth0", "Unable to write content into ifcfg-eth0");
INSERT INTO languages VALUES ("en_US", "Unable to write content into ntp.conf", "Unable to write content into ntp.conf");
INSERT INTO languages VALUES ("en_US", "Unexpected Error", "Unexpected Error");
INSERT INTO languages VALUES ("en_US", "Uninstall packages", "Uninstall packages");
INSERT INTO languages VALUES ("en_US", "Unit", "Unit");
INSERT INTO languages VALUES ("en_US", "Unknown User", "Unknown User");
INSERT INTO languages VALUES ("en_US", "Unknown", "Unknown");
INSERT INTO languages VALUES ("en_US", "Unlimited", "Unlimited");
INSERT INTO languages VALUES ("en_US", "Unreachable", "Unreachable");
INSERT INTO languages VALUES ("en_US", "Unsaved changes", "Unsaved changes");
INSERT INTO languages VALUES ("en_US", "Unselect column", "Unselect column");
INSERT INTO languages VALUES ("en_US", "Update license", "Update license...");
INSERT INTO languages VALUES ("en_US", "Update port...", "Update port...");
INSERT INTO languages VALUES ("en_US", "Updated on", "Updated on");
INSERT INTO languages VALUES ("en_US", "Updated", "Updated");
INSERT INTO languages VALUES ("en_US", "Updating IP address...", "Updating IP address...");
INSERT INTO languages VALUES ("en_US", "Updating database...", "Updating database...");
INSERT INTO languages VALUES ("en_US", "Updating the configuration file...", "Updating the configuration file...");
INSERT INTO languages VALUES ("en_US", "Updating", "Updating");
INSERT INTO languages VALUES ("en_US", "Upload Success", "Upload Success");
INSERT INTO languages VALUES ("en_US", "Upload a new package", "Upload a new package");
INSERT INTO languages VALUES ("en_US", "Upload file", "Upload file");
INSERT INTO languages VALUES ("en_US", "Upload new custom report", "Upload new custom report");
INSERT INTO languages VALUES ("en_US", "Upload new logo", "Upload new logo");
INSERT INTO languages VALUES ("en_US", "Upper limit", "Upper limit");
INSERT INTO languages VALUES ("en_US", "Usage", "Usage");
INSERT INTO languages VALUES ("en_US", "Use clock hardware", "Use clock hardware");
INSERT INTO languages VALUES ("en_US", "Use registered authentications", "Use configured authentications");
INSERT INTO languages VALUES ("en_US", "Use this model", "Use this model");
INSERT INTO languages VALUES ("en_US", "Used Dashboards", "Used Dashboards");
INSERT INTO languages VALUES ("en_US", "Used Hosts", "Used Hosts");
INSERT INTO languages VALUES ("en_US", "Used Services", "Used Services");
INSERT INTO languages VALUES ("en_US", "Used", "Used");
INSERT INTO languages VALUES ("en_US", "User administrator", "User administrator");
INSERT INTO languages VALUES ("en_US", "User already exists", "User already exists");
INSERT INTO languages VALUES ("en_US", "User and Password", "User and Password");
INSERT INTO languages VALUES ("en_US", "User created successfully", "User created successfully");
INSERT INTO languages VALUES ("en_US", "User name system administrator", "User name system administrator");
INSERT INTO languages VALUES ("en_US", "User", "User");
INSERT INTO languages VALUES ("en_US", "UserWithouPermissionDiscovery", "Your user dont't have permission to execute the Auto-Discovery!");
INSERT INTO languages VALUES ("en_US", "UserWithoutPermissionMsg", "Your user dont't have permission to execute commands!");
INSERT INTO languages VALUES ("en_US", "User_Language", "Language");
INSERT INTO languages VALUES ("en_US", "Users", "Users");
INSERT INTO languages VALUES ("en_US", "Using external authentication", "Using external authentication");
INSERT INTO languages VALUES ("en_US", "Value in minutes", "Value in minutes");
INSERT INTO languages VALUES ("en_US", "Value", "Value");
INSERT INTO languages VALUES ("en_US", "Vendor", "Vendor");
INSERT INTO languages VALUES ("en_US", "Verifying user and password", "Verifying user and password...");
INSERT INTO languages VALUES ("en_US", "Version", "Version");
INSERT INTO languages VALUES ("en_US", "View all hosts", "View all hosts");
INSERT INTO languages VALUES ("en_US", "View all models available", "View all models available");
INSERT INTO languages VALUES ("en_US", "View all models", "View all models");
INSERT INTO languages VALUES ("en_US", "View report and send by e-mail", "View report and send by e-mail");
INSERT INTO languages VALUES ("en_US", "Views", "Views");
INSERT INTO languages VALUES ("en_US", "WARNING", "WARNING");
INSERT INTO languages VALUES ("en_US", "Wait", "Wait...");
INSERT INTO languages VALUES ("en_US", "Wait... importing objects", "Wait... importing objects");
INSERT INTO languages VALUES ("en_US", "Want to apply the generated topology ?", "Want to apply the generated topology ?");
INSERT INTO languages VALUES ("en_US", "Warning", "Warning");
INSERT INTO languages VALUES ("en_US", "WarningStripe", "Warning Stripe");
INSERT INTO languages VALUES ("en_US", "Warns", "Warns");
INSERT INTO languages VALUES ("en_US", "We define the following", "We define the following");
INSERT INTO languages VALUES ("en_US", "We find the following probes. Check the probes you want to monitor.", "We find the following probes. Check the probes you want to monitor.");
INSERT INTO languages VALUES ("en_US", "We have already analyzed the available resources on your server.", "We have already analyzed the available resources on your server.");
INSERT INTO languages VALUES ("en_US", "Wednesday", "Wednesday");
INSERT INTO languages VALUES ("en_US", "Week day", "Week day");
INSERT INTO languages VALUES ("en_US", "Week", "Week");
INSERT INTO languages VALUES ("en_US", "Weekly", "Weekly");
INSERT INTO languages VALUES ("en_US", "Weeks", "Weeks");
INSERT INTO languages VALUES ("en_US", "Welcome to %tag%OpMon %version%%tagend%", "Welcome to %tag%OpMon %version%%tagend%");
INSERT INTO languages VALUES ("en_US", "Welcome to OpMon Traffic Analyzer", "Welcome to OpMon Traffic Analyzer");
INSERT INTO languages VALUES ("en_US", "Welcome", "Welcome");
INSERT INTO languages VALUES ("en_US", "What do you want to do?", "What do you want to do?");
INSERT INTO languages VALUES ("en_US", "What do you want to monitoring?", "What do you want to monitoring?");
INSERT INTO languages VALUES ("en_US", "Will be listed only hosts found by the discovery module", "Will be listed only hosts found by the discovery module");
INSERT INTO languages VALUES ("en_US", "With ack", "With ack");
INSERT INTO languages VALUES ("en_US", "With conflict", "With conflict");
INSERT INTO languages VALUES ("en_US", "Without ack", "Without ack");
INSERT INTO languages VALUES ("en_US", "Work", "Work");
INSERT INTO languages VALUES ("en_US", "Write your reasons", "Write your reasons");
INSERT INTO languages VALUES ("en_US", "Wrong password", "Wrong username or password.");
INSERT INTO languages VALUES ("en_US", "Year", "Year");
INSERT INTO languages VALUES ("en_US", "Yes , I want to remove", "Yes , I want to remove");
INSERT INTO languages VALUES ("en_US", "Yes", "Yes");
INSERT INTO languages VALUES ("en_US", "Yesterday", "Yesterday");
INSERT INTO languages VALUES ("en_US", "You are trying to edit services that belong to a template, unable to proceed", "You are trying to edit services that belong to a template, unable to proceed");
INSERT INTO languages VALUES ("en_US", "You can configure OpMon later", "You can configure OpMon later");
INSERT INTO languages VALUES ("en_US", "You can configure Traffic Analyzer later", "You can configure Traffic Analyzer later");
INSERT INTO languages VALUES ("en_US", "You can not recover the baseline \\\"Name baseline\\\" after erased.", "You can not recover the baseline \\\"Name baseline\\\" after erased.");
INSERT INTO languages VALUES ("en_US", "You can not remove the user opmonadmin", "You can not remove the user opmonadmin");
INSERT INTO languages VALUES ("en_US", "You have set the following", "You have set the following");
INSERT INTO languages VALUES ("en_US", "You have to write a reason", "You have to write a reason");
INSERT INTO languages VALUES ("en_US", "You must select at least one host", "You must select at least one host");
INSERT INTO languages VALUES ("en_US", "You must select at least one service", "You must select at least one service");
INSERT INTO languages VALUES ("en_US", "You need to read and accept the license agreement to proceed with the configuration process.", "You need to read and accept the license agreement to proceed with the configuration process.");
INSERT INTO languages VALUES ("en_US", "You reached the limit of units that can be selected", "You reached the limit of units that can be selected");
INSERT INTO languages VALUES ("en_US", "The selected hosts are of the service catalog type and can not be removed.", "The selected hosts are of the service catalog type and can not be removed.");
INSERT INTO languages VALUES ("en_US", "You want to remove the selected monitored hosts? Other hosts are of the service catalog type and can not be removed.", "You want to remove the %TOBEREMOVE% selected monitored services? Other %CANNOTBEREMOVE% hosts are of the service catalog type and can not be removed.");
INSERT INTO languages VALUES ("en_US", "You want to remove the selected monitored services? Other services belong to a template and can not be removed.", "You want to remove the %TOBEREMOVE% selected monitored services? Other %CANNOTBEREMOVE% services belong to a template and can not be removed.");
INSERT INTO languages VALUES ("en_US", "You want to remove the selected monitored host ( s ) ?", "You want to remove the %NUMBER% selected monitored host ( s ) ?");
INSERT INTO languages VALUES ("en_US", "You want to remove the selected monitored service ( s ) ?", "You want to remove the %NUMBER% selected monitored service ( s ) ?");
INSERT INTO languages VALUES ("en_US", "Your dashboards limit has been reached. To access this dashboard, you have to expand your license or remove a number of dashboards until your license limit is not exceeded.", "Your dashboards limit has been reached. To access this dashboard, you have to expand your license or remove a number of dashboards until your license limit is not exceeded.");
INSERT INTO languages VALUES ("en_US", "Your license does not allow you to access this module", "Your license does not allow you to access this module");
INSERT INTO languages VALUES ("en_US", "Your license expired", "Your license expired");
INSERT INTO languages VALUES ("en_US", "Your license is going to expire in", "Your license is going to expire in");
INSERT INTO languages VALUES ("en_US", "Your report has been uploaded", "Your report has been uploaded");
INSERT INTO languages VALUES ("en_US", "Your scheduler", "Your scheduler");
INSERT INTO languages VALUES ("en_US", "Your trial license expire in %DAY% day(s)", "Your trial license expire in %DAY% day(s)");
INSERT INTO languages VALUES ("en_US", "\\o\\f", "\\o\\f");
INSERT INTO languages VALUES ("en_US", "added", "added");
INSERT INTO languages VALUES ("en_US", "added.", "added.");
INSERT INTO languages VALUES ("en_US", "administrator", "Administrator");
INSERT INTO languages VALUES ("en_US", "already exists.", "already exists.");
INSERT INTO languages VALUES ("en_US", "and", "and");
INSERT INTO languages VALUES ("en_US", "backup", "backup");
INSERT INTO languages VALUES ("en_US", "click here", "click here");
INSERT INTO languages VALUES ("en_US", "days", "days");
INSERT INTO languages VALUES ("en_US", "default Gateway", "default Gateway");
INSERT INTO languages VALUES ("en_US", "demoVersion1", "(Demo Module - Only ");
INSERT INTO languages VALUES ("en_US", "demoVersion2", " hosts will be displayed)");
INSERT INTO languages VALUES ("en_US", "different alarms", "different alarms");
INSERT INTO languages VALUES ("en_US", "environment", "Environment");
INSERT INTO languages VALUES ("en_US", "filtered", "filtered");
INSERT INTO languages VALUES ("en_US", "for you.", "for you.");
INSERT INTO languages VALUES ("en_US", "for your environment.", "for your environment.");
INSERT INTO languages VALUES ("en_US", "for", "for");
INSERT INTO languages VALUES ("en_US", "from", "from");
INSERT INTO languages VALUES ("en_US", "here", "here");
INSERT INTO languages VALUES ("en_US", "host(s) discovered!", "host(s) discovered!");
INSERT INTO languages VALUES ("en_US", "host(s) selected", "host(s) selected");
INSERT INTO languages VALUES ("en_US", "hosts selected", "hosts selected");
INSERT INTO languages VALUES ("en_US", "hosts to be imported", "hosts to be imported");
INSERT INTO languages VALUES ("en_US", "hosts to be scanned", "hosts to be scanned");
INSERT INTO languages VALUES ("en_US", "hours", "hours");
INSERT INTO languages VALUES ("en_US", "licenseExceededMsg", "The number of objects in your license has been reached.");
INSERT INTO languages VALUES ("en_US", "licenseExceededMsghost", "You can not add %SELECTED% host(s), because your license only allows a total of %LICENSELIMIT% hosts and you currently have %LICENSEMONITORED% host(s).");
INSERT INTO languages VALUES ("en_US", "licenseExceededMsgservice", "You can not add %SELECTED% service(s), because your license only allows a total of %LICENSELIMIT% services and you currently have %LICENSEMONITORED% service(s).");
INSERT INTO languages VALUES ("en_US", "licenseExceededTitle", "Object limit exceeded!");
INSERT INTO languages VALUES ("en_US", "metric exceeds any limit", "metric exceeds any limit");
INSERT INTO languages VALUES ("en_US", "metric exceeds the lower limit", "metric exceeds the lower limit");
INSERT INTO languages VALUES ("en_US", "metric exceeds the upper limit", "metric exceeds the upper limit");
INSERT INTO languages VALUES ("en_US", "metric(s) selected", "metric(s) selected");
INSERT INTO languages VALUES ("en_US", "minutes", "minutes");
INSERT INTO languages VALUES ("en_US", "month", "month");
INSERT INTO languages VALUES ("en_US", "months", "months");
INSERT INTO languages VALUES ("en_US", "network", "Network");
INSERT INTO languages VALUES ("en_US", "no", "no");
INSERT INTO languages VALUES ("en_US", "non work day", "non work day");
INSERT INTO languages VALUES ("en_US", "non-working days", "non-working days");
INSERT INTO languages VALUES ("en_US", "notifications sended", "notification(s) sended");
INSERT INTO languages VALUES ("en_US", "objects being edited have different values for this property.<br />Change it here and it will be changed to all objects", "objects being edited have different values for this property.<br />Change it here and it will be changed to all objects");
INSERT INTO languages VALUES ("en_US", "of the month", "of the month");
INSERT INTO languages VALUES ("en_US", "or", "or");
INSERT INTO languages VALUES ("en_US", "region", "region");
INSERT INTO languages VALUES ("en_US", "rschedFooter", "<b>OpMon</b> automatically generated report.<br>If you don't want to receive this report, please refer to your OpMon administrator.");
INSERT INTO languages VALUES ("en_US", "scheduled reports", "scheduled reports");
INSERT INTO languages VALUES ("en_US", "seconds", "seconds");
INSERT INTO languages VALUES ("en_US", "selected metrics", "selected metrics");
INSERT INTO languages VALUES ("en_US", "standard deviation", "standard deviation");
INSERT INTO languages VALUES ("en_US", "to", "to");
INSERT INTO languages VALUES ("en_US", "via Discovery", "via Discovery");
INSERT INTO languages VALUES ("en_US", "weeks", "weeks");
INSERT INTO languages VALUES ("en_US", "with SLA Breach Reason", "with SLA Breach Reason");
INSERT INTO languages VALUES ("en_US", "work day", "work day");
INSERT INTO languages VALUES ("en_US", "working day of month", "working day of month");
INSERT INTO languages VALUES ("en_US", "working days", "working days");
INSERT INTO languages VALUES ("en_US", "yes", "yes");
INSERT INTO languages VALUES ("en_US", "Order by priority", "Order by priority");
INSERT INTO languages VALUES ("en_US", "Paste here the key sent by email", "Paste here the key sent by email");
INSERT INTO languages VALUES ("en_US", "Improve your network discovery  by registering its authentications", "Improve your network discovery  by registering its authentications");
INSERT INTO languages VALUES ("en_US", "Grouped", "Grouped");
INSERT INTO languages VALUES ("en_US", "View hosts before monitoring", "View hosts before monitoring");
INSERT INTO languages VALUES ("en_US", "Network Outages", "Network Outages");
INSERT INTO languages VALUES ("en_US", "Status summary", "Status summary");
INSERT INTO languages VALUES ("en_US", "Hosts Affected", "Hosts Affected");
INSERT INTO languages VALUES ("en_US", "Network Outages Grid", "Network Outages Grid");
INSERT INTO languages VALUES ("en_US", "Audit", "Audit");
INSERT INTO languages VALUES ("en_US", "Action", "Action");
INSERT INTO languages VALUES ("en_US", "Set range", "Set Range");
INSERT INTO languages VALUES ("en_US", "Preset periods", "Present periods");
INSERT INTO languages VALUES ("en_US", "There has not been any audit logged", "There has not been any audit logged");
INSERT INTO languages VALUES ("en_US", "Items", "Items");


INSERT INTO languages VALUES ("pt_BR", "Estimated value", "Valor estimado");
INSERT INTO languages VALUES ("pt_BR", "Estimated date", "Data estimada");
INSERT INTO languages VALUES ("pt_BR", "Collection date", "Data da coleta");
INSERT INTO languages VALUES ("pt_BR", "Trend", "Tend&ecirc;ncia");
INSERT INTO languages VALUES ("pt_BR", "Prediction", "Previs&atilde;o");

INSERT INTO languages VALUES ("pt_BR", "Predictive analysis description", "Neste widget s&atilde;o exibidos os objetos que ir&atilde;o romper os thresholds estabelecidos nos pr&oacute;ximos 30 dias.<br><br>Quando representado por vermelho significa que faltam menos de 7 dias para romper os thresholds. Amarelo &eacute; quando faltam menos de 30 dias.<br><br>Ao clicar no objeto voc&ecirc; ser&atilde; levado para o gr&atilde;fico de capacidades com uma an&atilde;lise preditiva baseada nos dados coletados deste host/servi&ccedil;o nos &uacute;ltimos 3 meses. No gr&atilde;fico de capacidades voc&ecirc; pode experimentar diferentes per&iacute;odos de coleta e de proje&ccedil;&atilde;o futura.<br><br>O objetivo desta funcionalidade &eacute; a de prover informa&ccedil;&otilde;es relevantes para a previs&atilde;o de problemas futuros, antes que os mesmos venham a ocorrer.");
INSERT INTO languages VALUES ("pt_BR", "Predictive analysis of future incidents", "An&aacute;lise preditiva de incidentes futuros");
INSERT INTO languages VALUES ("pt_BR", "Predictive Analysis", "An&aacute;lise Preditiva");

INSERT INTO languages VALUES ("pt_BR", "Invalid Expiration Date/Time", "Data/hora de expira&ccedil;&atilde;o inv&aacute;lida");
INSERT INTO languages VALUES ("pt_BR", "Network outages", "Quedas de rede");
INSERT INTO languages VALUES ("pt_BR", "Outages", "Quedas");
INSERT INTO languages VALUES ("pt_BR", "Affected", "Afetados");
INSERT INTO languages VALUES ("pt_BR", "Incidents last 24 hours", "Incidentes das &uacute;timas 24 horas");
INSERT INTO languages VALUES ("pt_BR", "System health", "Sa&uacute;de do sistema");
INSERT INTO languages VALUES ("pt_BR", "Incidents per groups", "Incidentes por grupo");
INSERT INTO languages VALUES ("pt_BR", "Top 10 incidents", "Top 10 incidentes");


INSERT INTO languages VALUES ("pt_BR", "Class", "Classe");
INSERT INTO languages VALUES ("pt_BR", "Object Name", "Objeto");
INSERT INTO languages VALUES ("pt_BR", "Auto refresh", "Atualiza&#231;&#227;o autom&#225;tica");
INSERT INTO languages VALUES ("pt_BR", "ServiceRemoved", "Servi&#231;o j&#225; foi removido");
INSERT INTO languages VALUES ("pt_BR", "HostRemoved", "Host j&#225; foi removido");
INSERT INTO languages VALUES ("pt_BR", "Filter activated", "Filtro ativo");
INSERT INTO languages VALUES ("pt_BR", "AdvancedFilterApplied", "Filtro avan&#231;ado aplicado");
INSERT INTO languages VALUES ("pt_BR", "Detailed view", "Vis&#227;o detalhada");
INSERT INTO languages VALUES ("pt_BR", "Grouped by tag", "Agrupado por tag");
INSERT INTO languages VALUES ("pt_BR", "devices and applications discovered", "dispositivos e aplica&#231;&#245;es descobertos");
INSERT INTO languages VALUES ("pt_BR", "Downtimes", "Manuten&#231;&#227;o");
INSERT INTO languages VALUES ("pt_BR", "Select All", "Selecione Todos");
INSERT INTO languages VALUES ("pt_BR", "Order by priority", "Ordem por prioridade");
INSERT INTO languages VALUES ("pt_BR", " If you need help click ", " Para ajuda clique ");
INSERT INTO languages VALUES ("pt_BR", "%COUNT% probes found. Mark which you want to monitor with the OpMon Traffic Analyzer.", "%COUNT% probes encontradas. Marque quais deseja monitorar pelo OpMon Traffic Analyzer.");
INSERT INTO languages VALUES ("pt_BR", "%link%Click here%endlink% if you need help", "%link%Clique aqui%endlink% caso necessite de ajuda");
INSERT INTO languages VALUES ("pt_BR", "%n% host(s) of %m% available", "%n% host(s) de %m% dispon&iacute;vel(is)");
INSERT INTO languages VALUES ("pt_BR", "%n% service(s) of %m% available", "%n% servi&ccedil;o(s) de %m% dispon&iacute;vel(is)");
INSERT INTO languages VALUES ("pt_BR", "%qtd%/%of% services have been retrieved successfully", "%qtd%/%of% servi&ccedil;os obtidos com sucesso");
INSERT INTO languages VALUES ("pt_BR", "(All)", "(Todos)");
INSERT INTO languages VALUES ("pt_BR", "(No shortcuts found)", "(Nenhum atalho)");
INSERT INTO languages VALUES ("pt_BR", "0", "Desabilitado");
INSERT INTO languages VALUES ("pt_BR", "1", "Habilitado");
INSERT INTO languages VALUES ("pt_BR", "<h2 class=\'popup-title\' style=\'margin:0;\'>Some settings could not be applied.<br>Check below.</h2>", "<h2 class=\'popup-title\' style=\'margin:0;\'>Algumas configura&ccedil;&otilde;es n&atilde;o puderam ser aplicadas.<br>Verifique abaixo.</h2>");
INSERT INTO languages VALUES ("pt_BR", "<strong> Algorithm </ strong> analysis", "<strong>Algoritmo</ strong> de an&aacute;lise");
INSERT INTO languages VALUES ("pt_BR", "<strong>Lower</strong> limit of the confidence interval", "Limite <strong>inferior</strong> do intervalo de confian&ccedil;a");
INSERT INTO languages VALUES ("pt_BR", "<strong>Upper</strong> limit of the confidence interval", "Limite <strong>superior</strong> do intervalo de confian&ccedil;a");
INSERT INTO languages VALUES ("pt_BR", "A new version of this package is available", "Uma nova vers&atilde;o deste pacote est&aacute; dispon&iacute;vel para atualiza&ccedil&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "API returned the following error on service %servicename% of host %hostname%", "A API retornou o seguinte erro no servi&ccedil;o %servicename% do host %hostname%");
INSERT INTO languages VALUES ("pt_BR", "AVAIL", "Disponibilidade");
INSERT INTO languages VALUES ("pt_BR", "Absolute min/max", "Min/max absolutos");
INSERT INTO languages VALUES ("pt_BR", "Access Denied", "Acesso Negado");
INSERT INTO languages VALUES ("pt_BR", "Access expired", "Seu acesso expirou. Entre em contato com o seu administrador.");
INSERT INTO languages VALUES ("pt_BR", "Ack", "A&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Acknowledge this incident", "Reconhecer incidente");
INSERT INTO languages VALUES ("pt_BR", "Acknowledge", "Reconhecimento");
INSERT INTO languages VALUES ("pt_BR", "Acknowledged incidents", "Incidentes reconhecidos");
INSERT INTO languages VALUES ("pt_BR", "Acknowledged", "Reconhecido");
INSERT INTO languages VALUES ("pt_BR", "Acks AND downtimes", "Reconhecimentos E manuten&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR", "Acks OR downtimes", "Reconhecimentos OU manuten&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR", "Acks", "Reconhecimentos");
INSERT INTO languages VALUES ("pt_BR", "Action URL", "URL de a&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Actions", "A&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR", "Activation key", "Chave de ativa&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Active Downtimes", "Manuten&ccedil;&otilde;es ativas");
INSERT INTO languages VALUES ("pt_BR", "Active check", "Checagem ativa");
INSERT INTO languages VALUES ("pt_BR", "Active checks disabled", "Checagens ativas desabilitadas");
INSERT INTO languages VALUES ("pt_BR", "Active checks enabled", "Checagens ativas habilitadas");
INSERT INTO languages VALUES ("pt_BR", "Active probes can not be removed", "Probes ativas n&atilde;o podem ser removidas");
INSERT INTO languages VALUES ("pt_BR", "Active", "Ativa");
INSERT INTO languages VALUES ("pt_BR", "Add Command to Service", "Adicionar Comando ao Servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR", "Add Command", "Adicionar Comando");
INSERT INTO languages VALUES ("pt_BR", "Add Host", "Adicionar Host");
INSERT INTO languages VALUES ("pt_BR", "Add IP / Range to discovery", "Adicionar Range ou IP &agrave; descoberta");
INSERT INTO languages VALUES ("pt_BR", "Add IP Range or the discovery", "Adicionar Range ou IP &agrave; descoberta");
INSERT INTO languages VALUES ("pt_BR", "Add IP or network range that you want to discover", "Acrescente o endere&ccedil;o IP ou a rede que deseja descobrir");
INSERT INTO languages VALUES ("pt_BR", "Add SNMP Community", "Adicionar comunidade SNMP");
INSERT INTO languages VALUES ("pt_BR", "Add Teams to user", "Adicionar grupos de contato a contato");
INSERT INTO languages VALUES ("pt_BR", "Add a SLA breach reason", "Adicionar justificativa de SLA");
INSERT INTO languages VALUES ("pt_BR", "Add a comment", "Adicionar coment&aacute;rio");
INSERT INTO languages VALUES ("pt_BR", "Add a new command to the list", "Adicionar um novo comando &agrave; lista");
INSERT INTO languages VALUES ("pt_BR", "Add action to all Hosts", "Adicionar a&ccedil;&atilde;o para todos Hosts");
INSERT INTO languages VALUES ("pt_BR", "Add action to all Services", "Adicionar a&ccedil;&atilde;o para todos Servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR", "Add and configure network elements", "Adicione e configure os elementos da rede");
INSERT INTO languages VALUES ("pt_BR", "Add directory", "Adicionar diret&oacute;rio");
INSERT INTO languages VALUES ("pt_BR", "Add host manually", "Adicionar host manualmente");
INSERT INTO languages VALUES ("pt_BR", "Add host", "Adicionar host");
INSERT INTO languages VALUES ("pt_BR", "Add hots to a group", "Adicionar hosts a grupo");
INSERT INTO languages VALUES ("pt_BR", "Add just one", "Adicionar somente um");
INSERT INTO languages VALUES ("pt_BR", "Add more communities", "Adicionar mais comunidades");
INSERT INTO languages VALUES ("pt_BR", "Add more than one", "Adicionar mais de um");
INSERT INTO languages VALUES ("pt_BR", "Add multiple hosts. Write as follow: ip,hostname,description. Write one host per line.", "Adicione multiplos hosts. Siga a estrutura: IP,nome do host,descri&ccedil;&atilde;o. Escreva um host por linha.");
INSERT INTO languages VALUES ("pt_BR", "Add new Application Protocol", "Adicionar novo Protocolo de Aplica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Add new host manually", "Adicionar novo host manualmente");
INSERT INTO languages VALUES ("pt_BR", "Add new metrics", "Adicionar novas m&eacute;tricas");
INSERT INTO languages VALUES ("pt_BR", "Add new package", "Adicionar novos pacotes");
INSERT INTO languages VALUES ("pt_BR", "Add new template", "Adicionar novo template");
INSERT INTO languages VALUES ("pt_BR", "Add selected elements", "Adicionar elementos selecionados");
INSERT INTO languages VALUES ("pt_BR", "Add service", "Adicionar servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR", "Add services to groups", "Adicionar servi&ccedil;os a grupos");
INSERT INTO languages VALUES ("pt_BR", "Add the current page to bookmark links", "Adicionar a p&aacute;gina atual aos favoritos");
INSERT INTO languages VALUES ("pt_BR", "Add the current page to shortcut links", "Adicionar a p&aacute;gina atual aos atalhos");
INSERT INTO languages VALUES ("pt_BR", "Add users to team", "Adicionar contatos ao grupo de contatos");
INSERT INTO languages VALUES ("pt_BR", "Add your first metric", "Adicionar sua primeira m&eacute;trica");
INSERT INTO languages VALUES ("pt_BR", "Add", "Adicionar");
INSERT INTO languages VALUES ("pt_BR", "Adding Traffic Sources", "Como adicionar fontes de tr&aacute;fego");
INSERT INTO languages VALUES ("pt_BR", "Additional Actions", "A&ccedil;&otilde;es adicionais");
INSERT INTO languages VALUES ("pt_BR", "Additional Modules", "M&oacute;dulos&nbsp;Adicionais");
INSERT INTO languages VALUES ("pt_BR", "Additional Notes", "Notas adicionais");
INSERT INTO languages VALUES ("pt_BR", "Address", "Endere&ccedil;o");
INSERT INTO languages VALUES ("pt_BR", "Administrator", "Administrador");
INSERT INTO languages VALUES ("pt_BR", "Advanced Options", "Op&ccedil;&otilde;es Avan&ccedil;adas");
INSERT INTO languages VALUES ("pt_BR", "Advanced Search", "Busca avan&ccedil;ada");
INSERT INTO languages VALUES ("pt_BR", "Advanced Service Level Agreement Report", "An&aacute;lise de n&iacute;vel de servi&ccedil;o - Avan&ccedil;ado");
INSERT INTO languages VALUES ("pt_BR", "Advanced commands", "Comandos avan&ccedil;ados");
INSERT INTO languages VALUES ("pt_BR", "Advanced options", "Op&ccedil;&otilde;es avan&ccedil;adas");
INSERT INTO languages VALUES ("pt_BR", "Advanced", "Avan&ccedil;adas");
INSERT INTO languages VALUES ("pt_BR", "Affected services", "Servi&ccedil;os afetados");
INSERT INTO languages VALUES ("pt_BR", "Alarm operation", "Funcionamento do alarme");
INSERT INTO languages VALUES ("pt_BR", "Alarm when", "Alarmar quando");
INSERT INTO languages VALUES ("pt_BR", "Alert history", "Hist&oacute;rico de alertas");
INSERT INTO languages VALUES ("pt_BR", "Alert", "Aviso");
INSERT INTO languages VALUES ("pt_BR", "Alerts Summary", "Sum&aacute;rio de Alertas");
INSERT INTO languages VALUES ("pt_BR", "Alerts", "Alertas");
INSERT INTO languages VALUES ("pt_BR", "Alias", "Alias");
INSERT INTO languages VALUES ("pt_BR", "All May View", "Qualquer usu&aacute;rio pode visualizar");
INSERT INTO languages VALUES ("pt_BR", "All categories", "Todas as categorias");
INSERT INTO languages VALUES ("pt_BR", "All hosts must contain at least one user or team responsible", "Todos os hosts devem conter pelo menos um contato ou grupo de contato");
INSERT INTO languages VALUES ("pt_BR", "All may view", "Todos podem ver");
INSERT INTO languages VALUES ("pt_BR", "All models", "Todos os modelos");
INSERT INTO languages VALUES ("pt_BR", "All ready", "Tudo pronto");
INSERT INTO languages VALUES ("pt_BR", "All rights reserved", "Todos os direitos reservados");
INSERT INTO languages VALUES ("pt_BR", "All services must contain at least one user or team responsible", "Todos os servi&ccedil;os devem conter pelo menos um contato ou grupo de contato");
INSERT INTO languages VALUES ("pt_BR", "All", "Todos");
INSERT INTO languages VALUES ("pt_BR", "Already created", "J&aacute; criado");
INSERT INTO languages VALUES ("pt_BR", "Already exists", "j&aacute; existe");
INSERT INTO languages VALUES ("pt_BR", "Already monitored items will not appear as discovered elements", "Itens j&aacute; monitorados n&atilde;o ser&atilde;o listados no discovery");
INSERT INTO languages VALUES ("pt_BR", "Already selected", "J&aacute; selecionado");
INSERT INTO languages VALUES ("pt_BR", "An unexpected error occured during Timecut save process", "Um erro inesperado ocorreu durante o salvamento de seu Corte de Tempo");
INSERT INTO languages VALUES ("pt_BR", "An unexpected error occured retrieving Timecut", "Um erro inesperado buscando Corte de Tempo");
INSERT INTO languages VALUES ("pt_BR", "AndRelatedAcknowledgements", "Tamb&eacute;m ser&aacute; exclu&iacute;da a&ccedil;&atilde;o relacionada");
INSERT INTO languages VALUES ("pt_BR", "Any probes weren't found. Try again.", "N&atilde;o foram encontrados coletores. Tente novamente.");
INSERT INTO languages VALUES ("pt_BR", "Application protocols registry", "Registro de Protocolos de Aplica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Application protocols", "Protocolos de aplica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Application", "Aplica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Apply Model", "Aplicar o modelo");
INSERT INTO languages VALUES ("pt_BR", "Apply Settings", "Aplicar Defini&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR", "Apply command to the service", "Aplicar comando ao servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR", "Apply command", "Aplicar comando");
INSERT INTO languages VALUES ("pt_BR", "Apply selected model", "Aplicar o modelo selecionado");
INSERT INTO languages VALUES ("pt_BR", "Apply service to hosts", "Aplicar servi&ccedil;o aos hosts");
INSERT INTO languages VALUES ("pt_BR", "Apply templates to selected hosts", "Aplicar templates selecionados aos hosts");
INSERT INTO languages VALUES ("pt_BR", "Apply the topology to OpMon", "Aplique a topologia ao OpMon");
INSERT INTO languages VALUES ("pt_BR", "Apply to all hosts", "Aplicar a todos hosts");
INSERT INTO languages VALUES ("pt_BR", "Apply to all services", "Aplicar a todos servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR", "Apply to all", "Aplicar a todos");
INSERT INTO languages VALUES ("pt_BR", "Apply to child hosts", "Aplicar para os Hosts filhos");
INSERT INTO languages VALUES ("pt_BR", "Apply to host", "Aplicar para o Host tamb&eacute;m");
INSERT INTO languages VALUES ("pt_BR", "Apply topology", "Aplicar topologia");
INSERT INTO languages VALUES ("pt_BR", "Apply", "Aplicar");
INSERT INTO languages VALUES ("pt_BR", "Applying new configuration", "Atualizando configura&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR", "Applying topology to OpMon and Complete", "Aplicar topologia ao OpMon e Concluir");
INSERT INTO languages VALUES ("pt_BR", "Apr", "Abr");
INSERT INTO languages VALUES ("pt_BR", "April", "Abril");
INSERT INTO languages VALUES ("pt_BR", "Are you ready to visualize all your network flow?", "Preparado para visualizar todo o fluxo de dados da sua rede?");
INSERT INTO languages VALUES ("pt_BR", "Are you sure do you want to uninstall this package? All services using it are going to be removed.", "Tem certeza de que deseja remover o pacote? Todos os servi&ccedil;os associados a este pacote ser&atilde;o removidos.");
INSERT INTO languages VALUES ("pt_BR", "Are you sure you want to remove this comment?", "Tem certeza que deseja remover este coment&aacute;rio?");
INSERT INTO languages VALUES ("pt_BR", "Are you sure you want to run the selected command?", "Tem certeza que deseja executar o comando selecionado?");
INSERT INTO languages VALUES ("pt_BR", "Assignment", "Atribui&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Associated Baseline", "Baseline associada");
INSERT INTO languages VALUES ("pt_BR", "Attempts", "Tentativas");
INSERT INTO languages VALUES ("pt_BR", "Aug", "Ago");
INSERT INTO languages VALUES ("pt_BR", "August", "Agosto");
INSERT INTO languages VALUES ("pt_BR", "Authentication Mode", "Tipo de autentica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Authentication name", "Nome da Autentica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Authentication", "Autentica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Author", "Autor");
INSERT INTO languages VALUES ("pt_BR", "Auto discovery disabled", "Descoberta autom&aacute;tica inativa");
INSERT INTO languages VALUES ("pt_BR", "Auto discovery enabled", "Descoberta autom&aacute;tica ativa");
INSERT INTO languages VALUES ("pt_BR", "Auto scale", "Escala autom&aacute;tica");
INSERT INTO languages VALUES ("pt_BR", "Auto-Discovery finished! (see log below)", "Auto-Discovery finalizado! (veja o log abaixo)");
INSERT INTO languages VALUES ("pt_BR", "Auto-Discovery finished!", "Auto-Discovery finalizado!");
INSERT INTO languages VALUES ("pt_BR", "Auto-Discovery started!", "Auto-Discovery iniciado!");
INSERT INTO languages VALUES ("pt_BR", "Auto-Discovery", "Auto-Discovery");
INSERT INTO languages VALUES ("pt_BR", "AutoDiscoveryDescription", "Se voc&ecirc; acabou de instalar OpMon, voc&ecirc; pode utilizar esta ferramenta para facilmente descobrir dispositivos na sua rede. &Eacute; o modo m&aacute;is f&aacute;cil de come&ccedil;ar.");
INSERT INTO languages VALUES ("pt_BR", "AutoDiscoveryMsg", "Insira as informa&ccedil;&atilde;es da sua rede abaixo para que seja executada um escaneamento autom&aacute;tico. Todos dispositvos encontrados ser&atilde;o importados. Este processo pode demorar um pouco.");
INSERT INTO languages VALUES ("pt_BR", "AutoDiscoveryMsg", "Put your network information below to perform an automatic scan. All discovered devices will be imported. This process can take some time.");
INSERT INTO languages VALUES ("pt_BR", "Autodiscovery enabled", "Autodiscovery habilitado");
INSERT INTO languages VALUES ("pt_BR", "Autoscale", "Autoscale");
INSERT INTO languages VALUES ("pt_BR", "Availability Report", "Relat&oacute;rio de disponibilidade");
INSERT INTO languages VALUES ("pt_BR", "Availability for CI", "Disponibilidade para Host");
INSERT INTO languages VALUES ("pt_BR", "Availability for service", "Disponibilidade para servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR", "Availability", "Disponibilidade");
INSERT INTO languages VALUES ("pt_BR", "Available Dashboards", "Dashboards Dispon&iacute;veis");
INSERT INTO languages VALUES ("pt_BR", "Available Hosts", "Hosts Dispon&iacute;veis");
INSERT INTO languages VALUES ("pt_BR", "Available Services", "Servi&ccedil;os Dispon&iacute;veis");
INSERT INTO languages VALUES ("pt_BR", "Available objects", "Objetos dispon&iacute;veis");
INSERT INTO languages VALUES ("pt_BR", "Available", "Dispon&iacute;vel");
INSERT INTO languages VALUES ("pt_BR", "Average", "M&eacute;dia");
INSERT INTO languages VALUES ("pt_BR", "Avg", "M&eacute;dia");
INSERT INTO languages VALUES ("pt_BR", "Back to Settings", "Voltar para Configura&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR", "Back to the default", "Voltar para o padr&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Back to the discovered elements", "Retornar aos &iacute;tens descobertos");
INSERT INTO languages VALUES ("pt_BR", "Back to the list", "Voltar &agrave; listagem");
INSERT INTO languages VALUES ("pt_BR", "Back", "Voltar");
INSERT INTO languages VALUES ("pt_BR", "Backup settings", "Configura&ccedil;&otilde;es de Backup");
INSERT INTO languages VALUES ("pt_BR", "Baseline Name", "Nome da baseline");
INSERT INTO languages VALUES ("pt_BR", "Baseline can not be deleted", "Baseline n&atilde;o pode ser apagada");
INSERT INTO languages VALUES ("pt_BR", "Baseline down", "Baseline inferior");
INSERT INTO languages VALUES ("pt_BR", "Baseline up", "Baseline superior");
INSERT INTO languages VALUES ("pt_BR", "Baselines registered", "Baselines cadastradas");
INSERT INTO languages VALUES ("pt_BR", "Before you start", "Antes de iniciar");
INSERT INTO languages VALUES ("pt_BR", "Behavior of the baseline", "Comportamento da baseline");
INSERT INTO languages VALUES ("pt_BR", "Behavioral simulation", "Simula&ccedil;&atilde;o do comportamento");
INSERT INTO languages VALUES ("pt_BR", "Bookmark already exists", "Este favorito ja existe!");
INSERT INTO languages VALUES ("pt_BR", "Bookmarks", "Favoritos");
INSERT INTO languages VALUES ("pt_BR", "Broadcast", "Broadcast");
INSERT INTO languages VALUES ("pt_BR", "Business Accountable", "Respons&aacute;veis pelo Neg&oacute;cio");
INSERT INTO languages VALUES ("pt_BR", "Business Impact Analysis (BIA)", "An&aacute;lise&nbsp;de&nbsp;Impacto&nbsp;nos&nbsp;Neg&oacute;cios(AIN)");
INSERT INTO languages VALUES ("pt_BR", "Business", "Neg&oacute;cios");
INSERT INTO languages VALUES ("pt_BR", "Buy Traffic Analyzer Link", "http://www.opservices.com.br/comercializacao-opmon-traffic-analyzer");
INSERT INTO languages VALUES ("pt_BR", "By group", "Por grupo");
INSERT INTO languages VALUES ("pt_BR", "CI Metrics Group", "Grupo de M&eacute;tricas");
INSERT INTO languages VALUES ("pt_BR", "CI's Attributes Groups", "Grupos de Servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR", "CI's Attributes", "Servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR", "CIs Groups", "Grupos&nbsp;de&nbsp;Hosts");
INSERT INTO languages VALUES ("pt_BR", "CIs Metrics", "M&eacute;tricas&nbsp;Hosts");
INSERT INTO languages VALUES ("pt_BR", "CIs", "Hosts");
INSERT INTO languages VALUES ("pt_BR", "CMDB", "CMDB");
INSERT INTO languages VALUES ("pt_BR", "CP", "Capacidade");
INSERT INTO languages VALUES ("pt_BR", "CRITICAL", "CR&Iacute;TICO");
INSERT INTO languages VALUES ("pt_BR", "Calculed", "Calculado");
INSERT INTO languages VALUES ("pt_BR", "Calendar Overview", "Overview do calend&aacute;rio");
INSERT INTO languages VALUES ("pt_BR", "Calendar settings", "Configura&ccedil;&otilde;es do calend&aacute;rio");
INSERT INTO languages VALUES ("pt_BR", "Cancel and go to management", "Cancelar o processo e ir para o gerenciamento");
INSERT INTO languages VALUES ("pt_BR", "Cancel process", "Cancelar processo");
INSERT INTO languages VALUES ("pt_BR", "Cancel setup", "Cancelar configura&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Cancel the process and go to management", "Cancelar o processo e ir para o gerenciamento");
INSERT INTO languages VALUES ("pt_BR", "Cancel", "Cancelar");
INSERT INTO languages VALUES ("pt_BR", "Cant write license file", "N&atilde;o foi poss&iacute;vel escrever arquivo de licen&ccedil;a.");
INSERT INTO languages VALUES ("pt_BR", "Capacity", "Capacidade");
INSERT INTO languages VALUES ("pt_BR", "Capacity/Performance", "Capacidade/Performance");
INSERT INTO languages VALUES ("pt_BR", "Catalogs", "Cat&aacute;logos");
INSERT INTO languages VALUES ("pt_BR", "Category", "Categoria");
INSERT INTO languages VALUES ("pt_BR", "Caution", "Tenha cuidado");
INSERT INTO languages VALUES ("pt_BR", "Change Teams and Team members", "Alterar contatos e grupos de contato");
INSERT INTO languages VALUES ("pt_BR", "Change password", "Troca de senha");
INSERT INTO languages VALUES ("pt_BR", "Change ports", "Alterar portas");
INSERT INTO languages VALUES ("pt_BR", "Change theme", "Mudar o tema");
INSERT INTO languages VALUES ("pt_BR", "Change to default and continue", "Alterar para configura&ccedil;&otilde;es padr&atilde;o e prosseguir");
INSERT INTO languages VALUES ("pt_BR", "Change", "Alterar");
INSERT INTO languages VALUES ("pt_BR", "ChangePasswordText", "Para trocar a sua senha,<br> entre em contato com o seu Administrador.");
INSERT INTO languages VALUES ("pt_BR", "Changes in baseline [name of baseline] were not saved.", "As altera&ccedil;&otilde;es na baseline [nome da baseline] n&atilde;o foram salvas.");
INSERT INTO languages VALUES ("pt_BR", "Changes saved successfully", "Altera&ccedil;&otilde;es salvas com sucesso");
INSERT INTO languages VALUES ("pt_BR", "Check Interval", "Intervalo de Checagem");
INSERT INTO languages VALUES ("pt_BR", "Check Period", "Per&iacute;odo da checagem");
INSERT INTO languages VALUES ("pt_BR", "Check command", "Comando de checagem");
INSERT INTO languages VALUES ("pt_BR", "Check duration", "Dura&ccedil;&atilde;o da checagem");
INSERT INTO languages VALUES ("pt_BR", "Check output", "Sa&iacute;da da checagem");
INSERT INTO languages VALUES ("pt_BR", "Check result", "Resultado da checagem");
INSERT INTO languages VALUES ("pt_BR", "Check the environment settings", "Verifique as configura&ccedil;&otilde;es do ambiente");
INSERT INTO languages VALUES ("pt_BR", "Check time", "Hora da checagem");
INSERT INTO languages VALUES ("pt_BR", "Check type", "Tipo da checagem");
INSERT INTO languages VALUES ("pt_BR", "Check your license.", "Verifique a sua licen&ccedil;a.");
INSERT INTO languages VALUES ("pt_BR", "Check", "Checagem");
INSERT INTO languages VALUES ("pt_BR", "Checking Period", "Per&iacute;odo de Checagem");
INSERT INTO languages VALUES ("pt_BR", "Checking if the port is available...", "Verificando se a porta est&aacute; dispon&iacute;vel...");
INSERT INTO languages VALUES ("pt_BR", "Checks", "Checagens");
INSERT INTO languages VALUES ("pt_BR", "Child hosts", "Hosts filhos");
INSERT INTO languages VALUES ("pt_BR", "Choose OpMon color theme", "Escolha a cor do tema");
INSERT INTO languages VALUES ("pt_BR", "Choose a metric", "Escolha uma m&eacute;trica");
INSERT INTO languages VALUES ("pt_BR", "Choose a monitoring model", "Escolha um modelo de monitora&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Clean Filter", "Limpar Filtros");
INSERT INTO languages VALUES ("pt_BR", "Clear Field", "Limpar campo");
INSERT INTO languages VALUES ("pt_BR", "Click here to purchase a license now", "Clique aqui e adquira uma licen&ccedil;a agora");
INSERT INTO languages VALUES ("pt_BR", "Click in the cel you want to edit", "Clique na c&eacute;lula que deseja editar");
INSERT INTO languages VALUES ("pt_BR", "Click to see the element details", "Clique para ver os detalhes do elemento");
INSERT INTO languages VALUES ("pt_BR", "Clone", "Clone");
INSERT INTO languages VALUES ("pt_BR", "Close advanced search", "Fechar busca avan&ccedil;ada");
INSERT INTO languages VALUES ("pt_BR", "Close details", "Fechar detalhes");
INSERT INTO languages VALUES ("pt_BR", "Close", "Fechar");
INSERT INTO languages VALUES ("pt_BR", "Color", "Cor");
INSERT INTO languages VALUES ("pt_BR", "Colors - State configuration", "Cores - Configura&ccedil;&atilde;o do estado");
INSERT INTO languages VALUES ("pt_BR", "Command Line", "Linha de Comando");
INSERT INTO languages VALUES ("pt_BR", "Command executed", "Comando executado");
INSERT INTO languages VALUES ("pt_BR", "Command list", "Lista de comandos");
INSERT INTO languages VALUES ("pt_BR", "Command name must have at last 2 caracters.", "O nome do comando de possuir ao menos 2 caracteres");
INSERT INTO languages VALUES ("pt_BR", "Command submitted successfully", "Comando submetido com sucesso!");
INSERT INTO languages VALUES ("pt_BR", "Command", "Comando");
INSERT INTO languages VALUES ("pt_BR", "Commands", "Comandos");
INSERT INTO languages VALUES ("pt_BR", "Comment", "Coment&aacute;rio");
INSERT INTO languages VALUES ("pt_BR", "Comments Totals", "Totaliza&ccedil;&atilde;o dos coment&aacute;rios");
INSERT INTO languages VALUES ("pt_BR", "Comments", "Coment&aacute;rios");
INSERT INTO languages VALUES ("pt_BR", "Common Users", "Usu&aacute;rios Comuns");
INSERT INTO languages VALUES ("pt_BR", "Communities added", "Comunidades Adicionadas");
INSERT INTO languages VALUES ("pt_BR", "Communities added", "Comunidades adicionadas");
INSERT INTO languages VALUES ("pt_BR", "Community Awareness Message", "Cadastre aqui as comunidades SNMP que voc&ecirc; utiliza em sua rede, isso possibilitar&aacute; ao Discovery monitorar muito mais dados a respeito dos servidores.");
INSERT INTO languages VALUES ("pt_BR", "Community", "Comunidade");
INSERT INTO languages VALUES ("pt_BR", "Compared with the days", "Comparado com os dias");
INSERT INTO languages VALUES ("pt_BR", "Comparison period", "Per&iacute;odo de compara&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Complete the setup for me", "Termine a configura&ccedil;&atilde;o para mim");
INSERT INTO languages VALUES ("pt_BR", "Complete", "Concluir");
INSERT INTO languages VALUES ("pt_BR", "Completed", "Completado");
INSERT INTO languages VALUES ("pt_BR", "Components", "Componentes");
INSERT INTO languages VALUES ("pt_BR", "Configuration Items", "Itens de Configura&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Configuration exported!", "Configura&ccedil;&atilde;o exportada!");
INSERT INTO languages VALUES ("pt_BR", "Configuration of application protocols performed successfully", "Configura&ccedil;&atilde;o de protocolos de aplica&ccedil;&atilde;o efetuada com sucesso");
INSERT INTO languages VALUES ("pt_BR", "Configuration", "Configura&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "ConfigurationDescription", "Esta op&ccedil;&atilde;o permitir&aacute; que voc&ecirc; configure manualmente novos dispositivos.");
INSERT INTO languages VALUES ("pt_BR", "Configurations", "Configura&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR", "Configure E-mail Server", "Configurar Servidor de E-mail");
INSERT INTO languages VALUES ("pt_BR", "Configure OpMon", "Configurar OpMon");
INSERT INTO languages VALUES ("pt_BR", "Configure Traffic Analyzer", "Configurar Traffic Analyzer");
INSERT INTO languages VALUES ("pt_BR", "Configure model settings", "Configure o modelo");
INSERT INTO languages VALUES ("pt_BR", "Configure selected elements", "Configurar elementos selecionados");
INSERT INTO languages VALUES ("pt_BR", "Configure selected items", "Configurar itens selecionados");
INSERT INTO languages VALUES ("pt_BR", "Configure the IP and port of the OpMon Traffic Analyzer", "Configurar o IP e a porta do OpMon Traffic Analyzer");
INSERT INTO languages VALUES ("pt_BR", "Configure the Report", "Configurar o relat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR", "Configure the data below to finish installation or %link%click here%endlink% if you need help", "Configure os dados abaixo para finalizar instala&ccedil;&atilde;o ou %link%clique aqui%endlink% caso necessite de ajuda.");
INSERT INTO languages VALUES ("pt_BR", "Configuring Network", "Configurar Rede");
INSERT INTO languages VALUES ("pt_BR", "Configuring application", "Configurando aplica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Configuring hosts", "Configurando hosts");
INSERT INTO languages VALUES ("pt_BR", "Configuring user", "Configurando o usu&aacute;rio");
INSERT INTO languages VALUES ("pt_BR", "Configuring", "Configurando");
INSERT INTO languages VALUES ("pt_BR", "Confirm change", "Confirmar altera&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Confirm command execution", "Confirmar execu&ccedil;&atilde;o do comando");
INSERT INTO languages VALUES ("pt_BR", "Confirm command execution?", "Confirmar execu&ccedil;&atilde;o do comando?");
INSERT INTO languages VALUES ("pt_BR", "Confirm delete?", "Confirma remo&ccedil;&atilde;o?");
INSERT INTO languages VALUES ("pt_BR", "Confirm password", "Confirmar senha");
INSERT INTO languages VALUES ("pt_BR", "Confirm", "Confirmar");
INSERT INTO languages VALUES ("pt_BR", "Confirmation", "Confirma&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Conflict resolved", "Conflito resolvido");
INSERT INTO languages VALUES ("pt_BR", "Connection Error", "Erro de conex&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Contact name", "Nome de contato");
INSERT INTO languages VALUES ("pt_BR", "Contact", "Contato");
INSERT INTO languages VALUES ("pt_BR", "Contactgroup", "Grupo de Contatos");
INSERT INTO languages VALUES ("pt_BR", "Contactgroups and Contacts", "Grupo de contatos e contatos");
INSERT INTO languages VALUES ("pt_BR", "Contactgroups", "Grupos de Contatos");
INSERT INTO languages VALUES ("pt_BR", "Contacts", "Contatos");
INSERT INTO languages VALUES ("pt_BR", "Contacts/Users", "Contato/Usu&acute;rio");
INSERT INTO languages VALUES ("pt_BR", "Containers", "Cont&ecirc;iners");
INSERT INTO languages VALUES ("pt_BR", "Context", "Contexto");
INSERT INTO languages VALUES ("pt_BR", "Continent / Country", "Continente/Pa&iacute;s");
INSERT INTO languages VALUES ("pt_BR", "Copyright", "Copyright");
INSERT INTO languages VALUES ("pt_BR", "Correct Syntax: hostname,adddress,description", "Sintaxe correta: nome e do host, endere&ccedil;o, descri&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Corrupted license", "Licen&ccedil;a corrompida");
INSERT INTO languages VALUES ("pt_BR", "Could not create shortcut because it exists already", "N&atilde;o foi poss&iacute;vel criar o atalho pois este nome j&aacute; est&aacute; em uso");
INSERT INTO languages VALUES ("pt_BR", "Could not get any data from the host. Make sure your global settings are correct.", "N&atilde;o foi poss&iacute;vel obter dados do host. Verifique se as configura&ccedil;&otilde;es globais est&atilde;o corretas");
INSERT INTO languages VALUES ("pt_BR", "Could not get any data from the selected hosts. Make sure your global settings are correct.", "N&atilde;o foi poss&iacute;vel obter dados do(s) host(s) selecionado(s). Verifique se as configura&ccedil;&otilde;es globais est&atilde;o corretas.");
INSERT INTO languages VALUES ("pt_BR", "Create Host Groups", "Criar grupos de host");
INSERT INTO languages VALUES ("pt_BR", "Create Service Groups", "Criar grupos de servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR", "Create a service manually", "Criar um servi&ccedil;o manualmente");
INSERT INTO languages VALUES ("pt_BR", "Create new Authentication", "Criar nova Autentica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Create new SNMP Community", "Criar nova Comunidade SNMP");
INSERT INTO languages VALUES ("pt_BR", "Create new baseline", "Criar nova baseline");
INSERT INTO languages VALUES ("pt_BR", "Create new host", "Criar novo host");
INSERT INTO languages VALUES ("pt_BR", "Create new hosts", "Criar novos hosts");
INSERT INTO languages VALUES ("pt_BR", "Create new report", "Criar novo relat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR", "Create new", "Criar novo");
INSERT INTO languages VALUES ("pt_BR", "Create service", "Criar servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR", "Created in", "Criada em");
INSERT INTO languages VALUES ("pt_BR", "Creation date", "Data de cria&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Critical", "Cr&iacute;tico");
INSERT INTO languages VALUES ("pt_BR", "Current attempt", "Tentativa atual");
INSERT INTO languages VALUES ("pt_BR", "Current logo", "Logo atual");
INSERT INTO languages VALUES ("pt_BR", "Custom map", "Mapa customizado");
INSERT INTO languages VALUES ("pt_BR", "Custom period", "Per&iacute;odo customizado");
INSERT INTO languages VALUES ("pt_BR", "Custom", "Customizado");
INSERT INTO languages VALUES ("pt_BR", "Customize alarm for this day", "Personalizar alarme para este dia");
INSERT INTO languages VALUES ("pt_BR", "DATABASECONNECTION", "Conex&atilde;o com Banco de Dados");
INSERT INTO languages VALUES ("pt_BR", "DNS", "DNS");
INSERT INTO languages VALUES ("pt_BR", "DOWN", "FORA");
INSERT INTO languages VALUES ("pt_BR", "Daily", "Di&aacute;rio");
INSERT INTO languages VALUES ("pt_BR", "Dashboards", "Dashboards");
INSERT INTO languages VALUES ("pt_BR", "Database connection problem", "Problemas de conex&atilde;o com a base de dados!");
INSERT INTO languages VALUES ("pt_BR", "Date and Time Settings", "Configura&ccedil;&otilde;es de Data e Hora");
INSERT INTO languages VALUES ("pt_BR", "Date and time", "Data e Hora");
INSERT INTO languages VALUES ("pt_BR", "Date", "Data");
INSERT INTO languages VALUES ("pt_BR", "Date/Time", "Data/Hora");
INSERT INTO languages VALUES ("pt_BR", "Day", "Dia");
INSERT INTO languages VALUES ("pt_BR", "Days", "Dias");
INSERT INTO languages VALUES ("pt_BR", "Dear", "Prezado");
INSERT INTO languages VALUES ("pt_BR", "Dec", "Dez");
INSERT INTO languages VALUES ("pt_BR", "December", "Dezembro");
INSERT INTO languages VALUES ("pt_BR", "Default", "Padr&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Define Output", "Definir sa&iacute;da");
INSERT INTO languages VALUES ("pt_BR", "Define basic parameters of selected hosts", "Defina os par&acirc;metros b&aacute;sicos dos hosts selecionados");
INSERT INTO languages VALUES ("pt_BR", "Define host check commmand and values", "Defina o comando de checagem do host e valores de checagem");
INSERT INTO languages VALUES ("pt_BR", "Define the authentication mode", "Define o modo de autentica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Define the report format", "Defina o formato do relat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR", "Defined", "Definido");
INSERT INTO languages VALUES ("pt_BR", "Delete baseline", "Apagar baseline");
INSERT INTO languages VALUES ("pt_BR", "Delete selected", "Remover selecionados");
INSERT INTO languages VALUES ("pt_BR", "Delete the custom report", "Exclua o relat&oacute;rio personalizado");
INSERT INTO languages VALUES ("pt_BR", "Delete this report", "Excluir este relat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR", "Description of baseline", "Descri&ccedil;&atilde;o da baseline");
INSERT INTO languages VALUES ("pt_BR", "Description", "Descri&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Destination", "Destino");
INSERT INTO languages VALUES ("pt_BR", "Detailed view", "Vis&atilde;o Detalhada");
INSERT INTO languages VALUES ("pt_BR", "Detailed", "Detalhado");
INSERT INTO languages VALUES ("pt_BR", "Details of", "Detalhes de");
INSERT INTO languages VALUES ("pt_BR", "Details", "Detalhes");
INSERT INTO languages VALUES ("pt_BR", "Different passwords", "Senhas diferentes");
INSERT INTO languages VALUES ("pt_BR", "Disable active checks for all services", "Desabilitar checagens ativas para todos Servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR", "Disable checks for all services", "Desabilitar checagens para todos os Servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR", "Disable checks", "Desabilitar checagens");
INSERT INTO languages VALUES ("pt_BR", "Disable notifications for all hosts", "Desabilitar notifica&ccedil;&otilde;es para todos Hosts");
INSERT INTO languages VALUES ("pt_BR", "Disable notifications for all services", "Desabilitar notifica&ccedil;&otilde;es em todos Servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR", "Disable notifications for all services", "Desabilitar notifica&ccedil;&otilde;es para todos Servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR", "Disable notifications", "Desabilitar notifica&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR", "Disabled", "Desabilitado");
INSERT INTO languages VALUES ("pt_BR", "Disableda", "Desabilitada");
INSERT INTO languages VALUES ("pt_BR", "Disassociate the metrics to be able to delete the baseline.", "Desassocie as m&eacute;tricas para poder apagar a baseline.");
INSERT INTO languages VALUES ("pt_BR", "Disassociate this metric", "Desassociar esta m&eacute;trica");
INSERT INTO languages VALUES ("pt_BR", "Discard", "Descartar");
INSERT INTO languages VALUES ("pt_BR", "Discarded packets", "Pacotes descartados");
INSERT INTO languages VALUES ("pt_BR", "Discover and IP Ranges", "Descobrir IPs e Ranges");
INSERT INTO languages VALUES ("pt_BR", "Discover elements", "Descobrir elementos");
INSERT INTO languages VALUES ("pt_BR", "Discovered Device", "Dispositivo Descoberto");
INSERT INTO languages VALUES ("pt_BR", "devices discovered", "dispositivos descobertos");
INSERT INTO languages VALUES ("pt_BR", "Discovering network elements", "Descobrir elementos da rede");
INSERT INTO languages VALUES ("pt_BR", "Discovery Awareness Message", "A descoberta de elementos de rede busca por portas abertas e por poss&iacute;veis respostas ao protocolo SNMP nos servidores de destino. Muitas vezes este tipo de varredura(busca por portas abertas) interpretado por um IDS como uma tentativa de invas&atilde;o, portanto, aconselhamos a sempre conversar com o administrador da rede antes de efetuar a descoberta.");
INSERT INTO languages VALUES ("pt_BR", "Discovery Configuration", "Configura&ccedil;&otilde;es da Descoberta");
INSERT INTO languages VALUES ("pt_BR", "Discovery Status", "Status do Discovery");
INSERT INTO languages VALUES ("pt_BR", "Discovery result", "Resultado da descoberta");
INSERT INTO languages VALUES ("pt_BR", "Discovery running", "Discovery em andamento");
INSERT INTO languages VALUES ("pt_BR", "Discovery", "Discovery");
INSERT INTO languages VALUES ("pt_BR", "Display the discovered elements by OpMon", "Visualize os elementos descobertos pelo OpMon");
INSERT INTO languages VALUES ("pt_BR", "Display the topology of the monitored elements", "Visualize a topologia dos elementos monitorados");
INSERT INTO languages VALUES ("pt_BR", "Displaying", "Exibindo");
INSERT INTO languages VALUES ("pt_BR", "Do not monitor", "N&atilde;o monitorar");
INSERT INTO languages VALUES ("pt_BR", "Do not select service", "N&atilde;o selecionar o servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR", "Do nothing", "N&atilde;o fa&ccedil;a nada");
INSERT INTO languages VALUES ("pt_BR", "Do you really want to apply all the changes ?", "Deseja realmente aplicar todas as altera&ccedil;&otilde;es?");
INSERT INTO languages VALUES ("pt_BR", "Do you really want to cancel it?", "Voc&ecirc; realmente quer cancelar?");
INSERT INTO languages VALUES ("pt_BR", "Do you really want to cancel the setup process", "Voc&ecirc; realmente deseja cancelar o processo de configura&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Do you really want to not monitor this service?", "Voc&ecirc; realmente deseja n&atilde;o monitorar esse servi&ccedil;o?");
INSERT INTO languages VALUES ("pt_BR", "Do you really want to remove it?", "Voc&ecirc; tem certeza que deseja remov&ecirc;-lo");
INSERT INTO languages VALUES ("pt_BR", "Do you want to cancel the process of adding / editing ?", "Deseja cancelar o processo de adi&ccedil;&atilde;o/edi&ccedil;&atilde;o?");
INSERT INTO languages VALUES ("pt_BR", "Do you want to remove the port", "Deseja remover a porta");
INSERT INTO languages VALUES ("pt_BR", "Do you want to remove the probe", "Deseja remover a probe");
INSERT INTO languages VALUES ("pt_BR", "Do you want to select this service?", "Voc&ecirc; deseja selecionar o servi&ccedil;o?");
INSERT INTO languages VALUES ("pt_BR", "Documentation", "Documenta&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "DocumentationDescription", "Voc&ecirc; pode acessar a nossa Wiki onde v&aacute;rios materiais est&atilde;o dispon&iacute;veis, inclu&iacute;ndo uma base de conhecimento, plugins, v&iacute;deos e tutoriais.");
INSERT INTO languages VALUES ("pt_BR", "Documentations", "Documenta&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR", "Don't show again", "N&atilde;o mostrar novamente");
INSERT INTO languages VALUES ("pt_BR", "Don't show this window again", "N&atilde;o exibir esta janela novamente");
INSERT INTO languages VALUES ("pt_BR", "Double-click to add to selection", "Clique duas vezes para adicionar &agrave; sele&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Double-click to edit", "Clique duas vezes para editar");
INSERT INTO languages VALUES ("pt_BR", "Double-click to remove the item of selection", "Clique duas vezes para remover o item de sele&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Down time", "Tempo fora");
INSERT INTO languages VALUES ("pt_BR", "Down", "Fora");
INSERT INTO languages VALUES ("pt_BR", "Download the custom report", "Fa&ccedil;a o download do relat&oacute;rio personalizado");
INSERT INTO languages VALUES ("pt_BR", "Downtime Totals", "Totaliza&ccedil;&atilde;o das manuten&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR", "Downtime", "Parada");
INSERT INTO languages VALUES ("pt_BR", "Downtimes between dates", "Manuten&ccedil;&otilde;es entre datas");
INSERT INTO languages VALUES ("pt_BR", "Duplicate host", "Duplicar host");
INSERT INTO languages VALUES ("pt_BR", "Duplicate host", "Duplicar o host");
INSERT INTO languages VALUES ("pt_BR", "Duplicate service", "Duplicar servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR", "Duration", "Dura&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "E-mail could not be sent", "Email n&atilde;o pode ser enviado");
INSERT INTO languages VALUES ("pt_BR", "E-mail notifications from to", "E-mail from para notifica&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR", "E-mail server settings", "Configura&ccedil;&otilde;es de Servidor de E-mail");
INSERT INTO languages VALUES ("pt_BR", "E-mail settings", "Configura&ccedil;&otilde;es de E-mail");
INSERT INTO languages VALUES ("pt_BR", "E-mail", "E-mail");
INSERT INTO languages VALUES ("pt_BR", "E-mails dont match", "E-mails diferentes");
INSERT INTO languages VALUES ("pt_BR", "EVENTGUARD", "EventGuard");
INSERT INTO languages VALUES ("pt_BR", "EXTERNALAUTH", "Autentica&ccedil;&atilde;o Externa");
INSERT INTO languages VALUES ("pt_BR", "EXTERNALCOMMANDS", "Comandos Externos");
INSERT INTO languages VALUES ("pt_BR", "Edit Host Groups", "Editar Grupos de Host");
INSERT INTO languages VALUES ("pt_BR", "Edit Service Groups", "Editar Grupos de Servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR", "Edit Teams and Team Members", "Editar grupos de contato e contatos");
INSERT INTO languages VALUES ("pt_BR", "Edit Templates", "Editar Templates");
INSERT INTO languages VALUES ("pt_BR", "Edit associated metrics", "Editar m&eacute;tricas associadas");
INSERT INTO languages VALUES ("pt_BR", "Edit baseline", "Editar baseline");
INSERT INTO languages VALUES ("pt_BR", "Edit before duplicating", "Editar antes de duplicar");
INSERT INTO languages VALUES ("pt_BR", "Edit bookmark links", "Editar os favoritos");
INSERT INTO languages VALUES ("pt_BR", "Edit check command", "Editar comando de checagem");
INSERT INTO languages VALUES ("pt_BR", "Edit checks", "Editar checagens");
INSERT INTO languages VALUES ("pt_BR", "Edit description", "Edit description");
INSERT INTO languages VALUES ("pt_BR", "Edit extended information", "Editar informa&ccedil;&otilde;es estendidas");
INSERT INTO languages VALUES ("pt_BR", "Edit host groups", "Editar grupos de host");
INSERT INTO languages VALUES ("pt_BR", "Edit host", "Editar host");
INSERT INTO languages VALUES ("pt_BR", "Edit name", "Edit name");
INSERT INTO languages VALUES ("pt_BR", "Edit notifications", "Editar notifica&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR", "Edit service", "Editar servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR", "Edit settings", "Editar as defini&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR", "Edit teams", "Editar grupos de contato");
INSERT INTO languages VALUES ("pt_BR", "Edit", "Editar");
INSERT INTO languages VALUES ("pt_BR", "Element (s) selected (s)", "elemento(s) selecionado(s)");
INSERT INTO languages VALUES ("pt_BR", "Element description", "Element description");
INSERT INTO languages VALUES ("pt_BR", "Element name", "Element name");
INSERT INTO languages VALUES ("pt_BR", "Element origin of new metrics", "Elemento origem das novas m&eacute;tricas");
INSERT INTO languages VALUES ("pt_BR", "Element's history is going to be permanently removed", "Todo o hist&oacute;rico do elemento ser&aacute; perdido");
INSERT INTO languages VALUES ("pt_BR", "Elements Selected for the Report", "elemento(s) selecionado(s) para o relat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR", "Email sent", "Email enviado.");
INSERT INTO languages VALUES ("pt_BR", "Email", "Email");
INSERT INTO languages VALUES ("pt_BR", "Empty host list", "Lista de hosts vazia");
INSERT INTO languages VALUES ("pt_BR", "Enable active checks for all services", "Habilitar checagens ativas para todos Servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR", "Enable checks for all services", "Habilitar checagens para todos os Servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR", "Enable checks", "Habilitar checagens");
INSERT INTO languages VALUES ("pt_BR", "Enable discovery", "Ativar Descoberta");
INSERT INTO languages VALUES ("pt_BR", "Enable notifications for all hosts", "Habilitar notifica&ccedil;&otilde;es para todos Hosts");
INSERT INTO languages VALUES ("pt_BR", "Enable notifications for all services", "Habilitar notifica&ccedil;&otilde;es em todos Servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR", "Enable notifications for all services", "Habilitar notifica&ccedil;&otilde;es para todos Servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR", "Enable notifications", "Habilitar notifica&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR", "Enable zoom", "Ativar zoom");
INSERT INTO languages VALUES ("pt_BR", "Enabled", "Habilitado");
INSERT INTO languages VALUES ("pt_BR", "Enableda", "Habilitada");
INSERT INTO languages VALUES ("pt_BR", "End Discovery", "Finalizar");
INSERT INTO languages VALUES ("pt_BR", "End date", "Data final");
INSERT INTO languages VALUES ("pt_BR", "End time", "Hora final");
INSERT INTO languages VALUES ("pt_BR", "End", "Fim");
INSERT INTO languages VALUES ("pt_BR", "Enter the Default Gateway", "Digite o Gateway Padr&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Enter the IP or the Range to be discovered", "Digite o IP ou o Range a ser descoberto");
INSERT INTO languages VALUES ("pt_BR", "Enter the Netmask", "Digite a M&aacute;scara de Rede");
INSERT INTO languages VALUES ("pt_BR", "Enter the Primary DNS", "Digite o DNS Prim&aacute;rio");
INSERT INTO languages VALUES ("pt_BR", "Enter the Secondary DNS", "Digite o DNS Secund&aacute;rio");
INSERT INTO languages VALUES ("pt_BR", "Enter the fixed IP", "Digite o IP fixo");
INSERT INTO languages VALUES ("pt_BR", "Enter the server address", "Digite o endere&ccedil;o do servidor");
INSERT INTO languages VALUES ("pt_BR", "Entry time", "Hora entrada");
INSERT INTO languages VALUES ("pt_BR", "Error to locate group of hosts", "Erro procurando grupo de hosts");
INSERT INTO languages VALUES ("pt_BR", "Error to locate team", "Erro ao localizar o grupo de contato");
INSERT INTO languages VALUES ("pt_BR", "Error", "Erro");
INSERT INTO languages VALUES ("pt_BR", "Event handler disabled", "Gerenciador de eventos desabilitado");
INSERT INTO languages VALUES ("pt_BR", "Event handler enabled", "Gerenciador de eventos habilitado");
INSERT INTO languages VALUES ("pt_BR", "Event handler", "Gerenciador de eventos");
INSERT INTO languages VALUES ("pt_BR", "Event handlers disabled in monitoring, but enabled in the Configuration", "Event handlers desabilitados na Monitora&ccedil;&atilde;o, por&eacute;m habilitados na Configura&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Event handlers enabled in monitoring, but disabled in the Configuration", "Event handlers habilitados na Monitora&ccedil;&atilde;o, por&eacute;m desabilitados na Configura&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Event log", "Log de eventos");
INSERT INTO languages VALUES ("pt_BR", "Event Log", "Log de Eventos");
INSERT INTO languages VALUES ("pt_BR", "Events Totals", "Totaliza&ccedil;&atilde;o dos eventos");
INSERT INTO languages VALUES ("pt_BR", "Events", "Eventos");
INSERT INTO languages VALUES ("pt_BR", "Every Sunday, 00:00", "Todo domingo, &agrave;s 00:00");
INSERT INTO languages VALUES ("pt_BR", "Every day, 00:00", "Todo dia, &agrave;s 00:00");
INSERT INTO languages VALUES ("pt_BR", "Every first Sunday of the month, 00:00", "Todo primeiro domingo do m&ecirc;s, &agrave;s 00:00");
INSERT INTO languages VALUES ("pt_BR", "Example: 192.168.10.1,linux server 07,intranet and website server.", "Exemplo: 192.168.10.1,linux server 07,servidor da intranet e website.");
INSERT INTO languages VALUES ("pt_BR", "Exceeded the Lower limit", "Ultrapassou o limite Inferior");
INSERT INTO languages VALUES ("pt_BR", "Exceeded the Upper limit", "Ultrapassou o limite Superior");
INSERT INTO languages VALUES ("pt_BR", "Execute a command on selected items", "Executa um comando nos itens selecionados");
INSERT INTO languages VALUES ("pt_BR", "Execute an external command", "Executar um comando externo");
INSERT INTO languages VALUES ("pt_BR", "Expiration (Date/Time)", "Expira&ccedil;&atilde;o (Dia/Hora)");
INSERT INTO languages VALUES ("pt_BR", "Expiration Date", "Data de Expira&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Expire time", "Data de expira&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Expire", "Expira");
INSERT INTO languages VALUES ("pt_BR", "Export as PDF", "Exportar como PDF");
INSERT INTO languages VALUES ("pt_BR", "Export to", "Exportar para");
INSERT INTO languages VALUES ("pt_BR", "Exporting new config", "Exportando nova configura&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Extended Output", "Sa&iacute;da estendida");
INSERT INTO languages VALUES ("pt_BR", "Extended information", "Informa&ccedil;&otilde;es estendidas");
INSERT INTO languages VALUES ("pt_BR", "External command cannot be executed", "O comando externo n&atilde;o pode ser executado");
INSERT INTO languages VALUES ("pt_BR", "External command was executed", "O comando externo foi executado");
INSERT INTO languages VALUES ("pt_BR", "External commands", "Comandos externos");
INSERT INTO languages VALUES ("pt_BR", "External links", "Links externos");
INSERT INTO languages VALUES ("pt_BR", "Extra parameter", "Par&acirc;metro extra");
INSERT INTO languages VALUES ("pt_BR", "Extras", "Extras");
INSERT INTO languages VALUES ("pt_BR", "Fail log", "Log de Falha");
INSERT INTO languages VALUES ("pt_BR", "Fail", "Falha");
INSERT INTO languages VALUES ("pt_BR", "Failed to connect to the server. Try again.", "Falha na conex&atilde;o com o servidor. Tente novamente.");
INSERT INTO languages VALUES ("pt_BR", "Failed to restart OpMon Traffic Analyzer process.", "Falha ao reiniciar o processo do OpMon Traffic Analyzer.");
INSERT INTO languages VALUES ("pt_BR", "Failed to save an activation key", "Falha ao salvar uma chave de ativa&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Failed to update OpMon Traffic Analyzer port.", "Falha ao atualizar a porta do OpMon Traffic Analyzer.");
INSERT INTO languages VALUES ("pt_BR", "Failed to update the configuration file.", "Falha ao atualizar o arquivo de configura&ccedil;&atilde;o.");
INSERT INTO languages VALUES ("pt_BR", "Failed to update the database.", "Falha ao atualizar a base de dados.");
INSERT INTO languages VALUES ("pt_BR", "Fas addition of elements", "Adi&ccedil;&atilde;o r&aacute;pida de elementos");
INSERT INTO languages VALUES ("pt_BR", "Fast addition of elements", "Adi&ccedil;&atilde;o r&aacute;pida de elementos");
INSERT INTO languages VALUES ("pt_BR", "Favorite this", "Favoritar");
INSERT INTO languages VALUES ("pt_BR", "Favorites", "Favoritos");
INSERT INTO languages VALUES ("pt_BR", "Feb", "Fev");
INSERT INTO languages VALUES ("pt_BR", "February", "Fevereiro");
INSERT INTO languages VALUES ("pt_BR", "File uploaded successfuly", "Arquivo enviado com sucesso");
INSERT INTO languages VALUES ("pt_BR", "Fill in the data below or %link%click here%endlink% if you need help", "Preencha os dados abaixo ou %link%clique aqui%endlink% caso necessite de ajuda");
INSERT INTO languages VALUES ("pt_BR", "Filter Report", "Relat&oacute;rio de Filtro");
INSERT INTO languages VALUES ("pt_BR", "Filter enabled", "Filtro %nameOfFilter% aplicado");
INSERT INTO languages VALUES ("pt_BR", "Filter by Application", "Filtrar por Aplica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Filter by host", "Filtrar por host");
INSERT INTO languages VALUES ("pt_BR", "Filter by metric", "Filtrar por m&eacute;trica");
INSERT INTO languages VALUES ("pt_BR", "Filter by port", "Filtrar por porta");
INSERT INTO languages VALUES ("pt_BR", "Filter by probe", "Filtrar por probe");
INSERT INTO languages VALUES ("pt_BR", "Filter by service", "Filtrar por servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR", "Filter by", "Filtrar por");
INSERT INTO languages VALUES ("pt_BR", "Filter by date", "Filtrar por data");
INSERT INTO languages VALUES ("pt_BR", "Filter discovered elements", "Filtrar elementos descobertos");
INSERT INTO languages VALUES ("pt_BR", "Filter", "Filtrar");
INSERT INTO languages VALUES ("pt_BR", "Filtering services", "filtrar servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR", "Filters", "Filtros");
INSERT INTO languages VALUES ("pt_BR", "Financial Losses", "Perdas Financeiras");
INSERT INTO languages VALUES ("pt_BR", "Finish Wizard and go to OpMon", "Finalizar o processo e ir para o OpMon");
INSERT INTO languages VALUES ("pt_BR", "Finish", "Finalizar");
INSERT INTO languages VALUES ("pt_BR", "Finished", "Terminada");
INSERT INTO languages VALUES ("pt_BR", "First Page", "Primeira P&aacute;gina");
INSERT INTO languages VALUES ("pt_BR", "First page", "Primeira p&aacute;gina");
INSERT INTO languages VALUES ("pt_BR", "Fixed IP", "IP Fixo");
INSERT INTO languages VALUES ("pt_BR", "Fixed", "Fixa");
INSERT INTO languages VALUES ("pt_BR", "Flap detection disabled", "Detec&ccedil;&atilde;o de instabilidade desabilitada");
INSERT INTO languages VALUES ("pt_BR", "Flap detection enabled", "Detec&ccedil;&atilde;o de instabilidade habilitada");
INSERT INTO languages VALUES ("pt_BR", "Flap detection", "Detec&ccedil;&atilde;o de instabilidade");
INSERT INTO languages VALUES ("pt_BR", "Flapping", "Instabilidade");
INSERT INTO languages VALUES ("pt_BR", "Flexible", "Flex&iacute;vel");
INSERT INTO languages VALUES ("pt_BR", "Flow collector", "Coletor de flows");
INSERT INTO languages VALUES ("pt_BR", "Force check", "For&ccedil;ar checagem");
INSERT INTO languages VALUES ("pt_BR", "Forced", "For&ccedil;ada");
INSERT INTO languages VALUES ("pt_BR", "Frequency of backup", "Frequ&ecirc;ncia do backup");
INSERT INTO languages VALUES ("pt_BR", "Frequency", "Frequ&ecirc;ncia");
INSERT INTO languages VALUES ("pt_BR", "Friday", "Sexta-feira");
INSERT INTO languages VALUES ("pt_BR", "From", "De");
INSERT INTO languages VALUES ("pt_BR", "FullscreenText", "Voc&ecirc; est&aacute; entrando em modo de visualiza&ccedil;&atilde;o em tela cheia. Para voltar ao modo normal, clique nos bot&otilde;es de expandir os pain&eacute;is localizados nas laterais da p&aacute;gina.");
INSERT INTO languages VALUES ("pt_BR", "Future trend", "Proje&ccedil;&atilde;o futura");
INSERT INTO languages VALUES ("pt_BR", "Generate a Capacity Planning Report from the selected items", "Gera um Relat&oacute;rio de Capacidade/Performance dos itens selecionados");
INSERT INTO languages VALUES ("pt_BR", "Generate a Network Utilization Report from the selected items", "Gera um Relat&oacute;rio de Utiliza&ccedil;&atilde;o&nbsp;de&nbsp;rede dos itens selecionados");
INSERT INTO languages VALUES ("pt_BR", "Generate an Availability Report from the selected items", "Gera um Relat&oacute;rio de Disponibilidade dos itens selecionados");
INSERT INTO languages VALUES ("pt_BR", "Generate network topology", "Gerar topologia de rede");
INSERT INTO languages VALUES ("pt_BR", "Generate network topology", "Montar topologia");
INSERT INTO languages VALUES ("pt_BR", "Generate report and send by e-mail", "Gerar relat&oacute;rio e enviar por e-mail");
INSERT INTO languages VALUES ("pt_BR", "Generate report", "Gerar relat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR", "Generating network topology", "Gerando topologia");
INSERT INTO languages VALUES ("pt_BR", "Get a new key", "Obter uma nova chave");
INSERT INTO languages VALUES ("pt_BR", "Get me out of here", "Tire-me daqui");
INSERT INTO languages VALUES ("pt_BR", "Global Settings", "Configura&ccedil;&otilde;es Globais");
INSERT INTO languages VALUES ("pt_BR", "Graphics in %", "Gr&aacute;ficos em %");
INSERT INTO languages VALUES ("pt_BR", "Green bullet means that the device is already being monitored. Gray bullet means that device has been discovered however it's not being monitored", "Bolinha verde significa que o dispositivo j&aacute; est&aacute; sendo monitorado, enquanto bolinha cinza significa que o dispositivo foi descoberto, por&eacute;m n&atilde;o est&aacute; monitorado ainda.");
INSERT INTO languages VALUES ("pt_BR", "GridNoElements", "Nada encontrado");
INSERT INTO languages VALUES ("pt_BR", "Group By", "Agrupado");
INSERT INTO languages VALUES ("pt_BR", "Group by metric", "Agrupar por m&eacute;trica");
INSERT INTO languages VALUES ("pt_BR", "Group by", "Agrupar por");
INSERT INTO languages VALUES ("pt_BR", "Groups of Hosts", "Grupos de Hosts");
INSERT INTO languages VALUES ("pt_BR", "HARD", "HARD");
INSERT INTO languages VALUES ("pt_BR", "HDs", "Discos");
INSERT INTO languages VALUES ("pt_BR", "Hard State", "Hard State");
INSERT INTO languages VALUES ("pt_BR", "Have documentation?", "Possui documenta&ccedil;&atilde;o?");
INSERT INTO languages VALUES ("pt_BR", "Help", "Ajuda");
INSERT INTO languages VALUES ("pt_BR", "Helpful", "&Uacute;til");
INSERT INTO languages VALUES ("pt_BR", "Hide options", "Esconder op&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR", "Highlight on the calendar", "Destacar no calend&aacute;rio");
INSERT INTO languages VALUES ("pt_BR", "Hint IP/Range", "Siga os exemplos:<br>192.168.10.130 ou;<br>192.168.10.* ou;<br>192.168.10.x - 192.168.10.y ou;<br>www.google.com.br ou;<br>para mais informa&#xE7;&#xF5;es, clique no &#xED;cone.");
INSERT INTO languages VALUES ("pt_BR", "Hint", "Dica");
INSERT INTO languages VALUES ("pt_BR", "History", "Hist&oacute;rico");
INSERT INTO languages VALUES ("pt_BR", "Holtz-Winters", "Holtz-Winters");
INSERT INTO languages VALUES ("pt_BR", "Host Grid", "Listagem de Hosts");
INSERT INTO languages VALUES ("pt_BR", "Host Group already contains target host", "Grupo de hosts alvo j&aacute; contem host");
INSERT INTO languages VALUES ("pt_BR", "Host Group", "Grupo de Host");
INSERT INTO languages VALUES ("pt_BR", "Host Groups", "Grupos de Host");
INSERT INTO languages VALUES ("pt_BR", "Host Name", "Nome do Host");
INSERT INTO languages VALUES ("pt_BR", "Host existing", "Host j&aacute; existente");
INSERT INTO languages VALUES ("pt_BR", "Host icon", "&Iacute;cone do host");
INSERT INTO languages VALUES ("pt_BR", "Host information", "Informa&ccedil;&otilde;es do Host");
INSERT INTO languages VALUES ("pt_BR", "Host origin of new metrics", "Host origem das novas m&eacute;tricas");
INSERT INTO languages VALUES ("pt_BR", "Host service is not selected", "O host do servi&ccedil;o n&atilde;o est&aacute; selecionado");
INSERT INTO languages VALUES ("pt_BR", "Host status", "Status dos Hosts");
INSERT INTO languages VALUES ("pt_BR", "Host", "Host");
INSERT INTO languages VALUES ("pt_BR", "Host(s) modified", "Host(s) modificado(s)");
INSERT INTO languages VALUES ("pt_BR", "Hostgroup Grid", "Listagem de Grupo de Hosts");
INSERT INTO languages VALUES ("pt_BR", "Hostgroup origin of new metrics", "Hostgroup origem das novas m&eacute;tricas");
INSERT INTO languages VALUES ("pt_BR", "Hostgroup", "Grupo de Host");
INSERT INTO languages VALUES ("pt_BR", "Hostname", "Nome do host");
INSERT INTO languages VALUES ("pt_BR", "Hosts and Contacts", "Hosts e Contatos");
INSERT INTO languages VALUES ("pt_BR", "Hosts with ack", "Hosts com a&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Hosts", "Hosts");
INSERT INTO languages VALUES ("pt_BR", "Hour", "Hora");
INSERT INTO languages VALUES ("pt_BR", "Hours", "Horas");
INSERT INTO languages VALUES ("pt_BR", "How do I add a probe?", "Como adiciono uma probe?");
INSERT INTO languages VALUES ("pt_BR", "I accept the %link%EULA terms described here%endlink%", "Eu aceito os termos do %link%EULA descritos aqui%endlink%");
INSERT INTO languages VALUES ("pt_BR", "I accept the EULA described above", "Eu aceito o EULA descrita acima");
INSERT INTO languages VALUES ("pt_BR", "I accept the eula described above", "Aceito a eula descrita acima");
INSERT INTO languages VALUES ("pt_BR", "I agree", "Concordo");
INSERT INTO languages VALUES ("pt_BR", "I am ready! Begin to monitor my traffic.", "Estou pronto! Comece a monitorar meu tr&aacute;fego.");
INSERT INTO languages VALUES ("pt_BR", "I did not understand. I need more information.", "N&atilde;o entendi. Preciso de mais informa&ccedil;&otilde;es.");
INSERT INTO languages VALUES ("pt_BR", "I disagree", "N&atilde;o concordo");
INSERT INTO languages VALUES ("pt_BR", "I do not agree", "N&atilde;o estou de acordo");
INSERT INTO languages VALUES ("pt_BR", "I know what I'm doing.", "Eu sei o que estou fazendo.");
INSERT INTO languages VALUES ("pt_BR", "I prefer to manually configure (Advanced Configuration)", "Prefiro configurar manualmente (Configura&ccedil;&atilde;o avan&ccedil;ada)");
INSERT INTO languages VALUES ("pt_BR", "I want to add more probes", "Quero adicionar mais probes");
INSERT INTO languages VALUES ("pt_BR", "I want to configure ports and protocol applications", "Quero configurar portas e protocolos de aplica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "I want to go to the traffic dashboard!", "Quero ir para o dashboard de tr&aacute;fego!");
INSERT INTO languages VALUES ("pt_BR", "I want to know more about OpMon Traffic Analyzer", "Quero saber mais sobre o OpMon Traffic Analyzer");
INSERT INTO languages VALUES ("pt_BR", "I want to monitoring OpMon Traffic Analyzer's internal traffic", "Quero monitorar o tr&aacute;fego interno do Optraffic");
INSERT INTO languages VALUES ("pt_BR", "ID", "ID");
INSERT INTO languages VALUES ("pt_BR", "IP Address", "Endere&ccedil;o IP");
INSERT INTO languages VALUES ("pt_BR", "IP", "Endere&ccedil;o IP");
INSERT INTO languages VALUES ("pt_BR", "Icon", "&Iacute;cone");
INSERT INTO languages VALUES ("pt_BR", "Identify, register and change ports and application protocols. This information will be used to storage and data presentation.", "Identifique, registre e altere portas e protocolos de aplica&ccedil;&atilde;o. Estas informa&ccedil;&otilde;es ser&atilde;o utilizadas para o armazenamento e apresenta&ccedil;&atilde;o dos dados.");
INSERT INTO languages VALUES ("pt_BR", "If flexible, duration", "Se flex&iacute;vel, dura&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "If you remove this element, all child nodes will be removed. Continue?", "Se voc&ecirc; remover este elemento, todos os elementos internos tamb&eacute;m ser&atilde; removidos. Deseja continuar?");
INSERT INTO languages VALUES ("pt_BR", "Impact", "Impacto");
INSERT INTO languages VALUES ("pt_BR", "Importing discovered objects", "Importando objetos");
INSERT INTO languages VALUES ("pt_BR", "In Flapping State", "Inst&aacute;vel");
INSERT INTO languages VALUES ("pt_BR", "In Progress", "Em Andamento");
INSERT INTO languages VALUES ("pt_BR", "In Scheduled Downtime", "Em Manuten&ccedil;&atilde;o Agendada");
INSERT INTO languages VALUES ("pt_BR", "In maintenance since", "Em manuten&ccedil;&atilde;o desde ");
INSERT INTO languages VALUES ("pt_BR", "In scheduled downtime", "Em manuten&ccedil;&atilde;o agendada");
INSERT INTO languages VALUES ("pt_BR", "Incidents", "Incidentes");
INSERT INTO languages VALUES ("pt_BR", "Include soft states", "Incluir soft states");
INSERT INTO languages VALUES ("pt_BR", "Information", "Informa&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Informations", "Informa&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR", "Initializing", "Inicializando");
INSERT INTO languages VALUES ("pt_BR", "Install custom package", "Instalar pacote customizado");
INSERT INTO languages VALUES ("pt_BR", "Install default packages", "Instalar pacotes");
INSERT INTO languages VALUES ("pt_BR", "Install selected packages", "Instalar pacotes selecionados");
INSERT INTO languages VALUES ("pt_BR", "Installing packages, do not close this window...", "Instalando pacotes, n&atilde;o feche esta janela...");
INSERT INTO languages VALUES ("pt_BR", "Interface", "Interface");
INSERT INTO languages VALUES ("pt_BR", "Interval", "Intervalo");
INSERT INTO languages VALUES ("pt_BR", "Invalid Configuration", "Configura&ccedil;&atilde;o inv&aacute;lida");
INSERT INTO languages VALUES ("pt_BR", "Invalid IP", "IP inv&aacute;lido");
INSERT INTO languages VALUES ("pt_BR", "Invalid Range", "IP ou Range inv&aacute;lido. Siga os exemplos: 192.168.10.100, como modelo para IPs; 192.168.10.*, como modelo para Ranges.");
INSERT INTO languages VALUES ("pt_BR", "Invalid Request", "Requisi&ccedil;&atilde;o inv&aacute;lida");
INSERT INTO languages VALUES ("pt_BR", "Invalid command description.", "Descri&ccedil;&atilde;o de comando inv&aacute;lida.");
INSERT INTO languages VALUES ("pt_BR", "Invalid command line.", "Linha de comando inv&aacute;lida");
INSERT INTO languages VALUES ("pt_BR", "Invalid command", "Comando inv&aacute;lido");
INSERT INTO languages VALUES ("pt_BR", "Invalid e-mail", "E-mail inv&aacute;lido");
INSERT INTO languages VALUES ("pt_BR", "Invalid group name", "Nome do grupo inv&aacute;lido");
INSERT INTO languages VALUES ("pt_BR", "Invalid host", "Host inv&aacute;lido");
INSERT INTO languages VALUES ("pt_BR", "Invalid hostname", "Nome de host inv&aacute;lido");
INSERT INTO languages VALUES ("pt_BR", "Invalid language selected", "L&iacute;ngua selecionada inv&aacute;lida");
INSERT INTO languages VALUES ("pt_BR", "Invalid license expire time", "Um erro ocorreu ao verificar validade de sua licen&ccedil;a");
INSERT INTO languages VALUES ("pt_BR", "Invalid license file extension", "Extens&atilde;o do arquivo de licen&ccedil;a &eacute; inv&aacute;lida. Requer .txt");
INSERT INTO languages VALUES ("pt_BR", "Invalid name", "Nome inv&aacute;lido");
INSERT INTO languages VALUES ("pt_BR", "Invalid parameters received. We need fields from, to and relay for send mail test.", "Par&acirc;metros inv&aacute;lidos recebidos. N&oacute;s precisamos dos campos \"from\", \"to\" e \"relay\" para o teste de envio de e-mail.");
INSERT INTO languages VALUES ("pt_BR", "Invalid password", "Senha inv&aacute;lida");
INSERT INTO languages VALUES ("pt_BR", "Invalid team name", "Nome de grupo de contatos inv&aacute;lido");
INSERT INTO languages VALUES ("pt_BR", "Invalid user type", "Tipo de contato inv&aacute;lido");
INSERT INTO languages VALUES ("pt_BR", "Invalid user", "Contato inv&aacute;lido!");
INSERT INTO languages VALUES ("pt_BR", "Invalid username", "Nome de contato inv&aacute;lido");
INSERT INTO languages VALUES ("pt_BR", "Ips and Ranges to be processed", "IPs e Ranges a processar");
INSERT INTO languages VALUES ("pt_BR", "Ips to be processed", "IPs a serem processados");
INSERT INTO languages VALUES ("pt_BR", "JSON not found", "Imposs&iacute;vel interpretar json");
INSERT INTO languages VALUES ("pt_BR", "Jan", "Jan");
INSERT INTO languages VALUES ("pt_BR", "January", "Janeiro");
INSERT INTO languages VALUES ("pt_BR", "Jelp", "Ajuda");
INSERT INTO languages VALUES ("pt_BR", "Jul", "Jul");
INSERT INTO languages VALUES ("pt_BR", "July", "Julho");
INSERT INTO languages VALUES ("pt_BR", "Jun", "Jun");
INSERT INTO languages VALUES ("pt_BR", "June", "Junho");
INSERT INTO languages VALUES ("pt_BR", "Key Availability Indicators", "Indicadores chave de disponibilidade");
INSERT INTO languages VALUES ("pt_BR", "Key Performance Indicators", "Indicadores chave de performance");
INSERT INTO languages VALUES ("pt_BR", "Key Users", "Usu&aacute;rios Chave");
INSERT INTO languages VALUES ("pt_BR", "Kind of source of metrics", "Tipo da origem das m&eacute;tricas");
INSERT INTO languages VALUES ("pt_BR", "Knowledge Base Link", "http://kb.opservices.com.br");
INSERT INTO languages VALUES ("pt_BR", "Label", "R&oacute;tulo");
INSERT INTO languages VALUES ("pt_BR", "Language", "Portugues Brasil");
INSERT INTO languages VALUES ("pt_BR", "Last 24 hours", "&Uacute;ltimas 24 horas");
INSERT INTO languages VALUES ("pt_BR", "Last 31 days", "&Uacute;ltimos 31 dias");
INSERT INTO languages VALUES ("pt_BR", "Last 7 days", "&Uacute;ltimos 7 dias");
INSERT INTO languages VALUES ("pt_BR", "Last Check Header", "&Uacute;lt. Chec.");
INSERT INTO languages VALUES ("pt_BR", "Last Check", "&Uacute;ltima Checagem");
INSERT INTO languages VALUES ("pt_BR", "Last Page", "&Uacute;ltima P&aacute;gina");
INSERT INTO languages VALUES ("pt_BR", "Last Update", "&Uacute;ltima atualiza&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Last Value", "&Uacute;ltimo valor");
INSERT INTO languages VALUES ("pt_BR", "Last collect", "&Uacute;ltima coleta");
INSERT INTO languages VALUES ("pt_BR", "Last hour", "&Uacute;ltima hora");
INSERT INTO languages VALUES ("pt_BR", "Last month", "&Uacute;ltimo m&ecirc;s");
INSERT INTO languages VALUES ("pt_BR", "Last notification", "&Uacute;ltima notifica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Last page", "&Uacute;ltima p&aacute;gina");
INSERT INTO languages VALUES ("pt_BR", "Last review", "&Uacute;ltima revis&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Last state change", "&Uacute;ltima altera&ccedil;&atilde;o de estado");
INSERT INTO languages VALUES ("pt_BR", "Last update", "&Uacute;ltima atualiza&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Last week", "&Uacute;ltima semana");
INSERT INTO languages VALUES ("pt_BR", "Last year", "&Uacute;ltimo ano");
INSERT INTO languages VALUES ("pt_BR", "Last", "&Uacute;ltimo");
INSERT INTO languages VALUES ("pt_BR", "Last...", "&Uacute;ltimos...");
INSERT INTO languages VALUES ("pt_BR", "Latency", "Lat&ecirc;ncia");
INSERT INTO languages VALUES ("pt_BR", "Layout", "Layout");
INSERT INTO languages VALUES ("pt_BR", "Learn more about OpMon", "Saiba mais sobre o OpMon");
INSERT INTO languages VALUES ("pt_BR", "Legend", "Legenda");
INSERT INTO languages VALUES ("pt_BR", "Level", "N&iacute;vel");
INSERT INTO languages VALUES ("pt_BR", "License Type", "Tipo de Licen&ccedil;a");
INSERT INTO languages VALUES ("pt_BR", "License details", "Detalhes da licen&ccedil;a");
INSERT INTO languages VALUES ("pt_BR", "License file updated successfully", "Licen&ccedil;a atualizada com sucesso.");
INSERT INTO languages VALUES ("pt_BR", "License is expired", "A licen&ccedil;a est&aacute; expirada");
INSERT INTO languages VALUES ("pt_BR", "License limit reached", "Limite de licen&ccedil;a atingido");
INSERT INTO languages VALUES ("pt_BR", "License limit reached.", "Atingido o limite da licen&ccedil;a.");
INSERT INTO languages VALUES ("pt_BR", "License", "Licen&ccedil;a");
INSERT INTO languages VALUES ("pt_BR", "Licensed Dashboards", "Dashboards Licenciados");
INSERT INTO languages VALUES ("pt_BR", "Licensed Hosts", "Hosts Licenciados");
INSERT INTO languages VALUES ("pt_BR", "Licensed Services", "Servi&ccedil;os Licenciados");
INSERT INTO languages VALUES ("pt_BR", "Licensed", "Licenciados");
INSERT INTO languages VALUES ("pt_BR", "List SLA Description", "Contrato celebrado entre prestadores de servi&ccedil;o e cliente, definindo os n&iacute;veis aceit&aacute;veis ou n&atilde;o de servi&ccedil;o.");
INSERT INTO languages VALUES ("pt_BR", "List SLA(Service Level Agreement)", "Listar SLA(Service Level Agreement)");
INSERT INTO languages VALUES ("pt_BR", "List of Communities", "Lista de Comunidades");
INSERT INTO languages VALUES ("pt_BR", "List", "Listar");
INSERT INTO languages VALUES ("pt_BR", "Loading Models...", "Carregando Modelos...");
INSERT INTO languages VALUES ("pt_BR", "Loading interface", "Carregando interface...");
INSERT INTO languages VALUES ("pt_BR", "Loading items...", "Carregando items...");
INSERT INTO languages VALUES ("pt_BR", "Loading language array", "Carregando linguagem...");
INSERT INTO languages VALUES ("pt_BR", "Loading objects", "Carregando objetos...");
INSERT INTO languages VALUES ("pt_BR", "Loading user's profile", "Carregando o perfil do usu&aacute;rio...");
INSERT INTO languages VALUES ("pt_BR", "Loading", "Carregando");
INSERT INTO languages VALUES ("pt_BR", "Location", "Localiza&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Log", "Log");
INSERT INTO languages VALUES ("pt_BR", "Login", "Entrar");
INSERT INTO languages VALUES ("pt_BR", "Logo upload", "Troca de logo");
INSERT INTO languages VALUES ("pt_BR", "Logout", "Logout");
INSERT INTO languages VALUES ("pt_BR", "Lower limit", "Limite inferior");
INSERT INTO languages VALUES ("pt_BR", "MTBF", "TMEF");
INSERT INTO languages VALUES ("pt_BR", "MTTF", "TMPF");
INSERT INTO languages VALUES ("pt_BR", "MTTR", "TMPR");
INSERT INTO languages VALUES ("pt_BR", "Make sure you have enabled your probe's netflow correctly.", "Verifique se voc&ecirc; habilitou o netflow de seus coletores corretamente.");
INSERT INTO languages VALUES ("pt_BR", "Manage in real time the selected items", "Gerenciar, em tempo real, os itens selecionados");
INSERT INTO languages VALUES ("pt_BR", "Management commands", "Comandos gerenciais");
INSERT INTO languages VALUES ("pt_BR", "Management", "Gerenciamento");
INSERT INTO languages VALUES ("pt_BR", "Manages the network topology with the elements", "Gere a topologia da rede com os elementos");
INSERT INTO languages VALUES ("pt_BR", "Maps", "Mapas");
INSERT INTO languages VALUES ("pt_BR", "Mar", "Mar");
INSERT INTO languages VALUES ("pt_BR", "March", "Mar&ccedil;o");
INSERT INTO languages VALUES ("pt_BR", "Max", "M&aacute;x");
INSERT INTO languages VALUES ("pt_BR", "Maximize view", "Maximize view");
INSERT INTO languages VALUES ("pt_BR", "Maximum Attempts", "N&ordm; m&aacute;ximo");
INSERT INTO languages VALUES ("pt_BR", "Maximum Check Attempts", "N&ordm; m&aacute;ximo de tentativas de checagem");
INSERT INTO languages VALUES ("pt_BR", "Maximum", "M&aacute;ximo");
INSERT INTO languages VALUES ("pt_BR", "May", "Mai");
INSERT INTO languages VALUES ("pt_BR", "May", "Maio");
INSERT INTO languages VALUES ("pt_BR", "Menu_Custom", "Customizados");
INSERT INTO languages VALUES ("pt_BR", "Method", "M&eacute;todo");
INSERT INTO languages VALUES ("pt_BR", "Metric Aggregated", "M&eacute;tricas agregadas");
INSERT INTO languages VALUES ("pt_BR", "Metric", "M&eacute;trica");
INSERT INTO languages VALUES ("pt_BR", "Metrics Available", "M&eacute;tricas dispon&iacute;veis");
INSERT INTO languages VALUES ("pt_BR", "Metrics associated with baseline", "M&eacute;tricas associadas &agrave; baseline");
INSERT INTO languages VALUES ("pt_BR", "Metrics available", "M&eacute;tricas dispon&iacute;veis");
INSERT INTO languages VALUES ("pt_BR", "Metrics", "M&eacute;trica");
INSERT INTO languages VALUES ("pt_BR", "Metrics", "M&eacute;tricas");
INSERT INTO languages VALUES ("pt_BR", "Min", "Min");
INSERT INTO languages VALUES ("pt_BR", "Minimum", "M&iacute;nimo");
INSERT INTO languages VALUES ("pt_BR", "Mobile", "Celular");
INSERT INTO languages VALUES ("pt_BR", "Model Groups", "Grupos de modelos");
INSERT INTO languages VALUES ("pt_BR", "Model name", "Nome do modelo");
INSERT INTO languages VALUES ("pt_BR", "Model", "Modelo");
INSERT INTO languages VALUES ("pt_BR", "Module not installed. Contact your system administrator.", "M&oacute;dulo n&atilde;o est&aacute; instalado. Contate o administrador do sistema.");
INSERT INTO languages VALUES ("pt_BR", "Module", "M&oacute;dulo");
INSERT INTO languages VALUES ("pt_BR", "Monday", "Segunda-feira");
INSERT INTO languages VALUES ("pt_BR", "Monitor selected", "Monitorar selecionados");
INSERT INTO languages VALUES ("pt_BR", "Monitored with new services", "Monitorado com novos servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR", "Monitored", "Monitorado");
INSERT INTO languages VALUES ("pt_BR", "Monitoring problems", "Configura&ccedil;&atilde;o da monitora&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Monitoring state", "Estado de monitora&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Monitoring without a model", "Monitorar sem modelo");
INSERT INTO languages VALUES ("pt_BR", "Monitoring without model", "Monitorar sem modelo");
INSERT INTO languages VALUES ("pt_BR", "Monitoring", "Monitora&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Month day", "Dia do m&ecircs");
INSERT INTO languages VALUES ("pt_BR", "Month", "M&ecirc;s");
INSERT INTO languages VALUES ("pt_BR", "Monthly", "Mensal");
INSERT INTO languages VALUES ("pt_BR", "Months", "Meses");
INSERT INTO languages VALUES ("pt_BR", "Move down", "Move para baixo");
INSERT INTO languages VALUES ("pt_BR", "Move up", "Move para cima");
INSERT INTO languages VALUES ("pt_BR", "MsgNoUserDefined", "(Nenhum usu&aacute;rio definido)");
INSERT INTO languages VALUES ("pt_BR", "My Dashboards", "Meus Dashboards");
INSERT INTO languages VALUES ("pt_BR", "N/D", "N/A");
INSERT INTO languages VALUES ("pt_BR", "NTP server", "Servidor NTP");
INSERT INTO languages VALUES ("pt_BR", "NTP server", "Servidor de NTP");
INSERT INTO languages VALUES ("pt_BR", "Name", "Nome");
INSERT INTO languages VALUES ("pt_BR", "Network Range", "Range de Rede");
INSERT INTO languages VALUES ("pt_BR", "Network Utilization", "Utiliza&ccedil;&atilde;o&nbsp;de&nbsp;rede");
INSERT INTO languages VALUES ("pt_BR", "Network configuration", "Configura&ccedil;&otilde;es de rede");
INSERT INTO languages VALUES ("pt_BR", "Network mask", "M&aacute;scara de Rede");
INSERT INTO languages VALUES ("pt_BR", "Network settings", "Configura&ccedil;&otilde;es de Rede");
INSERT INTO languages VALUES ("pt_BR", "Network", "Rede");
INSERT INTO languages VALUES ("pt_BR", "New IP / Range not added", "Novo IP/Range n&atilde;o adicionado");
INSERT INTO languages VALUES ("pt_BR", "New IP or Range", "Novo IP ou Range");
INSERT INTO languages VALUES ("pt_BR", "New IP or added range", "Novo IP ou range adicionado");
INSERT INTO languages VALUES ("pt_BR", "New Password", "Senha Nova");
INSERT INTO languages VALUES ("pt_BR", "New baseline", "Nova baseline");
INSERT INTO languages VALUES ("pt_BR", "New entries", "Cadastros");
INSERT INTO languages VALUES ("pt_BR", "New entry", "Cadastrar");
INSERT INTO languages VALUES ("pt_BR", "New host group", "Novo grupo de host");
INSERT INTO languages VALUES ("pt_BR", "New host", "Novo host");
INSERT INTO languages VALUES ("pt_BR", "New host(s) created", "Novo(s) host(s) criado(s)");
INSERT INTO languages VALUES ("pt_BR", "New package", "Pacote novo");
INSERT INTO languages VALUES ("pt_BR", "New passowrd doesn't match", "Nova senha n&atilde confere!");
INSERT INTO languages VALUES ("pt_BR", "New report", "Novo relat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR", "New service group", "Novo grupo de servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR", "New service(s) configured", "Novo(s) servi&ccedil;o(s) configurado(s)");
INSERT INTO languages VALUES ("pt_BR", "New shortcut", "Novo atalho");
INSERT INTO languages VALUES ("pt_BR", "New team", "Novo grupo de contato");
INSERT INTO languages VALUES ("pt_BR", "New user", "Novo contato");
INSERT INTO languages VALUES ("pt_BR", "New version available", "Nova vers&atilde;o dispon&iacute;vel");
INSERT INTO languages VALUES ("pt_BR", "New", "Novo");
INSERT INTO languages VALUES ("pt_BR", "Next Page", "P&aacute;gina Seguinte");
INSERT INTO languages VALUES ("pt_BR", "Next check Header", "Pr&oacute;x. Chec.");
INSERT INTO languages VALUES ("pt_BR", "Next check", "Pr&oacute;xima Checagem");
INSERT INTO languages VALUES ("pt_BR", "Next page", "Pr&oacute;xima p&aacute;gina");
INSERT INTO languages VALUES ("pt_BR", "Next", "Avan&ccedil;ar");
INSERT INTO languages VALUES ("pt_BR", "No Data", "Sem Dados");
INSERT INTO languages VALUES ("pt_BR", "No IPs or ranges to be processed", "N&atilde;o h&aacute; IPs ou ranges a serem processados");
INSERT INTO languages VALUES ("pt_BR", "No SNMP community added", "N&atilde;o h&aacute; comunidade SNMP adicionada");
INSERT INTO languages VALUES ("pt_BR", "No bookmark found", "Nenhum favorito encontrado");
INSERT INTO languages VALUES ("pt_BR", "No data available", "Sem dados dispon&iacute;veis");
INSERT INTO languages VALUES ("pt_BR", "No data found, please, check SNMP authentications", "Dados n&atilde;o foram encontrados, por favor, verifique suas autentica&ccedil;&otilde;es SNMP.");
INSERT INTO languages VALUES ("pt_BR", "No data", "Sem dados");
INSERT INTO languages VALUES ("pt_BR", "No has any service", "N&atilde;o existe nenhum servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR", "No incidents at this moment", "Nenhum incidente neste momento");
INSERT INTO languages VALUES ("pt_BR", "No model found", "Nenhum modelo encontrado");
INSERT INTO languages VALUES ("pt_BR", "No notifications available", "Sem notifica&ccedil;&otilde;es dispon&iacute;veis");
INSERT INTO languages VALUES ("pt_BR", "No selected template", "Nenhum template selecionado");
INSERT INTO languages VALUES ("pt_BR", "No template template", "Nenhum template selecionado");
INSERT INTO languages VALUES ("pt_BR", "No window", "Sem janela definida");
INSERT INTO languages VALUES ("pt_BR", "No", "N&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "No. I want to continue the process", "N&atilde;o. Quero prosseguir com o processo");
INSERT INTO languages VALUES ("pt_BR", "No. metrics", "N&ordm; de m&eacute;tricas");
INSERT INTO languages VALUES ("pt_BR", "NoElementsSelectedMsg", "Voc&ecirc; deve selecionar pelo menos um objeto para executar esta a&ccedil;&atilde;o!");
INSERT INTO languages VALUES ("pt_BR", "Non work", "N&atilde;o &uacute;til");
INSERT INTO languages VALUES ("pt_BR", "Not defined", "N&atilde;o definido");
INSERT INTO languages VALUES ("pt_BR", "Not helpful", "N&atilde;o &uacute;til");
INSERT INTO languages VALUES ("pt_BR", "Not monitored", "N&atilde;o monitorado");
INSERT INTO languages VALUES ("pt_BR", "Not saved report", "Relat&oacute;rio n&atilde;o salvo");
INSERT INTO languages VALUES ("pt_BR", "Note URL", "URL de anota&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Nothing to do.", "Nada a ser feito.");
INSERT INTO languages VALUES ("pt_BR", "Notification enabled", "Notifica&ccedil;&atilde;o habilitada");
INSERT INTO languages VALUES ("pt_BR", "Notification interval", "Intervalo de notifica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Notification period", "Per&iacute;odo de notifica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Notification", "Notifica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Notifications Totals", "Totaliza&ccedil;&atilde;o das notifica&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR", "Notifications disabled", "Notifica&ccedil;&otilde;es desabilitadas");
INSERT INTO languages VALUES ("pt_BR", "Notifications enabled", "Notifica&ccedil;&otilde;es habilitadas");
INSERT INTO languages VALUES ("pt_BR", "Notifications", "Notifica&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR", "Nov", "Nov");
INSERT INTO languages VALUES ("pt_BR", "November", "Novembro");
INSERT INTO languages VALUES ("pt_BR", "Number of users", "N&uacute;mero de usu&aacute;rios");
INSERT INTO languages VALUES ("pt_BR", "OEM", "OEM");
INSERT INTO languages VALUES ("pt_BR", "OK", "OK");
INSERT INTO languages VALUES ("pt_BR", "OK, I got it", "Ok entendi");
INSERT INTO languages VALUES ("pt_BR", "OK, I understood.", "OK, entendi.");
INSERT INTO languages VALUES ("pt_BR", "OK, I'm ready.", "OK, estou pronto.");
INSERT INTO languages VALUES ("pt_BR", "ONC", "ONC");
INSERT INTO languages VALUES ("pt_BR", "OPCFG_Advanced", "Advanced");
INSERT INTO languages VALUES ("pt_BR", "OPCFG_Alerting", "Alerting");
INSERT INTO languages VALUES ("pt_BR", "OPCFG_CGIConfig", "CGI Config");
INSERT INTO languages VALUES ("pt_BR", "OPCFG_Commands", "Commands");
INSERT INTO languages VALUES ("pt_BR", "OPCFG_ContactGroups", "Contact Groups");
INSERT INTO languages VALUES ("pt_BR", "OPCFG_Contacts", "Contacts");
INSERT INTO languages VALUES ("pt_BR", "OPCFG_Discovery", "Discovery");
INSERT INTO languages VALUES ("pt_BR", "OPCFG_DiscoveryCommunities", "SNMP Communities");
INSERT INTO languages VALUES ("pt_BR", "OPCFG_DiscoveryImport", "Import Objects");
INSERT INTO languages VALUES ("pt_BR", "OPCFG_DiscoveryImportedElements", "Imported objects");
INSERT INTO languages VALUES ("pt_BR", "OPCFG_Export", "Export");
INSERT INTO languages VALUES ("pt_BR", "OPCFG_Extras", "Extras");
INSERT INTO languages VALUES ("pt_BR", "OPCFG_HostGroups", "Host Groups");
INSERT INTO languages VALUES ("pt_BR", "OPCFG_Hosts", "Hosts");
INSERT INTO languages VALUES ("pt_BR", "OPCFG_MainConfig", "Main Config");
INSERT INTO languages VALUES ("pt_BR", "OPCFG_Monitoring", "Monitoring");
INSERT INTO languages VALUES ("pt_BR", "OPCFG_PortScan", "Object Import");
INSERT INTO languages VALUES ("pt_BR", "OPCFG_Resources", "Resources");
INSERT INTO languages VALUES ("pt_BR", "OPCFG_SNMPDiscovery", "SNMP Discovery");
INSERT INTO languages VALUES ("pt_BR", "OPCFG_ServiceGroups", "Service Groups");
INSERT INTO languages VALUES ("pt_BR", "OPCFG_TITLE", "Configuration Utility");
INSERT INTO languages VALUES ("pt_BR", "OPCFG_Templates", "Templates");
INSERT INTO languages VALUES ("pt_BR", "OPCFG_TimePeriods", "Time Periods");
INSERT INTO languages VALUES ("pt_BR", "OPCFG_Tools", "Tools");
INSERT INTO languages VALUES ("pt_BR", "OPCFG_Topology", "Topologia");
INSERT INTO languages VALUES ("pt_BR", "OPDOCS", "Documenta&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "OPTRAFFIC", "Traffic Analyzer");
INSERT INTO languages VALUES ("pt_BR", "OPVIEW", "Dashboards");
INSERT INTO languages VALUES ("pt_BR", "OPVIEWREMOTE", "Acesso Webservices do Dashboard");
INSERT INTO languages VALUES ("pt_BR", "OS", "SO");
INSERT INTO languages VALUES ("pt_BR", "OTRS", "Integra&ccedil;&atilde;o com OTRS");
INSERT INTO languages VALUES ("pt_BR", "Object not found", "Objeto n&atilde;o encontrado");
INSERT INTO languages VALUES ("pt_BR", "Object", "Objeto");
INSERT INTO languages VALUES ("pt_BR", "Objects Available", "Objetos dispon&iacute;veis");
INSERT INTO languages VALUES ("pt_BR", "Objects Selected", "Objetos selecionados");
INSERT INTO languages VALUES ("pt_BR", "Objects Spreadsheet", "Planilha de Objetos");
INSERT INTO languages VALUES ("pt_BR", "ObjectsLoadingMsg", "Carregando objetos. Por favor, aguarde...");
INSERT INTO languages VALUES ("pt_BR", "Obsess check", "Checagem obsessiva");
INSERT INTO languages VALUES ("pt_BR", "Obsess checks disabled", "Checagens obsessivas desabilitadas");
INSERT INTO languages VALUES ("pt_BR", "Obsess checks enabled", "Checagens obsessivas habilitadas");
INSERT INTO languages VALUES ("pt_BR", "Oct", "Out");
INSERT INTO languages VALUES ("pt_BR", "October", "Outubro");
INSERT INTO languages VALUES ("pt_BR", "Offset", "Desvio");
INSERT INTO languages VALUES ("pt_BR", "Old Password", "Senha Antiga");
INSERT INTO languages VALUES ("pt_BR", "Once", "Apenas uma vez");
INSERT INTO languages VALUES ("pt_BR", "Only Lines", "Somente Linhas");
INSERT INTO languages VALUES ("pt_BR", "Only acks", "Somente reconhecidos");
INSERT INTO languages VALUES ("pt_BR", "Only disabled", "Somente desabilitada");
INSERT INTO languages VALUES ("pt_BR", "Only downtimes", "Somenete manuten&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR", "Only enabled", "Somente habilitada");
INSERT INTO languages VALUES ("pt_BR", "Only hard state", "Somente hard state");
INSERT INTO languages VALUES ("pt_BR", "Only hosts", "Somente Hosts");
INSERT INTO languages VALUES ("pt_BR", "Only one time", "Apenas esta vez");
INSERT INTO languages VALUES ("pt_BR", "Only services", "Somente Servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR", "Only soft state", "Somente soft state");
INSERT INTO languages VALUES ("pt_BR", "Only unmonitored hosts discovered by OpMon are listed", "Est&atilde;o listados apenas os hosts n&atilde;o monitorados descobertos pelo OpMon");
INSERT INTO languages VALUES ("pt_BR", "Only view report", "Somente ver relat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR", "Only with", "Somente com");
INSERT INTO languages VALUES ("pt_BR", "Only without", "Somente sem");
INSERT INTO languages VALUES ("pt_BR", "OpDiscovery", "OpDiscovery");
INSERT INTO languages VALUES ("pt_BR", "OpLogs", "OpLogs");
INSERT INTO languages VALUES ("pt_BR", "OpMon Deamon is stopped", "Processo OpMon parado!");
INSERT INTO languages VALUES ("pt_BR", "OpMon Traffic Analizer can be configured later", "O OpMon Traffic Analyzer poder&aacute; ser configurado depois");
INSERT INTO languages VALUES ("pt_BR", "OpMon Traffic Analyzer Light", "OpMon Traffic Analyzer Light");
INSERT INTO languages VALUES ("pt_BR", "OpMon can be configured later", "O OpMon poder&aacute; ser configurado depois");
INSERT INTO languages VALUES ("pt_BR", "OpMon in maintenance", "OpMon em manuten&ccedil;&atilde;o!");
INSERT INTO languages VALUES ("pt_BR", "OpMon initial setup", "Configura&ccedil;&atilde;o inicial do OpMon");
INSERT INTO languages VALUES ("pt_BR", "OpMon", "OpMon");
INSERT INTO languages VALUES ("pt_BR", "OpMonExceededMsg", "OpMon com atraso no monitoramento.");
INSERT INTO languages VALUES ("pt_BR", "OpServices License and Services Agreement", "OpServices License and Services Agreement");
INSERT INTO languages VALUES ("pt_BR", "OpTraps", "OpTraps");
INSERT INTO languages VALUES ("pt_BR", "Open a saved baseline ...", "Open a saved baseline...");
INSERT INTO languages VALUES ("pt_BR", "Open a saved report", "Abrir um relat&oacute;rio salvo");
INSERT INTO languages VALUES ("pt_BR", "Operation succeeded", "Opera&ccedil;&atilde;o realizada com sucesso");
INSERT INTO languages VALUES ("pt_BR", "Operational commands", "Comandos operacionais");
INSERT INTO languages VALUES ("pt_BR", "Operational system", "Sistema operacional");
INSERT INTO languages VALUES ("pt_BR", "Operator", "Operador");
INSERT INTO languages VALUES ("pt_BR", "Opmonadmin", "Opmonadmin");
INSERT INTO languages VALUES ("pt_BR", "Origin of metrics", "Origem das m&eacute;tricas");
INSERT INTO languages VALUES ("pt_BR", "Other", "Outros");
INSERT INTO languages VALUES ("pt_BR", "Others", "Outros");
INSERT INTO languages VALUES ("pt_BR", "Output", "Sa&iacute;da");
INSERT INTO languages VALUES ("pt_BR", "Overview", "Resumo");
INSERT INTO languages VALUES ("pt_BR", "Overwrite all", "Sobrescrever todos");
INSERT INTO languages VALUES ("pt_BR", "Overwrite current hosts settings", "Sobrescrever configura&ccedil;&otilde;es atuais de hosts");
INSERT INTO languages VALUES ("pt_BR", "Overwrite default", "Sobrescrever padr&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Package manager", "Gerenciador de pacotes");
INSERT INTO languages VALUES ("pt_BR", "Package uninstalled successfuly", "Pacote deinstalado com sucesso");
INSERT INTO languages VALUES ("pt_BR", "Package uploaded successfuly", "Pacote enviado com sucesso");
INSERT INTO languages VALUES ("pt_BR", "Packages installed successfuly", "Pacotes instalados com sucesso");
INSERT INTO languages VALUES ("pt_BR", "Packet", "Pacote");
INSERT INTO languages VALUES ("pt_BR", "Page", "P&aacute;gina");
INSERT INTO languages VALUES ("pt_BR", "Parameters", "Par&acirc;metros");
INSERT INTO languages VALUES ("pt_BR", "Passive check", "Checagem passiva");
INSERT INTO languages VALUES ("pt_BR", "Passive checks disabled", "Checagens passivas desabilitadas");
INSERT INTO languages VALUES ("pt_BR", "Passive checks enabled", "Checagens passivas habilitadas");
INSERT INTO languages VALUES ("pt_BR", "Passive", "Passiva");
INSERT INTO languages VALUES ("pt_BR", "Password change", "Troca de senha");
INSERT INTO languages VALUES ("pt_BR", "Password updated successfully", "Senha atualizada com sucesso!");
INSERT INTO languages VALUES ("pt_BR", "Password", "Senha");
INSERT INTO languages VALUES ("pt_BR", "Passwords does not match", "Senhas diferentes");
INSERT INTO languages VALUES ("pt_BR", "Pendings", "Pendentes");
INSERT INTO languages VALUES ("pt_BR", "Perc95", "Perc95");
INSERT INTO languages VALUES ("pt_BR", "Percent change", "Percentual de mudan&ccedil;a");
INSERT INTO languages VALUES ("pt_BR", "Performance data", "Dados de performance");
INSERT INTO languages VALUES ("pt_BR", "Performance", "Performance");
INSERT INTO languages VALUES ("pt_BR", "Period check invalid", "Per&iacute;odo de checagem inv&aacute;lido");
INSERT INTO languages VALUES ("pt_BR", "Period check", "Per&iacute;odo de checagem");
INSERT INTO languages VALUES ("pt_BR", "Period variation", "Varia&ccedil;&atilde;o per&iacute;odo");
INSERT INTO languages VALUES ("pt_BR", "Period", "Per&iacute;odo");
INSERT INTO languages VALUES ("pt_BR", "Periodicity", "Periodicidade");
INSERT INTO languages VALUES ("pt_BR", "Permission Denied Description", "Voc&ecirc; <strong>n&atilde;o</strong> possui permiss&atilde;o para acessar esta p&aacute;gina.");
INSERT INTO languages VALUES ("pt_BR", "Permission Denied", "Acesso Restrito");
INSERT INTO languages VALUES ("pt_BR", "Permission denied", "Permiss&atilde;o negada");
INSERT INTO languages VALUES ("pt_BR", "Persistent comment", "Coment&aacute;rio persistente");
INSERT INTO languages VALUES ("pt_BR", "Persistent", "Persistente");
INSERT INTO languages VALUES ("pt_BR", "Ping", "Ping");
INSERT INTO languages VALUES ("pt_BR", "Planned Downtimes", "Manuten&ccedil;&otilde;es planejadas");
INSERT INTO languages VALUES ("pt_BR", "Planned", "Planejada");
INSERT INTO languages VALUES ("pt_BR", "Please contact your administrator", "<strong>Contate seu administrador</strong>");
INSERT INTO languages VALUES ("pt_BR", "Please enter a new report name", "Por favor, indique um novo nome de relat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR", "Please select a command", "Por favor, selecione um comando");
INSERT INTO languages VALUES ("pt_BR", "Please select a host already discovered", "Por favor, selecione um host j&aacute; descoberto");
INSERT INTO languages VALUES ("pt_BR", "Please select a host to be tested", "Por favor, selecione um host para usar no teste");
INSERT INTO languages VALUES ("pt_BR", "Please wait", "Por favor, aguarde.");
INSERT INTO languages VALUES ("pt_BR", "Please wait. Uploading your file...", "Aguarde. Enviando seu arquivo...");
INSERT INTO languages VALUES ("pt_BR", "Port", "Porta");
INSERT INTO languages VALUES ("pt_BR", "Ports", "Portas");
INSERT INTO languages VALUES ("pt_BR", "Portscan", "Portscan");
INSERT INTO languages VALUES ("pt_BR", "Previous Page", "P&aacute;gina Anterior");
INSERT INTO languages VALUES ("pt_BR", "Previous page", "P&aacute;gina anterior");
INSERT INTO languages VALUES ("pt_BR", "Primary DNS", "DNS Prim&aacute;rio");
INSERT INTO languages VALUES ("pt_BR", "Privacy", "Privacidade");
INSERT INTO languages VALUES ("pt_BR", "Problem uploading your report", "Problema ao enviar seu relat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR", "Problems", "Problemas");
INSERT INTO languages VALUES ("pt_BR", "Proceed with this element removal?", "Confirmar remo&ccedil;&atilde;o deste elemento?");
INSERT INTO languages VALUES ("pt_BR", "Process canceled successfully", "Processo cancelado com sucesso");
INSERT INTO languages VALUES ("pt_BR", "Process", "Processo");
INSERT INTO languages VALUES ("pt_BR", "Processes", "Processos");
INSERT INTO languages VALUES ("pt_BR", "Product", "Produto");
INSERT INTO languages VALUES ("pt_BR", "Property", "Propriedade");
INSERT INTO languages VALUES ("pt_BR", "Protocol", "Protocolo");
INSERT INTO languages VALUES ("pt_BR", "Put the license below", "Insira a licen&ccedil;a abaixo");
INSERT INTO languages VALUES ("pt_BR", "QUALITOR", "Integra&ccedil;&atilde;o com Qualitor");
INSERT INTO languages VALUES ("pt_BR", "RSCHED", "Agendador de Relat&oacute;rios");
INSERT INTO languages VALUES ("pt_BR", "Range check", "Intervalo de checagem");
INSERT INTO languages VALUES ("pt_BR", "Reached", "Atingido");
INSERT INTO languages VALUES ("pt_BR", "Realtime graph", "Gr&aacute;fico em tempo real");
INSERT INTO languages VALUES ("pt_BR", "Receive host's notification?", "Recebe notifica&ccedil;&otilde;es de hosts?");
INSERT INTO languages VALUES ("pt_BR", "Receive service's notification?", "Recebe notifica&ccedil;&otilde;es de servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR", "Received bytes", "Bytes recebidos");
INSERT INTO languages VALUES ("pt_BR", "Received kbps", "Recebido(kbps)");
INSERT INTO languages VALUES ("pt_BR", "Receiving network traffic on ports", "Recebendo tr&aacute;fego de rede nas portas");
INSERT INTO languages VALUES ("pt_BR", "Recheck", "Verificar novamente");
INSERT INTO languages VALUES ("pt_BR", "Recommended hosts for the model", "Hosts recomendados para o modelo");
INSERT INTO languages VALUES ("pt_BR", "Recovery", "Recuperado");
INSERT INTO languages VALUES ("pt_BR", "Redirecting to discovery", "Redirecionando para a descoberta");
INSERT INTO languages VALUES ("pt_BR", "Refresh list", "Atualizar listagem");
INSERT INTO languages VALUES ("pt_BR", "Refresh", "Atualizar");
INSERT INTO languages VALUES ("pt_BR", "Register a new authentication", "Cadastrar uma nova autentica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Register and associate ports, applications and protocols", "Registre e associe as portas, aplica&ccedil;&otilde;es e protocolos");
INSERT INTO languages VALUES ("pt_BR", "Register new authentication", "Cadastrar nova autentica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Registered Authentications", "Autentica&ccedil;&otilde;es Cadastradas");
INSERT INTO languages VALUES ("pt_BR", "Registering changes", "Registrando altera&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR", "Relay server email", "Servidor de relay de e-mail");
INSERT INTO languages VALUES ("pt_BR", "Remember me", "Lembrar dados");
INSERT INTO languages VALUES ("pt_BR", "Remove Host (s) ?", "Remover o(s) host(s)?");
INSERT INTO languages VALUES ("pt_BR", "Remove Item", "Remover Item");
INSERT INTO languages VALUES ("pt_BR", "Remove Timecut", "Excluir Corte de tempo");
INSERT INTO languages VALUES ("pt_BR", "Remove a downtime", "Remover manuten&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Remove acknowledgement for this incident", "Remover reconhecimento para este incidente");
INSERT INTO languages VALUES ("pt_BR", "Remove acknowledgement", "Remover reconhecimento de incidente");
INSERT INTO languages VALUES ("pt_BR", "Remove all actions of Hosts", "Remover todas a&ccedil;&otilde;es dos Hosts");
INSERT INTO languages VALUES ("pt_BR", "Remove all actions of Services", "Remover todas a&ccedil;&otilde;es dos Servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR", "Remove all comments", "Remover todos os coment&aacute;rios");
INSERT INTO languages VALUES ("pt_BR", "Remove all host comments", "Remover todos os coment&aacute;rios deste Host");
INSERT INTO languages VALUES ("pt_BR", "Remove all scheduled downtimes of the Hosts", "Remover todas as manuten&ccedil;&otilde;es agendadas dos Hosts");
INSERT INTO languages VALUES ("pt_BR", "Remove all scheduled downtimes of the Services", "Remover todas as manuten&ccedil;&otilde;es agendadas dos Servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR", "Remove bookmark", "Remove favorito");
INSERT INTO languages VALUES ("pt_BR", "Remove current report", "Remover relat&oacute;rio atual");
INSERT INTO languages VALUES ("pt_BR", "Remove host", "Remover host");
INSERT INTO languages VALUES ("pt_BR", "Remove report", "Remover relat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR", "Remove selected elements", "Remover elementos selecionados");
INSERT INTO languages VALUES ("pt_BR", "Remove service (s) ?", "Remover o(s) servi&ccedil;o(s)?");
INSERT INTO languages VALUES ("pt_BR", "Remove service", "Remover servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR", "Remove this comment", "Remover este coment&aacute;rio");
INSERT INTO languages VALUES ("pt_BR", "Remove this scheduled downtime", "Remover/cancelar esta manuten&ccedil;&atilde;o agendada");
INSERT INTO languages VALUES ("pt_BR", "Remove", "Remover");
INSERT INTO languages VALUES ("pt_BR", "Removed successfully", "Removido com sucesso");
INSERT INTO languages VALUES ("pt_BR", "Rename service", "Renomear servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR", "Rename", "Renomear");
INSERT INTO languages VALUES ("pt_BR", "Repeat New Password", "Repetir Senha Nova");
INSERT INTO languages VALUES ("pt_BR", "Repeat email", "Repita o e-mail");
INSERT INTO languages VALUES ("pt_BR", "Repeat selected hours", "Repetir hor&aacute;rios selecionados");
INSERT INTO languages VALUES ("pt_BR", "Repeat the e-mail", "Repita o e-mail");
INSERT INTO languages VALUES ("pt_BR", "Repeat the password", "Repita a senha");
INSERT INTO languages VALUES ("pt_BR", "Report Name", "Nome do relat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR", "Report Scheduler", "Agendador de relat&oacute;rios");
INSERT INTO languages VALUES ("pt_BR", "Report Type", "Tipo de relat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR", "Report by e-mail", "Relat&oacute;rio por e-mail");
INSERT INTO languages VALUES ("pt_BR", "Report configuration", "Configura&ccedil;&atilde;o do relat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR", "Report objects", "Objetos do relat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR", "Report removed successfully", "Relat&oacute;rio removido com sucesso");
INSERT INTO languages VALUES ("pt_BR", "Report scheduled", "Relat&oacute;rio agendado");
INSERT INTO languages VALUES ("pt_BR", "Reports", "Relat&oacute;rios");
INSERT INTO languages VALUES ("pt_BR", "Requeriments", "Requerimentos");
INSERT INTO languages VALUES ("pt_BR", "Request Error", "Erro na requisi&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Request Status", "Status da solicita&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "RequestErrorMsg", "Ocorreu um erro ao tentar processar esta requisi&ccedil;&atilde;o. Por favor, atualize a p&aacute;gina.<br>Se o problema persistir, entre em contato com o administrador do sistema.");
INSERT INTO languages VALUES ("pt_BR", "Requesting information for %COUNT%.", "Requisitando informa&ccedil;&otilde;es para %COUNT%.");
INSERT INTO languages VALUES ("pt_BR", "Reschedule next check", "Reagendar pr&oacute;xima checagem");
INSERT INTO languages VALUES ("pt_BR", "Reschedule next host check", "Reagendar pr&oacute;xima checagem do Host");
INSERT INTO languages VALUES ("pt_BR", "Reset Done", "Reset efetuado com sucesso");
INSERT INTO languages VALUES ("pt_BR", "Reset fields", "Limpar campos");
INSERT INTO languages VALUES ("pt_BR", "Resolve conflict", "Resolver conflito");
INSERT INTO languages VALUES ("pt_BR", "Resolve conflict", "Resolver conflitos");
INSERT INTO languages VALUES ("pt_BR", "Responsible users", "Usu&aacute;rios Respons&aacute;veis");
INSERT INTO languages VALUES ("pt_BR", "Responsible", "Respons&aacute;vel");
INSERT INTO languages VALUES ("pt_BR", "Restarting OpMon Traffic Analyzer process...", "Reiniciando o processo do OpMon Traffic Analyzer...");
INSERT INTO languages VALUES ("pt_BR", "Restore default OpMon logo", "Restaurar logo original");
INSERT INTO languages VALUES ("pt_BR", "Restore default", "Restaurar padr&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Restore values", "Restaurar valores");
INSERT INTO languages VALUES ("pt_BR", "Retrieving discovered objects", "Obtendo os dispositivos encontrados");
INSERT INTO languages VALUES ("pt_BR", "Retry Interval", "Intervalo de rechecagem");
INSERT INTO languages VALUES ("pt_BR", "Retry check interval", "Intervalo de rechecagem");
INSERT INTO languages VALUES ("pt_BR", "Retry interval", "Rechecagem");
INSERT INTO languages VALUES ("pt_BR", "Retry", "Repetir comando");
INSERT INTO languages VALUES ("pt_BR", "Return", "Voltar");
INSERT INTO languages VALUES ("pt_BR", "Review your configuration", "Revise sua configura&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Run Command?", "Executa Comando?");
INSERT INTO languages VALUES ("pt_BR", "SCAT Description", "Aqui voc&ecirc; pode montar a estrutura do servi&ccedil;o fornecido");
INSERT INTO languages VALUES ("pt_BR", "SCAT", "Cat&aacute;logos de Servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR", "SCM", "Backup de Switch");
INSERT INTO languages VALUES ("pt_BR", "SLA Breach Reason Start", "INÍCIO DE JUSTIFICATIVA");
INSERT INTO languages VALUES ("pt_BR", "SLA Breach Reason Stop", "FIM DE JUSTIFICATIVA");
INSERT INTO languages VALUES ("pt_BR", "SLA Breach Reason", "Justificativa de SLA");
INSERT INTO languages VALUES ("pt_BR", "SLA Breach Reasons as OK", "SLAs justificados como OK");
INSERT INTO languages VALUES ("pt_BR", "SLA Breach Reasons", "Justificativas de SLA");
INSERT INTO languages VALUES ("pt_BR", "SLA Breach", "Quebra de SLA");
INSERT INTO languages VALUES ("pt_BR", "SLA Description", "Contrato celebrado entre prestadores de servi&ccedil;o e cliente, definindo os n&iacute;veis aceit&aacute;veis ou n&atilde;o de servi&ccedil;o.");
INSERT INTO languages VALUES ("pt_BR", "SLA For Catalog", "SLA para servi&ccedil;o do Cat&aacute;logo de Servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR", "SLA", "SLA");
INSERT INTO languages VALUES ("pt_BR", "SLA(Service Level Agreement)", "SLA(Service Level Agreement)");
INSERT INTO languages VALUES ("pt_BR", "SLM", "SLM");
INSERT INTO languages VALUES ("pt_BR", "SLM_License", "Gerenciamento de Nivel de Servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR", "SNMP Communities", "Comunidades SNMP");
INSERT INTO languages VALUES ("pt_BR", "SNMP Version", "Vers&atilde;o SNMP");
INSERT INTO languages VALUES ("pt_BR", "SOAP", "Soap API");
INSERT INTO languages VALUES ("pt_BR", "SOFT", "SOFT");
INSERT INTO languages VALUES ("pt_BR", "SUMALERT", "Sum&aacute;rio de Alertas");
INSERT INTO languages VALUES ("pt_BR", "Sample collected", "Amostra coletada");
INSERT INTO languages VALUES ("pt_BR", "Saturday", "S&aacute;bado");
INSERT INTO languages VALUES ("pt_BR", "Savar baseline", "Savar baseline");
INSERT INTO languages VALUES ("pt_BR", "Save Changes", "Salvar altera&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR", "Save Settings", "Salvar defini&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR", "Save Timecut", "Salvar Corte de tempo");
INSERT INTO languages VALUES ("pt_BR", "Save as ...", "Save as...");
INSERT INTO languages VALUES ("pt_BR", "Save as", "Salvar como");
INSERT INTO languages VALUES ("pt_BR", "Save changes", "Salvar altera&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR", "Save created command", "Salvar comando criado");
INSERT INTO languages VALUES ("pt_BR", "Save report", "Salvar relat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR", "Save the Report", "Salvar o relat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR", "Save this report", "Salvar este relat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR", "Save", "Salvar");
INSERT INTO languages VALUES ("pt_BR", "Saving Changes", "Salvando altera&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR", "Scan finished!", "Escaneamento finalizado!");
INSERT INTO languages VALUES ("pt_BR", "Scanning network", "Escaneando rede");
INSERT INTO languages VALUES ("pt_BR", "Scanning", "Escaneando");
INSERT INTO languages VALUES ("pt_BR", "Sched. Downtime", "Manuten&ccedil;&atilde;o Ag.");
INSERT INTO languages VALUES ("pt_BR", "Schedule a downtime for all hosts", "Agendar manuten&ccedil;&atilde;o para todos Hosts");
INSERT INTO languages VALUES ("pt_BR", "Schedule a downtime for all services", "Agendar manuten&ccedil;&atilde;o para todos Servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR", "Schedule a downtime", "Agendar manuten&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Schedule a non programmed downtime", "Agendar manuten&ccedil;&atilde;o n&atilde;o-programada");
INSERT INTO languages VALUES ("pt_BR", "Schedule a programmed downtime", "Agendar manuten&ccedil;&atilde;o programada");
INSERT INTO languages VALUES ("pt_BR", "Schedule check for all services", "Agendar checagem para todos os Servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR", "Schedule report", "Agendar relat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR", "Scheduled Downtime Begin", "Inicio de Manuten&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Scheduled Downtime End", "Fim de Manuten&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Scheduled as OK", "Agendadas como OK");
INSERT INTO languages VALUES ("pt_BR", "Scheduled checks queue", "Fila de checagens agendadas");
INSERT INTO languages VALUES ("pt_BR", "Scheduled downtime", "Manuten&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Scheduled downtimes", "Manuten&ccedil;&otilde;es programadas");
INSERT INTO languages VALUES ("pt_BR", "Scheduled queue", "Fila de agendamentos");
INSERT INTO languages VALUES ("pt_BR", "Scheduled", "Agendados");
INSERT INTO languages VALUES ("pt_BR", "Scheduler", "Agendamento");
INSERT INTO languages VALUES ("pt_BR", "Search for specific elements", "Fa&ccedil;a buscas por elementos espec&iacute;ficos");
INSERT INTO languages VALUES ("pt_BR", "Search", "Busca");
INSERT INTO languages VALUES ("pt_BR", "Searching for sources of network traffic", "Buscando fontes de tr&aacute;fego na rede");
INSERT INTO languages VALUES ("pt_BR", "Secondary DNS", "DNS Secund&aacute;rio");
INSERT INTO languages VALUES ("pt_BR", "Secundary DNS", "DNS Secund&aacute;rio");
INSERT INTO languages VALUES ("pt_BR", "Security", "Seguran&ccedil;a");
INSERT INTO languages VALUES ("pt_BR", "See Ips and Ranges to be processed", "Ver IPs e Ranges a processar");
INSERT INTO languages VALUES ("pt_BR", "See metrics", "Ver m&eacute;tricas");
INSERT INTO languages VALUES ("pt_BR", "Select Template", "Selecionar template");
INSERT INTO languages VALUES ("pt_BR", "Select a CI", "Selecione um Host");
INSERT INTO languages VALUES ("pt_BR", "Select a command", "Selecione um comando");
INSERT INTO languages VALUES ("pt_BR", "Select a contactgroup", "Selecione grupo(s) de contatos");
INSERT INTO languages VALUES ("pt_BR", "Select a contacts", "Selecione contato(s)");
INSERT INTO languages VALUES ("pt_BR", "Select a custom report", "Selecione um relat&oacute;rio personalizado");
INSERT INTO languages VALUES ("pt_BR", "Select a host already discovered", "Selecionar um host j&aacute; descoberto");
INSERT INTO languages VALUES ("pt_BR", "Select a host", "Selecione um host");
INSERT INTO languages VALUES ("pt_BR", "Select a method for group by", "Selecione um m&eacute;todo de agrupamento");
INSERT INTO languages VALUES ("pt_BR", "Select a report first", "Selecione um relat&oacute;rio primeiramente");
INSERT INTO languages VALUES ("pt_BR", "Select a servicegroup", "Selecione grupo(s) de servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR", "Select a timecut", "Selecione um corte de tempo");
INSERT INTO languages VALUES ("pt_BR", "Select all elements", "Selecionar todos elementos");
INSERT INTO languages VALUES ("pt_BR", "Select an available command", "Selecione um comando dispon&iacute;vel");
INSERT INTO languages VALUES ("pt_BR", "Select an object type", "Selecione um tipo de objeto");
INSERT INTO languages VALUES ("pt_BR", "Select an output type", "Selecione um tipo de sa&iacute;da");
INSERT INTO languages VALUES ("pt_BR", "Select and configure the elements you want to monitor", "Selecione e configure os elementos que deseja monitorar");
INSERT INTO languages VALUES ("pt_BR", "Select column", "Selecionar coluna");
INSERT INTO languages VALUES ("pt_BR", "Select desired objects", "Selecione os objetos desejados");
INSERT INTO languages VALUES ("pt_BR", "Select models", "Criar servi&ccedil;o atrav&eacute;s de um modelo");
INSERT INTO languages VALUES ("pt_BR", "Select objects", "Selecionar objetos");
INSERT INTO languages VALUES ("pt_BR", "Select one or more exist metrics on your system to apply the baseline.", "Selecione uma ou mais m&eacute;tricas existentes em seu sistema para aplicar a baseline.");
INSERT INTO languages VALUES ("pt_BR", "Select one or more hosts to apply the model", "Selecione um ou mais hosts para aplicar o modelo");
INSERT INTO languages VALUES ("pt_BR", "Select or search an external command", "Selecione ou busque um comando externo");
INSERT INTO languages VALUES ("pt_BR", "Select package for upload", "Selecione um pacote para upload");
INSERT INTO languages VALUES ("pt_BR", "Select packages for installation", "Selecione pacotes para a instala&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Select period", "Escolha um per&iacute;odo");
INSERT INTO languages VALUES ("pt_BR", "Select saved report", "Selecione relat&oacute;rio salvo");
INSERT INTO languages VALUES ("pt_BR", "Select service", "Selecionar servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR", "Select services", "Selecione os servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR", "Select the Report Objects", "Selecione os objetos do relat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR", "Select the contact", "Selecione o contato");
INSERT INTO languages VALUES ("pt_BR", "Select the element", "Selecione o elemento");
INSERT INTO languages VALUES ("pt_BR", "Select the group", "Selecione o grupo");
INSERT INTO languages VALUES ("pt_BR", "Select the host", "Selecione o host");
INSERT INTO languages VALUES ("pt_BR", "Select the hosts that receive the service", "Selecione os hosts que receber&atilde;o o servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR", "Select the hosts", "Selecione os hosts");
INSERT INTO languages VALUES ("pt_BR", "Select the probes you want to monitor", "Selecione as probes que voc&ecirc; deseja monitorar");
INSERT INTO languages VALUES ("pt_BR", "Select the service and its parameters", "Selecione os servi&ccedil;os e seus par&acirc;metros");
INSERT INTO languages VALUES ("pt_BR", "Select the services to monitor and set its parameters", "Selecione os servi&ccedil;os e defina os par&acirc;metros");
INSERT INTO languages VALUES ("pt_BR", "Select the source host", "Selecione o host de origem");
INSERT INTO languages VALUES ("pt_BR", "Select the templates you want to apply to hosts in the editing", "Selecione os templates que deseja aplicar aos hosts em edi&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Select the type of the element", "Selecione o tipo do elemento");
INSERT INTO languages VALUES ("pt_BR", "Select timecut", "Selecione corte de tempo");
INSERT INTO languages VALUES ("pt_BR", "Selected objects", "Objetos selecionados");
INSERT INTO languages VALUES ("pt_BR", "Selected", "Selecionado");
INSERT INTO languages VALUES ("pt_BR", "Send Test", "Enviar teste");
INSERT INTO languages VALUES ("pt_BR", "Send by e-mail for {0} contact(s)", "Enviar por e-mail para {0} contato(s)");
INSERT INTO languages VALUES ("pt_BR", "Send by e-mail for", "Enviar por e-mail para");
INSERT INTO languages VALUES ("pt_BR", "Send custom notification", "Enviar notifica&ccedil;&atilde;o customizada");
INSERT INTO languages VALUES ("pt_BR", "Send notification", "Enviar notifica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Send passive check result", "Enviar resultado de checagem passiva");
INSERT INTO languages VALUES ("pt_BR", "Send report by e-mail", "Enviar relat&oacute;rio por e-mail");
INSERT INTO languages VALUES ("pt_BR", "Send result", "Enviar resultado");
INSERT INTO languages VALUES ("pt_BR", "Send", "Enviar");
INSERT INTO languages VALUES ("pt_BR", "Sent bytes", "Bytes enviados");
INSERT INTO languages VALUES ("pt_BR", "Sent kbps", "Enviado(kbps)");
INSERT INTO languages VALUES ("pt_BR", "Sep", "Set");
INSERT INTO languages VALUES ("pt_BR", "September", "Setembro");
INSERT INTO languages VALUES ("pt_BR", "Service Grid", "Listagem de Servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR", "Service Group", "Grupo de Servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR", "Service Groups", "Grupos de Servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR", "Service Groups", "Grupos de Servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR", "Service Name", "Nome do Servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR", "Service Name", "Nome do servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR", "Service Structure", "Estrutura do Servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR", "Service description invalid", "Descri&ccedil;&atilde;o de servi&ccedil;o inv&aacute;lida");
INSERT INTO languages VALUES ("pt_BR", "Service description", "Descri&ccedil;&atilde;o do servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR", "Service groups", "Grupos de servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR", "Service is not selected", "Servi&ccedil;o n&atilde;o selecionado");
INSERT INTO languages VALUES ("pt_BR", "Service origin of new metrics", "Servi&ccedil;o origem das novas m&eacute;tricas");
INSERT INTO languages VALUES ("pt_BR", "Service status", "Status dos Servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR", "Service successfully updated", "Servi&ccedil;o atualizado com sucesso");
INSERT INTO languages VALUES ("pt_BR", "Service", "Servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR", "Service(s) with conflict", "Servi&ccedil;o(s) com conflito");
INSERT INTO languages VALUES ("pt_BR", "Servicegroup Grid", "Listagem de Grupo de Servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR", "Servicegroup origin of new metrics", "Servicegroup origem das novas m&eacute;tricas");
INSERT INTO languages VALUES ("pt_BR", "Servicegroup", "Grupo de Servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR", "Services Catalog", "Cat&aacute;logos");
INSERT INTO languages VALUES ("pt_BR", "Services and Contacts", "Servi&ccedil;os e Contatos");
INSERT INTO languages VALUES ("pt_BR", "Services of ", "Servi&ccedil;os do modelo ");
INSERT INTO languages VALUES ("pt_BR", "Services template", "Servi&ccedil;os do template");
INSERT INTO languages VALUES ("pt_BR", "Services with ack", "Servi&ccedil;os com a&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Services", "Servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR", "Set Date and Time", "Configurar Data e Hora");
INSERT INTO languages VALUES ("pt_BR", "Set Teams and Responsibles for hosts", "Defina contatos e grupos de contato para os hosts");
INSERT INTO languages VALUES ("pt_BR", "Set Up Backup", "Configurar Backup");
INSERT INTO languages VALUES ("pt_BR", "Set contacts and contactgroups for services", "Defina contatos e grupos de contato para os servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR", "Set email and password to start or %link%click here%endlink% for help", "Definir e-mail e senha para iniciar ou %link%clique aqui%endlink% para obter ajuda");
INSERT INTO languages VALUES ("pt_BR", "Set password and email", "Defina a senha e o e-mail");
INSERT INTO languages VALUES ("pt_BR", "Set the Community parameters", "Definir os par&acirc;metros da Comunidade");
INSERT INTO languages VALUES ("pt_BR", "Set the administrator password", "Definir senha do administrador");
INSERT INTO languages VALUES ("pt_BR", "Set the arguments of the selected command", "Defina os argumentos do comando selecionado");
INSERT INTO languages VALUES ("pt_BR", "Set the data of the system administrator user.", "Defina os dados do usu&aacute;rio administrador do sistema.");
INSERT INTO languages VALUES ("pt_BR", "Set the description", "Defina a descri&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Set the e-mail", "Defina o e-mail");
INSERT INTO languages VALUES ("pt_BR", "Set the group parameters", "Defina os par&acirc;metros do grupo");
INSERT INTO languages VALUES ("pt_BR", "Set the host IP", "Defina o IP do host");
INSERT INTO languages VALUES ("pt_BR", "Set the hostname", "Defina o nome do host");
INSERT INTO languages VALUES ("pt_BR", "Set the parameters of group", "Defina os par&acirc;metros do grupo");
INSERT INTO languages VALUES ("pt_BR", "Set the parameters of the command", "Defina os par&acirc;metros do comando");
INSERT INTO languages VALUES ("pt_BR", "Set the parameters of the host", "Definir os par&acirc;metros do host");
INSERT INTO languages VALUES ("pt_BR", "Set the parameters of the service", "Definir os par&acirc;metros do servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR", "Set the parameters of the team", "Defina os par&acirc;metros do grupo de contatos");
INSERT INTO languages VALUES ("pt_BR", "Set the password and the e-mail", "Defina a senha e o e-mail");
INSERT INTO languages VALUES ("pt_BR", "Set the password of the administrator user and email", "Defina a senha o e email do usu&aacute;rio administrador");
INSERT INTO languages VALUES ("pt_BR", "Set the password", "Defina a senha");
INSERT INTO languages VALUES ("pt_BR", "Set the services parameters", "Defina os par&acirc;metros dos servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR", "Set the source host to be added", "Defina a origem do host a ser adicionado");
INSERT INTO languages VALUES ("pt_BR", "Set up the environment for me <br> <span class=\'btn_subtext fa-green\'> Recommended </ span>", "Configure o ambiente para mim<br><span class=\'btn_subtext fa-green\'>Recomendado</span>");
INSERT INTO languages VALUES ("pt_BR", "Set via DHCP", "Definido via DHCP");
INSERT INTO languages VALUES ("pt_BR", "Setting behavior", "Configura&ccedil;&atilde;o do comportamento");
INSERT INTO languages VALUES ("pt_BR", "Settings saved successfully", "Configura&ccedil;&otilde;es salvas com sucesso");
INSERT INTO languages VALUES ("pt_BR", "Settings", "Configura&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR", "Setup finished!", "Configura&ccedil;&atilde;o conclu&iacute;da!");
INSERT INTO languages VALUES ("pt_BR", "Share", "Compartilhar");
INSERT INTO languages VALUES ("pt_BR", "Shortcuts", "Atalhos");
INSERT INTO languages VALUES ("pt_BR", "Show alarms", "Mostrar alarmes");
INSERT INTO languages VALUES ("pt_BR", "Show details", "Mostrar detalhes");
INSERT INTO languages VALUES ("pt_BR", "Show errors", "Mostrar erros");
INSERT INTO languages VALUES ("pt_BR", "Show only", "Mostrar somente");
INSERT INTO languages VALUES ("pt_BR", "Show thresholds", "Mostrar thresholds");
INSERT INTO languages VALUES ("pt_BR", "Simple Service Level Agreement Report", "An&aacute;lise de n&iacute;vel de servi&ccedil;o - Simples");
INSERT INTO languages VALUES ("pt_BR", "Simple", "Simplificado");
INSERT INTO languages VALUES ("pt_BR", "Size of the collected sample", "Tamanho da amostra coletada");
INSERT INTO languages VALUES ("pt_BR", "Skip", "Pular");
INSERT INTO languages VALUES ("pt_BR", "Soft State", "Soft State");
INSERT INTO languages VALUES ("pt_BR", "Some changes on OpMon configuration are being applied, this can time some time.", "Mudan&ccedil;as na configura&ccedil;&atilde;o do OpMon &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; est&atilde;o sendo aplicadas.");
INSERT INTO languages VALUES ("pt_BR", "Some network settings are invalid", "Algumas configura&ccedil;&otilde;es de rede s&atilde;o inv&aacute;lidas");
INSERT INTO languages VALUES ("pt_BR", "Some of your services belong to a template, unable to remove them", "Alguns servi&ccedil;os selecionados pertecem a um template e n&atilde;o podem ser removidos");
INSERT INTO languages VALUES ("pt_BR", "Special calendar", "Calend&aacute;rio");
INSERT INTO languages VALUES ("pt_BR", "SplashScreenMsg", "Obrigado por utilizar OpMon, uma plataforma completa para Governan&ccedil;a de TI, Monitora&ccedil;&atilde;o dos Processos de Neg&oacute;cio e Gerenciamento de Redes e Sistemas.");
INSERT INTO languages VALUES ("pt_BR", "Stage 1 of 4", "Etapa 1 de 4");
INSERT INTO languages VALUES ("pt_BR", "Stage 2 of 4", "Etapa 2 de 4");
INSERT INTO languages VALUES ("pt_BR", "Stage 3 of 4", "Etapa 3 de 4");
INSERT INTO languages VALUES ("pt_BR", "Stage 4 of 4", "Etapa 4 de 4");
INSERT INTO languages VALUES ("pt_BR", "Start Scan", "Iniciar Escaneamento");
INSERT INTO languages VALUES ("pt_BR", "Start date", "Data inicial");
INSERT INTO languages VALUES ("pt_BR", "Start discovery", "Iniciar descoberta");
INSERT INTO languages VALUES ("pt_BR", "Start new Discovery", "Iniciar nova Descoberta");
INSERT INTO languages VALUES ("pt_BR", "Start selection", "Iniciar sele&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Start setting your report here", "Comece definindo o seu relat&oacute;rio aqui");
INSERT INTO languages VALUES ("pt_BR", "Start setup", "Iniciar a configura&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Start the configuration!", "Iniciar a configura&ccedil;&atilde;o!");
INSERT INTO languages VALUES ("pt_BR", "Start time", "Hora inicial");
INSERT INTO languages VALUES ("pt_BR", "Start", "In&iacute;cio");
INSERT INTO languages VALUES ("pt_BR", "State Type", "Tipo de Estado");
INSERT INTO languages VALUES ("pt_BR", "State type", "Tipo de estado");
INSERT INTO languages VALUES ("pt_BR", "State", "Estado");
INSERT INTO languages VALUES ("pt_BR", "Status Overview", "Resumo dos Estados");
INSERT INTO languages VALUES ("pt_BR", "Status Totals", "Totaliza&ccedil;&atilde;o de status");
INSERT INTO languages VALUES ("pt_BR", "Status", "Estado");
INSERT INTO languages VALUES ("pt_BR", "Step 1 of 3", "Passo 1 de 3");
INSERT INTO languages VALUES ("pt_BR", "Step 1 of 4", "Passo 1 de 4");
INSERT INTO languages VALUES ("pt_BR", "Step 1", "Passo 1");
INSERT INTO languages VALUES ("pt_BR", "Step 1: Set the Administrator user", "Passo 1: Definir o usu&aacute;rio Administrador");
INSERT INTO languages VALUES ("pt_BR", "Step 2 of 3", "Passo 2 de 3");
INSERT INTO languages VALUES ("pt_BR", "Step 2 of 4", "Passo 2 de 4");
INSERT INTO languages VALUES ("pt_BR", "Step 2", "Passo 2");
INSERT INTO languages VALUES ("pt_BR", "Step 2: Set up the environment", "Passo 2: Configurar o ambiente");
INSERT INTO languages VALUES ("pt_BR", "Step 3 of 4", "Passo 3 de 4");
INSERT INTO languages VALUES ("pt_BR", "Step 3", "Passo 3");
INSERT INTO languages VALUES ("pt_BR", "Step 3: Configure the application", "Passo 3: Configurar a aplica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Step 4 of 4", "Passo 4 de 4");
INSERT INTO languages VALUES ("pt_BR", "Stop setting. I want to leave it for later.", "Pare a configura&ccedil;&atilde;o. Quero deixar para depois.");
INSERT INTO languages VALUES ("pt_BR", "Stop", "Parar");
INSERT INTO languages VALUES ("pt_BR", "Stopped since", "Daemon OpMon parado desde ");
INSERT INTO languages VALUES ("pt_BR", "Storage error", "Erro de armazenamento");
INSERT INTO languages VALUES ("pt_BR", "Storage path", "Caminho do armazenamento");
INSERT INTO languages VALUES ("pt_BR", "Submit", "Enviar");
INSERT INTO languages VALUES ("pt_BR", "Submiting command, please wait", "Submetendo comando, por favor aguarde");
INSERT INTO languages VALUES ("pt_BR", "Subscribe", "Cadastros");
INSERT INTO languages VALUES ("pt_BR", "Success log", "Log de Sucesso");
INSERT INTO languages VALUES ("pt_BR", "Success", "Sucesso");
INSERT INTO languages VALUES ("pt_BR", "Suggested categories", "Categorias sugeridas");
INSERT INTO languages VALUES ("pt_BR", "Suggested models", "Modelos sugeridos");
INSERT INTO languages VALUES ("pt_BR", "Sum", "Soma");
INSERT INTO languages VALUES ("pt_BR", "Summary view", "Vis&atilde;o de Resumo");
INSERT INTO languages VALUES ("pt_BR", "Sunday", "Domingo");
INSERT INTO languages VALUES ("pt_BR", "Support", "Suporte");
INSERT INTO languages VALUES ("pt_BR", "Syntax error on line:", "Erro de sintaxe na linha:");
INSERT INTO languages VALUES ("pt_BR", "System", "Sistema");
INSERT INTO languages VALUES ("pt_BR", "THEMES", "Temas");
INSERT INTO languages VALUES ("pt_BR", "TOPOLOGY", "Topologia da Monitora&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Tabular", "Tabular");
INSERT INTO languages VALUES ("pt_BR", "Tactical View", "Vis&atilde;o T&aacute;tica");
INSERT INTO languages VALUES ("pt_BR", "Tactical Overview", "Vis&atilde;o T&aacute;tica");
INSERT INTO languages VALUES ("pt_BR", "Target hosts", "Hosts alvo");
INSERT INTO languages VALUES ("pt_BR", "Team already contains this user", "Equipe j&aacute; contem este usu&aacute;rio");
INSERT INTO languages VALUES ("pt_BR", "Teams Responsible", "Equipes Respons&aacute;veis");
INSERT INTO languages VALUES ("pt_BR", "Teams", "Equipes");
INSERT INTO languages VALUES ("pt_BR", "Technical Accountable", "Respons&aacute;veis T&eacute;cnicos");
INSERT INTO languages VALUES ("pt_BR", "Template name", "Nome do template");
INSERT INTO languages VALUES ("pt_BR", "Test Command", "Teste de Comando");
INSERT INTO languages VALUES ("pt_BR", "Test command", "Testar comando");
INSERT INTO languages VALUES ("pt_BR", "Test command", "Teste o comando");
INSERT INTO languages VALUES ("pt_BR", "Test result", "Resultado do teste");
INSERT INTO languages VALUES ("pt_BR", "Test sending", "Testar o envio");
INSERT INTO languages VALUES ("pt_BR", "Test", "Testar");
INSERT INTO languages VALUES ("pt_BR", "Thank you for installing OpMon . Now you can anticipate problems and manage your IT environment and Telecom proactively , before it impact your organization . With only 3 steps you can set the administrator , perform the discovery operation , identify and monitor hosts and services automatically and generate the topology of your network .", "Obrigado por instalar o OpMon. Agora voc&ecirc; poder&aacute; antecipar-se aos problemas e gerenciar o seu ambiente de TI e Telecom de forma proativa, antes que gere impacto para a sua organiza&ccedil;&atilde;o. Com somente 3 passos voc&ecirc; poder&aacute; definir os dados do administrador, executar a opera&ccedil;&atilde;o de descoberta, para identificar e monitorar hosts e servi&ccedil;os automaticamente, e gerar a topologia de sua rede.");
INSERT INTO languages VALUES ("pt_BR", "The %COUNT% address does not respond...", "O endere&ccedil;o %COUNT% n&atilde;o responde...");
INSERT INTO languages VALUES ("pt_BR", "The %XYZ% module is available only from the PRO version", "O M&oacute;dulo %XYZ% est&aacute; somente dispon&iacute;vel a partir da vers&atilde;o PRO");
INSERT INTO languages VALUES ("pt_BR", "The OpMon Traffic Analyzer already has settings for ports, protocols and applications. Changes to these settings will impact the way data is stored and presented.", "O OpMon Traffic Analyzer j&aacute; possui defini&ccedil;&otilde;es para portas, aplica&ccedil;&otilde;es e protocolos. Altera&ccedil;&otilde;es nessas configura&ccedil;&otilde;es impactar&atilde;o no modo como os dados s&atilde;o armazenados e apresentados.");
INSERT INTO languages VALUES ("pt_BR", "The OpMon Traffic Analyzer found no source of traffic", "O OpMon Traffic Analyzer n&atilde;o encontrou nenhuma fonte de tr&aacute;fego");
INSERT INTO languages VALUES ("pt_BR", "The OpMon Traffic Analyzer is waiting while you set up your sources of network traffic.", "O OpMon Traffic Analyzer est&aacute; aguardando enquanto voc&ecirc; configura suas fontes de tr&aacute;fego de rede.");
INSERT INTO languages VALUES ("pt_BR", "The OpMon Traffic Analyzer is waiting", "O OpMon Traffic Analyzer est&aacute; aguardando");
INSERT INTO languages VALUES ("pt_BR", "The emails you entered do not match", "Os e-mails digitados n&atilde;o conferem");
INSERT INTO languages VALUES ("pt_BR", "The end date and end time must be less than now", "A data e o hor&aacute;rio final devem ser menores que agora");
INSERT INTO languages VALUES ("pt_BR", "The following services belong to a template and can't be edited", "Os servi&ccedil;os listados abaixo pertencem a templates e n&atilde;o poder&atilde;o ser editados");
INSERT INTO languages VALUES ("pt_BR", "The greatest number allowed for ports is", "O maior valor permitido para portas &eacute;");
INSERT INTO languages VALUES ("pt_BR", "The lowest number allowed for ports is", "O menor valor permitido para portas &eacute;");
INSERT INTO languages VALUES ("pt_BR", "The passwords entered do not match", "As senhas digitadas n&atilde;o conferem");
INSERT INTO languages VALUES ("pt_BR", "The ports must be different.", "As portas devem ser diferentes.");
INSERT INTO languages VALUES ("pt_BR", "The selected port is already in use by OpMon Traffic Analyzer.", "A porta selecionada est&aacute; em uso pelo OpMon Traffic Analyzer.");
INSERT INTO languages VALUES ("pt_BR", "The selected port is already in use.", "A porta selecionada est&aacute; em uso.");
INSERT INTO languages VALUES ("pt_BR", "The settings could not be applied, please try again later", "N&atilde;o foi poss&iacute;vel aplicar as defini&ccedil;&otilde;es. Tente novamente mais tarde");
INSERT INTO languages VALUES ("pt_BR", "The start date must be less than the end date.", "A data inicial deve ser menor que a data final.");
INSERT INTO languages VALUES ("pt_BR", "The traffic analysis environment is ready for you.", "O ambiente de an&aacute;lise de tr&aacute;fego est&aacute; pronto para voc&ecirc;.");
INSERT INTO languages VALUES ("pt_BR", "The version %s are available in our repositories. Click here to see more.", "A vers&atilde;o %s est&aacute; dispon&iacute;vel nos nossos reposit&oacute;rios. Clique aqui para saber mais.");
INSERT INTO languages VALUES ("pt_BR", "Theme Changed", "Tema alterado com sucesso");
INSERT INTO languages VALUES ("pt_BR", "Theme color", "Cor do tema");
INSERT INTO languages VALUES ("pt_BR", "Themes", "Temas");
INSERT INTO languages VALUES ("pt_BR", "There are any metrics on this service.", "N&atilde;o h&aacute; m&eacute;tricas associadas a este servi&ccedil;o.");
INSERT INTO languages VALUES ("pt_BR", "There are no metric available", "N&atilde;o h&aacute; m&eacute;tricas dispon&iacute;veis");
INSERT INTO languages VALUES ("pt_BR", "There are no metrics selected yet", "N&atilde;o existem m&eacute;tricas selecionadas ainda");
INSERT INTO languages VALUES ("pt_BR", "There has not been any elements discovered yet. %link% in order to start the discovery process.", "Ainda n&atilde;o h&aacute; elementos descobertos para serem adicionados na monitora&ccedil;&atilde;o. %link% para iniciar o processo de descoberta.");
INSERT INTO languages VALUES ("pt_BR", "There is no model related to hosts", "N&atilde;o h&aacute; modelos relacionado ao(s) host(s)");
INSERT INTO languages VALUES ("pt_BR", "There is no object available", "N&atilde;o h&aacute; nenhum objeto dispon&iacute;vel");
INSERT INTO languages VALUES ("pt_BR", "There is no object selected", "N&atilde;o h&aacute; nenhum objeto selecionado");
INSERT INTO languages VALUES ("pt_BR", "These are the chosen environment settings. Make sure they are correct.", "Estas s&atilde;o as defini&ccedil;&otilde;es de ambiente escolhidas. Verifique se est&atilde;o corretas.");
INSERT INTO languages VALUES ("pt_BR", "This authentication cannot be removed because is used by the following hosts", "Esta autentica&ccedil;&atilde;o n&atilde;o pode ser apagada pois est&aacute; em uso pelos seguintes hosts");
INSERT INTO languages VALUES ("pt_BR", "This baseline can not be deleted because it is associated with [number of metrics available] metrics.", "Esta baseline n&atilde;o pode ser apagada pois est&aacute; associada a [n&uacute;mero de m&eacute;tricas associadas] m&eacute;tricas.");
INSERT INTO languages VALUES ("pt_BR", "This baseline serves to test the interface", "Esta baseline serve para testar a interface");
INSERT INTO languages VALUES ("pt_BR", "This field is mandatory", "Este campo &eacute; de preenchimento obrigat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR", "This hour", "Esta hora");
INSERT INTO languages VALUES ("pt_BR", "This is a system element and can't be removed!", "Este &eacute; um elemento do sistema e n&atilde;o pode ser removido!");
INSERT INTO languages VALUES ("pt_BR", "This item dont have performance data", "Este item n&atilde;o possui dados de performance");
INSERT INTO languages VALUES ("pt_BR", "This month", "Este m&ecirc;s");
INSERT INTO languages VALUES ("pt_BR", "This port is already used by Netflow", "Esta porta j&aacute; est&aacute; em uso pelo Netflow");
INSERT INTO languages VALUES ("pt_BR", "This port is already used by SFlow", "Esta porta j&aacute; est&aacute; em uso pelo SFlow");
INSERT INTO languages VALUES ("pt_BR", "This service is not available for the selected host(s)", "Este servi&ccedil;o n&atilde;o est&aacute; dispon&iacute;vel para o host(s) selecionado(s)");
INSERT INTO languages VALUES ("pt_BR", "This week", "Esta semana");
INSERT INTO languages VALUES ("pt_BR", "This year", "Este ano");
INSERT INTO languages VALUES ("pt_BR", "Thresholds", "Limiares");
INSERT INTO languages VALUES ("pt_BR", "Thursday", "Quinta-feira");
INSERT INTO languages VALUES ("pt_BR", "Time", "Tempo");
INSERT INTO languages VALUES ("pt_BR", "Timecut Description", "Aqui voc&ecirc; pode definir os hor&aacute;rios de funcionamento de sua empresa e utilizar os mesmos para gera&ccedil;&atilde;o de relat&oacute;rios de Disponibilidade e/ou Capacidade.");
INSERT INTO languages VALUES ("pt_BR", "Timecut removed sucessfully", "Corte de Tempo removido com sucesso");
INSERT INTO languages VALUES ("pt_BR", "Timecut saved sucessfully", "Corte de Tempo salvo com sucesso");
INSERT INTO languages VALUES ("pt_BR", "Timecut", "Corte de tempo");
INSERT INTO languages VALUES ("pt_BR", "To", "At&eacute;");
INSERT INTO languages VALUES ("pt_BR", "Today", "Hoje");
INSERT INTO languages VALUES ("pt_BR", "Toggle autoscale", "Alternar autoescala");
INSERT INTO languages VALUES ("pt_BR", "Toggle metric", "Alternar m&eacute;trica");
INSERT INTO languages VALUES ("pt_BR", "Toggle metrics", "Alternar m&eacute;tricas");
INSERT INTO languages VALUES ("pt_BR", "Toggle thresholds", "Alternar thresholds");
INSERT INTO languages VALUES ("pt_BR", "Tools", "Ferramentas");
INSERT INTO languages VALUES ("pt_BR", "Top 5 - Alerts", "Top 5 - Alertas");
INSERT INTO languages VALUES ("pt_BR", "Topology Awareness Message", "Aqui voc&ecirc; poder&aacute; gerar e visualizar antes de aplicar a topologia entre todos os servidores monitorados.");
INSERT INTO languages VALUES ("pt_BR", "Topology", "Topologia");
INSERT INTO languages VALUES ("pt_BR", "Traceroute", "Traceroute");
INSERT INTO languages VALUES ("pt_BR", "Transfer errors", "Erros de transfer.");
INSERT INTO languages VALUES ("pt_BR", "Trend lines", "Linhas de tend&ecirc;ncia");
INSERT INTO languages VALUES ("pt_BR", "Trigger ID", "ID Gatilho");
INSERT INTO languages VALUES ("pt_BR", "Triggered by", "Disparado por");
INSERT INTO languages VALUES ("pt_BR", "Try again", "Tentar novamente");
INSERT INTO languages VALUES ("pt_BR", "Try exporting configuration", "Tentar realizar um export");
INSERT INTO languages VALUES ("pt_BR", "Tuesday", "Ter&ccedil;a-feira");
INSERT INTO languages VALUES ("pt_BR", "Type an user", "Digite um usu&aacute;rio!");
INSERT INTO languages VALUES ("pt_BR", "Type of day", "Tipo de dia");
INSERT INTO languages VALUES ("pt_BR", "Type of day", "Tipo do dia");
INSERT INTO languages VALUES ("pt_BR", "Type the directory name", "Digite o nome do diret&oacute;rio");
INSERT INTO languages VALUES ("pt_BR", "Type the new bookmark name", "Digite o nome do novo favorito");
INSERT INTO languages VALUES ("pt_BR", "Type the new shortcut name", "Digite o nome do novo atalho");
INSERT INTO languages VALUES ("pt_BR", "Type the word <strong> DELETE </ strong> to confirm", "Digite a palavra <strong>DELETE</strong> para confirmar");
INSERT INTO languages VALUES ("pt_BR", "Type", "Tipo");
INSERT INTO languages VALUES ("pt_BR", "UNKNOWN", "DESCONHECIDO");
INSERT INTO languages VALUES ("pt_BR", "UNREACHABLE", "INALCAN&Ccedil;&Aacute;VEL");
INSERT INTO languages VALUES ("pt_BR", "UP", "UP");
INSERT INTO languages VALUES ("pt_BR", "Unable to access the server", "N&atilde;o foi poss&iacute;vel acessar o servidor");
INSERT INTO languages VALUES ("pt_BR", "Unable to add a field without `name' defined", "Impossivel adicionar campo sem um nome");
INSERT INTO languages VALUES ("pt_BR", "Unable to connect to server", "Imposs&iacute;vel conectar ao servidor");
INSERT INTO languages VALUES ("pt_BR", "Unable to locate host group", "Imposs&iacute;vel localizar grupo de hosts");
INSERT INTO languages VALUES ("pt_BR", "Unable to locate host", "Imposs&iacute;vel localizar host");
INSERT INTO languages VALUES ("pt_BR", "Unable to locate service", "Imposs&iacute;vel localizar servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR", "Unable to locate services group", "Imposs&iacute;vel localizar grupo de servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR", "Unable to locate staff", "Imposs&iacute;vel localizar grupo de contatos");
INSERT INTO languages VALUES ("pt_BR", "Unable to locate team", "Imposs&iacute;vel localizar grupo de contatos");
INSERT INTO languages VALUES ("pt_BR", "Unable to synchronize group of hosts", "Imposs&iacute;vel sincronizar grupo de hosts");
INSERT INTO languages VALUES ("pt_BR", "Unable to synchronize services group", "Imposs&iacute;vel sincronizar grupo de servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR", "Unable to synchronize teams", "Imposs&iacute;vel sincronizar grupos de contato");
INSERT INTO languages VALUES ("pt_BR", "Unable to write content into backup", "N&atilde;o &eacute; poss&iacute;vel gravar o conte&uacute;do em backup");
INSERT INTO languages VALUES ("pt_BR", "Unable to write content into ifcfg-eth0", "N&atilde;o &eacute; poss&iacute;vel gravar o conte&uacute;do em ifcfg-eth0");
INSERT INTO languages VALUES ("pt_BR", "Unable to write content into ntp.conf", "N&atilde;o &eacute; poss&iacute;vel gravar o conte&uacute;do em ntp.conf");
INSERT INTO languages VALUES ("pt_BR", "Unexpected Error", "Erro inesperado");
INSERT INTO languages VALUES ("pt_BR", "Uninstall packages", "Desinstalar pacotes");
INSERT INTO languages VALUES ("pt_BR", "Unit", "Unidade");
INSERT INTO languages VALUES ("pt_BR", "Unknown User", "Usu&aacute;rio Desconhecido");
INSERT INTO languages VALUES ("pt_BR", "Unknown", "Desconhecido");
INSERT INTO languages VALUES ("pt_BR", "Unlimited", "Ilimitado");
INSERT INTO languages VALUES ("pt_BR", "Unreachable", "Inacess&iacute;vel");
INSERT INTO languages VALUES ("pt_BR", "Unsaved changes", "Altera&ccedil;&otilde;es n&atilde;o salvas");
INSERT INTO languages VALUES ("pt_BR", "Unselect column", "Desmarcar coluna");
INSERT INTO languages VALUES ("pt_BR", "Update license", "Atualizar licen&ccedil;a...");
INSERT INTO languages VALUES ("pt_BR", "Update port...", "Atualizar porta...");
INSERT INTO languages VALUES ("pt_BR", "Updated on", "Atualizado em");
INSERT INTO languages VALUES ("pt_BR", "Updated", "Atualizada em");
INSERT INTO languages VALUES ("pt_BR", "Updating IP address...", "Atualizando o endere&ccedil;o IP...");
INSERT INTO languages VALUES ("pt_BR", "Updating database...", "Atualizando base de dados...");
INSERT INTO languages VALUES ("pt_BR", "Updating the configuration file...", "Atualizando arquivo de configura&ccedil;&atilde;o...");
INSERT INTO languages VALUES ("pt_BR", "Updating", "Atualizando");
INSERT INTO languages VALUES ("pt_BR", "Upload Success", "Upload efetuado com sucesso");
INSERT INTO languages VALUES ("pt_BR", "Upload a new package", "Enviar um novo pacote");
INSERT INTO languages VALUES ("pt_BR", "Upload file", "Enviar arquivo");
INSERT INTO languages VALUES ("pt_BR", "Upload new custom report", "Carregar novo relat&oacute;rio personalizado");
INSERT INTO languages VALUES ("pt_BR", "Upload new logo", "Enviar novo logo");
INSERT INTO languages VALUES ("pt_BR", "Upper limit", "Limite superior");
INSERT INTO languages VALUES ("pt_BR", "Usage", "Uso");
INSERT INTO languages VALUES ("pt_BR", "Use clock hardware", "Utilizar rel&oacute;gio do hardware");
INSERT INTO languages VALUES ("pt_BR", "Use registered authentications", "Utilizar as autentica&ccedil;&otilde;es cadastradas");
INSERT INTO languages VALUES ("pt_BR", "Use this model", "Usar este modelo");
INSERT INTO languages VALUES ("pt_BR", "Used Dashboards", "Dashboards Usados");
INSERT INTO languages VALUES ("pt_BR", "Used Hosts", "Hosts Usados");
INSERT INTO languages VALUES ("pt_BR", "Used Services", "Servi&ccedil;os Usados");
INSERT INTO languages VALUES ("pt_BR", "Used", "Usados");
INSERT INTO languages VALUES ("pt_BR", "User administrator", "Usu&aacute;rio administrador");
INSERT INTO languages VALUES ("pt_BR", "User already exists", "Usu&aacute;rio j&aacute; existe");
INSERT INTO languages VALUES ("pt_BR", "User and Password", "Usu&aacute;rio e Senha");
INSERT INTO languages VALUES ("pt_BR", "User created successfully", "Usu&aacute;rio criado com sucesso");
INSERT INTO languages VALUES ("pt_BR", "User name system administrator", "Nome do usu&aacute;rio administrador do sistema");
INSERT INTO languages VALUES ("pt_BR", "User", "Usu&aacute;rio");
INSERT INTO languages VALUES ("pt_BR", "UserWithouPermissionDiscovery", "Seu usu&aacute;rio n&atilde;o tem permiss&atilde;o para executar o Auto-Discovery!");
INSERT INTO languages VALUES ("pt_BR", "UserWithoutPermissionMsg", "Seu usu&aacute;rio n&atilde;o tem permiss&atilde;o para executar comandos!");
INSERT INTO languages VALUES ("pt_BR", "User_Language", "L&iacute;ngua");
INSERT INTO languages VALUES ("pt_BR", "Users", "Usu&aacute;rios");
INSERT INTO languages VALUES ("pt_BR", "Using external authentication", "Usar autentica&ccedil;&atilde;o externa");
INSERT INTO languages VALUES ("pt_BR", "Value in minutes", "Valor em minutos");
INSERT INTO languages VALUES ("pt_BR", "Value", "Valor");
INSERT INTO languages VALUES ("pt_BR", "Vendor", "Fabricante");
INSERT INTO languages VALUES ("pt_BR", "Verifying user and password", "Verificando usu&aacute;rio e senha...");
INSERT INTO languages VALUES ("pt_BR", "Version", "Vers&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "View all hosts", "Ver todos os hosts");
INSERT INTO languages VALUES ("pt_BR", "View all models available", "Ver todos os modelos dispon&iacute;veis");
INSERT INTO languages VALUES ("pt_BR", "View all models", "Visualizar todos modelos");
INSERT INTO languages VALUES ("pt_BR", "View report and send by e-mail", "Ver o relat&oacute;rio e enviar por e-mail");
INSERT INTO languages VALUES ("pt_BR", "Views", "Vis&otilde;es");
INSERT INTO languages VALUES ("pt_BR", "WARNING", "ADVERT&Ecirc;NCIA");
INSERT INTO languages VALUES ("pt_BR", "Wait", "Aguarde...");
INSERT INTO languages VALUES ("pt_BR", "Wait... importing objects", "Aguarde, importando objetos");
INSERT INTO languages VALUES ("pt_BR", "Want to apply the generated topology ?", "Deseja aplicar a topologia gerada?");
INSERT INTO languages VALUES ("pt_BR", "Warning", "Advert&ecirc;ncia");
INSERT INTO languages VALUES ("pt_BR", "WarningStripe", "Faixa de advert&ecirc;ncia");
INSERT INTO languages VALUES ("pt_BR", "Warns", "advert&ecirc;ncias");
INSERT INTO languages VALUES ("pt_BR", "We define the following", "Definimos as seguintes");
INSERT INTO languages VALUES ("pt_BR", "We find the following probes. Check the probes you want to monitor.", "Encontramos as probes a seguir. Marque as probes que deseja monitorar.");
INSERT INTO languages VALUES ("pt_BR", "We have already analyzed the available resources on your server.", "J&aacute; analisamos os recursos dispon&iacute;veis no seu servidor.");
INSERT INTO languages VALUES ("pt_BR", "Wednesday", "Quarta-feira");
INSERT INTO languages VALUES ("pt_BR", "Week day", "Dia da semana");
INSERT INTO languages VALUES ("pt_BR", "Week", "Semana");
INSERT INTO languages VALUES ("pt_BR", "Weekly", "Semanal ");
INSERT INTO languages VALUES ("pt_BR", "Weekly", "Semanal");
INSERT INTO languages VALUES ("pt_BR", "Weeks", "Semanas");
INSERT INTO languages VALUES ("pt_BR", "Welcome to %tag%OpMon %version%%tagend%", "Bem vindo ao %tag%OpMon %version%%tagend%");
INSERT INTO languages VALUES ("pt_BR", "Welcome to OpMon Traffic Analyzer", "Bem vindo ao OpMon Traffic Analyzer");
INSERT INTO languages VALUES ("pt_BR", "Welcome", "Bem-Vindo");
INSERT INTO languages VALUES ("pt_BR", "What do you want to do?", "O que voc&ecirc; deseja fazer?");
INSERT INTO languages VALUES ("pt_BR", "What do you want to monitoring?", "O que voc&ecirc; deseja monitorar?");
INSERT INTO languages VALUES ("pt_BR", "Will be listed only hosts found by the discovery module", "Ser&atilde;o listados somente os hosts encontrados pelo m&oacute;dulo de descoberta do OpMon");
INSERT INTO languages VALUES ("pt_BR", "With ack", "Com a&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "With conflict", "Com conflito");
INSERT INTO languages VALUES ("pt_BR", "Without ack", "Sem a&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Work", "&Uacute;til");
INSERT INTO languages VALUES ("pt_BR", "Write your reasons", "Escreva sua justificativa");
INSERT INTO languages VALUES ("pt_BR", "Wrong password", "Senha ou usu&aacute;rio incorreto");
INSERT INTO languages VALUES ("pt_BR", "Year", "Ano");
INSERT INTO languages VALUES ("pt_BR", "Yes , I want to remove", "Sim, quero remover");
INSERT INTO languages VALUES ("pt_BR", "Yes", "Sim");
INSERT INTO languages VALUES ("pt_BR", "Yesterday", "Ontem");
INSERT INTO languages VALUES ("pt_BR", "You are trying to edit services that belong to a template, unable to proceed", "Os servi&ccedil;os que voc&ecirc; est&aacute; tentando editar pertencem a um template. Imposs&iacute;vel prosseguir.");
INSERT INTO languages VALUES ("pt_BR", "You can configure OpMon later", "Voc&ecirc; poder&aacute; configurar OpMon depois");
INSERT INTO languages VALUES ("pt_BR", "You can configure Traffic Analyzer later", "Voc&ecirc; poder&aacute; configurar Traffic Analyzer depois");
INSERT INTO languages VALUES ("pt_BR", "You can not recover the baseline \\\"Name baseline\\\" after erased.", "N&atilde;o ser&aacute; poss&iacute;vel recuperar a baseline \\\"Nome da baseline\\\" depois de apagada.");
INSERT INTO languages VALUES ("pt_BR", "You can not remove the user opmonadmin", "Voc&ecirc; n&atilde;o pode remover o usu&aacute;rio opmonadmin");
INSERT INTO languages VALUES ("pt_BR", "You have set the following", "Voc&ecirc; definiu as seguintes");
INSERT INTO languages VALUES ("pt_BR", "You have to write a reason", "Você precisa escrever uma justificativa");
INSERT INTO languages VALUES ("pt_BR", "You must select at least one host", "Voc&ecirc; precisa selecionar pelo menos um host");
INSERT INTO languages VALUES ("pt_BR", "You must select at least one service", "Voc&ecirc; precisa selecionar pelo menos um servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR", "You need to read and accept the license agreement to proceed with the configuration process.", "&Eacute; necess&aacute;rio que voc&ecirc; leia e aceite a licen&ccedil;a de uso para prosseguir com o processo de configura&ccedil;&atilde;o.");
INSERT INTO languages VALUES ("pt_BR", "You reached the limit of units that can be selected", "Foi alcan&ccedil;ado o limite de unidades que podem ser selecionadas");
INSERT INTO languages VALUES ("pt_BR", "The selected hosts are of the service catalog type and can not be removed.", "Os hosts selecionados s&atilde;o do tipo cat&aacute;logo de servi&ccedil;o e n&atilde;o podem ser removidos.");
INSERT INTO languages VALUES ("pt_BR", "You want to remove the selected monitored services? Other services belong to a template and can not be removed.", "Voc&ecirc; deseja remover o(s) %TOBEREMOVE% servi&ccedil;o(s) selecionado(s) da monitora&ccedil;&atilde;o? Outros %CANNOTBEREMOVE% servi&ccedil;o(s) pertence(m) ao um template e n&atilde;o pode(m) ser removido(s).");

INSERT INTO languages VALUES ("pt_BR", "You want to remove the selected monitored hosts? Other hosts are of the service catalog type and can not be removed.", "Voc&ecirc; deseja remover o(s) %TOBEREMOVE% host(s) selecionado(s) da monitora&ccedil;&atilde;o? Outros %CANNOTBEREMOVE% host(s) s&atilde;o do tipo cat&aacute;logo de servi&ccedil;os e n&atilde;o pode(m) ser removido(s).");

INSERT INTO languages VALUES ("pt_BR", "You want to remove the selected monitored host ( s ) ?", "Voc&ecirc; deseja remover o(s) %NUMBER% host(s) selecionado(s) da monitora&ccedil;&atilde;o?");
INSERT INTO languages VALUES ("pt_BR", "You want to remove the selected monitored service ( s ) ?", "Voc&ecirc; deseja remover o(s) %NUMBER% servi&ccedil;o(s) selecionado(s) da monitora&ccedil;&atilde;o?");
INSERT INTO languages VALUES ("pt_BR", "Your dashboards limit has been reached. To access this dashboard, you have to expand your license or remove a number of dashboards until your license limit is not exceeded.", "Seu limite de dashboards foi atingido. Para acessar esse dashboard voc&ecirc; precisa aumentar sua licença ou remover um n&uacute;mero de dashboards at&eacute; o limite da licen&ccedil;a.");
INSERT INTO languages VALUES ("pt_BR", "Your license does not allow you to access this module", "Sua licen&ccedil;a n&atilde;o permite voc&ecirc; acessar esse m&oacute;dulo");
INSERT INTO languages VALUES ("pt_BR", "Your license expired", "Sua licen&ccedil;a expirou");
INSERT INTO languages VALUES ("pt_BR", "Your license is going to expire in", "Sua licen&ccedil;a expirar&aacute; em");
INSERT INTO languages VALUES ("pt_BR", "Your report has been uploaded", "Seu relat&oacute;rio foi enviado");
INSERT INTO languages VALUES ("pt_BR", "Your scheduler", "Seu agendador");
INSERT INTO languages VALUES ("pt_BR", "Your trial license expire in %DAY% day(s)", "Sua licen&ccedil;a teste expira em %DAY% dia(s)");
INSERT INTO languages VALUES ("pt_BR", "\\o\\f", "\\d\\e");
INSERT INTO languages VALUES ("pt_BR", "added", "adicionado");
INSERT INTO languages VALUES ("pt_BR", "added.", "adicionado.");
INSERT INTO languages VALUES ("pt_BR", "administrator", "Administrador");
INSERT INTO languages VALUES ("pt_BR", "already exists.", "j&aacute; existe.");
INSERT INTO languages VALUES ("pt_BR", "and", "e");
INSERT INTO languages VALUES ("pt_BR", "backup", "backup");
INSERT INTO languages VALUES ("pt_BR", "click here", "clique aqui");
INSERT INTO languages VALUES ("pt_BR", "days", "dias");
INSERT INTO languages VALUES ("pt_BR", "default Gateway", "Gateway padr&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "demoVersion1", "(M&oacute;dulo em Demonstra&ccedil;&atilde;o - Somente ");
INSERT INTO languages VALUES ("pt_BR", "demoVersion2", " hosts ser&atilde;o mostrados)");
INSERT INTO languages VALUES ("pt_BR", "different alarms", "alarmes diferentes");
INSERT INTO languages VALUES ("pt_BR", "environment", "Ambiente");
INSERT INTO languages VALUES ("pt_BR", "filtered", "filtrada");
INSERT INTO languages VALUES ("pt_BR", "for you.", "para voc&ecirc;.");
INSERT INTO languages VALUES ("pt_BR", "for your environment.", "para seu ambiente.");
INSERT INTO languages VALUES ("pt_BR", "for", "para");
INSERT INTO languages VALUES ("pt_BR", "from", "das");
INSERT INTO languages VALUES ("pt_BR", "here", "aqui");
INSERT INTO languages VALUES ("pt_BR", "host(s) discovered!", "host(s) encontrado(s)!");
INSERT INTO languages VALUES ("pt_BR", "host(s) selected", "host(s) selecionados");
INSERT INTO languages VALUES ("pt_BR", "hosts selected", "hosts selecionados");
INSERT INTO languages VALUES ("pt_BR", "hosts to be imported", "hosts para serem importados");
INSERT INTO languages VALUES ("pt_BR", "hosts to be scanned", "hosts para serem varridos");
INSERT INTO languages VALUES ("pt_BR", "hours", "horas");
INSERT INTO languages VALUES ("pt_BR", "licenseExceededMsg", "O n&uacute;mero de objetos de sua licen&ccedil;a atingiu o limite.");
INSERT INTO languages VALUES ("pt_BR", "licenseExceededMsghost", "Voc&ecirc; n&atilde;o pode adicionar %SELECTED% host(s), pois sua licen&ccedil;a permite um total de %LICENSELIMIT% hosts e voc&ecirc; j&aacute; monitora %LICENSEMONITORED% host(s).");
INSERT INTO languages VALUES ("pt_BR", "licenseExceededMsgservice", "Voc&ecirc; n&atilde;o pode adicionar %SELECTED% servi&ccedil;o(s), pois sua licen&ccedil;a permite um total de %LICENSELIMIT% servi&ccedil;os e voc&ecirc; j&aacute; monitora %LICENSEMONITORED% servi&ccedil;o(s).");
INSERT INTO languages VALUES ("pt_BR", "licenseExceededTitle", "Limite de objetos excedidos!");
INSERT INTO languages VALUES ("pt_BR", "metric exceeds any limit", "m&eacute;trica ultrapassa qualquer limite");
INSERT INTO languages VALUES ("pt_BR", "metric exceeds any limit", "m&eacute;trica ultrapassar qualquer limite");
INSERT INTO languages VALUES ("pt_BR", "metric exceeds the lower limit", "m&eacute;trica excede o limite inferior");
INSERT INTO languages VALUES ("pt_BR", "metric exceeds the upper limit", "m&eacute;trica excede o limite superior");
INSERT INTO languages VALUES ("pt_BR", "metric(s) selected", "m&eacute;trica(s) selecionada(s)");
INSERT INTO languages VALUES ("pt_BR", "minutes", "minutos");
INSERT INTO languages VALUES ("pt_BR", "month", "meses");
INSERT INTO languages VALUES ("pt_BR", "months", "meses");
INSERT INTO languages VALUES ("pt_BR", "network", "Rede");
INSERT INTO languages VALUES ("pt_BR", "no", "n&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "non work day", "n&atilde;o &uacute;til");
INSERT INTO languages VALUES ("pt_BR", "non-working days", "dias n&atilde;o &uacute;teis");
INSERT INTO languages VALUES ("pt_BR", "notifications sended", "notifica&ccedil;&atilde;o(&otilde;es) enviada(s)");
INSERT INTO languages VALUES ("pt_BR", "objects being edited have different values for this property.<br />Change it here and it will be changed to all objects", "possui diferentes valores para esta propriedade.<br />Mudando esta propriedade acarretar&aacute; em uma mudan&ccedil;a<br />em todos estes objetos");
INSERT INTO languages VALUES ("pt_BR", "of the month", "do m&ecirc;s");
INSERT INTO languages VALUES ("pt_BR", "of", "de");
INSERT INTO languages VALUES ("pt_BR", "or", "ou");
INSERT INTO languages VALUES ("pt_BR", "region", "Regi&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "rschedFooter", "Relat&oacute;rio gerado automaticamente pelo seu <b>OpMon</b>.<br>Caso n&atilde;o deseje receber novamente este email, por favor contate o seu administrador OpMon.");
INSERT INTO languages VALUES ("pt_BR", "scheduled reports", "relat&oacute;rios agendados");
INSERT INTO languages VALUES ("pt_BR", "seconds", "segundos");
INSERT INTO languages VALUES ("pt_BR", "selected metrics", "m&eacute;tricas selecionadas");
INSERT INTO languages VALUES ("pt_BR", "standard deviation", "desvios padr&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "to", "&agrave;");
INSERT INTO languages VALUES ("pt_BR", "via Discovery", "via Discovery");
INSERT INTO languages VALUES ("pt_BR", "weeks", "semanas");
INSERT INTO languages VALUES ("pt_BR", "with SLA Breach Reason", "com SLA justificado");
INSERT INTO languages VALUES ("pt_BR", "work day", "&uacute;til");
INSERT INTO languages VALUES ("pt_BR", "working day of month", "dia &uacute;til do m&ecirc;s");
INSERT INTO languages VALUES ("pt_BR", "working days", "dias &uacute;teis");
INSERT INTO languages VALUES ("pt_BR", "yes", "sim");
INSERT INTO languages VALUES ("pt_BR", "Paste here the key sent by email", "Cole aqui a chave enviada por e-mail");
INSERT INTO languages VALUES ("pt_BR", "Improve your network discovery  by registering its authentications", "Melhore a descoberta da sua rede cadastrando suas autentica&#xE7;&#xF5;es");
INSERT INTO languages VALUES ("pt_BR", "Grouped", "Agrupado");
INSERT INTO languages VALUES ("pt_BR", "View hosts before monitoring", "Ver hosts antes de monitorar");
INSERT INTO languages VALUES ("pt_BR", "Network Outages", "Quedas de Rede");
INSERT INTO languages VALUES ("pt_BR", "Status summary", "Sum&aacute;rio de Status");
INSERT INTO languages VALUES ("pt_BR", "Hosts Affected", "Hosts Afetados");
INSERT INTO languages VALUES ("pt_BR", "Network Outages Grid", "Listagem de Quedas de Rede");
INSERT INTO languages VALUES ("pt_BR", "Audit", "Auditoria");
INSERT INTO languages VALUES ("pt_BR", "Action", "A&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Set range", "Definir intervalos");
INSERT INTO languages VALUES ("pt_BR", "Preset periods", "Per&iacute;odos predefinidos");
INSERT INTO languages VALUES ("pt_BR", "There has not been any audit logged", "N&atilde;o houve nenhuma auditoria registrada");
INSERT INTO languages VALUES ("pt_BR", "Filter by date", "Filtro por data");
INSERT INTO languages VALUES ("pt_BR", "Service Description", "Descri&#xE7;&#xE3;o do Servi&#xE7;o");
INSERT INTO languages VALUES ("pt_BR", "Host / Service", "Host / Servi&#xE7;o");
INSERT INTO languages VALUES ("pt_BR", "events", "eventos");
INSERT INTO languages VALUES ("pt_BR", "Items", "Itens");
INSERT INTO languages VALUES ("pt_BR", "showing last 24h", "mostrando &#xFA;ltimas 24h");
INSERT INTO languages VALUES ("pt_BR", "Return to realtime mode", "Retornar ao modo realtime");
INSERT INTO languages VALUES ("pt_BR", "Bookmark this filter", "Adicionar filtro aos favoritos");
INSERT INTO languages VALUES ("pt_BR", "Add a shortcut for this filter", "Adicionar um atalho para esse filtro");
INSERT INTO languages VALUES ("pt_BR", "of {0}", "de {0}");
INSERT INTO languages VALUES ("pt_BR", "{0} to {1} of {2} event(s)", "{0} &agrave; {1} de {2} evento(s)");
INSERT INTO languages VALUES ("pt_BR", "No events to display", "Sem eventos para exibir");
INSERT INTO languages VALUES ("pt_BR", "New Filter", "Novo Filtro");
INSERT INTO languages VALUES ("pt_BR", "Create new dashboard", "Criar novo dashboard");
INSERT INTO languages VALUES ("pt_BR", "Filter by name", "Filtrar por nome");
INSERT INTO languages VALUES ("pt_BR", "Edit mode", "Modo de edi&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Dashboard Gallery", "Galeria de Dashboards");
INSERT INTO languages VALUES ("pt_BR", "Permissions settings", "Configura&ccedil;&atilde;o de permiss&otilde;es");
INSERT INTO languages VALUES ("pt_BR", "Select a contact group", "Selecione um grupo de contato");
INSERT INTO languages VALUES ("pt_BR", "Select a permission", "Selecione uma permiss&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Contact group", "Grupo de contatos");
INSERT INTO languages VALUES ("pt_BR", "Permission", "Permiss&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "remove", "remover");
INSERT INTO languages VALUES ("pt_BR", "Show all dashboards", "Mostrar todos dashboards");
INSERT INTO languages VALUES ("pt_BR", "Show my dashboards", "Mostrar meus dashboards");
INSERT INTO languages VALUES ("pt_BR", "Loading contact groups", "Carregando grupo de contatos");
INSERT INTO languages VALUES ("pt_BR", "Preparing permissions", "Preparando as permiss&otilde;es");
INSERT INTO languages VALUES ("pt_BR", "Duplicated contact group", "Grupo de contatos duplicado");
INSERT INTO languages VALUES ("pt_BR", "Are you want to override the configurations?", "Voc&ecirc; deseja sobreescrever as configura&ccedil;&otilde;es?");
INSERT INTO languages VALUES ("pt_BR", "Please wait until permissions is saved", "Por favor, espere as permiss&otilde;es serem salvas");
INSERT INTO languages VALUES ("pt_BR", "Permission", "Permiss&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Error to delete permission", "Erro ao deletar permiss&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Error to save permission", "Erro ao salvar permiss&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "If you continue, you will not see this dashboard on the list", "Se continuar, voc&ecirc; n&atilde;o ir&aacute; ver em sua listagem de dashboards");
INSERT INTO languages VALUES ("pt_BR", "You can still configure the permissions by clicking the 'View all dashboards' button", "Voc&ecirc; ainda poder&aacute; configurar as permiss&otilde;es ao clicar no bot&atilde;o 'Ver todos dashboards'");
INSERT INTO languages VALUES ("pt_BR", "Read and Write", "Leitura e Escrita");
INSERT INTO languages VALUES ("pt_BR", "Read only", "Somente leitura");
INSERT INTO languages VALUES ("pt_BR", "Feature used to check alerts by colors according to criticality levels.", "Recurso para visualiza&ccedil;&atilde;o de alertas definidos por cores de acordo com o n&iacute;vel de criticidade.");
INSERT INTO languages VALUES ("pt_BR", "There are 9 colors which identify different states.", "S&atilde;o 9 cores que identificam diferentes estados");
INSERT INTO languages VALUES ("pt_BR", "Status priority", "Prioridade de estados");
INSERT INTO languages VALUES ("pt_BR", "Click here if you need help", "Clique aqui caso necessite de ajuda");
INSERT INTO languages VALUES ("pt_BR", "Color selection", "Sele&ccedil;&atilde;o de cor");
INSERT INTO languages VALUES ("pt_BR", "Restore to defaults colors", "Restaurar para cores padr&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "LESS Critical", "MENOS Cr&iacute;tico");
INSERT INTO languages VALUES ("pt_BR", "MORE Critical", "MAIS Cr&iacute;tico");
INSERT INTO languages VALUES ("pt_BR", "Successfully saved status colors", "Cores de estados salvas com sucesso");
INSERT INTO languages VALUES ("pt_BR", "No permission", "Sem permiss&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Type class", "Tipo de classe");
INSERT INTO languages VALUES ("pt_BR", "Notification reason", "Motivo de notifica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Flapping Start", "In&iacute;cio de Instabilidade");
INSERT INTO languages VALUES ("pt_BR", "Flapping Stop", "Fim de Instabilidade");
INSERT INTO languages VALUES ("pt_BR", "Flapping Disabled", "Instabilidade Desabilitada");
INSERT INTO languages VALUES ("pt_BR", "Downtime Start", "In&iacute;cio de Manuten&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Downtime End", "Fim de Manuten&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR", "Downtime Cancelled", "Manuten&ccedil;&atilde;o Cancelada");
INSERT INTO languages VALUES ("pt_BR", "Downtime Cancelled", "Manuten&ccedil;&atilde;o Cancelada");
INSERT INTO languages VALUES ("pt_BR", "Acknowledgement", "Reconhecimento");
INSERT INTO languages VALUES ("pt_BR", "Advanced search", "Busca avan&ccedil;ada");
INSERT INTO languages VALUES ("pt_BR", "You do not have permission to delete the dashboard", "Voc&ecirc; n&atilde;o tem permiss&atilde;o para excluir o dashboard");
INSERT INTO languages VALUES ("pt_BR", "Quantity", "Quantidade");
INSERT INTO languages VALUES ("pt_BR", "No incidents", "No incidents");
INSERT INTO languages VALUES ("pt_BR", "Affecteds", "Afetados");
INSERT INTO languages VALUES ("pt_BR", "%qtd% element(s) in %state% state", "%qtd% elemento(s) em estado %state%");
INSERT INTO languages VALUES ("pt_BR", "Top 5 alerts producers last 24h", "Top 5 geradores de alertas nas &uacute;ltimas 24h");
INSERT INTO languages VALUES ("pt_BR", "Service catalog", "Cat&aacute;logo de servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR", "Incidents by state", "Incidentes por estado");
INSERT INTO languages VALUES ("pt_BR", "Impacted IT services", "Servi&ccedil;os impactados");
INSERT INTO languages VALUES ("pt_BR", "%n% more", "mais %n%");
INSERT INTO languages VALUES ("pt_BR", "%pct% of incidents in %total% objects monitored", "%pct% dos incidentes em %total% objetos monitorados");
INSERT INTO languages VALUES ("pt_BR", "Alerts last 24h", "Alertas das &uacute;ltimas 24h");
INSERT INTO languages VALUES ("pt_BR", "%pct% of %total% objects in OK", "%pct% de %total% objetos em OK");
INSERT INTO languages VALUES ("pt_BR", "Event log last 24h", "Log de eventos das &uacute;ltimas 24h");
INSERT INTO languages VALUES ("pt_BR", "Last update was at %time%", "&Uacute;ltima atualiza&ccedil;&atilde;o foi as %time%");
INSERT INTO languages VALUES ("pt_BR", "in OK", "em OK");
INSERT INTO languages VALUES ("pt_BR", "Incidents by group", "Incidente por grupo");
INSERT INTO languages VALUES ("pt_BR", "Percentage of incidents for each state. By clicking on a state the itens on this state will be shown", "Percentual de incidentes por estado. Ao clicar no estado os elementos nesse estado s&atilde;o mostrados");
INSERT INTO languages VALUES ("pt_BR", "Total network outages and how many devices are affected by them. On clicking the list of network outages is shown", "Total de quedas de rede e quantos dispositivos est&atilde;o afetados. Ao clicar, a lista de quedas de rede &eacute; mostrada");
INSERT INTO languages VALUES ("pt_BR", "Total incidents per group by state. Clicking on a group shows the incidents details", "Total de incidetes por grupo dividos por estado. Ao clicar no grupo, os detalhes dos incidentes s&atilde;o mostrados");
INSERT INTO languages VALUES ("pt_BR", "Incidents per hour in the last 24 hours. You can click on a hour bar of the graph to see event log details of the incidents", "Incidentes por hora das &uacute;ltimas 24 horas. Ao clicar na hora desejada &eacute; mostrado todos os detalhes dos eventos da hora selecionada");
INSERT INTO languages VALUES ("pt_BR", "Top 5 itens that have produced the most alerts in the last 24 hours. Clicking on the a object shows more details", "Top 5 itens que mais geraram alertas nas &uacute;ltimas 24 horas. Clicando no objeto mostra mais detalhes");
INSERT INTO languages VALUES ("pt_BR", "The most recent events from the last 24h. On click the details of the item are shown", "Os eventos mais recentes das &uacute;ltimas 24 horas. Clicando os detalhes do item s&atilde;o mostrados");
INSERT INTO languages VALUES ("pt_BR", "Top 10 most important incidents ordered by priority and duration. On click the details of the item are shown. It is also possible to apply actions to the incidents by clicking on the icon %img%", "Top 10 mais importantes incidentes ordenados por prioridade e dura&ccedil;&atilde;o. Clicando, os detalhes do item s&atilde;o mostrados. &Eacute; poss&iacute;vel tamb&eacute;m aplicar a&ccedil;&otilde;es aos incidentes clicando no &iacute;cone %img%");
INSERT INTO languages VALUES ("pt_BR", "Live IT Services being impacted by incidents in monitored itens", "Servi&ccedil;os de IT com impacto");
INSERT INTO languages VALUES ("pt_BR", "worst state duration %d%", "Dura&ccedil;&atilde;o do pior estado %d%");
INSERT INTO languages VALUES ("pt_BR", "%n% elements", "%n% elementos");
INSERT INTO languages VALUES ("pt_BR", "You don't have any dashboard", "Voc&ecirc; n&atilde;o tem dashboards");
INSERT INTO languages VALUES ("pt_BR", "Click here to create a dashboard", "Clique aqui para criar um dashboard");
INSERT INTO languages VALUES ("pt_BR", "Create dashboard", "Criar dashboard");
INSERT INTO languages VALUES ("pt_BR", "Use template", "Usar um template");
INSERT INTO languages VALUES ("pt_BR", "Last check", "&Uacute;ltima checagem");
INSERT INTO languages VALUES ("pt_BR", "Period metrics", "M&eacute;tricas do per&iacute;odo");
INSERT INTO languages VALUES ("pt_BR", "Hi, I'm Neoson", "Oi, eu sou o Neoson");
INSERT INTO languages VALUES ("pt_BR", "More information" , "Mais informa&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR", "Check now" , "Checar agora");
INSERT INTO languages VALUES ("pt_BR", "New monitor" , "Nova monitora&ccedil;&atilde;o");

INSERT INTO languages VALUES ("pt_BR_ITIL", "New monitor" , "Nova monitora&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Check now" , "Checar agora");
INSERT INTO languages VALUES ("pt_BR_ITIL", "More information" , "Mais informa&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR", "Neoson informs", "Neoson informa");
INSERT INTO languages VALUES ("pt_BR", "Neoson has come back from the future to anticipate %s possible predictive alerts for the coming days. Click here to see more.", "Neoson voltou do futuro para antecipar %s possíveis alertas preditivos para os pr&oacute;ximos dias. Clique aqui para ver mais.");
INSERT INTO languages VALUES ("pt_BR", "Run next check", "Executar pr&oacute;xima checagem");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Run next check", "Executar pr&oacute;xima checagem");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Neoson informs", "Neoson informa");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Neoson has come back from the future to anticipate %s possible predictive alerts for the coming days. Click here to see more.", "Neoson voltou do futuro para antecipar %s possíveis alertas preditivos para os pr&oacute;ximos dias. Clique aqui para ver mais.");

INSERT INTO languages VALUES ("pt_BR", "the OpMon virtual assistant!", "o assistente virtual do OpMon!");
INSERT INTO languages VALUES ("pt_BR", "Let's create our first dashboard?", "Vamos criar nosso primeiro dashboard?");
INSERT INTO languages VALUES ("pt_BR", "Get started", "Iniciar");
INSERT INTO languages VALUES ("pt_BR", "No dashboard registered", "Nenhum dashboard cadastrado");
INSERT INTO languages VALUES ("pt_BR", "No prediction at this moment", "Nenhuma previs&atilde;o neste momento");
INSERT INTO languages VALUES ("pt_BR", "Notification disabled", "Notifica&ccedil;&atilde;o desabilitada");
INSERT INTO languages VALUES ("pt_BR", "Notification enabled", "Notifica&ccedil;&atilde;o habilitada");

INSERT INTO languages VALUES ("pt_BR_ITIL", "No dashboard registered", "Nenhum dashboard cadastrado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Notification disabled", "Notifica&ccedil;&atilde;o desabilitada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Notification enabled", "Notifica&ccedil;&atilde;o habilitada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "No prediction at this moment", "Nenhuma previs&atilde;o neste momento");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Hi, I'm Neoson", "Oi, eu sou o Neoson");
INSERT INTO languages VALUES ("pt_BR_ITIL", "the OpMon virtual assistant!", "o assistente virtual do OpMon!");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Let's create our first dashboard?", "Vamos criar nosso primeiro dashboard?");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Get started", "Iniciar");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Period metrics", "M&eacute;tricas do per&iacute;odo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Last check", "&Uacute;ltima checagem");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Use template", "Usar um template");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Create dashboard", "Criar dashboard");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Click here to create a dashboard", "Clique aqui para criar um dashboard");
INSERT INTO languages VALUES ("pt_BR_ITIL", "You don't have any dashboard", "Voc&ecirc; n&atilde;o tem dashboards");
INSERT INTO languages VALUES ("pt_BR_ITIL", "%n% elements", "%n% elementos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "worst state duration %d%", "Dura&ccedil;&atilde;o do pior estado %d%");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Live IT Services being impacted by incidents in monitored itens", "Servi&ccedil;os de IT com impacto");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Top 10 most important incidents ordered by priority and duration. On click the details of the item are shown. It is also possible to apply actions to the incidents by clicking on the icon %img%", "Top 10 mais importantes incidentes ordenados por prioridade e dura&ccedil;&atilde;o. Clicando, os detalhes do item s&atilde;o mostrados. &Eacute; poss&iacute;vel tamb&eacute;m aplicar a&ccedil;&otilde;es aos incidentes clicando no &iacute;cone %img%");
INSERT INTO languages VALUES ("pt_BR_ITIL", "The most recent events from the last 24h. On click the details of the item are shown", "Os eventos mais recentes das &uacute;ltimas 24 horas. Clicando os detalhes do item s&atilde;o mostrados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Top 5 itens that have produced the most alerts in the last 24 hours. Clicking on the a object shows more details", "Top 5 itens que mais geraram alertas nas &uacute;ltimas 24 horas. Clicando no objeto mostra mais detalhes");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Incidents per hour in the last 24 hours. You can click on a hour bar of the graph to see event log details of the incidents", "Incidentes por hora das &uacute;ltimas 24 horas. Ao clicar na hora desejada &eacute; mostrado todos os detalhes dos eventos da hora selecionada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Total incidents per group by state. Clicking on a group shows the incidents details", "Total de incidetes por grupo dividos por estado. Ao clicar no grupo, os detalhes dos incidentes s&atilde;o mostrados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Total network outages and how many devices are affected by them. On clicking the list of network outages is shown", "Total de quedas de rede e quantos dispositivos est&atilde;o afetados. Ao clicar, a lista de quedas de rede &eacute; mostrada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Percentage of incidents for each state. By clicking on a state the itens on this state will be shown", "Percentual de incidentes por estado. Ao clicar no estado os elementos nesse estado s&atilde;o mostrados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Incidents by group", "Incidente por grupo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "in OK", "em OK");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Last update was at %time%", "&Uacute;ltima atualiza&ccedil;&atilde;o foi as %time%");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Event log last 24h", "Log de eventos das &uacute;ltimas 24h");
INSERT INTO languages VALUES ("pt_BR_ITIL", "%pct% of %total% objects in OK", "%pct% de %total% objetos em OK");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Alerts last 24h", "Alertas das &uacute;ltimas 24h");
INSERT INTO languages VALUES ("pt_BR_ITIL", "%pct% of incidents in %total% objects monitored", "%pct% dos incidentes em %total% objetos monitorados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "%n% more", "mais %n%");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Impacted IT services", "Servi&ccedil;os impactados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Incidents by state", "Incidentes por estado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Service catalog", "Cat&aacute;logo de servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Invalid Expiration Date/Time", "Data/hora de expira&ccedil;&atilde;o inv&aacute;lida");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Top 5 alerts producers last 24h", "Top 5 geradores de alertas nas &uacute;ltimas 24h");
INSERT INTO languages VALUES ("pt_BR_ITIL", "%qtd% element(s) in %state% state", "%qtd% elemento(s) em estado %state%");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Affecteds", "Afetados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "No incidents", "No incidents");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Quantity", "Quantidade");
INSERT INTO languages VALUES ("pt_BR_ITIL", "You do not have permission to delete the dashboard", "Voc&ecirc; n&atilde;o tem permiss&atilde;o para excluir o dashboard");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Advanced search", "Busca avan&ccedil;ada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Acknowledgement", "Reconhecimento");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Downtime Cancelled", "Manuten&ccedil;&atilde;o Cancelada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Downtime End", "Fim de Manuten&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Downtime Start", "In&iacute;cio de Manuten&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Flapping Disabled", "Instabilidade Desabilitada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Flapping Stop", "Fim de Instabilidade");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Flapping Start", "Inicio de Instabilidade");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Flapping Start", "Flapping Start");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Notification reason", "Motivo de notifica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Type class", "Tipo de classe");
INSERT INTO languages VALUES ("pt_BR_ITIL", "No permission", "Sem permiss&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Successfully saved status colors", "Cores de estados salvas com sucesso");
INSERT INTO languages VALUES ("pt_BR_ITIL", "LESS Critical", "MENOS Cr&iacute;tico");
INSERT INTO languages VALUES ("pt_BR_ITIL", "MORE Critical", "MAIS Cr&iacute;tico");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Restore to defaults colors", "Restaurar para cores padr&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Color selection", "Sele&ccedil;&atilde;o de cor");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Click here if you need help", "Clique aqui caso necessite de ajuda");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Status priority", "Prioridade de estados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Feature used to check alerts by colors according to criticality levels.", "Recurso para visualiza&ccedil;&atilde;o de alertas definidos por cores de acordo com o n&iacute;vel de criticidade.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "There are 9 colors which identify different states.", "S&atilde;o 9 cores que identificam diferentes estados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Read only", "Somente leitura");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Read and Write", "Leitura e Escrita");
INSERT INTO languages VALUES ("pt_BR_ITIL", "You can still configure the permissions by clicking the 'View all dashboards' button", "Voc&ecirc; ainda poder&aacute; configurar as permiss&otilde;es ao clicar no bot&atilde;o 'Ver todos dashboards'");
INSERT INTO languages VALUES ("pt_BR_ITIL", "If you continue, you will not see this dashboard on the list", "Se continuar, voc&ecirc; n&atilde;o ir&aacute; ver em sua listagem de dashboards");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Error to save permission", "Erro ao salvar permiss&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Permission", "Permiss&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Please wait until permissions is saved", "Por favor, espere as permiss&otilde;es serem salvas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Are you want to override the configurations?", "Voc&ecirc; deseja sobreescrever as configura&ccedil;&otilde;es?");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Duplicated contact group", "Grupo de contatos duplicado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Preparing permissions", "Preparando as permiss&otilde;es");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Loading contact groups", "Carregando grupo de contatos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Show my dashboards", "Mostrar meus dashboards");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Show all dashboards", "Mostrar todos dashboards");
INSERT INTO languages VALUES ("pt_BR_ITIL", "remove", "remover");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Permission", "Permiss&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Contact group", "Grupo de contatos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select a permission", "Selecione uma permiss&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select a contact group", "Selecione um grupo de contato");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Permissions settings", "Configura&ccedil;&atilde;o de permiss&otilde;es");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Dashboard Gallery", "Galeria de Dashboards");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Edit mode", "Modo de edi&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Filter by name", "Filtrar por nome");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Create new dashboard", "Criar novo dashboard");
INSERT INTO languages VALUES ("pt_BR_ITIL", "New Filter", "Novo Filtro");
INSERT INTO languages VALUES ("pt_BR_ITIL", "No events to display", "Sem eventos para exibir");
INSERT INTO languages VALUES ("pt_BR_ITIL", "{0} to {1} of {2} event(s)", "{0} &agrave; {1} de {2} evento(s)");
INSERT INTO languages VALUES ("pt_BR_ITIL", "of {0}", "de {0}");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Add a shortcut for this filter", "Adicionar um atalho para esse filtro");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Bookmark this filter", "Adicionar filtro aos favoritos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Return to realtime mode", "Retornar ao modo realtime");
INSERT INTO languages VALUES ("pt_BR_ITIL", "showing last 24h", "mostrando &#xFA;ltimas 24h");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Network outages", "Quedas de rede");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Outages", "Quedas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Affected", "Afetados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Incidents last 24 hours", "Incidentes das &uacute;timas 24 horas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "System health", "Sa&uacute;de do sistema");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Incidents per groups", "Incidentes por grupo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Top 10 incidents", "Top 10 incidentes");

INSERT INTO languages VALUES ("pt_BR_ITIL", "events", "eventos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Host / Service", "Host / Servi&#xE7;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Service Description", "Descri&#xE7;&#xE3;o do Servi&#xE7;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Filter by date", "Filtro por data");
INSERT INTO languages VALUES ("pt_BR_ITIL", "ServiceRemoved", "Servi&#231;o j&#225; foi removido");
INSERT INTO languages VALUES ("pt_BR_ITIL", "HostRemoved", "Host j&#225; foi removido");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Filter activated", "Filtro ativo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "AdvancedFilterApplied", "Filtro avan&#231;ado aplicado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Detailed view", "Vis&#227;o detalhada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Grouped by tag", "Agrupado por tag");
INSERT INTO languages VALUES ("pt_BR_ITIL", "devices and applications discovered", "dispositivos e aplica&#231;&#245;es descobertos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Downtimes", "Manuten&#231;&#227;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", " If you need help click ", "  Para ajuda clique ");
INSERT INTO languages VALUES ("pt_BR_ITIL", "%COUNT% probes found. Mark which you want to monitor with the OpMon Traffic Analyzer.", "%COUNT% probes encontradas. Marque quais deseja monitorar pelo OpMon Traffic Analyzer.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "%link%Click here%endlink% if you need help", "%link%Clique aqui%endlink% caso necessite de ajuda");
INSERT INTO languages VALUES ("pt_BR_ITIL", "%n% host(s) of %m% available", "%n% host(s) de %m% dispon&iacute;vel(is)");
INSERT INTO languages VALUES ("pt_BR_ITIL", "%n% service(s) of %m% available", "%n% servi&ccedil;o(s) de %m% dispon&iacute;vel(is)");
INSERT INTO languages VALUES ("pt_BR_ITIL", "%qtd%/%of% services have been retrieved successfully", "%qtd%/%of% servi&ccedil;os obtidos com sucesso");
INSERT INTO languages VALUES ("pt_BR_ITIL", "(All)", "(Todos)");
INSERT INTO languages VALUES ("pt_BR_ITIL", "(No shortcuts found)", "(Nenhum atalho)");
INSERT INTO languages VALUES ("pt_BR_ITIL", "0", "Desabilitado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "1", "Habilitado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "<strong> Algorithm </ strong> analysis", "<strong>Algoritmo</ strong> de an&aacute;lise");
INSERT INTO languages VALUES ("pt_BR_ITIL", "<strong>Lower</strong> limit of the confidence interval", "Limite <strong>inferior</strong> do intervalo de confian&ccedil;a");
INSERT INTO languages VALUES ("pt_BR_ITIL", "<strong>Upper</strong> limit of the confidence interval", "Limite <strong>superior</strong> do intervalo de confian&ccedil;a");
INSERT INTO languages VALUES ("pt_BR_ITIL", "A new version of this package is available", "Uma nova vers&atilde;o deste pacote est&aacute; dispon&iacute;vel para atualiza&ccedil&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "API returned the following error on service %servicename% of host %hostname%", "A API retornou o seguinte erro no servi&ccedil;o %servicename% do host %hostname%");
INSERT INTO languages VALUES ("pt_BR_ITIL", "AVAIL", "Disponibilidade");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Absolute min/max", "Min/max absolutos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Access Denied", "Acesso Negado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Access expired", "Seu acesso expirou. Entre em contato com o seu administrador.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Ack", "A&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Acknowledge this incident", "Reconhecer incidente");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Acknowledge", "Reconhecimento");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Acknowledged incidents", "Incidentes reconhecidos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Acknowledged", "Reconhecido");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Acks AND downtimes", "Reconhecimentos E manuten&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Acks OR downtimes", "Reconhecimentos OU manuten&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Acks", "Reconhecimentos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Action URL", "URL de a&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Actions", "A&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Activation key", "Chave de ativa&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Active Downtimes", "Manuten&ccedil;&otilde;es ativas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Active check", "Checagem ativa");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Active checks disabled", "Checagens ativas desabilitadas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Active checks enabled", "Checagens ativas habilitadas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Active probes can not be removed", "Probes ativas n&atilde;o podem ser removidas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Active", "Ativa");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Add Command to Service", "Adicionar Comando ao Servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Add Command", "Adicionar Comando");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Add Host", "Adicionar Host");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Add IP / Range to discovery", "Adicionar Range ou IP &agrave; descoberta");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Add IP Range or the discovery", "Adicionar Range ou IP &agrave; descoberta");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Add IP or network range that you want to discover", "Acrescente o endere&ccedil;o IP ou a rede que deseja descobrir");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Add SNMP Community", "Adicionar comunidade SNMP");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Add Teams to user", "Adicionar grupos de contato a contato");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Add a SLA breach reason", "Adicionar justificativa de SLA");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Add a comment", "Adicionar coment&aacute;rio");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Add a new command to the list", "Adicionar um novo comando &agrave; lista");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Add action to all Hosts", "Adicionar a&ccedil;&atilde;o para todos ICs");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Add action to all Services", "Adicionar a&ccedil;&atilde;o para todos AICs");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Add and configure network elements", "Adicione e configure os elementos da rede");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Add directory", "Adicionar diret&oacute;rio");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Add host manually", "Adicionar host manualmente");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Add host", "Adicionar IC");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Add hots to a group", "Adicionar hosts a grupo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Add just one", "Adicionar somente um");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Add more communities", "Adicionar mais comunidades");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Add more than one", "Adicionar mais de um");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Add multiple hosts. Write as follow: ip,hostname,description. Write one host per line.", "Adicione multiplos hosts. Siga a estrutura: IP,nome do host,descri&ccedil;&atilde;o. Escreva um host por linha.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Add new Application Protocol", "Adicionar novo Protocolo de Aplica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Add new host manually", "Adicionar novo host manualmente");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Add new metrics", "Adicionar novas m&eacute;tricas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Add new package", "Adicionar novos pacotes");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Add new template", "Adicionar novo template");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Add selected elements", "Adicionar elementos selecionados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Add service", "Adicionar AIC");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Add services to groups", "Adicionar servi&ccedil;os a grupos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Add the current page to bookmark links", "Adicionar a p&aacute;gina atual aos favoritos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Add the current page to shortcut links", "Adicionar a p&aacute;gina atual aos atalhos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Add users to team", "Adicionar contato a grupo de contatos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Add your first metric", "Adicionar sua primeira m&eacute;trica");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Add", "Adicionar");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Adding Traffic Sources", "Como adicionar fontes de tr&aacute;fego");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Additional Actions", "A&ccedil;&otilde;es adicionais");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Additional Modules", "M&oacute;dulos&nbsp;Adicionais");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Additional Notes", "Notas adicionais");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Address", "Endere&ccedil;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Administrator", "Administrador");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Advanced Options", "Op&ccedil;&otilde;es Avan&ccedil;adas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Advanced Search", "Busca avan&ccedil;ada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Advanced Service Level Agreement Report", "An&aacute;lise de n&iacute;vel de servi&ccedil;o - Avan&ccedil;ado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Advanced commands", "Comandos avan&ccedil;ados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Advanced options", "Op&ccedil;&otilde;es avan&ccedil;adas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Advanced", "Avan&ccedil;adas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Affected services", "Servi&ccedil;os afetados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Alarm operation", "Funcionamento do alarme");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Alarm when", "Alarmar quando");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Alert history", "Hist&oacute;rico de alertas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Alert", "Aviso");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Alerts Summary", "Sum&aacute;rio de Alertas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Alerts", "Alertas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Alias", "Alias");
INSERT INTO languages VALUES ("pt_BR_ITIL", "All May View", "Qualquer usu&aacute;rio pode visualizar");
INSERT INTO languages VALUES ("pt_BR_ITIL", "All categories", "Todas as categorias");
INSERT INTO languages VALUES ("pt_BR_ITIL", "All hosts must contain at least one user or team responsible", "Todos os hosts devem conter pelo menos um contato ou grupo de contatos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "All may view", "Todos podem ver");
INSERT INTO languages VALUES ("pt_BR_ITIL", "All models", "Todos os modelos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "All rights reserved", "Todos os direitos reservados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "All services must contain at least one user or team responsible", "Todos os servi&ccedil;os devem conter pelo menos um contato ou grupo de contatos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "All", "Todos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Already created", "J&aacute; criado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Already exists", "j&aacute; existe");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Already monitored items will not appear as discovered elements", "Itens j&aacute; monitorados n&atilde;o ser&atilde;o listados no discovery");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Already selected", "J&aacute; selecionado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "An unexpected error occured during Timecut save process", "Um erro inesperado ocorreu durante o salvamento de seu Corte de Tempo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "An unexpected error occured retrieving Timecut", "Um erro inesperado buscando Corte de Tempo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "AndRelatedAcknowledgements", "Tamb&eacute;m ser&aacute; exclu&iacute;da a&ccedil;&atilde;o relacionada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Any probes weren't found. Try again.", "N&atilde;o foram encontrados coletores. Tente novamente.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Application protocols registry", "Registro de Protocolos de Aplica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Application protocols", "Protocolos de aplica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Application", "Aplica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Apply Model", "Aplicar o modelo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Apply Settings", "Aplicar Defini&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Apply command to the service", "Aplicar comando ao servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Apply command", "Aplicar comando");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Apply selected model", "Aplicar o modelo selecionado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Apply service to hosts", "Aplicar servi&ccedil;o aos hosts");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Apply templates to selected hosts", "Aplicar templates selecionados aos hosts");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Apply the topology to OpMon", "Aplique a topologia ao OpMon");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Apply to all hosts", "Aplicar a todos hosts");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Apply to all services", "Aplicar a todos servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Apply to all", "Aplicar a todos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Apply to child hosts", "Aplicar para os ICs filhos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Apply to host", "Aplicar para o IC tamb&eacute;m");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Apply topology", "Aplicar topologia");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Apply", "Aplicar");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Applying new configuration", "Atualizando configura&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Applying topology to OpMon and Complete", "Aplicar topologia ao OpMon e Concluir");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Apr", "Abr");
INSERT INTO languages VALUES ("pt_BR_ITIL", "April", "Abril");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Are you ready to visualize all your network flow?", "Preparado para visualizar todo o fluxo de dados da sua rede?");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Are you sure do you want to uninstall this package? All services using it are going to be removed.", "Tem certeza de que deseja remover o pacote? Todos os servi&ccedil;os associados a este pacote ser&atilde;o removidos.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Are you sure you want to remove this comment?", "Tem certeza que deseja remover este coment&aacute;rio?");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Are you sure you want to run the selected command?", "Tem certeza que deseja executar o comando selecionado?");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Assignment", "Atribui&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Associated Baseline", "Baseline associada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Attempts", "Tentativas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Aug", "Ago");
INSERT INTO languages VALUES ("pt_BR_ITIL", "August", "Agosto");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Authentication Mode", "Tipo de autentica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Authentication name", "Nome da Autentica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Authentication", "Autentica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Author", "Autor");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Auto discovery disabled", "Descoberta autom&aacute;tica inativa");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Auto discovery enabled", "Descoberta autom&aacute;tica ativa");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Auto scale", "Escala autom&aacute;tica");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Auto-Discovery finished! (see log below)", "Auto-Discovery finalizado! (veja o log abaixo)");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Auto-Discovery finished!", "Auto-Discovery finalizado!");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Auto-Discovery started!", "Auto-Discovery iniciado!");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Auto-Discovery", "Auto-Discovery");
INSERT INTO languages VALUES ("pt_BR_ITIL", "AutoDiscoveryDescription", "Se voc&ecirc; acabou de instalar OpMon, voc&ecirc; pode utilizar esta ferramenta para facilmente descobrir dispositivos na sua rede. &Eacute; o modo m&aacute;is f&aacute;cil de come&ccedil;ar.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "AutoDiscoveryMsg", "Insira as informa&ccedil;&atilde;es da sua rede abaixo para que seja executada um escaneamento autom&aacute;tico. Todos dispositvos encontrados ser&atilde;o importados. Este processo pode demorar um pouco.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "AutoDiscoveryMsg", "Put your network information below to perform an automatic scan. All discovered devices will be imported. This process can take some time.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Autodiscovery enabled", "Autodiscovery habilitado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Autoscale", "Autoscale");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Availability Report", "Relat&oacute;rio de disponibilidade");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Availability for CI", "Disponibilidade para IC");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Availability for service", "Disponibilidade para servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Availability", "Disponibilidade");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Available Dashboards", "Dashboards Dispon&iacute;veis");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Available Hosts", "Hosts Dispon&iacute;veis");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Available Services", "Servi&ccedil;os Dispon&iacute;veis");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Available objects", "Objetos dispon&iacute;veis");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Available", "Dispon&iacute;veis");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Available", "Dispon&iacute;vel");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Average", "M&eacute;dia");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Avg", "M&eacute;dia");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Back to Settings", "Voltar para Configura&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Back to the discovered elements", "Retornar aos &iacute;tens descobertos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Back to the list", "Voltar &agrave; listagem");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Back", "Voltar");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Baseline Name", "Nome da baseline");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Baseline can not be deleted", "Baseline n&atilde;o pode ser apagada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Baseline down", "Baseline inferior");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Baseline up", "Baseline superior");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Baselines registered", "Baselines cadastradas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Behavior of the baseline", "Comportamento da baseline");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Behavioral simulation", "Simula&ccedil;&atilde;o do comportamento");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Bookmark already exists", "Este favorito ja existe!");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Bookmarks", "Favoritos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Broadcast", "Broadcast");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Business Accountable", "Respons&aacute;veis pelo Neg&oacute;cio");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Business Impact Analysis (BIA)", "An&aacute;lise&nbsp;de&nbsp;Impacto&nbsp;nos&nbsp;Neg&oacute;cios(AIN)");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Business", "Neg&oacute;cios");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Buy Traffic Analyzer Link", "http://www.opservices.com.br/comercializacao-opmon-traffic-analyzer");
INSERT INTO languages VALUES ("pt_BR_ITIL", "By group", "Por grupo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "CI Metrics Group", "Grupo de M&eacute;tricas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "CI's Attributes Groups", "Grupos de Atributos de ICs (AICs)");
INSERT INTO languages VALUES ("pt_BR_ITIL", "CI's Attributes", "Atributos&nbsp;ICs&nbsp;(AICs)");
INSERT INTO languages VALUES ("pt_BR_ITIL", "CIs Groups", "Grupos&nbsp;de&nbsp;IC's");
INSERT INTO languages VALUES ("pt_BR_ITIL", "CIs Metrics", "M&eacute;tricas&nbsp;IC's");
INSERT INTO languages VALUES ("pt_BR_ITIL", "CIs", "IC's");
INSERT INTO languages VALUES ("pt_BR_ITIL", "CMDB", "CMDB");
INSERT INTO languages VALUES ("pt_BR_ITIL", "CP", "Capacidade");
INSERT INTO languages VALUES ("pt_BR_ITIL", "CRITICAL", "CR&Iacute;TICO");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Calculed", "Calculado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Calendar Overview", "Overview do calend&aacute;rio");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Calendar settings", "Configura&ccedil;&otilde;es do calend&aacute;rio");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Cancel and go to management", "Cancelar o processo e ir para o gerenciamento");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Cancel process", "Cancelar processo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Cancel the process and go to management", "Cancelar o processo e ir para o gerenciamento");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Cancel", "Cancelar");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Cant write license file", "N&atilde;o foi poss&iacute;vel escrever arquivo de licen&ccedil;a.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Capacity", "Capacidade");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Capacity/Performance", "Capacidade/Performance");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Catalogs", "Cat&aacute;logos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Category", "Categoria");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Caution", "Tenha cuidado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Change Teams and Team members", "Alterar contatos e grupos de contato");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Change password", "Troca de senha");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Change ports", "Alterar portas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Change theme", "Mudar o tema");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Change", "Alterar");
INSERT INTO languages VALUES ("pt_BR_ITIL", "ChangePasswordText", "Para trocar a sua senha,<br> entre em contato com o seu Administrador.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Changes in baseline [name of baseline] were not saved.", "As altera&ccedil;&otilde;es na baseline [nome da baseline] n&atilde;o foram salvas.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Changes saved successfully", "Altera&ccedil;&otilde;es salvas com sucesso");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Check Interval", "Intervalo de Checagem");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Check Period", "Per&iacute;odo da checagem");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Check command", "Comando de checagem");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Check duration", "Dura&ccedil;&atilde;o da checagem");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Check output", "Sa&iacute;da da checagem");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Check result", "Resultado da checagem");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Check time", "Hora da checagem");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Check type", "Tipo da checagem");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Check", "Checagem");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Checking Period", "Per&iacute;odo de Checagem");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Checking if the port is available...", "Verificando se a porta est&aacute; dispon&iacute;vel...");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Checks", "Checagens");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Child hosts", "ICs filhos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Choose OpMon color theme", "Escolha a cor do tema");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Choose a metric", "Escolha uma m&eacute;trica");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Choose a monitoring model", "Escolha um modelo de monitora&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Clean Filter", "Limpar Filtros");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Click here to purchase a license now", "Clique aqui e adquira uma licen&ccedil;a agora");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Click in the cel you want to edit", "Clique na c&eacute;lula que deseja editar");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Click to see the element details", "Clique para ver os detalhes do elemento");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Clone", "Clone");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Close advanced search", "Fechar busca avan&ccedil;ada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Close details", "Fechar detalhes");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Close", "Fechar");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Color", "Cor");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Colors - State configuration", "Cores - Configura&ccedil;&atilde;o do estado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Command Line", "Linha de Comando");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Command executed", "Comando executado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Command list", "Lista de comandos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Command name must have at last 2 caracters.", "O nome do comando de possuir ao menos 2 caracteres");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Command submitted successfully", "Comando submetido com sucesso!");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Command", "Comando");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Commands", "Comandos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Comment", "Coment&aacute;rio");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Comments Totals", "Totaliza&ccedil;&atilde;o dos coment&aacute;rios");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Comments", "Coment&aacute;rios");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Common Users", "Usu&aacute;rios Comuns");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Communities added", "Comunidades Adicionadas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Communities added", "Comunidades adicionadas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Community Awareness Message", "Cadastre aqui as comunidades SNMP que voc&ecirc; utiliza em sua rede, isso possibilitar&aacute; ao Discovery monitorar muito mais dados a respeito dos servidores.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Community", "Comunidade");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Compared with the days", "Comparado com os dias");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Comparison period", "Per&iacute;odo de compara&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Complete", "Concluir");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Completed", "Completado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Components", "Componentes");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Configuration Items", "Itens de Configura&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Configuration exported!", "Configura&ccedil;&atilde;o exportada!");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Configuration of application protocols performed successfully", "Configura&ccedil;&atilde;o de protocolos de aplica&ccedil;&atilde;o efetuada com sucesso");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Configuration", "Configura&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "ConfigurationDescription", "Esta op&ccedil;&atilde;o permitir&aacute; que voc&ecirc; configure manualmente novos dispositivos.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Configurations", "Configura&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Configure OpMon", "Configurar OpMon");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Configure Traffic Analyzer", "Configurar Traffic Analyzer");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Configure model settings", "Configure o modelo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Configure selected elements", "Configurar elementos selecionados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Configure selected items", "Configurar itens selecionados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Configure the IP and port of the OpMon Traffic Analyzer", "Configurar o IP e a porta do OpMon Traffic Analyzer");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Configure the Report", "Configurar o relat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Configure the data below to finish installation or %link%click here%endlink% if you need help", "Configure os dados abaixo para finalizar instala&ccedil;&atilde;o ou %link%clique aqui%endlink% caso necessite de ajuda.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Configuring Network", "Configurar Rede");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Configuring application", "Configurando aplica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Configuring hosts", "Configurando hosts");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Configuring user", "Configurando o usu&aacute;rio");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Configuring", "Configurando");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Confirm change", "Confirmar altera&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Confirm command execution", "Confirmar execu&ccedil;&atilde;o do comando?");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Confirm command execution?", "Confirmar execu&ccedil;&atilde;o do comando?");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Confirm delete?", "Confirma remo&ccedil;&atilde;o?");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Confirm password", "Confirmar senha");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Confirm", "Confirmar");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Confirmation", "Confirma&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Conflict resolved", "Conflito resolvido");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Connection Error", "Erro de conex&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Contact name", "Nome de contato");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Contact", "Contato");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Contactgroup", "Grupo de Contatos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Contactgroups and Contacts", "Grupo de contatos e contatos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Contactgroups", "Grupos de Contatos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Contacts", "Contatos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Contacts/Users", "Contato/Usu&acute;rio");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Containers", "Cont&ecirc;iners");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Context", "Contexto");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Copyright", "Copyright");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Correct Syntax: hostname,adddress,description", "Sintaxe correta: nome e do host, endere&ccedil;o, descri&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Corrupted license", "Licen&ccedil;a corrompida");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Could not create shortcut because it exists already", "N&atilde;o foi poss&iacute;vel criar o atalho pois este nome j&aacute; est&aacute; em uso");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Could not get any data from the host. Make sure your global settings are correct.", "N&atilde;o foi poss&iacute;vel obter dados do host. Verifique se as configura&ccedil;&otilde;es globais est&atilde;o corretas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Could not get any data from the selected hosts. Make sure your global settings are correct.", "N&atilde;o foi poss&iacute;vel obter dados do(s) host(s) selecionado(s). Verifique se as configura&ccedil;&otilde;es globais est&atilde;o corretas.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Create Host Groups", "Criar grupos de host");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Create Service Groups", "Criar grupos de servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Create a service manually", "Criar um servi&ccedil;o manualmente");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Create new Authentication", "Criar nova Autentica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Create new SNMP Community", "Criar nova Comunidade SNMP");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Create new baseline", "Criar nova baseline");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Create new host", "Criar novo host");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Create new hosts", "Criar novos hosts");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Create new report", "Criar novo relat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Create new", "Criar novo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Create service", "Criar servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Created in", "Criada em");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Creation date", "Data de cria&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Critical", "Cr&iacute;tico");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Current attempt", "Tentativa atual");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Current logo", "Logo atual");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Custom map", "Mapa customizado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Custom period", "Per&iacute;odo customizado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Custom", "Customizado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Customize alarm for this day", "Personalizar alarme para este dia");
INSERT INTO languages VALUES ("pt_BR_ITIL", "DATABASECONNECTION", "Conex&atilde;o com Banco de Dados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "DOWN", "FORA");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Daily", "Di&aacute;ria");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Dashboards", "Dashboards");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Database connection problem", "Problemas de conex&atilde;o com a base de dados!");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Date", "Data");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Date/Time", "Data/Hora");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Day", "Dia");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Days", "Dias");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Dear", "Prezado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Dec", "Dez");
INSERT INTO languages VALUES ("pt_BR_ITIL", "December", "Dezembro");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Default", "Padr&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Define Output", "Definir sa&iacute;da");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Define basic parameters of selected hosts", "Defina os par&acirc;metros b&aacute;sicos dos hosts selecionados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Define host check commmand and values", "Defina o comando de checagem do host e valores de checagem");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Define the authentication mode", "Define o modo de autentica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Define the report format", "Defina o formato do relat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Defined", "Definido");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Delete baseline", "Apagar baseline");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Delete selected", "Remover selecionados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Delete the custom report", "Exclua o relat&oacute;rio personalizado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Delete this report", "Excluir este relat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Description of baseline", "Descri&ccedil;&atilde;o da baseline");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Description", "Descri&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Destination", "Destino");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Detailed view", "Vis&atilde;o Detalhada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Detailed", "Detalhado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Details of", "Detalhes de");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Details", "Detalhes");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Different passwords", "Senhas diferentes");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Disable active checks for all services", "Desabilitar checagens ativas para todos Atributos de IC");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Disable checks for all services", "Desabilitar checagens para todos os Atributos de IC");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Disable checks", "Desabilitar checagens");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Disable notifications for all hosts", "Desabilitar notifica&ccedil;&otilde;es para todos ICs");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Disable notifications for all services", "Desabilitar notifica&ccedil;&otilde;es em todos Atributos de IC");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Disable notifications for all services", "Desabilitar notifica&ccedil;&otilde;es para todos Atributos de IC");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Disable notifications", "Desabilitar notifica&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Disabled", "Desabilitado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Disableda", "Desabilitada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Disassociate the metrics to be able to delete the baseline.", "Desassocie as m&eacute;tricas para poder apagar a baseline.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Disassociate this metric", "Desassociar esta m&eacute;trica");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Discard", "Descartar");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Discarded packets", "Pacotes descartados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Discover and IP Ranges", "Descobrir IPs e Ranges");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Discover elements", "Descobrir elementos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Discovered Device", "Dispositivo Descoberto");
INSERT INTO languages VALUES ("pt_BR_ITIL", "devices discovered", "dispositivos descobertos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Discovering network elements", "Descobrir elementos da rede");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Discovery Awareness Message", "A descoberta de elementos de rede busca por portas abertas e por poss&iacute;veis respostas ao protocolo SNMP nos servidores de destino. Muitas vezes este tipo de varredura(busca por portas abertas) interpretado por um IDS como uma tentativa de invas&atilde;o, portanto, aconselhamos a sempre conversar com o administrador da rede antes de efetuar a descoberta.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Discovery Configuration", "Configura&ccedil;&otilde;es da Descoberta");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Discovery Status", "Status do Discovery");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Discovery result", "Resultado da descoberta");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Discovery running", "Discovery em andamento");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Discovery", "Discovery");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Display the discovered elements by OpMon", "Visualize os elementos descobertos pelo OpMon");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Display the topology of the monitored elements", "Visualize a topologia dos elementos monitorados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Displaying", "Exibindo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Do not monitor", "N&atilde;o monitorar");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Do not select service", "N&atilde;o selecionar o servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Do nothing", "N&atilde;o fa&ccedil;a nada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Do you really want to apply all the changes ?", "Deseja realmente aplicar todas as altera&ccedil;&otilde;es?");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Do you really want to cancel it?", "Voc&ecirc; realmente quer cancelar?");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Do you really want to not monitor this service?", "Voc&ecirc; realmente deseja n&atilde;o monitorar esse servi&ccedil;o?");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Do you really want to remove it?", "Voc&ecirc; tem certeza que deseja remov&ecirc;-lo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Do you want to cancel the process of adding / editing ?", "Deseja cancelar o processo de adi&ccedil;&atilde;o/edi&ccedil;&atilde;o?");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Do you want to remove the port", "Deseja remover a porta");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Do you want to remove the probe", "Deseja remover a probe");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Do you want to select this service?", "Voc&ecirc; deseja selecionar o servi&ccedil;o?");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Documentation", "Documenta&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "DocumentationDescription", "Voc&ecirc; pode acessar a nossa Wiki onde v&aacute;rios materiais est&atilde;o dispon&iacute;veis, inclu&iacute;ndo uma base de conhecimento, plugins, v&iacute;deos e tutoriais.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Documentations", "Documenta&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Don't show again", "N&atilde;o mostrar novamente");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Don't show this window again", "N&atilde;o exibir esta janela novamente");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Double-click to add to selection", "Clique duas vezes para adicionar &agrave; sele&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Double-click to edit", "Clique duas vezes para editar");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Double-click to remove the item of selection", "Clique duas vezes para remover o item de sele&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Down time", "Tempo fora");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Down", "Fora");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Download the custom report", "Fa&ccedil;a o download do relat&oacute;rio personalizado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Downtime Totals", "Totaliza&ccedil;&atilde;o das manuten&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Downtime", "Parada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Downtimes between dates", "Manuten&ccedil;&otilde;es entre datas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Duplicate host", "Duplicar IC");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Duplicate host", "Duplicar o host");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Duplicate service", "Duplicar AIC");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Duration", "Dura&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "E-mail", "E-mail");
INSERT INTO languages VALUES ("pt_BR_ITIL", "E-mails dont match", "E-mails diferentes");
INSERT INTO languages VALUES ("pt_BR_ITIL", "EVENTGUARD", "EventGuard");
INSERT INTO languages VALUES ("pt_BR_ITIL", "EXTERNALAUTH", "Autentica&ccedil;&atilde;o Externa");
INSERT INTO languages VALUES ("pt_BR_ITIL", "EXTERNALCOMMANDS", "Comandos Externos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Edit Host Groups", "Editar Grupos de Host");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Edit Service Groups", "Editar Grupos de Servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Edit Teams and Team Members", "Editar grupos de contato e contatos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Edit Templates", "Editar Templates");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Edit associated metrics", "Editar m&eacute;tricas associadas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Edit baseline", "Editar baseline");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Edit before duplicating", "Editar antes de duplicar");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Edit bookmark links", "Editar os favoritos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Edit check command", "Editar comando de checagem");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Edit checks", "Editar checagens");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Edit description", "Edit description");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Edit extended information", "Editar informa&ccedil;&otilde;es estendidas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Edit host groups", "Editar grupos de host");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Edit host", "Editar IC");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Edit name", "Edit name");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Edit notifications", "Editar notifica&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Edit service", "Editar AIC");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Edit teams", "Editar grupos de contato");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Edit", "Editar");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Element (s) selected (s)", "elemento(s) selecionado(s)");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Element description", "Element description");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Element name", "Element name");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Element origin of new metrics", "Elemento origem das novas m&eacute;tricas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Element's history is going to be permanently removed", "Todo o hist&oacute;rico do elemento ser&aacute; perdido");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Elements Selected for the Report", "elemento(s) selecionado(s) para o relat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Email", "Email");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Empty host list", "Lista de hosts vazia");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Enable active checks for all services", "Habilitar checagens ativas para todos Atributos de IC");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Enable checks for all services", "Habilitar checagens para todos os Atributos de IC");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Enable checks", "Habilitar checagens");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Enable discovery", "Ativar Descoberta");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Enable notifications for all hosts", "Habilitar notifica&ccedil;&otilde;es para todos ICs");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Enable notifications for all services", "Habilitar notifica&ccedil;&otilde;es em todos Atributos de IC");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Enable notifications for all services", "Habilitar notifica&ccedil;&otilde;es para todos Atributos de IC");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Enable notifications", "Habilitar notifica&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Enable zoom", "Ativar zoom");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Enabled", "Habilitado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Enableda", "Habilitada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "End Discovery", "Finalizar");
INSERT INTO languages VALUES ("pt_BR_ITIL", "End date", "Data final");
INSERT INTO languages VALUES ("pt_BR_ITIL", "End time", "Hora final");
INSERT INTO languages VALUES ("pt_BR_ITIL", "End", "Fim");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Enter the IP or the Range to be discovered", "Digite o IP ou o Range a ser descoberto");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Entry time", "Hora entrada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Error to locate group of hosts", "Erro procurando grupo de hosts");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Error to locate team", "Erro ao localizar grupo de contatos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Error", "Erro");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Event handler disabled", "Gerenciador de eventos desabilitado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Event handler enabled", "Gerenciador de eventos habilitado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Event handler", "Gerenciador de eventos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Event handlers disabled in monitoring, but enabled in the Configuration", "Event handlers desabilitados na Monitora&ccedil;&atilde;o, por&eacute;m habilitados na Configura&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Event handlers enabled in monitoring, but disabled in the Configuration", "Event handlers habilitados na Monitora&ccedil;&atilde;o, por&eacute;m desabilitados na Configura&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Event log", "Log de eventos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Events Totals", "Totaliza&ccedil;&atilde;o dos eventos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Events", "Eventos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Example: 192.168.10.1,linux server 07,intranet and website server.", "Exemplo: 192.168.10.1,linux server 07,servidor da intranet e website.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Exceeded the Lower limit", "Ultrapassou o limite Inferior");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Exceeded the Upper limit", "Ultrapassou o limite Superior");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Execute a command on selected items", "Executa um comando nos itens selecionados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Execute an external command", "Executar um comando externo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Expiration (Date/Time)", "Expira&ccedil;&atilde;o (Dia/Hora)");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Expiration Date", "Data de Expira&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Expire time", "Data de expira&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Expire", "Expira");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Export as PDF", "Exportar como PDF");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Export to", "Exportar para");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Exporting new config", "Exportando nova configura&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Extended Output", "Sa&iacute;da estendida");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Extended information", "Informa&ccedil;&otilde;es estendidas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "External command cannot be executed", "O comando externo n&atilde;o pode ser executado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "External command was executed", "O comando externo foi executado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "External commands", "Comandos externos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "External links", "Links externos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Extra parameter", "Par&acirc;metro extra");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Extras", "Extras");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Fail log", "Log de Falha");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Fail", "Falha");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Failed to connect to the server. Try again.", "Falha na conex&atilde;o com o servidor. Tente novamente.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Failed to restart OpMon Traffic Analyzer process.", "Falha ao reiniciar o processo do OpMon Traffic Analyzer.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Failed to save an activation key", "Falha ao salvar uma chave de ativa&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Failed to update OpMon Traffic Analyzer port.", "Falha ao atualizar a porta do OpMon Traffic Analyzer.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Failed to update the configuration file.", "Falha ao atualizar o arquivo de configura&ccedil;&atilde;o.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Failed to update the database.", "Falha ao atualizar a base de dados.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Fas addition of elements", "Adi&ccedil;&atilde;o r&aacute;pida de elementos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Fast addition of elements", "Adi&ccedil;&atilde;o r&aacute;pida de elementos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Favorite this", "Favoritar");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Favorites", "Favoritos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Feb", "Fev");
INSERT INTO languages VALUES ("pt_BR_ITIL", "February", "Fevereiro");
INSERT INTO languages VALUES ("pt_BR_ITIL", "File uploaded successfuly", "Arquivo enviado com sucesso");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Fill in the data below or %link%click here%endlink% if you need help", "Preencha os dados abaixo ou %link%clique aqui%endlink% caso necessite de ajuda");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Filter Report", "Relat&oacute;rio de Filtro");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Filter enabled", "Filtro %nameOfFilter% aplicado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Filter by Application", "Filtrar por Aplica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Filter by host", "Filtrar por host");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Filter by metric", "Filtrar por m&eacute;trica");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Filter by port", "Filtrar por porta");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Filter by probe", "Filtrar por probe");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Filter by service", "Filtrar por servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Filter by", "Filtrar por");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Filter by date", "Filtrar por data");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Filter discovered elements", "Filtrar elementos descobertos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Filter", "Filtrar");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Filtering services", "filtrar servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Filters", "Filtros");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Financial Losses", "Perdas Financeiras");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Finish Wizard and go to OpMon", "Finalizar o processo e ir para o OpMon");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Finish", "Finalizar");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Finished", "Terminada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "First Page", "Primeira P&aacute;gina");
INSERT INTO languages VALUES ("pt_BR_ITIL", "First page", "Primeira p&aacute;gina");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Fixed", "Fixa");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Flap detection disabled", "Detec&ccedil;&atilde;o de instabilidade desabilitada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Flap detection enabled", "Detec&ccedil;&atilde;o de instabilidade habilitada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Flap detection", "Detec&ccedil;&atilde;o de instabilidade");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Flapping", "Instabilidade");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Flexible", "Flex&iacute;vel");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Flow collector", "Coletor de flows");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Force check", "For&ccedil;ar checagem");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Forced", "For&ccedil;ada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Frequency", "Frequ&ecirc;ncia");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Friday", "Sexta-feira");
INSERT INTO languages VALUES ("pt_BR_ITIL", "From", "De");
INSERT INTO languages VALUES ("pt_BR_ITIL", "FullscreenText", "Voc&ecirc; est&aacute; entrando em modo de visualiza&ccedil;&atilde;o em tela cheia. Para voltar ao modo normal, clique nos bot&otilde;es de expandir os pain&eacute;is localizados nas laterais da p&aacute;gina.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Future trend", "Proje&ccedil;&atilde;o futura");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Generate a Capacity Planning Report from the selected items", "Gera um Relat&oacute;rio de Capacidade/Performance dos itens selecionados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Generate a Network Utilization Report from the selected items", "Gera um Relat&oacute;rio de Utiliza&ccedil;&atilde;o&nbsp;de&nbsp;rede dos itens selecionados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Generate an Availability Report from the selected items", "Gera um Relat&oacute;rio de Disponibilidade dos itens selecionados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Generate network topology", "Gerar topologia de rede");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Generate network topology", "Montar topologia");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Generate report and send by e-mail", "Gerar relat&oacute;rio e enviar por e-mail");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Generate report", "Gerar relat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Generating network topology", "Gerando topologia");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Get a new key", "Obter uma nova chave");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Get me out of here", "Tire-me daqui");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Global Settings", "Configura&ccedil;&otilde;es Globais");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Graphics in %", "Gr&aacute;ficos em %");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Green bullet means that the device is already being monitored. Gray bullet means that device has been discovered however it's not being monitored", "Bolinha verde significa que o dispositivo j&aacute; est&aacute; sendo monitorado, enquanto bolinha cinza significa que o dispositivo foi descoberto, por&eacute;m n&atilde;o est&aacute; monitorado ainda.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "GridNoElements", "Nada encontrado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Group By", "Agrupado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Group by metric", "Agrupar por m&eacute;trica");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Group by", "Agrupar por");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Groups of Hosts", "Grupos de Hosts");
INSERT INTO languages VALUES ("pt_BR_ITIL", "HARD", "HARD");
INSERT INTO languages VALUES ("pt_BR_ITIL", "HDs", "Discos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Hard State", "Hard State");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Have documentation?", "Possui documenta&ccedil;&atilde;o?");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Help", "Ajuda");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Helpful", "&Uacute;til");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Hide options", "Esconder op&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Highlight on the calendar", "Destacar no calend&aacute;rio");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Hint IP/Range", "Siga os exemplos:<br>192.168.10.130 ou;<br>192.168.10.* ou;<br>192.168.10.x - 192.168.10.y ou;<br>www.google.com.br ou;<br>para mais informa&#xE7;&#xF5;es, clique no &#xED;cone.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Hint", "Dica");
INSERT INTO languages VALUES ("pt_BR_ITIL", "History", "Hist&oacute;rico");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Holtz-Winters", "Holtz-Winters");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Host Grid", "Listagem de ICs");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Host Group already contains target host", "Grupo de hosts alvo j&aacute; contem host");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Host Group", "Grupo de ICs");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Host Groups", "Grupos de Host");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Host Name", "Nome do Host");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Host existing", "Host j&aacute; existente");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Host icon", "&Iacute;cone do host");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Host information", "Informa&ccedil;&otilde;es do IC");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Host origin of new metrics", "Host origem das novas m&eacute;tricas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Host service is not selected", "O host do servi&ccedil;o n&atilde;o est&aacute; selecionado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Host status", "Status dos ICs");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Host", "Host");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Host", "IC");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Host(s) modified", "Host(s) modificado(s)");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Hostgroup Grid", "Listagem de Grupo de ICs");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Hostgroup origin of new metrics", "Hostgroup origem das novas m&eacute;tricas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Hostgroup", "Grupo de IC");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Hostname", "Nome do host");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Hosts and Contacts", "ICs e Contatos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Hosts with ack", "ICs com a&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Hosts", "Hosts");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Hosts", "ICs");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Hour", "Hora");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Hours", "Horas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "How do I add a probe?", "Como adiciono uma probe?");
INSERT INTO languages VALUES ("pt_BR_ITIL", "I accept the %link%EULA terms described here%endlink%", "Eu aceito os termos do %link%EULA descritos aqui%endlink%");
INSERT INTO languages VALUES ("pt_BR_ITIL", "I accept the EULA described above", "Eu aceito o EULA descrita acima");
INSERT INTO languages VALUES ("pt_BR_ITIL", "I accept the eula described above", "Aceito a eula descrita acima");
INSERT INTO languages VALUES ("pt_BR_ITIL", "I agree", "Concordo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "I am ready! Begin to monitor my traffic.", "Estou pronto! Comece a monitorar meu tr&aacute;fego.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "I did not understand. I need more information.", "N&atilde;o entendi. Preciso de mais informa&ccedil;&otilde;es.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "I do not agree", "N&atilde;o estou de acordo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "I know what I'm doing.", "Eu sei o que estou fazendo.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "I want to add more probes", "Quero adicionar mais probes");
INSERT INTO languages VALUES ("pt_BR_ITIL", "I want to configure ports and protocol applications", "Quero configurar portas e protocolos de aplica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "I want to go to the traffic dashboard!", "Quero ir para o dashboard de tr&aacute;fego!");
INSERT INTO languages VALUES ("pt_BR_ITIL", "I want to know more about OpMon Traffic Analyzer", "Quero saber mais sobre o OpMon Traffic Analyzer");
INSERT INTO languages VALUES ("pt_BR_ITIL", "I want to monitoring OpMon Traffic Analyzer's internal traffic", "Quero monitorar o tr&aacute;fego interno do Optraffic");
INSERT INTO languages VALUES ("pt_BR_ITIL", "ID", "ID");
INSERT INTO languages VALUES ("pt_BR_ITIL", "IP Address", "Endere&ccedil;o IP");
INSERT INTO languages VALUES ("pt_BR_ITIL", "IP", "Endere&ccedil;o IP");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Icon", "&Iacute;cone");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Identify, register and change ports and application protocols. This information will be used to storage and data presentation.", "Identifique, registre e altere portas e protocolos de aplica&ccedil;&atilde;o. Estas informa&ccedil;&otilde;es ser&atilde;o utilizadas para o armazenamento e apresenta&ccedil;&atilde;o dos dados.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "If flexible, duration", "Se flex&iacute;vel, dura&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "If you remove this element, all child nodes will be removed. Continue?", "Se voc&ecirc; remover este elemento, todos os elementos internos tamb&eacute;m ser&atilde; removidos. Deseja continuar?");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Impact", "Impacto");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Importing discovered objects", "Importando objetos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "In Flapping State", "Inst&aacute;vel");
INSERT INTO languages VALUES ("pt_BR_ITIL", "In Progress", "Em Andamento");
INSERT INTO languages VALUES ("pt_BR_ITIL", "In Scheduled Downtime", "Em Manuten&ccedil;&atilde;o Agendada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "In maintenance since", "Em manuten&ccedil;&atilde;o desde ");
INSERT INTO languages VALUES ("pt_BR_ITIL", "In scheduled downtime", "Em manuten&ccedil;&atilde;o agendada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Incidents", "Incidentes");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Include soft states", "Incluir soft states");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Information", "Informa&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Informations", "Informa&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Initializing", "Inicializando");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Install custom package", "Instalar pacote customizado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Install default packages", "Instalar pacotes");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Install selected packages", "Instalar pacotes selecionados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Installing packages, do not close this window...", "Instalando pacotes, n&atilde;o feche esta janela...");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Interface", "Interface");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Interval", "Intervalo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Invalid Configuration", "Configura&ccedil;&atilde;o inv&aacute;lida");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Invalid IP", "IP inv&aacute;lido");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Invalid Range", "IP ou Range inv&aacute;lido. Siga os exemplos: 192.168.10.100, como modelo para IPs; 192.168.10.*, como modelo para Ranges.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Invalid Request", "Requisi&ccedil;&atilde;o inv&aacute;lida");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Invalid command description.", "Descri&ccedil;&atilde;o de comando inv&aacute;lida.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Invalid command line.", "Linha de comando inv&aacute;lida");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Invalid command", "Comando inv&aacute;lido");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Invalid e-mail", "E-mail inv&aacute;lido");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Invalid group name", "Nome do grupo inv&aacute;lido");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Invalid host", "Host inv&aacute;lido");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Invalid hostname", "Nome de host inv&aacute;lido");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Invalid language selected", "L&iacute;ngua selecionada inv&aacute;lida");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Invalid license expire time", "Um erro ocorreu ao verificar validade de sua licen&ccedil;a");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Invalid license file extension", "Extens&atilde;o do arquivo de licen&ccedil;a &eacute; inv&aacute;lida. Requer .txt");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Invalid name", "Nome inv&aacute;lido");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Invalid parameters received. We need fields from, to and relay for send mail test.", "Par&acirc;metros inv&aacute;lidos recebidos. N&oacute;s precisamos dos campos \"from\", \"to\" e \"relay\" para o teste de envio de e-mail.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Invalid password", "Senha inv&aacute;lida");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Invalid team name", "Nome de grupo de contatos inv&aacute;lido");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Invalid user type", "Tipo de contato inv&aacute;lido");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Invalid user", "Contato inv&aacute;lido!");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Invalid username", "Nome de contato inv&aacute;lido");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Ips and Ranges to be processed", "IPs e Ranges a processar");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Ips to be processed", "IPs a serem processados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "JSON not found", "Imposs&iacute;vel interpretar json");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Jan", "Jan");
INSERT INTO languages VALUES ("pt_BR_ITIL", "January", "Janeiro");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Jelp", "Ajuda");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Jul", "Jul");
INSERT INTO languages VALUES ("pt_BR_ITIL", "July", "Julho");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Jun", "Jun");
INSERT INTO languages VALUES ("pt_BR_ITIL", "June", "Junho");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Key Availability Indicators", "Indicadores chave de disponibilidade");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Key Performance Indicators", "Indicadores chave de performance");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Key Users", "Usu&aacute;rios Chave");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Kind of source of metrics", "Tipo da origem das m&eacute;tricas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Knowledge Base Link", "http://kb.opservices.com.br");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Label", "R&oacute;tulo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Language", "Portugues Brasil - OpMon");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Last 24 hours", "&Uacute;ltimas 24 horas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Last 31 days", "&Uacute;ltimos 31 dias");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Last 7 days", "&Uacute;ltimos 7 dias");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Last Check Header", "&Uacute;lt. Chec.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Last Check", "&Uacute;ltima Checagem");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Last Page", "&Uacute;ltima P&aacute;gina");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Last Update", "&Uacute;ltima atualiza&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Last Value", "&Uacute;ltimo valor");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Last collect", "&Uacute;ltima coleta");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Last hour", "&Uacute;ltima hora");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Last month", "&Uacute;ltimo m&ecirc;s");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Last notification", "&Uacute;ltima notifica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Last page", "&Uacute;ltima p&aacute;gina");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Last review", "&Uacute;ltima revis&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Last state change", "&Uacute;ltima altera&ccedil;&atilde;o de estado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Last update", "&Uacute;ltima atualiza&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Last week", "&Uacute;ltima semana");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Last year", "&Uacute;ltimo ano");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Last", "&Uacute;ltimo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Last...", "&Uacute;ltimos...");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Latency", "Lat&ecirc;ncia");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Layout", "Layout");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Learn more about OpMon", "Saiba mais sobre o OpMon");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Legend", "Legenda");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Level", "N&iacute;vel");
INSERT INTO languages VALUES ("pt_BR_ITIL", "License Type", "Tipo de Licen&ccedil;a");
INSERT INTO languages VALUES ("pt_BR_ITIL", "License details", "Detalhes da licen&ccedil;a");
INSERT INTO languages VALUES ("pt_BR_ITIL", "License file updated successfully", "Licen&ccedil;a atualizada com sucesso.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "License is expired", "A licen&ccedil;a est&aacute; expirada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "License limit reached", "Limite de licen&ccedil;a atingido");
INSERT INTO languages VALUES ("pt_BR_ITIL", "License", "Licen&ccedil;a");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Licensed Dashboards", "Dashboards Licenciados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Licensed Hosts", "Hosts Licenciados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Licensed Services", "Servi&ccedil;os Licenciados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Licensed", "Licenciados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "List SLA Description", "Contrato celebrado entre prestadores de servi&ccedil;o e cliente, definindo os n&iacute;veis aceit&aacute;veis ou n&atilde;o de servi&ccedil;o.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "List SLA(Service Level Agreement)", "Listar SLA(Service Level Agreement)");
INSERT INTO languages VALUES ("pt_BR_ITIL", "List of Communities", "Lista de Comunidades");
INSERT INTO languages VALUES ("pt_BR_ITIL", "List", "Listar");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Loading Models...", "Carregando Modelos...");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Loading interface", "Carregando interface...");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Loading items...", "Carregando items...");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Loading language array", "Carregando linguagem...");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Loading objects", "Carregando objetos...");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Loading user's profile", "Carregando o perfil do usu&aacute;rio...");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Loading", "Carregando");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Log", "Log");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Login", "Entrar");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Logo upload", "Troca de logo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Logout", "Logout");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Lower limit", "Limite inferior");
INSERT INTO languages VALUES ("pt_BR_ITIL", "MTBF", "TMEF");
INSERT INTO languages VALUES ("pt_BR_ITIL", "MTTF", "TMPF");
INSERT INTO languages VALUES ("pt_BR_ITIL", "MTTR", "TMPR");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Make sure you have enabled your probe's netflow correctly.", "Verifique se voc&ecirc; habilitou o netflow de seus coletores corretamente.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Manage in real time the selected items", "Gerenciar, em tempo real, os itens selecionados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Management commands", "Comandos gerenciais");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Management", "Gerenciamento");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Manages the network topology with the elements", "Gere a topologia da rede com os elementos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Maps", "Mapas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Mar", "Mar");
INSERT INTO languages VALUES ("pt_BR_ITIL", "March", "Mar&ccedil;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Max", "M&aacute;x");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Maximize view", "Maximize view");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Maximum Attempts", "N&ordm; m&aacute;ximo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Maximum Check Attempts", "N&ordm; m&aacute;ximo de tentativas de checagem");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Maximum", "M&aacute;ximo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "May", "Mai");
INSERT INTO languages VALUES ("pt_BR_ITIL", "May", "Maio");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Menu_Custom", "Customizados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Method", "M&eacute;todo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Metric Aggregated", "M&eacute;tricas agregadas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Metric", "M&eacute;trica");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Metrics Available", "M&eacute;tricas dispon&iacute;veis");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Metrics associated with baseline", "M&eacute;tricas associadas &agrave; baseline");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Metrics available", "M&eacute;tricas dispon&iacute;veis");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Metrics", "M&eacute;trica");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Metrics", "M&eacute;tricas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Min", "Min");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Minimum", "M&iacute;nimo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Mobile", "Celular");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Model Groups", "Grupos de modelos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Model name", "Nome do modelo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Model", "Modelo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Module not installed. Contact your system administrator.", "M&oacute;dulo n&atilde;o est&aacute; instalado. Contate o administrador do sistema.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Module", "M&oacute;dulo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Monday", "Segunda-feira");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Monitor selected", "Monitorar selecionados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Monitored with new services", "Monitorado com novos servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Monitored", "Monitorado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Monitoring problems", "Configura&ccedil;&atilde;o da monitora&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Monitoring state", "Estado de monitora&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Monitoring without a model", "Monitorar sem modelo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Monitoring without model", "Monitorar sem modelo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Monitoring", "Monitora&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Month day", "Dia do m&ecircs");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Month", "M&ecirc;s");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Monthly", "Mensal");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Months", "Meses");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Move down", "Move para baixo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Move up", "Move para cima");
INSERT INTO languages VALUES ("pt_BR_ITIL", "MsgNoUserDefined", "(Nenhum usu&aacute;rio definido)");
INSERT INTO languages VALUES ("pt_BR_ITIL", "My Dashboards", "Meus Dashboards");
INSERT INTO languages VALUES ("pt_BR_ITIL", "N/D", "N/A");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Name", "Nome");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Network Range", "Range de Rede");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Network Utilization", "Utiliza&ccedil;&atilde;o&nbsp;de&nbsp;rede");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Network configuration", "Configura&ccedil;&otilde;es de rede");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Network", "Rede");
INSERT INTO languages VALUES ("pt_BR_ITIL", "New IP / Range not added", "Novo IP/Range n&atilde;o adicionado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "New IP or Range", "Novo IP ou Range");
INSERT INTO languages VALUES ("pt_BR_ITIL", "New IP or added range", "Novo IP ou range adicionado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "New Password", "Senha Nova");
INSERT INTO languages VALUES ("pt_BR_ITIL", "New baseline", "Nova baseline");
INSERT INTO languages VALUES ("pt_BR_ITIL", "New entries", "Cadastros");
INSERT INTO languages VALUES ("pt_BR_ITIL", "New entry", "Cadastrar");
INSERT INTO languages VALUES ("pt_BR_ITIL", "New host group", "Novo grupo de host");
INSERT INTO languages VALUES ("pt_BR_ITIL", "New host", "Novo host");
INSERT INTO languages VALUES ("pt_BR_ITIL", "New host(s) created", "Novo(s) host(s) criado(s)");
INSERT INTO languages VALUES ("pt_BR_ITIL", "New package", "Pacote novo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "New passowrd doesn't match", "Nova senha n&atilde confere!");
INSERT INTO languages VALUES ("pt_BR_ITIL", "New report", "Novo relat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR_ITIL", "New service group", "Novo grupo de servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "New service(s) configured", "Novo(s) servi&ccedil;o(s) configurado(s)");
INSERT INTO languages VALUES ("pt_BR_ITIL", "New shortcut", "Novo atalho");
INSERT INTO languages VALUES ("pt_BR_ITIL", "New team", "Novo grupo de contatos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "New user", "Novo contato");
INSERT INTO languages VALUES ("pt_BR_ITIL", "New version available", "Nova vers&atilde;o dispon&iacute;vel");
INSERT INTO languages VALUES ("pt_BR_ITIL", "New", "Novo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Next Page", "P&aacute;gina Seguinte");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Next check Header", "Pr&oacute;x. Chec.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Next check", "Pr&oacute;xima Checagem");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Next page", "Pr&oacute;xima p&aacute;gina");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Next", "Avan&ccedil;ar");
INSERT INTO languages VALUES ("pt_BR_ITIL", "No Data", "Sem Dados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "No IPs or ranges to be processed", "N&atilde;o h&aacute; IPs ou ranges a serem processados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "No SNMP community added", "N&atilde;o h&aacute; comunidade SNMP adicionada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "No bookmark found", "Nenhum favorito encontrado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "No data available", "Sem dados dispon&iacute;veis");
INSERT INTO languages VALUES ("pt_BR_ITIL", "No data found, please, check SNMP authentications", "Dados n&atilde;o foram encontrados, por favor, verifique suas autentica&ccedil;&otilde;es SNMP.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "No data", "Sem dados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "No has any service", "N&atilde;o existe nenhum servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "No incidents at this moment", "Nenhum incidente neste momento");
INSERT INTO languages VALUES ("pt_BR_ITIL", "No model found", "Nenhum modelo encontrado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "No notifications available", "Sem notifica&ccedil;&otilde;es dispon&iacute;veis");
INSERT INTO languages VALUES ("pt_BR_ITIL", "No selected template", "Nenhum template selecionado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "No template template", "Nenhum template selecionado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "No window", "Sem janela definida");
INSERT INTO languages VALUES ("pt_BR_ITIL", "No", "N&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "No. metrics", "N&ordm; de m&eacute;tricas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "NoElementsSelectedMsg", "Voc&ecirc; deve selecionar pelo menos um objeto para executar esta a&ccedil;&atilde;o!");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Non work", "N&atilde;o &uacute;til");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Not helpful", "N&atilde;o &uacute;til");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Not monitored", "N&atilde;o monitorado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Not saved report", "Relat&oacute;rio n&atilde;o salvo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Note URL", "URL de anota&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Nothing to do.", "Nada a ser feito.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Notification enabled", "Notifica&ccedil;&atilde;o habilitada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Notification interval", "Intervalo de notifica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Notification period", "Per&iacute;odo de notifica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Notification", "Notifica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Notifications Totals", "Totaliza&ccedil;&atilde;o das notifica&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Notifications disabled", "Notifica&ccedil;&otilde;es desabilitadas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Notifications enabled", "Notifica&ccedil;&otilde;es habilitadas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Notifications", "Notifica&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Nov", "Nov");
INSERT INTO languages VALUES ("pt_BR_ITIL", "November", "Novembro");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OEM", "OEM");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OK", "OK");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OK, I got it", "Ok entendi");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OK, I understood.", "OK, entendi.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OK, I'm ready.", "OK, estou pronto.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "ONC", "ONC");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OPCFG_Advanced", "Advanced");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OPCFG_Alerting", "Alerting");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OPCFG_CGIConfig", "CGI Config");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OPCFG_Commands", "Commands");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OPCFG_ContactGroups", "Contact Groups");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OPCFG_Contacts", "Contacts");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OPCFG_Discovery", "Discovery");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OPCFG_DiscoveryCommunities", "SNMP Communities");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OPCFG_DiscoveryImport", "Import Objects");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OPCFG_DiscoveryImportedElements", "Imported objects");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OPCFG_Export", "Export");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OPCFG_Extras", "Extras");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OPCFG_HostGroups", "Host Groups");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OPCFG_Hosts", "Hosts");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OPCFG_MainConfig", "Main Config");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OPCFG_Monitoring", "Monitoring");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OPCFG_PortScan", "Object Import");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OPCFG_Resources", "Resources");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OPCFG_SNMPDiscovery", "SNMP Discovery");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OPCFG_ServiceGroups", "Service Groups");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OPCFG_TITLE", "Configuration Utility");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OPCFG_Templates", "Templates");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OPCFG_TimePeriods", "Time Periods");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OPCFG_Tools", "Tools");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OPCFG_Topology", "Topologia");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OPDOCS", "Documenta&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OPTRAFFIC", "Traffic Analyzer");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OPVIEW", "Dashboards");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OPVIEWREMOTE", "Acesso Webservices do Dashboard");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OS", "SO");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OTRS", "Integra&ccedil;&atilde;o com OTRS");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Object not found", "Objeto n&atilde;o encontrado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Object", "Objeto");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Objects Available", "Objetos dispon&iacute;veis");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Objects Selected", "Objetos selecionados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Objects Spreadsheet", "Planilha de Objetos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "ObjectsLoadingMsg", "Carregando objetos. Por favor, aguarde...");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Obsess check", "Checagem obsessiva");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Obsess checks disabled", "Checagens obsessivas desabilitadas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Obsess checks enabled", "Checagens obsessivas habilitadas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Oct", "Out");
INSERT INTO languages VALUES ("pt_BR_ITIL", "October", "Outubro");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Offset", "Desvio");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Old Password", "Senha Antiga");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Once", "Apenas uma vez");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Only Lines", "Somente Linhas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Only acks", "Somente reconhecidos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Only disabled", "Somente desabilitada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Only downtimes", "Somenete manuten&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Only enabled", "Somente habilitada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Only hard state", "Somente hard state");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Only hosts", "Somente ICs");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Only one time", "Apenas esta vez");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Only services", "Somente Atributos de IC");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Only soft state", "Somente soft state");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Only unmonitored hosts discovered by OpMon are listed", "Est&atilde;o listados apenas os ICs n&atilde;o monitorados descobertos pelo OpMon");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Only view report", "Somente ver relat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Only with", "Somente com");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Only without", "Somente sem");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OpDiscovery", "OpDiscovery");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OpLogs", "OpLogs");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OpMon Deamon is stopped", "Processo OpMon parado!");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OpMon Traffic Analyzer Light", "OpMon Traffic Analyzer Light");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OpMon in maintenance", "OpMon em manuten&ccedil;&atilde;o!");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OpMon initial setup", "Configura&ccedil;&atilde;o inicial do OpMon");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OpMon", "OpMon");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OpMonExceededMsg", "OpMon com atraso no monitoramento.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "OpTraps", "OpTraps");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Open a saved baseline ...", "Open a saved baseline...");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Open a saved report", "Abrir um relat&oacute;rio salvo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Operation succeeded", "Opera&ccedil;&atilde;o realizada com sucesso");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Operational commands", "Comandos operacionais");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Operational system", "Sistema operacional");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Operator", "Operador");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Opmonadmin", "Opmonadmin");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Origin of metrics", "Origem das m&eacute;tricas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Other", "Outros");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Others", "Outros");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Output", "Sa&iacute;da");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Overview", "Resumo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Overwrite all", "Sobrescrever todos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Overwrite current hosts settings", "Sobrescrever configura&ccedil;&otilde;es atuais de hosts");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Overwrite default", "Sobrescrever padr&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Package manager", "Gerenciador de pacotes");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Package uninstalled successfuly", "Pacote deinstalado com sucesso");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Package uploaded successfuly", "Pacote enviado com sucesso");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Packages installed successfuly", "Pacotes instalados com sucesso");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Packet", "Pacote");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Page", "P&aacute;gina");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Parameters", "Par&acirc;metros");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Passive check", "Checagem passiva");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Passive checks disabled", "Checagens passivas desabilitadas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Passive checks enabled", "Checagens passivas habilitadas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Passive", "Passiva");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Password change", "Troca de senha");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Password updated successfully", "Senha atualizada com sucesso!");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Password", "Senha");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Passwords does not match", "Senhas diferentes");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Pendings", "Pendentes");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Perc95", "Perc95");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Percent change", "Percentual de mudan&ccedil;a");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Performance data", "Dados de performance");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Performance", "Performance");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Period check invalid", "Per&iacute;odo de checagem inv&aacute;lido");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Period check", "Per&iacute;odo de checagem");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Period variation", "Varia&ccedil;&atilde;o per&iacute;odo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Period", "Per&iacute;odo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Permission Denied Description", "Voc&ecirc; <strong>n&atilde;o</strong> possui permiss&atilde;o para acessar esta p&aacute;gina.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Permission Denied", "Acesso Restrito");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Permission denied", "Permiss&atilde;o negada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Persistent comment", "Coment&aacute;rio persistente");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Persistent", "Persistente");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Ping", "Ping");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Planned Downtimes", "Manuten&ccedil;&otilde;es planejadas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Planned", "Planejada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Please contact your administrator", "<strong>Contate seu administrador</strong>");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Please enter a new report name", "Por favor, indique um novo nome de relat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Please select a command", "Por favor, selecione um comando");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Please select a host already discovered", "Por favor, selecione um host j&aacute; descoberto");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Please select a host to be tested", "Por favor, selecione um host para usar no teste");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Please wait", "Por favor, aguarde.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Please wait. Uploading your file...", "Aguarde. Enviando seu arquivo...");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Port", "Porta");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Ports", "Portas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Portscan", "Portscan");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Previous Page", "P&aacute;gina Anterior");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Previous page", "P&aacute;gina anterior");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Privacy", "Privacidade");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Problem uploading your report", "Problema ao enviar seu relat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Problems", "Problemas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Proceed with this element removal?", "Confirmar remo&ccedil;&atilde;o deste elemento?");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Process canceled successfully", "Processo cancelado com sucesso");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Process", "Processo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Processes", "Processos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Product", "Produto");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Property", "Propriedade");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Protocol", "Protocolo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Put the license below", "Insira a licen&ccedil;a abaixo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "QUALITOR", "Integra&ccedil;&atilde;o com Qualitor");
INSERT INTO languages VALUES ("pt_BR_ITIL", "RSCHED", "Agendador de Relat&oacute;rios");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Range check", "Intervalo de checagem");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Reached", "Atingido");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Realtime graph", "Gr&aacute;fico em tempo real");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Receive host's notification?", "Recebe notifica&ccedil;&otilde;es de ICs?");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Receive service's notification?", "Recebe notifica&ccedil;&otilde;es de Atributos de ICs");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Received bytes", "Bytes recebidos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Received kbps", "Recebido(kbps)");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Receiving network traffic on ports", "Recebendo tr&aacute;fego de rede nas portas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Recheck", "Verificar novamente");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Recommended hosts for the model", "ICs recomendados para o modelo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Recovery", "Recuperado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Redirecting to discovery", "Redirecionando para a descoberta");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Refresh list", "Atualizar listagem");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Refresh", "Atualizar");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Register a new authentication", "Cadastrar uma nova autentica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Register and associate ports, applications and protocols", "Registre e associe as portas, aplica&ccedil;&otilde;es e protocolos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Register new authentication", "Cadastrar nova autentica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Registered Authentications", "Autentica&ccedil;&otilde;es Cadastradas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Registering changes", "Registrando altera&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Remember me", "Lembrar dados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Remove Host (s) ?", "Remover o(s) host(s)?");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Remove Item", "Remover Item");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Remove Timecut", "Excluir Corte de tempo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Remove a downtime", "Remover manuten&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Remove acknowledgement for this incident", "Remover reconhecimento para este incidente");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Remove acknowledgement", "Remover reconhecimento de incidente");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Remove all actions of Hosts", "Remover todas a&ccedil;&otilde;es dos ICs");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Remove all actions of Services", "Remover todas a&ccedil;&otilde;es dos AICs");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Remove all comments", "Remover todos os coment&aacute;rios");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Remove all host comments", "Remover todos os coment&aacute;rios deste IC");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Remove all scheduled downtimes of the Hosts", "Remover todas as manuten&ccedil;&otilde;es agendadas dos ICs");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Remove all scheduled downtimes of the Services", "Remover todas as manuten&ccedil;&otilde;es agendadas dos AICs");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Remove bookmark", "Remove favorito");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Remove current report", "Remover relat&oacute;rio atual");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Remove host", "Remover IC");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Remove report", "Remover relat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Remove selected elements", "Remover elementos selecionados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Remove service (s) ?", "Remover o(s) servi&ccedil;o(s)?");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Remove service", "Remover AIC");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Remove this comment", "Remover este coment&aacute;rio");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Remove this scheduled downtime", "Remover/cancelar esta manuten&ccedil;&atilde;o agendada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Remove", "Remover");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Removed successfully", "Removido com sucesso");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Rename service", "Renomear servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Rename", "Renomear");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Repeat New Password", "Repetir Senha Nova");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Repeat email", "Repita o e-mail");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Repeat selected hours", "Repetir hor&aacute;rios selecionados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Repeat the password", "Repita a senha");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Report Scheduler", "Agendador de relat&oacute;rios");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Report by e-mail", "Relat&oacute;rio por e-mail");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Report configuration", "Configura&ccedil;&atilde;o do relat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Report objects", "Objetos do relat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Report removed successfully", "Relat&oacute;rio removido com sucesso");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Report scheduled", "Relat&oacute;rio agendado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Reports", "Relat&oacute;rios");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Requeriments", "Requerimentos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Request Error", "Erro na requisi&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "RequestErrorMsg", "Ocorreu um erro ao tentar processar esta requisi&ccedil;&atilde;o. Por favor, atualize a p&aacute;gina.<br>Se o problema persistir, entre em contato com o administrador do sistema.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Requesting information for %COUNT%.", "Requisitando informa&ccedil;&otilde;es para %COUNT%.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Reschedule next check", "Reagendar pr&oacute;xima checagem");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Reschedule next host check", "Reagendar pr&oacute;xima checagem do IC");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Reset Done", "Reset efetuado com sucesso");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Resolve conflict", "Resolver conflito");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Resolve conflict", "Resolver conflitos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Responsible users", "Usu&aacute;rios Respons&aacute;veis");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Responsible", "Respons&aacute;vel");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Restarting OpMon Traffic Analyzer process...", "Reiniciando o processo do OpMon Traffic Analyzer...");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Restore default OpMon logo", "Restaurar logo original");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Restore default", "Restaurar padr&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Restore values", "Restaurar valores");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Retrieving discovered objects", "Obtendo os dispositivos encontrados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Retry Interval", "Intervalo de rechecagem");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Retry check interval", "Intervalo de rechecagem");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Retry interval", "Rechecagem");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Retry", "Repetir comando");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Return", "Voltar");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Review your configuration", "Revise sua configura&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Run Command?", "Executa Comando?");
INSERT INTO languages VALUES ("pt_BR_ITIL", "SCAT Description", "Aqui voc&ecirc; pode montar a estrutura do servi&ccedil;o fornecido");
INSERT INTO languages VALUES ("pt_BR_ITIL", "SCAT", "Servi&ccedil;os ITIL");
INSERT INTO languages VALUES ("pt_BR_ITIL", "SCM", "Backup de Switch");
INSERT INTO languages VALUES ("pt_BR_ITIL", "SLA Breach Reason Start", "INÍCIO DE JUSTIFICATIVA");
INSERT INTO languages VALUES ("pt_BR_ITIL", "SLA Breach Reason Stop", "FIM DE JUSTIFICATIVA");
INSERT INTO languages VALUES ("pt_BR_ITIL", "SLA Breach Reason", "Justificativa de SLA");
INSERT INTO languages VALUES ("pt_BR_ITIL", "SLA Breach Reasons as OK", "SLAs justificados como OK");
INSERT INTO languages VALUES ("pt_BR_ITIL", "SLA Breach Reasons", "Justificativas de SLA");
INSERT INTO languages VALUES ("pt_BR_ITIL", "SLA Breach", "Quebra de SLA");
INSERT INTO languages VALUES ("pt_BR_ITIL", "SLA Description", "Contrato celebrado entre prestadores de servi&ccedil;o e cliente, definindo os n&iacute;veis aceit&aacute;veis ou n&atilde;o de servi&ccedil;o.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "SLA For Catalog", "SLA para servi&ccedil;o do Cat&aacute;logo de Servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR_ITIL", "SLA", "SLA");
INSERT INTO languages VALUES ("pt_BR_ITIL", "SLA(Service Level Agreement)", "SLA(Service Level Agreement)");
INSERT INTO languages VALUES ("pt_BR_ITIL", "SLM", "SLM");
INSERT INTO languages VALUES ("pt_BR_ITIL", "SLM_License", "Gerenciamento de Nivel de Servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "SNMP Communities", "Comunidades SNMP");
INSERT INTO languages VALUES ("pt_BR_ITIL", "SNMP Version", "Vers&atilde;o SNMP");
INSERT INTO languages VALUES ("pt_BR_ITIL", "SOAP", "Soap API");
INSERT INTO languages VALUES ("pt_BR_ITIL", "SOFT", "SOFT");
INSERT INTO languages VALUES ("pt_BR_ITIL", "SUMALERT", "Sum&aacute;rio de Alertas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Sample collected", "Amostra coletada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Saturday", "S&aacute;bado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Savar baseline", "Savar baseline");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Save Changes", "Salvar altera&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Save Settings", "Salvar defini&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Save Timecut", "Salvar Corte de tempo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Save as ...", "Save as...");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Save as", "Salvar como");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Save changes", "Salvar altera&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Save created command", "Salvar comando criado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Save report", "Salvar relat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Save the Report", "Salvar o relat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Save this report", "Salvar este relat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Save", "Salvar");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Saving Changes", "Salvando altera&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Scan finished!", "Escaneamento finalizado!");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Scanning network", "Escaneando rede");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Scanning", "Escaneando");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Sched. Downtime", "Manuten&ccedil;&atilde;o Ag.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Schedule a downtime for all hosts", "Agendar manuten&ccedil;&atilde;o para todos ICs");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Schedule a downtime for all services", "Agendar manuten&ccedil;&atilde;o para todos Atributos de IC");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Schedule a downtime", "Agendar manuten&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Schedule a non programmed downtime", "Agendar manuten&ccedil;&atilde;o n&atilde;o-programada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Schedule a programmed downtime", "Agendar manuten&ccedil;&atilde;o programada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Schedule check for all services", "Agendar checagem para todos os Atributos de IC");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Schedule report", "Agendar relat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Scheduled Downtime Begin", "Inicio de Manuten&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Scheduled Downtime End", "Fim de Manuten&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Scheduled as OK", "Agendadas como OK");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Scheduled checks queue", "Fila de checagens agendadas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Scheduled downtime", "Manuten&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Scheduled downtimes", "Manuten&ccedil;&otilde;es programadas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Scheduled queue", "Fila de agendamentos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Scheduled", "Agendados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Scheduler", "Agendamento");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Search for specific elements", "Fa&ccedil;a buscas por elementos espec&iacute;ficos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Search", "Busca");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Searching for sources of network traffic", "Buscando fontes de tr&aacute;fego na rede");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Security", "Seguran&ccedil;a");
INSERT INTO languages VALUES ("pt_BR_ITIL", "See Ips and Ranges to be processed", "Ver IPs e Ranges a processar");
INSERT INTO languages VALUES ("pt_BR_ITIL", "See metrics", "Ver m&eacute;tricas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select Template", "Selecionar template");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select a CI", "Selecione um IC");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select a command", "Selecione um comando");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select a contactgroup", "Selecione grupo(s) de contatos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select a contacts", "Selecione contato(s)");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select a custom report", "Selecione um relat&oacute;rio personalizado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select a host already discovered", "Selecionar um host j&aacute; descoberto");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select a host", "Selecione um host");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select a method for group by", "Selecione um m&eacute;todo de agrupamento");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select a report first", "Selecione um relat&oacute;rio primeiramente");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select a servicegroup", "Selecione grupo(s) de servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select a timecut", "Selecione um corte de tempo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select all elements", "Selecionar todos elementos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select an available command", "Selecione um comando dispon&iacute;vel");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select an object type", "Selecione um tipo de objeto");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select an output type", "Selecione um tipo de sa&iacute;da");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select and configure the elements you want to monitor", "Selecione e configure os elementos que deseja monitorar");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select column", "Selecionar coluna");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select desired objects", "Selecione os objetos desejados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select models", "Criar servi&ccedil;o atrav&eacute;s de um modelo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select objects", "Selecionar objetos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select one or more exist metrics on your system to apply the baseline.", "Selecione uma ou mais m&eacute;tricas existentes em seu sistema para aplicar a baseline.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select one or more hosts to apply the model", "Selecione um ou mais hosts para aplicar o modelo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select or search an external command", "Selecione ou busque um comando externo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select package for upload", "Selecione um pacote para upload");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select packages for installation", "Selecione pacotes para a instala&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select period", "Escolha um per&iacute;odo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select saved report", "Selecione relat&oacute;rio salvo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select service", "Selecionar servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select services", "Selecione os servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select the Report Objects", "Selecione os objetos do relat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select the contact", "Selecione o contato");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select the element", "Selecione o elemento");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select the group", "Selecione o grupo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select the host", "Selecione o IC");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select the hosts that receive the service", "Selecione os hosts que receber&atilde;o o servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select the hosts", "Selecione os hosts");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select the probes you want to monitor", "Selecione as probes que voc&ecirc; deseja monitorar");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select the service and its parameters", "Selecione os servi&ccedil;os e seus par&acirc;metros");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select the services to monitor and set its parameters", "Selecione os servi&ccedil;os e defina os par&acirc;metros");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select the source host", "Selecione o host de origem");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select the templates you want to apply to hosts in the editing", "Selecione os templates que deseja aplicar aos hosts em edi&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select the type of the element", "Selecione o tipo do elemento");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select timecut", "Selecione corte de tempo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Selected objects", "Objetos selecionados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Selected", "Selecionado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Send by e-mail for {0} contact(s)", "Enviar por e-mail para {0} contato(s)");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Send by e-mail for", "Enviar por e-mail para");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Send custom notification", "Enviar notifica&ccedil;&atilde;o customizada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Send notification", "Enviar notifica&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Send passive check result", "Enviar resultado de checagem passiva");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Send report by e-mail", "Enviar relat&oacute;rio por e-mail");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Send result", "Enviar resultado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Send", "Enviar");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Sent bytes", "Bytes enviados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Sent kbps", "Enviado(kbps)");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Sep", "Set");
INSERT INTO languages VALUES ("pt_BR_ITIL", "September", "Setembro");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Service Grid", "Listagem de Atributos de ICs");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Service Group", "Grupo de Atributos de ICs");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Service Groups", "Grupos de Servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Service Groups", "Grupos de Servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Service Name", "Nome do Servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Service Name", "Nome do servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Service Structure", "Estrutura do Servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Service description invalid", "Descri&ccedil;&atilde;o de servi&ccedil;o inv&aacute;lida");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Service description", "Descri&ccedil;&atilde;o do servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Service groups", "Grupos de servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Service is not selected", "Servi&ccedil;o n&atilde;o selecionado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Service origin of new metrics", "Servi&ccedil;o origem das novas m&eacute;tricas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Service status", "Status dos Atributos de IC");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Service successfully updated", "Servi&ccedil;o atualizado com sucesso");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Service", "Atributo de IC");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Service", "Servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Service(s) with conflict", "Servi&ccedil;o(s) com conflito");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Servicegroup Grid", "Listagem de Grupo de Atributos de ICs");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Servicegroup origin of new metrics", "Servicegroup origem das novas m&eacute;tricas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Servicegroup", "Grupo de Atributos de IC");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Services Catalog", "Cat&aacute;logos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Services and Contacts", "Atributos de IC e Contatos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Services of ", "Servi&ccedil;os do modelo ");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Services template", "Servi&ccedil;os do template");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Services with ack", "Atributos de IC com a&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Services", "Atributos de IC");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Services", "Servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Set Teams and Responsibles for hosts", "Defina contatos e grupos de contato para os hosts");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Set contacts and contactgroups for services", "Defina contatos e grupos de contato para os servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Set email and password to start or %link%click here%endlink% for help", "Definir e-mail e senha para iniciar ou %link%clique aqui%endlink% para obter ajuda");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Set password and email", "Defina a senha e o e-mail");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Set the Community parameters", "Definir os par&acirc;metros da Comunidade");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Set the administrator password", "Definir senha do administrador");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Set the arguments of the selected command", "Defina os argumentos do comando selecionado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Set the description", "Defina a descri&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Set the e- mail", "Defina o e-mail");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Set the group parameters", "Defina os par&acirc;metros do grupo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Set the host IP", "Defina o IP do host");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Set the hostname", "Defina o nome do host");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Set the parameters of group", "Defina os par&acirc;metros do grupo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Set the parameters of the command", "Defina os par&acirc;metros do comando");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Set the parameters of the host", "Definir os par&acirc;metros do host");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Set the parameters of the service", "Definir os par&acirc;metros do servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Set the parameters of the team", "Defina os par&acirc;metros do grupo de contatos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Set the password of the administrator user and email", "Defina a senha o e email do usu&aacute;rio administrador");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Set the password", "Defina a senha");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Set the services parameters", "Defina os par&acirc;metros dos servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Set the source host to be added", "Defina a origem do host a ser adicionado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Setting behavior", "Configura&ccedil;&atilde;o do comportamento");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Settings saved successfully", "Configura&ccedil;&otilde;es salvas com sucesso");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Settings", "Configura&ccedil;&otilde;es");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Setup finished!", "Configura&ccedil;&atilde;o conclu&iacute;da!");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Share", "Compartilhar");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Shortcuts", "Atalhos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Show alarms", "Mostrar alarmes");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Show details", "Mostrar detalhes");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Show errors", "Mostrar erros");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Show only", "Mostrar somente");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Show thresholds", "Mostrar thresholds");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Simple Service Level Agreement Report", "An&aacute;lise de n&iacute;vel de servi&ccedil;o - Simples");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Simple", "Simplificado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Size of the collected sample", "Tamanho da amostra coletada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Skip", "Pular");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Soft State", "Soft State");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Some changes on OpMon configuration are being applied, this can time some time.", "Mudan&ccedil;as na configura&ccedil;&atilde;o do OpMon &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; est&atilde;o sendo aplicadas.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Some of your services belong to a template, unable to remove them", "Alguns servi&ccedil;os selecionados pertecem a um template e n&atilde;o podem ser removidos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Special calendar", "Calend&aacute;rio");
INSERT INTO languages VALUES ("pt_BR_ITIL", "SplashScreenMsg", "Obrigado por utilizar OpMon, uma plataforma completa para Governan&ccedil;a de TI, Monitora&ccedil;&atilde;o dos Processos de Neg&oacute;cio e Gerenciamento de Redes e Sistemas.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Start Scan", "Iniciar Escaneamento");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Start date", "Data inicial");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Start discovery", "Iniciar descoberta");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Start new Discovery", "Iniciar nova descoberta");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Start selection", "Iniciar sele&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Start setting your report here", "Comece definindo o seu relat&oacute;rio aqui");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Start setup", "Iniciar a configura&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Start the configuration!", "Iniciar a configura&ccedil;&atilde;o!");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Start time", "Hora inicial");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Start", "In&iacute;cio");
INSERT INTO languages VALUES ("pt_BR_ITIL", "State Type", "Tipo de Estado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "State type", "Tipo de estado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "State", "Estado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Status Overview", "Resumo dos Estados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Status Totals", "Totaliza&ccedil;&atilde;o de status");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Status", "Estado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Step 1 of 4", "Passo 1 de 4");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Step 1", "Passo 1");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Step 2 of 4", "Passo 2 de 4");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Step 2", "Passo 2");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Step 3 of 4", "Passo 3 de 4");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Step 3", "Passo 3");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Step 4 of 4", "Passo 4 de 4");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Stop setting. I want to leave it for later.", "Pare a configura&ccedil;&atilde;o. Quero deixar para depois.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Stop", "Parar");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Stopped since", "Daemon OpMon parado desde ");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Storage error", "Erro de armazenamento");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Submit", "Enviar");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Submiting command, please wait", "Submetendo comando, por favor aguarde");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Subscribe", "Cadastros");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Success log", "Log de Sucesso");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Success", "Sucesso");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Suggested categories", "Categorias sugeridas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Suggested models", "Modelos sugeridos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Sum", "Soma");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Summary view", "Vis&atilde;o de Resumo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Sunday", "Domingo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Support", "Suporte");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Syntax error on line:", "Erro de sintaxe na linha:");
INSERT INTO languages VALUES ("pt_BR_ITIL", "System", "Sistema");
INSERT INTO languages VALUES ("pt_BR_ITIL", "THEMES", "Temas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "TOPOLOGY", "Topologia da Monitora&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Tabular", "Tabular");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Tactical View", "Vis&atilde;o T&aacute;tica");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Tactical Overview", "Vis&atilde;o T&aacute;tica");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Target hosts", "Hosts alvo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Team already contains this user", "Equipe j&aacute; contem este usu&aacute;rio");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Teams Responsible", "Equipes Respons&aacute;veis");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Teams", "Equipes");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Technical Accountable", "Respons&aacute;veis T&eacute;cnicos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Template name", "Nome do template");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Test Command", "Teste de Comando");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Test command", "Testar comando");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Test command", "Teste o comando");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Test result", "Resultado do teste");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Test", "Testar");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Thank you for installing OpMon . Now you can anticipate problems and manage your IT environment and Telecom proactively , before it impact your organization . With only 3 steps you can set the administrator , perform the discovery operation , identify and monitor hosts and services automatically and generate the topology of your network .", "Obrigado por instalar o OpMon. Agora voc&ecirc; poder&aacute; antecipar-se aos problemas e gerenciar o seu ambiente de TI e Telecom de forma proativa, antes que gere impacto para a sua organiza&ccedil;&atilde;o. Com somente 3 passos voc&ecirc; poder&aacute; definir os dados do administrador, executar a opera&ccedil;&atilde;o de descoberta, para identificar e monitorar hosts e servi&ccedil;os automaticamente, e gerar a topologia de sua rede.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "The %COUNT% address does not respond...", "O endere&ccedil;o %COUNT% n&atilde;o responde...");
INSERT INTO languages VALUES ("pt_BR_ITIL", "The %XYZ% module is available only from the PRO version", "O M&oacute;dulo %XYZ% est&aacute; somente dispon&iacute;vel a partir da vers&atilde;o PRO");
INSERT INTO languages VALUES ("pt_BR_ITIL", "The OpMon Traffic Analyzer already has settings for ports, protocols and applications. Changes to these settings will impact the way data is stored and presented.", "O OpMon Traffic Analyzer j&aacute; possui defini&ccedil;&otilde;es para portas, aplica&ccedil;&otilde;es e protocolos. Altera&ccedil;&otilde;es nessas configura&ccedil;&otilde;es impactar&atilde;o no modo como os dados s&atilde;o armazenados e apresentados.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "The OpMon Traffic Analyzer found no source of traffic", "O OpMon Traffic Analyzer n&atilde;o encontrou nenhuma fonte de tr&aacute;fego");
INSERT INTO languages VALUES ("pt_BR_ITIL", "The OpMon Traffic Analyzer is waiting while you set up your sources of network traffic.", "O OpMon Traffic Analyzer est&aacute; aguardando enquanto voc&ecirc; configura suas fontes de tr&aacute;fego de rede.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "The OpMon Traffic Analyzer is waiting", "O OpMon Traffic Analyzer est&aacute; aguardando");
INSERT INTO languages VALUES ("pt_BR_ITIL", "The emails you entered do not match", "Os e-mails digitados n&atilde;o conferem");
INSERT INTO languages VALUES ("pt_BR_ITIL", "The end date and end time must be less than now", "A data e o hor&aacute;rio final devem ser menores que agora");
INSERT INTO languages VALUES ("pt_BR_ITIL", "The following services belong to a template and can't be edited", "Os servi&ccedil;os listados abaixo pertencem a templates e n&atilde;o poder&atilde;o ser editados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "The greatest number allowed for ports is", "O maior valor permitido para portas &eacute;");
INSERT INTO languages VALUES ("pt_BR_ITIL", "The lowest number allowed for ports is", "O menor valor permitido para portas &eacute;");
INSERT INTO languages VALUES ("pt_BR_ITIL", "The passwords entered do not match", "As senhas digitadas n&atilde;o conferem");
INSERT INTO languages VALUES ("pt_BR_ITIL", "The ports must be different.", "As portas devem ser diferentes.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "The selected port is already in use by OpMon Traffic Analyzer.", "A porta selecionada est&aacute; em uso pelo OpMon Traffic Analyzer.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "The selected port is already in use.", "A porta selecionada est&aacute; em uso.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "The settings could not be applied, please try again later", "N&atilde;o foi poss&iacute;vel aplicar as defini&ccedil;&otilde;es. Tente novamente mais tarde");
INSERT INTO languages VALUES ("pt_BR_ITIL", "The start date must be less than the end date.", "A data inicial deve ser menor que a data final.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "The traffic analysis environment is ready for you.", "O ambiente de an&aacute;lise de tr&aacute;fego est&aacute; pronto para voc&ecirc;.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "The version %s are available in our repositories. Click here to see more.", "A vers&atilde;o %s est&aacute; dispon&iacute;vel nos nossos reposit&oacute;rios. Clique aqui para saber mais.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Theme Changed", "Tema alterado com sucesso");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Theme color", "Cor do tema");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Themes", "Temas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "There are any metrics on this service.", "N&atilde;o h&aacute; m&eacute;tricas associadas a este servi&ccedil;o.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "There are no metric available", "N&atilde;o h&aacute; m&eacute;tricas dispon&iacute;veis");
INSERT INTO languages VALUES ("pt_BR_ITIL", "There are no metrics selected yet", "N&atilde;o existem m&eacute;tricas selecionadas ainda");
INSERT INTO languages VALUES ("pt_BR_ITIL", "There has not been any elements discovered yet. %link% in order to start the discovery process.", "Ainda n&atilde;o h&aacute; elementos descobertos para serem adicionados na monitora&ccedil;&atilde;o. %link% para iniciar o processo de descoberta.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "There is no model related to hosts", "N&atilde;o h&aacute; modelos relacionado ao(s) host(s)");
INSERT INTO languages VALUES ("pt_BR_ITIL", "There is no object available", "N&atilde;o h&aacute; nenhum objeto dispon&iacute;vel");
INSERT INTO languages VALUES ("pt_BR_ITIL", "There is no object selected", "N&atilde;o h&aacute; nenhum objeto selecionado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "This authentication cannot be removed because is used by the following hosts", "Esta autentica&ccedil;&atilde;o n&atilde;o pode ser apagada pois est&aacute; em uso pelos seguintes hosts");
INSERT INTO languages VALUES ("pt_BR_ITIL", "This baseline can not be deleted because it is associated with [number of metrics available] metrics.", "Esta baseline n&atilde;o pode ser apagada pois est&aacute; associada a [n&uacute;mero de m&eacute;tricas associadas] m&eacute;tricas.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "This baseline serves to test the interface", "Esta baseline serve para testar a interface");
INSERT INTO languages VALUES ("pt_BR_ITIL", "This field is mandatory", "Este campo &eacute; de preenchimento obrigat&oacute;rio");
INSERT INTO languages VALUES ("pt_BR_ITIL", "This hour", "Esta hora");
INSERT INTO languages VALUES ("pt_BR_ITIL", "This is a system element and can't be removed!", "Este &eacute; um elemento do sistema e n&atilde;o pode ser removido!");
INSERT INTO languages VALUES ("pt_BR_ITIL", "This item dont have performance data", "Este item n&atilde;o possui dados de performance");
INSERT INTO languages VALUES ("pt_BR_ITIL", "This month", "Este m&ecirc;s");
INSERT INTO languages VALUES ("pt_BR_ITIL", "This port is already used by Netflow", "Esta porta j&aacute; est&aacute; em uso pelo Netflow");
INSERT INTO languages VALUES ("pt_BR_ITIL", "This port is already used by SFlow", "Esta porta j&aacute; est&aacute; em uso pelo SFlow");
INSERT INTO languages VALUES ("pt_BR_ITIL", "This service is not available for the selected host(s)", "Este servi&ccedil;o n&atilde;o est&aacute; dispon&iacute;vel para o host(s) selecionado(s)");
INSERT INTO languages VALUES ("pt_BR_ITIL", "This week", "Esta semana");
INSERT INTO languages VALUES ("pt_BR_ITIL", "This year", "Este ano");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Thresholds", "Limiares");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Thursday", "Quinta-feira");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Time", "Tempo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Timecut Description", "Aqui voc&ecirc; pode definir os hor&aacute;rios de funcionamento de sua empresa e utilizar os mesmos para gera&ccedil;&atilde;o de relat&oacute;rios de Disponibilidade e/ou Capacidade.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Timecut removed sucessfully", "Corte de Tempo removido com sucesso");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Timecut saved sucessfully", "Corte de Tempo salvo com sucesso");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Timecut", "Corte de tempo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "To", "At&eacute;");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Today", "Hoje");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Toggle autoscale", "Alternar autoescala");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Toggle metric", "Alternar m&eacute;trica");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Toggle metrics", "Alternar m&eacute;tricas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Toggle thresholds", "Alternar thresholds");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Tools", "Ferramentas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Top 5 - Alerts", "Top 5 - Alertas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Topology Awareness Message", "Aqui voc&ecirc; poder&aacute; gerar e visualizar antes de aplicar a topologia entre todos os servidores monitorados.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Topology", "Topologia");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Traceroute", "Traceroute");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Transfer errors", "Erros de transfer.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Trend lines", "Linhas de tend&ecirc;ncia");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Trigger ID", "ID Gatilho");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Triggered by", "Disparado por");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Try exporting configuration", "Tentar realizar um export");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Tuesday", "Ter&ccedil;a-feira");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Type an user", "Digite um usu&aacute;rio!");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Type of day", "Tipo de dia");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Type of day", "Tipo do dia");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Type the directory name", "Digite o nome do diret&oacute;rio");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Type the new bookmark name", "Digite o nome do novo favorito");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Type the new shortcut name", "Digite o nome do novo atalho");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Type the word <strong> DELETE </ strong> to confirm", "Digite a palavra <strong>DELETE</strong> para confirmar");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Type", "Tipo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "UNKNOWN", "DESCONHECIDO");
INSERT INTO languages VALUES ("pt_BR_ITIL", "UNREACHABLE", "INALCAN&Ccedil;&Aacute;VEL");
INSERT INTO languages VALUES ("pt_BR_ITIL", "UP", "UP");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Unable to access the server", "N&atilde;o foi poss&iacute;vel acessar o servidor");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Unable to add a field without `name' defined", "Impossivel adicionar campo sem um nome");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Unable to connect to server", "Imposs&iacute;vel conectar ao servidor");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Unable to locate host group", "Imposs&iacute;vel localizar grupo de hosts");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Unable to locate host", "Imposs&iacute;vel localizar host");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Unable to locate service", "Imposs&iacute;vel localizar servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Unable to locate services group", "Imposs&iacute;vel localizar grupo de servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Unable to locate staff", "Imposs&iacute;vel localizar grupo de contatos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Unable to locate team", "Imposs&iacute;vel localizar grupo de contatos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Unable to synchronize group of hosts", "Imposs&iacute;vel sincronizar grupo de hosts");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Unable to synchronize services group", "Imposs&iacute;vel sincronizar grupo de servi&ccedil;os");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Unable to synchronize teams", "Imposs&iacute;vel sincronizar grupos de contato");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Unexpected Error", "Erro inesperado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Uninstall packages", "Desinstalar pacotes");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Unit", "Unidade");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Unknown User", "Usu&aacute;rio Desconhecido");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Unknown", "Desconhecido");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Unlimited", "Ilimitado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Unreachable", "Inacess&iacute;vel");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Unsaved changes", "Altera&ccedil;&otilde;es n&atilde;o salvas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Unselect column", "Desmarcar coluna");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Update license", "Atualizar licen&ccedil;a...");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Update port...", "Atualizar porta...");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Updated on", "Atualizado em");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Updated", "Atualizada em");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Updating IP address...", "Atualizando o endere&ccedil;o IP...");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Updating database...", "Atualizando base de dados...");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Updating the configuration file...", "Atualizando arquivo de configura&ccedil;&atilde;o...");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Updating", "Atualizando");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Upload Success", "Upload efetuado com sucesso");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Upload a new package", "Enviar um novo pacote");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Upload file", "Enviar arquivo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Upload new custom report", "Carregar novo relat&oacute;rio personalizado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Upload new logo", "Enviar novo logo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Upper limit", "Limite superior");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Usage", "Uso");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Use registered authentications", "Utilizar as autentica&ccedil;&otilde;es cadastradas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Use this model", "Usar este modelo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Used Dashboards", "Dashboards Usados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Used Hosts", "Hosts Usados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Used Services", "Servi&ccedil;os Usados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Used", "Usados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "User administrator", "Usu&aacute;rio administrador");
INSERT INTO languages VALUES ("pt_BR_ITIL", "User already exists", "Usu&aacute;rio j&aacute; existe");
INSERT INTO languages VALUES ("pt_BR_ITIL", "User and Password", "Usu&aacute;rio e Senha");
INSERT INTO languages VALUES ("pt_BR_ITIL", "User created successfully", "Usu&aacute;rio criado com sucesso");
INSERT INTO languages VALUES ("pt_BR_ITIL", "User", "Usu&aacute;rio");
INSERT INTO languages VALUES ("pt_BR_ITIL", "UserWithouPermissionDiscovery", "Seu usu&aacute;rio n&atilde;o tem permiss&atilde;o para executar o Auto-Discovery!");
INSERT INTO languages VALUES ("pt_BR_ITIL", "UserWithoutPermissionMsg", "Seu usu&aacute;rio n&atilde;o tem permiss&atilde;o para executar comandos!");
INSERT INTO languages VALUES ("pt_BR_ITIL", "User_Language", "L&iacute;ngua");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Users", "Usu&aacute;rios");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Using external authentication", "Usar autentica&ccedil;&atilde;o externa");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Value in minutes", "Valor em minutos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Value", "Valor");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Vendor", "Fabricante");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Verifying user and password", "Verificando usu&aacute;rio e senha...");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Version", "Vers&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "View all hosts", "Ver todos os ICs");
INSERT INTO languages VALUES ("pt_BR_ITIL", "View all models available", "Ver todos os modelos dispon&iacute;veis");
INSERT INTO languages VALUES ("pt_BR_ITIL", "View all models", "Visualizar todos modelos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "View report and send by e-mail", "Ver o relat&oacute;rio e enviar por e-mail");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Views", "Vis&otilde;es");
INSERT INTO languages VALUES ("pt_BR_ITIL", "WARNING", "ADVERT&Ecirc;NCIA");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Wait", "Aguarde...");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Wait... importing objects", "Aguarde, importando objetos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Want to apply the generated topology ?", "Deseja aplicar a topologia gerada?");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Warning", "Advert&ecirc;ncia");
INSERT INTO languages VALUES ("pt_BR_ITIL", "WarningStripe", "Faixa de advert&ecirc;ncia");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Warns", "Advert&ecirc;ncias");
INSERT INTO languages VALUES ("pt_BR_ITIL", "We find the following probes. Check the probes you want to monitor.", "Encontramos as probes a seguir. Marque as probes que deseja monitorar.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Wednesday", "Quarta-feira");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Week day", "Dia da semana");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Week", "Semana");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Weekly", "Semanal");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Weeks", "Semanas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Welcome to %tag%OpMon %version%%tagend%", "Bem vindo ao %tag%OpMon %version%%tagend%");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Welcome to OpMon Traffic Analyzer", "Bem vindo ao OpMon Traffic Analyzer");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Welcome", "Bem-Vindo");
INSERT INTO languages VALUES ("pt_BR_ITIL", "What do you want to do?", "O que voc&ecirc; deseja fazer?");
INSERT INTO languages VALUES ("pt_BR_ITIL", "What do you want to monitoring?", "O que voc&ecirc; quer monitorar?");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Will be listed only hosts found by the discovery module", "Ser&atilde;o listados somente os hosts encontrados pelo m&oacute;dulo de descoberta do OpMon");
INSERT INTO languages VALUES ("pt_BR_ITIL", "With ack", "Com a&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "With conflict", "Com conflito");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Without ack", "Sem a&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Work", "&Uacute;til");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Write your reasons", "Escreva sua justificativa");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Wrong password", "Senha ou usu&aacute;rio incorreto");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Year", "Ano");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Yes , I want to remove", "Sim, quero remover");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Yes", "Sim");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Yesterday", "Ontem");
INSERT INTO languages VALUES ("pt_BR_ITIL", "You are trying to edit services that belong to a template, unable to proceed", "Os servi&ccedil;os que voc&ecirc; est&aacute; tentando editar pertencem a um template. Imposs&iacute;vel prosseguir.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "You can configure OpMon later", "Voc&ecirc; poder&aacute; configurar OpMon depois");
INSERT INTO languages VALUES ("pt_BR_ITIL", "You can configure Traffic Analyzer later", "Voc&ecirc; poder&aacute; configurar Traffic Analyzer depois");
INSERT INTO languages VALUES ("pt_BR_ITIL", "You can not recover the baseline \\\"Name baseline\\\" after erased.", "N&atilde;o ser&aacute; poss&iacute;vel recuperar a baseline \\\"Nome da baseline\\\" depois de apagada.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "You can not remove the user opmonadmin", "Voc&ecirc; n&atilde;o pode remover o usu&aacute;rio opmonadmin");
INSERT INTO languages VALUES ("pt_BR_ITIL", "You have to write a reason", "Você precisa escrever uma justificativa");
INSERT INTO languages VALUES ("pt_BR_ITIL", "You must select at least one host", "Voc&ecirc; precisa selecionar pelo menos um host");
INSERT INTO languages VALUES ("pt_BR_ITIL", "You must select at least one service", "Voc&ecirc; precisa selecionar pelo menos um servi&ccedil;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "You reached the limit of units that can be selected", "Foi alcan&ccedil;ado o limite de unidades que podem ser selecionadas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "The selected hosts are of the service catalog type and can not be removed.", "Os ICs selecionados s&atilde;o do tipo cat&aacute;logo de servi&ccedil;o e n&atilde;o podem ser removidos.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "You want to remove the selected monitored services? Other services belong to a template and can not be removed.", "Voc&ecirc; deseja remover o(s) %TOBEREMOVE% AIC(s) selecionado(s) da monitora&ccedil;&atilde;o? Outros %CANNOTBEREMOVE% AIC(s) pertence(m) ao um template e n&atilde;o pode(m) ser removido(s).");

INSERT INTO languages VALUES ("pt_BR_ITIL", "You want to remove the selected monitored hosts? Other hosts are of the service catalog type and can not be removed.", "Voc&ecirc; deseja remover o(s) %TOBEREMOVE% IC(s) selecionado(s) da monitora&ccedil;&atilde;o? Outros %CANNOTBEREMOVE% IC(s) s&atilde;o do tipo cat&aacute;logo de servi&ccedil;os e n&atilde;o pode(m) ser removido(s).");

INSERT INTO languages VALUES ("pt_BR_ITIL", "You want to remove the selected monitored host ( s ) ?", "Voc&ecirc; deseja remover o(s) %NUMBER% IC(s) selecionado(s) da monitora&ccedil;&atilde;o?");
INSERT INTO languages VALUES ("pt_BR_ITIL", "You want to remove the selected monitored service ( s ) ?", "Voc&ecirc; deseja remover o(s) %NUMBER% AIC(s) selecionado(s) da monitora&ccedil;&atilde;o?");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Your license expired", "Sua licen&ccedil;a expirou");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Your license is going to expire in", "Sua licen&ccedil;a expirar&aacute; em");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Your report has been uploaded", "Seu relat&oacute;rio foi enviado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Your scheduler", "Seu agendador");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Your trial license expire in %DAY% day(s)", "Sua licen&ccedil;a teste expira em %DAY% dia(s)");
INSERT INTO languages VALUES ("pt_BR_ITIL", "\\o\\f", "\\d\\e");
INSERT INTO languages VALUES ("pt_BR_ITIL", "added", "adicionado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "added.", "adicionado.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "already exists.", "j&aacute; existe.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "and", "e");
INSERT INTO languages VALUES ("pt_BR_ITIL", "click here", "clique aqui");
INSERT INTO languages VALUES ("pt_BR_ITIL", "days", "dias");
INSERT INTO languages VALUES ("pt_BR_ITIL", "demoVersion1", "(M&oacute;dulo em Demonstra&ccedil;&atilde;o - Somente ");
INSERT INTO languages VALUES ("pt_BR_ITIL", "demoVersion2", " IC's ser&atilde;o mostrados)");
INSERT INTO languages VALUES ("pt_BR_ITIL", "different alarms", "alarmes diferentes");
INSERT INTO languages VALUES ("pt_BR_ITIL", "filtered", "filtrada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "for", "para");
INSERT INTO languages VALUES ("pt_BR_ITIL", "from", "das");
INSERT INTO languages VALUES ("pt_BR_ITIL", "here", "aqui");
INSERT INTO languages VALUES ("pt_BR_ITIL", "host(s) discovered!", "host(s) encontrado(s)!");
INSERT INTO languages VALUES ("pt_BR_ITIL", "host(s) selected", "host(s) selecionados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "hosts selected", "ICs selecionados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "hosts to be imported", "ICs para serem importados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "hosts to be scanned", "ICs para serem varridos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "hours", "horas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "licenseExceededMsg", "O n&uacute;mero de objetos de sua licen&ccedil;a atingiu o limite.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "licenseExceededMsghost", "Voc&ecirc; n&atilde;o pode adicionar %SELECTED% IC(s), pois sua licen&ccedil;a permite um total de %LICENSELIMIT% ICs e voc&ecirc; j&aacute; monitora %LICENSEMONITORED% IC(s).");
INSERT INTO languages VALUES ("pt_BR_ITIL", "licenseExceededMsgservice", "Voc&ecirc; n&atilde;o pode adicionar %SELECTED% AIC(s), pois sua licen&ccedil;a permite um total de %LICENSELIMIT% AICs e voc&ecirc; j&aacute; monitora %LICENSEMONITORED% AIC(s).");
INSERT INTO languages VALUES ("pt_BR_ITIL", "licenseExceededTitle", "Limite de objetos excedidos!");
INSERT INTO languages VALUES ("pt_BR_ITIL", "metric exceeds any limit", "m&eacute;trica ultrapassa qualquer limite");
INSERT INTO languages VALUES ("pt_BR_ITIL", "metric exceeds any limit", "m&eacute;trica ultrapassar qualquer limite");
INSERT INTO languages VALUES ("pt_BR_ITIL", "metric exceeds the lower limit", "m&eacute;trica excede o limite inferior");
INSERT INTO languages VALUES ("pt_BR_ITIL", "metric exceeds the upper limit", "m&eacute;trica excede o limite superior");
INSERT INTO languages VALUES ("pt_BR_ITIL", "metric(s) selected", "m&eacute;trica(s) selecionada(s)");
INSERT INTO languages VALUES ("pt_BR_ITIL", "minutes", "minutos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "month", "meses");
INSERT INTO languages VALUES ("pt_BR_ITIL", "months", "meses");
INSERT INTO languages VALUES ("pt_BR_ITIL", "no", "n&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "non work day", "n&atilde;o &uacute;til");
INSERT INTO languages VALUES ("pt_BR_ITIL", "non-working days", "dias n&atilde;o &uacute;teis");
INSERT INTO languages VALUES ("pt_BR_ITIL", "notifications sended", "notifica&ccedil;&atilde;o(&otilde;es) enviada(s)");
INSERT INTO languages VALUES ("pt_BR_ITIL", "objects being edited have different values for this property.<br />Change it here and it will be changed to all objects", "possui diferentes valores para esta propriedade.<br />Mudando esta propriedade acarretar&aacute; em uma mudan&ccedil;a<br />em todos estes objetos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "of the month", "do m&ecirc;s");
INSERT INTO languages VALUES ("pt_BR_ITIL", "of", "de");
INSERT INTO languages VALUES ("pt_BR_ITIL", "or", "ou");
INSERT INTO languages VALUES ("pt_BR_ITIL", "rschedFooter", "Relat&oacute;rio gerado automaticamente pelo seu <b>OpMon</b>.<br>Caso n&atilde;o deseje receber novamente este email, por favor contate o seu administrador OpMon.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "scheduled reports", "relat&oacute;rios agendados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "seconds", "segundos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "selected metrics", "m&eacute;tricas selecionadas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "standard deviation", "desvios padr&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "to", "&agrave;");
INSERT INTO languages VALUES ("pt_BR_ITIL", "via Discovery", "via Discovery");
INSERT INTO languages VALUES ("pt_BR_ITIL", "weeks", "semanas");
INSERT INTO languages VALUES ("pt_BR_ITIL", "with SLA Breach Reason", "com SLA justificado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "work day", "&uacute;til");
INSERT INTO languages VALUES ("pt_BR_ITIL", "working day of month", "dia &uacute;til do m&ecirc;s");
INSERT INTO languages VALUES ("pt_BR_ITIL", "working days", "dias &uacute;teis");
INSERT INTO languages VALUES ("pt_BR_ITIL", "yes", "sim");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Paste here the key sent by email", "Cole aqui a chave enviada por e-mail");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Improve your network discovery  by registering its authentications", "Melhore a descoberta da sua rede cadastrando suas autentica&#xE7;&#xF5;es");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Order by priority", "Ordem por prioridade");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Select All", "Selecione Todos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Grouped", "Agrupado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "View hosts before monitoring", "Ver hosts antes de monitorar");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Network Outages", "Quedas de Rede");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Status summary", "Sum&aacute;rio de Status");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Hosts Affected", "ICs Afetados");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Network Outages Grid", "Listagem de Quedas de Rede");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Audit", "Auditoria");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Action", "A&ccedil;&atilde;o");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Set range", "Definir intervalos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Preset periods", "Per&iacute;odos predefinidos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "There has not been any audit logged", "N&atilde;o houve nenhuma auditoria registrada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Class", "Classe");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Object Name", "Objeto");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Auto refresh", "Atualiza&#231;&#227;o autom&#225;tica");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Event Log", "Log de Eventos");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Items", "Itens");


INSERT INTO languages VALUES ("pt_BR_ITIL", "Predictive analysis description", "Neste widget s&atilde;o exibidos os objetos que ir&atilde;o romper os thresholds estabelecidos nos pr&oacute;ximos 30 dias.<br><br>Quando representado por vermelho significa que faltam menos de 7 dias para romper os thresholds. Amarelo &eacute; quando faltam menos de 30 dias.<br><br>Ao clicar no objeto voc&ecirc; ser&atilde; levado para o gr&atilde;fico de capacidades com uma an&atilde;lise preditiva baseada nos dados coletados deste host/servi&ccedil;o nos &uacute;ltimos 3 meses. No gr&atilde;fico de capacidades voc&ecirc; pode experimentar diferentes per&iacute;odos de coleta e de proje&ccedil;&atilde;o futura.<br><br>O objetivo desta funcionalidade &eacute; a de prover informa&ccedil;&otilde;es relevantes para a previs&atilde;o de problemas futuros, antes que os mesmos venham a ocorrer.");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Predictive analysis of future incidents", "An&aacute;lise preditiva de incidentes futuros");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Predictive Analysis", "An&aacute;lise Preditiva");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Estimated value", "Valor estimado");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Estimated date", "Data estimada");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Collection date", "Data da coleta");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Trend", "Tend&ecirc;ncia");
INSERT INTO languages VALUES ("pt_BR_ITIL", "Prediction", "Previs&atilde;o");
